/* UserEventReceiver.c generated by valac 0.56.15, the Vala compiler
 * generated from UserEventReceiver.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include "CbMessageReceiver.h"
#include "cawbird.h"
#include <glib.h>
#include "CbUserStream.h"
#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include "CbTweet.h"
#include "CbTypes.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_USER_EVENT_RECEIVER (user_event_receiver_get_type ())
#define USER_EVENT_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_EVENT_RECEIVER, UserEventReceiver))
#define USER_EVENT_RECEIVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_EVENT_RECEIVER, UserEventReceiverClass))
#define IS_USER_EVENT_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_EVENT_RECEIVER))
#define IS_USER_EVENT_RECEIVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_EVENT_RECEIVER))
#define USER_EVENT_RECEIVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_EVENT_RECEIVER, UserEventReceiverClass))

typedef struct _UserEventReceiver UserEventReceiver;
typedef struct _UserEventReceiverClass UserEventReceiverClass;
typedef struct _UserEventReceiverPrivate UserEventReceiverPrivate;
enum  {
	USER_EVENT_RECEIVER_0_PROPERTY,
	USER_EVENT_RECEIVER_NUM_PROPERTIES
};
static GParamSpec* user_event_receiver_properties[USER_EVENT_RECEIVER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _UserEventReceiver {
	GObject parent_instance;
	UserEventReceiverPrivate * priv;
};

struct _UserEventReceiverClass {
	GObjectClass parent_class;
};

struct _UserEventReceiverPrivate {
	Account* account;
};

static gint UserEventReceiver_private_offset;
static gpointer user_event_receiver_parent_class = NULL;
static CbMessageReceiverInterface * user_event_receiver_cb_message_receiver_parent_iface = NULL;

VALA_EXTERN GType user_event_receiver_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UserEventReceiver* user_event_receiver_new (Account* account);
VALA_EXTERN UserEventReceiver* user_event_receiver_construct (GType object_type,
                                                  Account* account);
static void user_event_receiver_real_stream_message_received (CbMessageReceiver* base,
                                                       CbStreamMessageType type,
                                                       JsonNode* root_node);
VALA_EXTERN gchar* utils_unescape_html (const gchar* input);
VALA_EXTERN void tweet_utils_set_tweet_hidden_flags (CbTweet* t,
                                         Account* account);
static void user_event_receiver_finalize (GObject * obj);
static GType user_event_receiver_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
user_event_receiver_get_instance_private (UserEventReceiver* self)
{
	return G_STRUCT_MEMBER_P (self, UserEventReceiver_private_offset);
}

UserEventReceiver*
user_event_receiver_construct (GType object_type,
                               Account* account)
{
	UserEventReceiver * self = NULL;
#line 21 "../src/UserEventReceiver.vala"
	g_return_val_if_fail (account != NULL, NULL);
#line 21 "../src/UserEventReceiver.vala"
	self = (UserEventReceiver*) g_object_new (object_type, NULL);
#line 22 "../src/UserEventReceiver.vala"
	self->priv->account = account;
#line 21 "../src/UserEventReceiver.vala"
	return self;
#line 116 "UserEventReceiver.c"
}

UserEventReceiver*
user_event_receiver_new (Account* account)
{
#line 21 "../src/UserEventReceiver.vala"
	return user_event_receiver_construct (TYPE_USER_EVENT_RECEIVER, account);
#line 124 "UserEventReceiver.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 69 "../src/UserEventReceiver.vala"
	return self ? json_object_ref (self) : NULL;
#line 132 "UserEventReceiver.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 87 "../src/UserEventReceiver.vala"
	return self ? g_object_ref (self) : NULL;
#line 140 "UserEventReceiver.c"
}

static void
user_event_receiver_real_stream_message_received (CbMessageReceiver* base,
                                                  CbStreamMessageType type,
                                                  JsonNode* root_node)
{
	UserEventReceiver * self;
#line 25 "../src/UserEventReceiver.vala"
	self = (UserEventReceiver*) base;
#line 25 "../src/UserEventReceiver.vala"
	g_return_if_fail (root_node != NULL);
#line 27 "../src/UserEventReceiver.vala"
	switch (type) {
#line 27 "../src/UserEventReceiver.vala"
		case CB_STREAM_MESSAGE_FRIENDS:
#line 157 "UserEventReceiver.c"
		{
			Account* _tmp0_;
			JsonObject* _tmp1_;
			JsonArray* _tmp2_;
#line 29 "../src/UserEventReceiver.vala"
			_tmp0_ = self->priv->account;
#line 29 "../src/UserEventReceiver.vala"
			_tmp1_ = json_node_get_object (root_node);
#line 29 "../src/UserEventReceiver.vala"
			_tmp2_ = json_object_get_array_member (_tmp1_, "friends");
#line 29 "../src/UserEventReceiver.vala"
			account_set_friends (_tmp0_, _tmp2_);
#line 30 "../src/UserEventReceiver.vala"
			break;
#line 172 "UserEventReceiver.c"
		}
#line 27 "../src/UserEventReceiver.vala"
		case CB_STREAM_MESSAGE_EVENT_FOLLOW:
#line 176 "UserEventReceiver.c"
		{
			gint64 user_id = 0LL;
			JsonObject* _tmp3_;
			JsonObject* _tmp4_;
			Account* _tmp5_;
#line 33 "../src/UserEventReceiver.vala"
			_tmp3_ = json_node_get_object (root_node);
#line 33 "../src/UserEventReceiver.vala"
			_tmp4_ = json_object_get_object_member (_tmp3_, "target");
#line 33 "../src/UserEventReceiver.vala"
			user_id = json_object_get_int_member (_tmp4_, "id");
#line 35 "../src/UserEventReceiver.vala"
			_tmp5_ = self->priv->account;
#line 35 "../src/UserEventReceiver.vala"
			account_follow_id (_tmp5_, user_id);
#line 36 "../src/UserEventReceiver.vala"
			break;
#line 194 "UserEventReceiver.c"
		}
#line 27 "../src/UserEventReceiver.vala"
		case CB_STREAM_MESSAGE_EVENT_UNFOLLOW:
#line 198 "UserEventReceiver.c"
		{
			gint64 user_id = 0LL;
			JsonObject* _tmp6_;
			JsonObject* _tmp7_;
			Account* _tmp8_;
#line 39 "../src/UserEventReceiver.vala"
			_tmp6_ = json_node_get_object (root_node);
#line 39 "../src/UserEventReceiver.vala"
			_tmp7_ = json_object_get_object_member (_tmp6_, "target");
#line 39 "../src/UserEventReceiver.vala"
			user_id = json_object_get_int_member (_tmp7_, "id");
#line 41 "../src/UserEventReceiver.vala"
			_tmp8_ = self->priv->account;
#line 41 "../src/UserEventReceiver.vala"
			account_unfollow_id (_tmp8_, user_id);
#line 42 "../src/UserEventReceiver.vala"
			break;
#line 216 "UserEventReceiver.c"
		}
#line 27 "../src/UserEventReceiver.vala"
		case CB_STREAM_MESSAGE_EVENT_MUTE:
#line 220 "UserEventReceiver.c"
		{
			gint64 user_id = 0LL;
			JsonObject* _tmp9_;
			JsonObject* _tmp10_;
			Account* _tmp11_;
#line 45 "../src/UserEventReceiver.vala"
			_tmp9_ = json_node_get_object (root_node);
#line 45 "../src/UserEventReceiver.vala"
			_tmp10_ = json_object_get_object_member (_tmp9_, "target");
#line 45 "../src/UserEventReceiver.vala"
			user_id = json_object_get_int_member (_tmp10_, "id");
#line 47 "../src/UserEventReceiver.vala"
			_tmp11_ = self->priv->account;
#line 47 "../src/UserEventReceiver.vala"
			account_mute_id (_tmp11_, user_id);
#line 48 "../src/UserEventReceiver.vala"
			break;
#line 238 "UserEventReceiver.c"
		}
#line 27 "../src/UserEventReceiver.vala"
		case CB_STREAM_MESSAGE_EVENT_UNMUTE:
#line 242 "UserEventReceiver.c"
		{
			gint64 user_id = 0LL;
			JsonObject* _tmp12_;
			JsonObject* _tmp13_;
			Account* _tmp14_;
#line 51 "../src/UserEventReceiver.vala"
			_tmp12_ = json_node_get_object (root_node);
#line 51 "../src/UserEventReceiver.vala"
			_tmp13_ = json_object_get_object_member (_tmp12_, "target");
#line 51 "../src/UserEventReceiver.vala"
			user_id = json_object_get_int_member (_tmp13_, "id");
#line 53 "../src/UserEventReceiver.vala"
			_tmp14_ = self->priv->account;
#line 53 "../src/UserEventReceiver.vala"
			account_unmute_id (_tmp14_, user_id);
#line 54 "../src/UserEventReceiver.vala"
			break;
#line 260 "UserEventReceiver.c"
		}
#line 27 "../src/UserEventReceiver.vala"
		case CB_STREAM_MESSAGE_EVENT_BLOCK:
#line 264 "UserEventReceiver.c"
		{
			gint64 user_id = 0LL;
			JsonObject* _tmp15_;
			JsonObject* _tmp16_;
			Account* _tmp17_;
#line 57 "../src/UserEventReceiver.vala"
			_tmp15_ = json_node_get_object (root_node);
#line 57 "../src/UserEventReceiver.vala"
			_tmp16_ = json_object_get_object_member (_tmp15_, "target");
#line 57 "../src/UserEventReceiver.vala"
			user_id = json_object_get_int_member (_tmp16_, "id");
#line 59 "../src/UserEventReceiver.vala"
			_tmp17_ = self->priv->account;
#line 59 "../src/UserEventReceiver.vala"
			account_block_id (_tmp17_, user_id);
#line 60 "../src/UserEventReceiver.vala"
			break;
#line 282 "UserEventReceiver.c"
		}
#line 27 "../src/UserEventReceiver.vala"
		case CB_STREAM_MESSAGE_EVENT_UNBLOCK:
#line 286 "UserEventReceiver.c"
		{
			gint64 user_id = 0LL;
			JsonObject* _tmp18_;
			JsonObject* _tmp19_;
			Account* _tmp20_;
#line 63 "../src/UserEventReceiver.vala"
			_tmp18_ = json_node_get_object (root_node);
#line 63 "../src/UserEventReceiver.vala"
			_tmp19_ = json_object_get_object_member (_tmp18_, "target");
#line 63 "../src/UserEventReceiver.vala"
			user_id = json_object_get_int_member (_tmp19_, "id");
#line 65 "../src/UserEventReceiver.vala"
			_tmp20_ = self->priv->account;
#line 65 "../src/UserEventReceiver.vala"
			account_unblock_id (_tmp20_, user_id);
#line 66 "../src/UserEventReceiver.vala"
			break;
#line 304 "UserEventReceiver.c"
		}
#line 27 "../src/UserEventReceiver.vala"
		case CB_STREAM_MESSAGE_EVENT_USER_UPDATE:
#line 308 "UserEventReceiver.c"
		{
			JsonObject* user_obj = NULL;
			JsonObject* _tmp21_;
			JsonObject* _tmp22_;
			JsonObject* _tmp23_;
			JsonObject* _tmp24_;
			Account* _tmp25_;
#line 69 "../src/UserEventReceiver.vala"
			_tmp21_ = json_node_get_object (root_node);
#line 69 "../src/UserEventReceiver.vala"
			_tmp22_ = json_object_get_object_member (_tmp21_, "target");
#line 69 "../src/UserEventReceiver.vala"
			_tmp23_ = _json_object_ref0 (_tmp22_);
#line 69 "../src/UserEventReceiver.vala"
			user_obj = _tmp23_;
#line 70 "../src/UserEventReceiver.vala"
			_tmp24_ = user_obj;
#line 70 "../src/UserEventReceiver.vala"
			_tmp25_ = self->priv->account;
#line 70 "../src/UserEventReceiver.vala"
			if (json_object_get_int_member (_tmp24_, "id") == _tmp25_->id) {
#line 330 "UserEventReceiver.c"
				gchar* old_screen_name = NULL;
				Account* _tmp26_;
				const gchar* _tmp27_;
				gchar* _tmp28_;
				Account* _tmp29_;
				JsonObject* _tmp30_;
				const gchar* _tmp31_;
				gchar* _tmp32_;
				Account* _tmp33_;
				JsonObject* _tmp34_;
				const gchar* _tmp35_;
				gchar* _tmp36_;
				Account* _tmp37_;
				JsonObject* _tmp38_;
				const gchar* _tmp39_;
				gchar* _tmp40_;
				Account* _tmp41_;
				Account* _tmp42_;
				const gchar* _tmp43_;
				Account* _tmp44_;
				const gchar* _tmp45_;
				Account* _tmp46_;
				cairo_surface_t* _tmp47_;
				cairo_surface_t* _tmp48_;
				Account* _tmp49_;
				cairo_surface_t* _tmp50_;
				cairo_surface_t* _tmp51_;
				Account* _tmp52_;
				const gchar* _tmp53_;
				Account* _tmp54_;
				const gchar* _tmp55_;
#line 71 "../src/UserEventReceiver.vala"
				_tmp26_ = self->priv->account;
#line 71 "../src/UserEventReceiver.vala"
				_tmp27_ = _tmp26_->screen_name;
#line 71 "../src/UserEventReceiver.vala"
				_tmp28_ = g_strdup (_tmp27_);
#line 71 "../src/UserEventReceiver.vala"
				old_screen_name = _tmp28_;
#line 72 "../src/UserEventReceiver.vala"
				_tmp29_ = self->priv->account;
#line 72 "../src/UserEventReceiver.vala"
				_tmp30_ = user_obj;
#line 72 "../src/UserEventReceiver.vala"
				_tmp31_ = json_object_get_string_member (_tmp30_, "name");
#line 72 "../src/UserEventReceiver.vala"
				_tmp32_ = g_strdup (_tmp31_);
#line 72 "../src/UserEventReceiver.vala"
				_g_free0 (_tmp29_->name);
#line 72 "../src/UserEventReceiver.vala"
				_tmp29_->name = _tmp32_;
#line 73 "../src/UserEventReceiver.vala"
				_tmp33_ = self->priv->account;
#line 73 "../src/UserEventReceiver.vala"
				_tmp34_ = user_obj;
#line 73 "../src/UserEventReceiver.vala"
				_tmp35_ = json_object_get_string_member (_tmp34_, "description");
#line 73 "../src/UserEventReceiver.vala"
				_tmp36_ = g_strdup (_tmp35_);
#line 73 "../src/UserEventReceiver.vala"
				_g_free0 (_tmp33_->description);
#line 73 "../src/UserEventReceiver.vala"
				_tmp33_->description = _tmp36_;
#line 74 "../src/UserEventReceiver.vala"
				_tmp37_ = self->priv->account;
#line 74 "../src/UserEventReceiver.vala"
				_tmp38_ = user_obj;
#line 74 "../src/UserEventReceiver.vala"
				_tmp39_ = json_object_get_string_member (_tmp38_, "screen_name");
#line 74 "../src/UserEventReceiver.vala"
				_tmp40_ = g_strdup (_tmp39_);
#line 74 "../src/UserEventReceiver.vala"
				_g_free0 (_tmp37_->screen_name);
#line 74 "../src/UserEventReceiver.vala"
				_tmp37_->screen_name = _tmp40_;
#line 75 "../src/UserEventReceiver.vala"
				_tmp41_ = self->priv->account;
#line 75 "../src/UserEventReceiver.vala"
				_tmp42_ = self->priv->account;
#line 75 "../src/UserEventReceiver.vala"
				_tmp43_ = _tmp42_->screen_name;
#line 75 "../src/UserEventReceiver.vala"
				_tmp44_ = self->priv->account;
#line 75 "../src/UserEventReceiver.vala"
				_tmp45_ = _tmp44_->name;
#line 75 "../src/UserEventReceiver.vala"
				_tmp46_ = self->priv->account;
#line 75 "../src/UserEventReceiver.vala"
				_tmp47_ = account_get_avatar_small (_tmp46_);
#line 75 "../src/UserEventReceiver.vala"
				_tmp48_ = _tmp47_;
#line 75 "../src/UserEventReceiver.vala"
				_tmp49_ = self->priv->account;
#line 75 "../src/UserEventReceiver.vala"
				_tmp50_ = account_get_avatar (_tmp49_);
#line 75 "../src/UserEventReceiver.vala"
				_tmp51_ = _tmp50_;
#line 75 "../src/UserEventReceiver.vala"
				g_signal_emit_by_name (_tmp41_, "info-changed", _tmp43_, _tmp45_, _tmp48_, _tmp51_);
#line 79 "../src/UserEventReceiver.vala"
				_tmp52_ = self->priv->account;
#line 79 "../src/UserEventReceiver.vala"
				account_save_info (_tmp52_);
#line 80 "../src/UserEventReceiver.vala"
				_tmp53_ = old_screen_name;
#line 80 "../src/UserEventReceiver.vala"
				_tmp54_ = self->priv->account;
#line 80 "../src/UserEventReceiver.vala"
				_tmp55_ = _tmp54_->screen_name;
#line 80 "../src/UserEventReceiver.vala"
				utils_update_startup_account (_tmp53_, _tmp55_);
#line 70 "../src/UserEventReceiver.vala"
				_g_free0 (old_screen_name);
#line 444 "UserEventReceiver.c"
			} else {
#line 82 "../src/UserEventReceiver.vala"
				g_warning ("UserEventReceiver.vala:82: USER_UPDATE: ids don't match");
#line 448 "UserEventReceiver.c"
			}
#line 84 "../src/UserEventReceiver.vala"
			_json_object_unref0 (user_obj);
#line 84 "../src/UserEventReceiver.vala"
			break;
#line 454 "UserEventReceiver.c"
		}
#line 27 "../src/UserEventReceiver.vala"
		case CB_STREAM_MESSAGE_DIRECT_MESSAGE:
#line 458 "UserEventReceiver.c"
		{
			Cawbird* cb = NULL;
			GApplication* _tmp56_;
			Cawbird* _tmp57_;
			gboolean _tmp58_ = FALSE;
			gboolean _tmp59_ = FALSE;
			Cawbird* _tmp60_;
			Account* _tmp61_;
#line 87 "../src/UserEventReceiver.vala"
			_tmp56_ = g_application_get_default ();
#line 87 "../src/UserEventReceiver.vala"
			_tmp57_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, TYPE_CAWBIRD, Cawbird));
#line 87 "../src/UserEventReceiver.vala"
			cb = _tmp57_;
#line 88 "../src/UserEventReceiver.vala"
			_tmp60_ = cb;
#line 88 "../src/UserEventReceiver.vala"
			_tmp61_ = self->priv->account;
#line 88 "../src/UserEventReceiver.vala"
			if (!cawbird_is_window_open_for_user_id (_tmp60_, _tmp61_->id, NULL)) {
#line 479 "UserEventReceiver.c"
				Account* _tmp62_;
#line 89 "../src/UserEventReceiver.vala"
				_tmp62_ = self->priv->account;
#line 89 "../src/UserEventReceiver.vala"
				_tmp59_ = !_tmp62_->suppress_dm_notifications;
#line 485 "UserEventReceiver.c"
			} else {
#line 88 "../src/UserEventReceiver.vala"
				_tmp59_ = FALSE;
#line 489 "UserEventReceiver.c"
			}
#line 88 "../src/UserEventReceiver.vala"
			if (_tmp59_) {
#line 90 "../src/UserEventReceiver.vala"
				_tmp58_ = settings_notify_new_dms ();
#line 495 "UserEventReceiver.c"
			} else {
#line 88 "../src/UserEventReceiver.vala"
				_tmp58_ = FALSE;
#line 499 "UserEventReceiver.c"
			}
#line 88 "../src/UserEventReceiver.vala"
			if (_tmp58_) {
#line 503 "UserEventReceiver.c"
				JsonObject* dm_obj = NULL;
				JsonObject* _tmp63_;
				JsonObject* _tmp64_;
				JsonObject* _tmp65_;
				JsonObject* sender_obj = NULL;
				JsonObject* _tmp66_;
				JsonObject* _tmp67_;
				JsonObject* _tmp68_;
				gint64 sender_id = 0LL;
				JsonObject* _tmp69_;
				gchar* sender_name = NULL;
				JsonObject* _tmp70_;
				const gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* dm_text = NULL;
				JsonObject* _tmp73_;
				const gchar* _tmp74_;
				gchar* _tmp75_;
				Account* _tmp76_;
				NotificationManager* _tmp77_;
				const gchar* _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
				const gchar* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				gchar* _tmp84_;
				gchar* _tmp85_;
#line 91 "../src/UserEventReceiver.vala"
				_tmp63_ = json_node_get_object (root_node);
#line 91 "../src/UserEventReceiver.vala"
				_tmp64_ = json_object_get_object_member (_tmp63_, "direct_message");
#line 91 "../src/UserEventReceiver.vala"
				_tmp65_ = _json_object_ref0 (_tmp64_);
#line 91 "../src/UserEventReceiver.vala"
				dm_obj = _tmp65_;
#line 92 "../src/UserEventReceiver.vala"
				_tmp66_ = dm_obj;
#line 92 "../src/UserEventReceiver.vala"
				_tmp67_ = json_object_get_object_member (_tmp66_, "sender");
#line 92 "../src/UserEventReceiver.vala"
				_tmp68_ = _json_object_ref0 (_tmp67_);
#line 92 "../src/UserEventReceiver.vala"
				sender_obj = _tmp68_;
#line 93 "../src/UserEventReceiver.vala"
				_tmp69_ = sender_obj;
#line 93 "../src/UserEventReceiver.vala"
				sender_id = json_object_get_int_member (_tmp69_, "id");
#line 94 "../src/UserEventReceiver.vala"
				_tmp70_ = sender_obj;
#line 94 "../src/UserEventReceiver.vala"
				_tmp71_ = json_object_get_string_member (_tmp70_, "name");
#line 94 "../src/UserEventReceiver.vala"
				_tmp72_ = g_strdup (_tmp71_);
#line 94 "../src/UserEventReceiver.vala"
				sender_name = _tmp72_;
#line 95 "../src/UserEventReceiver.vala"
				_tmp73_ = dm_obj;
#line 95 "../src/UserEventReceiver.vala"
				_tmp74_ = json_object_get_string_member (_tmp73_, "text");
#line 95 "../src/UserEventReceiver.vala"
				_tmp75_ = g_strdup (_tmp74_);
#line 95 "../src/UserEventReceiver.vala"
				dm_text = _tmp75_;
#line 97 "../src/UserEventReceiver.vala"
				_tmp76_ = self->priv->account;
#line 97 "../src/UserEventReceiver.vala"
				_tmp77_ = _tmp76_->notifications;
#line 97 "../src/UserEventReceiver.vala"
				_tmp78_ = sender_name;
#line 97 "../src/UserEventReceiver.vala"
				_tmp79_ = g_strdup_printf (_ ("New direct message from %s"), _tmp78_);
#line 97 "../src/UserEventReceiver.vala"
				_tmp80_ = _tmp79_;
#line 97 "../src/UserEventReceiver.vala"
				_tmp81_ = dm_text;
#line 97 "../src/UserEventReceiver.vala"
				_tmp82_ = utils_unescape_html (_tmp81_);
#line 97 "../src/UserEventReceiver.vala"
				_tmp83_ = _tmp82_;
#line 97 "../src/UserEventReceiver.vala"
				_tmp84_ = notification_manager_send_dm (_tmp77_, sender_id, NULL, _tmp80_, _tmp83_);
#line 97 "../src/UserEventReceiver.vala"
				_tmp85_ = _tmp84_;
#line 97 "../src/UserEventReceiver.vala"
				_g_free0 (_tmp85_);
#line 97 "../src/UserEventReceiver.vala"
				_g_free0 (_tmp83_);
#line 97 "../src/UserEventReceiver.vala"
				_g_free0 (_tmp80_);
#line 88 "../src/UserEventReceiver.vala"
				_g_free0 (dm_text);
#line 88 "../src/UserEventReceiver.vala"
				_g_free0 (sender_name);
#line 88 "../src/UserEventReceiver.vala"
				_json_object_unref0 (sender_obj);
#line 88 "../src/UserEventReceiver.vala"
				_json_object_unref0 (dm_obj);
#line 602 "UserEventReceiver.c"
			}
#line 102 "../src/UserEventReceiver.vala"
			_g_object_unref0 (cb);
#line 102 "../src/UserEventReceiver.vala"
			break;
#line 608 "UserEventReceiver.c"
		}
#line 27 "../src/UserEventReceiver.vala"
		case CB_STREAM_MESSAGE_MENTION:
#line 612 "UserEventReceiver.c"
		{
			Cawbird* cb = NULL;
			GApplication* _tmp86_;
			Cawbird* _tmp87_;
			gboolean _tmp88_ = FALSE;
			gboolean _tmp89_ = FALSE;
			Cawbird* _tmp90_;
			Account* _tmp91_;
#line 105 "../src/UserEventReceiver.vala"
			_tmp86_ = g_application_get_default ();
#line 105 "../src/UserEventReceiver.vala"
			_tmp87_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp86_, TYPE_CAWBIRD, Cawbird));
#line 105 "../src/UserEventReceiver.vala"
			cb = _tmp87_;
#line 106 "../src/UserEventReceiver.vala"
			_tmp90_ = cb;
#line 106 "../src/UserEventReceiver.vala"
			_tmp91_ = self->priv->account;
#line 106 "../src/UserEventReceiver.vala"
			if (!cawbird_is_window_open_for_user_id (_tmp90_, _tmp91_->id, NULL)) {
#line 633 "UserEventReceiver.c"
				Account* _tmp92_;
#line 107 "../src/UserEventReceiver.vala"
				_tmp92_ = self->priv->account;
#line 107 "../src/UserEventReceiver.vala"
				_tmp89_ = !_tmp92_->suppress_mention_notifications;
#line 639 "UserEventReceiver.c"
			} else {
#line 106 "../src/UserEventReceiver.vala"
				_tmp89_ = FALSE;
#line 643 "UserEventReceiver.c"
			}
#line 106 "../src/UserEventReceiver.vala"
			if (_tmp89_) {
#line 108 "../src/UserEventReceiver.vala"
				_tmp88_ = settings_notify_new_mentions ();
#line 649 "UserEventReceiver.c"
			} else {
#line 106 "../src/UserEventReceiver.vala"
				_tmp88_ = FALSE;
#line 653 "UserEventReceiver.c"
			}
#line 106 "../src/UserEventReceiver.vala"
			if (_tmp88_) {
#line 657 "UserEventReceiver.c"
				CbTweet* tweet = NULL;
				CbTweet* _tmp93_;
				CbTweet* _tmp94_;
				Account* _tmp95_;
				GDateTime* _tmp96_;
				GDateTime* _tmp97_;
				CbTweet* _tmp98_;
				Account* _tmp99_;
				CbTweet* _tmp100_;
#line 109 "../src/UserEventReceiver.vala"
				_tmp93_ = cb_tweet_new ();
#line 109 "../src/UserEventReceiver.vala"
				tweet = _tmp93_;
#line 110 "../src/UserEventReceiver.vala"
				_tmp94_ = tweet;
#line 110 "../src/UserEventReceiver.vala"
				_tmp95_ = self->priv->account;
#line 110 "../src/UserEventReceiver.vala"
				_tmp96_ = g_date_time_new_now_local ();
#line 110 "../src/UserEventReceiver.vala"
				_tmp97_ = _tmp96_;
#line 110 "../src/UserEventReceiver.vala"
				cb_tweet_load_from_json (_tmp94_, root_node, _tmp95_->id, _tmp97_);
#line 110 "../src/UserEventReceiver.vala"
				_g_date_time_unref0 (_tmp97_);
#line 111 "../src/UserEventReceiver.vala"
				_tmp98_ = tweet;
#line 111 "../src/UserEventReceiver.vala"
				_tmp99_ = self->priv->account;
#line 111 "../src/UserEventReceiver.vala"
				tweet_utils_set_tweet_hidden_flags (_tmp98_, _tmp99_);
#line 114 "../src/UserEventReceiver.vala"
				_tmp100_ = tweet;
#line 114 "../src/UserEventReceiver.vala"
				if (!cb_tweet_is_hidden (_tmp100_)) {
#line 693 "UserEventReceiver.c"
					gchar* summary = NULL;
					CbTweet* _tmp101_;
					CbMiniTweet _tmp102_;
					CbUserIdentity _tmp103_;
					const gchar* _tmp104_;
					Account* _tmp105_;
					const gchar* _tmp106_;
					gchar* _tmp107_;
					Account* _tmp108_;
					NotificationManager* _tmp109_;
					const gchar* _tmp110_;
					CbTweet* _tmp111_;
					gchar* _tmp112_;
					gchar* _tmp113_;
					gchar* _tmp114_;
					gchar* _tmp115_;
#line 117 "../src/UserEventReceiver.vala"
					_tmp101_ = tweet;
#line 117 "../src/UserEventReceiver.vala"
					_tmp102_ = _tmp101_->source_tweet;
#line 117 "../src/UserEventReceiver.vala"
					_tmp103_ = _tmp102_.author;
#line 117 "../src/UserEventReceiver.vala"
					_tmp104_ = _tmp103_.user_name;
#line 117 "../src/UserEventReceiver.vala"
					_tmp105_ = self->priv->account;
#line 117 "../src/UserEventReceiver.vala"
					_tmp106_ = _tmp105_->name;
#line 117 "../src/UserEventReceiver.vala"
					_tmp107_ = g_strdup_printf (_ ("%s mentioned %s"), _tmp104_, _tmp106_);
#line 117 "../src/UserEventReceiver.vala"
					summary = _tmp107_;
#line 120 "../src/UserEventReceiver.vala"
					_tmp108_ = self->priv->account;
#line 120 "../src/UserEventReceiver.vala"
					_tmp109_ = _tmp108_->notifications;
#line 120 "../src/UserEventReceiver.vala"
					_tmp110_ = summary;
#line 120 "../src/UserEventReceiver.vala"
					_tmp111_ = tweet;
#line 120 "../src/UserEventReceiver.vala"
					_tmp112_ = cb_tweet_get_real_text (_tmp111_);
#line 120 "../src/UserEventReceiver.vala"
					_tmp113_ = _tmp112_;
#line 120 "../src/UserEventReceiver.vala"
					_tmp114_ = notification_manager_send (_tmp109_, _tmp110_, _tmp113_, NULL);
#line 120 "../src/UserEventReceiver.vala"
					_tmp115_ = _tmp114_;
#line 120 "../src/UserEventReceiver.vala"
					_g_free0 (_tmp115_);
#line 120 "../src/UserEventReceiver.vala"
					_g_free0 (_tmp113_);
#line 114 "../src/UserEventReceiver.vala"
					_g_free0 (summary);
#line 748 "UserEventReceiver.c"
				}
#line 106 "../src/UserEventReceiver.vala"
				_g_object_unref0 (tweet);
#line 752 "UserEventReceiver.c"
			}
#line 123 "../src/UserEventReceiver.vala"
			_g_object_unref0 (cb);
#line 123 "../src/UserEventReceiver.vala"
			break;
#line 758 "UserEventReceiver.c"
		}
		default:
		{
#line 126 "../src/UserEventReceiver.vala"
			break;
#line 764 "UserEventReceiver.c"
		}
	}
}

static void
user_event_receiver_class_init (UserEventReceiverClass * klass,
                                gpointer klass_data)
{
#line 18 "../src/UserEventReceiver.vala"
	user_event_receiver_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/UserEventReceiver.vala"
	g_type_class_adjust_private_offset (klass, &UserEventReceiver_private_offset);
#line 18 "../src/UserEventReceiver.vala"
	G_OBJECT_CLASS (klass)->finalize = user_event_receiver_finalize;
#line 779 "UserEventReceiver.c"
}

static void
user_event_receiver_cb_message_receiver_interface_init (CbMessageReceiverInterface * iface,
                                                        gpointer iface_data)
{
#line 18 "../src/UserEventReceiver.vala"
	user_event_receiver_cb_message_receiver_parent_iface = g_type_interface_peek_parent (iface);
#line 18 "../src/UserEventReceiver.vala"
	iface->stream_message_received = (void (*) (CbMessageReceiver*, CbStreamMessageType, JsonNode*)) user_event_receiver_real_stream_message_received;
#line 790 "UserEventReceiver.c"
}

static void
user_event_receiver_instance_init (UserEventReceiver * self,
                                   gpointer klass)
{
#line 18 "../src/UserEventReceiver.vala"
	self->priv = user_event_receiver_get_instance_private (self);
#line 799 "UserEventReceiver.c"
}

static void
user_event_receiver_finalize (GObject * obj)
{
	UserEventReceiver * self;
#line 18 "../src/UserEventReceiver.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_EVENT_RECEIVER, UserEventReceiver);
#line 18 "../src/UserEventReceiver.vala"
	G_OBJECT_CLASS (user_event_receiver_parent_class)->finalize (obj);
#line 810 "UserEventReceiver.c"
}

static GType
user_event_receiver_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UserEventReceiverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_event_receiver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserEventReceiver), 0, (GInstanceInitFunc) user_event_receiver_instance_init, NULL };
	static const GInterfaceInfo cb_message_receiver_info = { (GInterfaceInitFunc) user_event_receiver_cb_message_receiver_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType user_event_receiver_type_id;
	user_event_receiver_type_id = g_type_register_static (G_TYPE_OBJECT, "UserEventReceiver", &g_define_type_info, 0);
	g_type_add_interface_static (user_event_receiver_type_id, CB_TYPE_MESSAGE_RECEIVER, &cb_message_receiver_info);
	UserEventReceiver_private_offset = g_type_add_instance_private (user_event_receiver_type_id, sizeof (UserEventReceiverPrivate));
	return user_event_receiver_type_id;
}

GType
user_event_receiver_get_type (void)
{
	static volatile gsize user_event_receiver_type_id__once = 0;
	if (g_once_init_enter (&user_event_receiver_type_id__once)) {
		GType user_event_receiver_type_id;
		user_event_receiver_type_id = user_event_receiver_get_type_once ();
		g_once_init_leave (&user_event_receiver_type_id__once, user_event_receiver_type_id);
	}
	return user_event_receiver_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

