/* AddImageButton.c generated by valac 0.56.15, the Vala compiler
 * generated from AddImageButton.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <atk/atk.h>
#include <gdk/gdk.h>
#include "cawbird.h"

#define ADD_IMAGE_BUTTON_MIN_WIDTH 40
#define ADD_IMAGE_BUTTON_MAX_HEIGHT 150
#define ADD_IMAGE_BUTTON_MIN_HEIGHT 100
#define ADD_IMAGE_BUTTON_ICON_SIZE 32
#define TRANSITION_DURATION (200 * 1000)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_ADD_IMAGE_BUTTON (add_image_button_get_type ())
#define ADD_IMAGE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADD_IMAGE_BUTTON, AddImageButton))
#define ADD_IMAGE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADD_IMAGE_BUTTON, AddImageButtonClass))
#define IS_ADD_IMAGE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADD_IMAGE_BUTTON))
#define IS_ADD_IMAGE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADD_IMAGE_BUTTON))
#define ADD_IMAGE_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADD_IMAGE_BUTTON, AddImageButtonClass))

typedef struct _AddImageButton AddImageButton;
typedef struct _AddImageButtonClass AddImageButtonClass;
typedef struct _AddImageButtonPrivate AddImageButtonPrivate;

#define TYPE_MEDIA_UPLOAD (media_upload_get_type ())
#define MEDIA_UPLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_UPLOAD, MediaUpload))
#define MEDIA_UPLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_UPLOAD, MediaUploadClass))
#define IS_MEDIA_UPLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_UPLOAD))
#define IS_MEDIA_UPLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_UPLOAD))
#define MEDIA_UPLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_UPLOAD, MediaUploadClass))

typedef struct _MediaUpload MediaUpload;
typedef struct _MediaUploadClass MediaUploadClass;
enum  {
	ADD_IMAGE_BUTTON_0_PROPERTY,
	ADD_IMAGE_BUTTON_IMAGE_PATH_PROPERTY,
	ADD_IMAGE_BUTTON_UUID_PROPERTY,
	ADD_IMAGE_BUTTON_MEDIA_ID_PROPERTY,
	ADD_IMAGE_BUTTON_NUM_PROPERTIES
};
static GParamSpec* add_image_button_properties[ADD_IMAGE_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
enum  {
	ADD_IMAGE_BUTTON_DELETED_SIGNAL,
	ADD_IMAGE_BUTTON_NUM_SIGNALS
};
static guint add_image_button_signals[ADD_IMAGE_BUTTON_NUM_SIGNALS] = {0};

struct _AddImageButton {
	GtkButton parent_instance;
	AddImageButtonPrivate * priv;
	gchar* description;
	cairo_surface_t* surface;
};

struct _AddImageButtonClass {
	GtkButtonClass parent_class;
};

struct _AddImageButtonPrivate {
	MediaUpload* _media_upload;
	gdouble delete_factor;
	guint64 delete_transition_start;
};

static gint AddImageButton_private_offset;
static gpointer add_image_button_parent_class = NULL;

VALA_EXTERN GType add_image_button_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType media_upload_get_type (void) G_GNUC_CONST ;
VALA_EXTERN AddImageButton* add_image_button_new (MediaUpload* upload);
VALA_EXTERN AddImageButton* add_image_button_construct (GType object_type,
                                            MediaUpload* upload);
VALA_EXTERN gchar* media_upload_get_filepath (MediaUpload* self);
VALA_EXTERN void add_image_button_get_draw_size (AddImageButton* self,
                                     gint* width,
                                     gint* height,
                                     gdouble* scale);
static gboolean add_image_button_real_draw (GtkWidget* base,
                                     cairo_t* ct);
static GtkSizeRequestMode add_image_button_real_get_request_mode (GtkWidget* base);
static void add_image_button_real_get_preferred_height_for_width (GtkWidget* base,
                                                           gint width,
                                                           gint* minimum,
                                                           gint* natural);
static void add_image_button_real_get_preferred_width_for_height (GtkWidget* base,
                                                           gint height,
                                                           gint* minimum,
                                                           gint* natural);
static void add_image_button_real_get_preferred_width (GtkWidget* base,
                                                gint* minimum,
                                                gint* natural);
static void add_image_button_real_get_preferred_height (GtkWidget* base,
                                                 gint* minimum,
                                                 gint* natural);
static gboolean add_image_button_delete_tick_cb (AddImageButton* self,
                                          GtkWidget* widget,
                                          GdkFrameClock* frame_clock);
VALA_EXTERN gdouble ease_out_cubic (gdouble t);
VALA_EXTERN void add_image_button_start_remove (AddImageButton* self);
static gboolean _add_image_button_delete_tick_cb_gtk_tick_callback (GtkWidget* widget,
                                                             GdkFrameClock* frame_clock,
                                                             gpointer self);
VALA_EXTERN gchar* add_image_button_get_image_path (AddImageButton* self);
VALA_EXTERN const gchar* add_image_button_get_uuid (AddImageButton* self);
VALA_EXTERN const gchar* media_upload_get_id (MediaUpload* self);
VALA_EXTERN gint64 add_image_button_get_media_id (AddImageButton* self);
VALA_EXTERN gint64 media_upload_get_media_id (MediaUpload* self);
static GObject * add_image_button_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void add_image_button_finalize (GObject * obj);
static GType add_image_button_get_type_once (void);
static void _vala_add_image_button_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
add_image_button_get_instance_private (AddImageButton* self)
{
	return G_STRUCT_MEMBER_P (self, AddImageButton_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 42 "../src/widgets/AddImageButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 168 "AddImageButton.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 191 "AddImageButton.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 200 "AddImageButton.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 219 "AddImageButton.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 223 "AddImageButton.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 229 "AddImageButton.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 239 "AddImageButton.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 247 "AddImageButton.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 251 "AddImageButton.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 257 "AddImageButton.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 267 "AddImageButton.c"
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1171 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1172 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1172 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1174 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1174 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 289 "AddImageButton.c"
		gchar* _tmp2_;
#line 1175 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1175 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1175 "glib-2.0.vapi"
		return result;
#line 297 "AddImageButton.c"
	} else {
#line 1177 "glib-2.0.vapi"
		result = -1;
#line 1177 "glib-2.0.vapi"
		return result;
#line 303 "AddImageButton.c"
	}
}

AddImageButton*
add_image_button_construct (GType object_type,
                            MediaUpload* upload)
{
	AddImageButton * self = NULL;
	MediaUpload* _tmp0_;
	AtkObject* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 41 "../src/widgets/AddImageButton.vala"
	g_return_val_if_fail (upload != NULL, NULL);
#line 41 "../src/widgets/AddImageButton.vala"
	self = (AddImageButton*) g_object_new (object_type, NULL);
#line 42 "../src/widgets/AddImageButton.vala"
	_tmp0_ = _g_object_ref0 (upload);
#line 42 "../src/widgets/AddImageButton.vala"
	_g_object_unref0 (self->priv->_media_upload);
#line 42 "../src/widgets/AddImageButton.vala"
	self->priv->_media_upload = _tmp0_;
#line 43 "../src/widgets/AddImageButton.vala"
	_tmp1_ = gtk_widget_get_accessible ((GtkWidget*) self);
#line 43 "../src/widgets/AddImageButton.vala"
	_tmp2_ = media_upload_get_filepath (upload);
#line 43 "../src/widgets/AddImageButton.vala"
	_tmp3_ = _tmp2_;
#line 43 "../src/widgets/AddImageButton.vala"
	_tmp4_ = _tmp3_;
#line 43 "../src/widgets/AddImageButton.vala"
	_tmp5_ = media_upload_get_filepath (upload);
#line 43 "../src/widgets/AddImageButton.vala"
	_tmp6_ = _tmp5_;
#line 43 "../src/widgets/AddImageButton.vala"
	_tmp7_ = _tmp6_;
#line 43 "../src/widgets/AddImageButton.vala"
	_tmp8_ = string_substring (_tmp4_, (glong) (string_last_index_of_char (_tmp7_, (gunichar) '/', 0) + 1), (glong) -1);
#line 43 "../src/widgets/AddImageButton.vala"
	_tmp9_ = _tmp8_;
#line 43 "../src/widgets/AddImageButton.vala"
	atk_object_set_description (_tmp1_, _tmp9_);
#line 43 "../src/widgets/AddImageButton.vala"
	_g_free0 (_tmp9_);
#line 43 "../src/widgets/AddImageButton.vala"
	_g_free0 (_tmp7_);
#line 43 "../src/widgets/AddImageButton.vala"
	_g_free0 (_tmp4_);
#line 41 "../src/widgets/AddImageButton.vala"
	return self;
#line 360 "AddImageButton.c"
}

AddImageButton*
add_image_button_new (MediaUpload* upload)
{
#line 41 "../src/widgets/AddImageButton.vala"
	return add_image_button_construct (TYPE_ADD_IMAGE_BUTTON, upload);
#line 368 "AddImageButton.c"
}

void
add_image_button_get_draw_size (AddImageButton* self,
                                gint* width,
                                gint* height,
                                gdouble* scale)
{
	gint _vala_width = 0;
	gint _vala_height = 0;
	gdouble _vala_scale = 0.0;
	cairo_surface_t* _tmp0_;
	gdouble scale_x = 0.0;
	cairo_surface_t* _tmp1_;
	gdouble scale_y = 0.0;
	cairo_surface_t* _tmp2_;
	cairo_surface_t* _tmp3_;
	cairo_surface_t* _tmp4_;
#line 50 "../src/widgets/AddImageButton.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/widgets/AddImageButton.vala"
	_tmp0_ = self->surface;
#line 53 "../src/widgets/AddImageButton.vala"
	if (_tmp0_ == NULL) {
#line 54 "../src/widgets/AddImageButton.vala"
		_vala_width = 0;
#line 55 "../src/widgets/AddImageButton.vala"
		_vala_height = 0;
#line 56 "../src/widgets/AddImageButton.vala"
		_vala_scale = 0.0;
#line 57 "../src/widgets/AddImageButton.vala"
		if (width) {
#line 57 "../src/widgets/AddImageButton.vala"
			*width = _vala_width;
#line 403 "AddImageButton.c"
		}
#line 57 "../src/widgets/AddImageButton.vala"
		if (height) {
#line 57 "../src/widgets/AddImageButton.vala"
			*height = _vala_height;
#line 409 "AddImageButton.c"
		}
#line 57 "../src/widgets/AddImageButton.vala"
		if (scale) {
#line 57 "../src/widgets/AddImageButton.vala"
			*scale = _vala_scale;
#line 415 "AddImageButton.c"
		}
#line 57 "../src/widgets/AddImageButton.vala"
		return;
#line 419 "AddImageButton.c"
	}
#line 60 "../src/widgets/AddImageButton.vala"
	_vala_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 61 "../src/widgets/AddImageButton.vala"
	_vala_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 62 "../src/widgets/AddImageButton.vala"
	_tmp1_ = self->surface;
#line 62 "../src/widgets/AddImageButton.vala"
	scale_x = ((gdouble) _vala_width) / cairo_image_surface_get_width (_tmp1_);
#line 63 "../src/widgets/AddImageButton.vala"
	_tmp2_ = self->surface;
#line 63 "../src/widgets/AddImageButton.vala"
	scale_y = ((gdouble) _vala_height) / cairo_image_surface_get_height (_tmp2_);
#line 65 "../src/widgets/AddImageButton.vala"
	_vala_scale = MIN (MIN (scale_x, scale_y), 1.0) * self->priv->delete_factor;
#line 67 "../src/widgets/AddImageButton.vala"
	_tmp3_ = self->surface;
#line 67 "../src/widgets/AddImageButton.vala"
	_vala_width = (gint) (cairo_image_surface_get_width (_tmp3_) * _vala_scale);
#line 68 "../src/widgets/AddImageButton.vala"
	_tmp4_ = self->surface;
#line 68 "../src/widgets/AddImageButton.vala"
	_vala_height = (gint) (cairo_image_surface_get_height (_tmp4_) * _vala_scale);
#line 50 "../src/widgets/AddImageButton.vala"
	if (width) {
#line 50 "../src/widgets/AddImageButton.vala"
		*width = _vala_width;
#line 447 "AddImageButton.c"
	}
#line 50 "../src/widgets/AddImageButton.vala"
	if (height) {
#line 50 "../src/widgets/AddImageButton.vala"
		*height = _vala_height;
#line 453 "AddImageButton.c"
	}
#line 50 "../src/widgets/AddImageButton.vala"
	if (scale) {
#line 50 "../src/widgets/AddImageButton.vala"
		*scale = _vala_scale;
#line 459 "AddImageButton.c"
	}
}

static gboolean
add_image_button_real_draw (GtkWidget* base,
                            cairo_t* ct)
{
	AddImageButton * self;
	gint widget_width = 0;
	gint widget_height = 0;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	cairo_surface_t* _tmp2_;
	gboolean result;
#line 71 "../src/widgets/AddImageButton.vala"
	self = (AddImageButton*) base;
#line 71 "../src/widgets/AddImageButton.vala"
	g_return_val_if_fail (ct != NULL, FALSE);
#line 72 "../src/widgets/AddImageButton.vala"
	widget_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 73 "../src/widgets/AddImageButton.vala"
	widget_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 74 "../src/widgets/AddImageButton.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 74 "../src/widgets/AddImageButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 74 "../src/widgets/AddImageButton.vala"
	style_context = _tmp1_;
#line 77 "../src/widgets/AddImageButton.vala"
	_tmp2_ = self->surface;
#line 77 "../src/widgets/AddImageButton.vala"
	if (_tmp2_ != NULL) {
#line 493 "AddImageButton.c"
		gint draw_width = 0;
		gint draw_height = 0;
		gdouble scale = 0.0;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gdouble _tmp5_ = 0.0;
		gboolean _tmp6_ = FALSE;
		GtkStyleContext* _tmp8_;
#line 78 "../src/widgets/AddImageButton.vala"
		cairo_save (ct);
#line 79 "../src/widgets/AddImageButton.vala"
		cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) widget_width, (gdouble) widget_height);
#line 83 "../src/widgets/AddImageButton.vala"
		add_image_button_get_draw_size (self, &_tmp3_, &_tmp4_, &_tmp5_);
#line 83 "../src/widgets/AddImageButton.vala"
		draw_width = _tmp3_;
#line 83 "../src/widgets/AddImageButton.vala"
		draw_height = _tmp4_;
#line 83 "../src/widgets/AddImageButton.vala"
		scale = _tmp5_;
#line 85 "../src/widgets/AddImageButton.vala"
		if (draw_width > 0) {
#line 85 "../src/widgets/AddImageButton.vala"
			_tmp6_ = draw_height > 0;
#line 518 "AddImageButton.c"
		} else {
#line 85 "../src/widgets/AddImageButton.vala"
			_tmp6_ = FALSE;
#line 522 "AddImageButton.c"
		}
#line 85 "../src/widgets/AddImageButton.vala"
		if (_tmp6_) {
#line 526 "AddImageButton.c"
			cairo_surface_t* _tmp7_;
#line 86 "../src/widgets/AddImageButton.vala"
			cairo_scale (ct, scale, scale);
#line 87 "../src/widgets/AddImageButton.vala"
			_tmp7_ = self->surface;
#line 87 "../src/widgets/AddImageButton.vala"
			cairo_set_source_surface (ct, _tmp7_, ((widget_width - draw_width) / 2) / scale, ((widget_height - draw_height) / 2) / scale);
#line 88 "../src/widgets/AddImageButton.vala"
			cairo_fill (ct);
#line 536 "AddImageButton.c"
		}
#line 90 "../src/widgets/AddImageButton.vala"
		cairo_restore (ct);
#line 92 "../src/widgets/AddImageButton.vala"
		_tmp8_ = style_context;
#line 92 "../src/widgets/AddImageButton.vala"
		gtk_render_check (_tmp8_, ct, (widget_width / 2.0) - (ADD_IMAGE_BUTTON_ICON_SIZE / 2.0), (widget_height / 2.0) - (ADD_IMAGE_BUTTON_ICON_SIZE / 2.0), (gdouble) ADD_IMAGE_BUTTON_ICON_SIZE, (gdouble) ADD_IMAGE_BUTTON_ICON_SIZE);
#line 544 "AddImageButton.c"
	}
#line 99 "../src/widgets/AddImageButton.vala"
	result = GDK_EVENT_PROPAGATE;
#line 99 "../src/widgets/AddImageButton.vala"
	_g_object_unref0 (style_context);
#line 99 "../src/widgets/AddImageButton.vala"
	return result;
#line 552 "AddImageButton.c"
}

static GtkSizeRequestMode
add_image_button_real_get_request_mode (GtkWidget* base)
{
	AddImageButton * self;
	GtkSizeRequestMode result;
#line 102 "../src/widgets/AddImageButton.vala"
	self = (AddImageButton*) base;
#line 103 "../src/widgets/AddImageButton.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 103 "../src/widgets/AddImageButton.vala"
	return result;
#line 566 "AddImageButton.c"
}

static void
add_image_button_real_get_preferred_height_for_width (GtkWidget* base,
                                                      gint width,
                                                      gint* minimum,
                                                      gint* natural)
{
	AddImageButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_width = 0;
	gint media_height = 0;
	cairo_surface_t* _tmp0_;
	gdouble width_ratio = 0.0;
	gint height = 0;
#line 106 "../src/widgets/AddImageButton.vala"
	self = (AddImageButton*) base;
#line 112 "../src/widgets/AddImageButton.vala"
	_tmp0_ = self->surface;
#line 112 "../src/widgets/AddImageButton.vala"
	if (_tmp0_ == NULL) {
#line 113 "../src/widgets/AddImageButton.vala"
		media_width = ADD_IMAGE_BUTTON_MIN_WIDTH;
#line 114 "../src/widgets/AddImageButton.vala"
		media_height = ADD_IMAGE_BUTTON_MAX_HEIGHT;
#line 593 "AddImageButton.c"
	} else {
		cairo_surface_t* _tmp1_;
		cairo_surface_t* _tmp2_;
#line 116 "../src/widgets/AddImageButton.vala"
		_tmp1_ = self->surface;
#line 116 "../src/widgets/AddImageButton.vala"
		media_width = cairo_image_surface_get_width (_tmp1_);
#line 117 "../src/widgets/AddImageButton.vala"
		_tmp2_ = self->surface;
#line 117 "../src/widgets/AddImageButton.vala"
		media_height = cairo_image_surface_get_height (_tmp2_);
#line 605 "AddImageButton.c"
	}
#line 120 "../src/widgets/AddImageButton.vala"
	width_ratio = ((gdouble) width) / ((gdouble) media_width);
#line 121 "../src/widgets/AddImageButton.vala"
	height = MIN (media_height, (gint) (media_height * width_ratio));
#line 122 "../src/widgets/AddImageButton.vala"
	height = MIN (ADD_IMAGE_BUTTON_MAX_HEIGHT, height);
#line 123 "../src/widgets/AddImageButton.vala"
	_vala_minimum = ADD_IMAGE_BUTTON_MIN_HEIGHT;
#line 124 "../src/widgets/AddImageButton.vala"
	_vala_natural = MAX (_vala_minimum, (gint) (height * self->priv->delete_factor));
#line 106 "../src/widgets/AddImageButton.vala"
	if (minimum) {
#line 106 "../src/widgets/AddImageButton.vala"
		*minimum = _vala_minimum;
#line 621 "AddImageButton.c"
	}
#line 106 "../src/widgets/AddImageButton.vala"
	if (natural) {
#line 106 "../src/widgets/AddImageButton.vala"
		*natural = _vala_natural;
#line 627 "AddImageButton.c"
	}
}

static void
add_image_button_real_get_preferred_width_for_height (GtkWidget* base,
                                                      gint height,
                                                      gint* minimum,
                                                      gint* natural)
{
	AddImageButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_width = 0;
	gint media_height = 0;
	cairo_surface_t* _tmp0_;
	gdouble height_ratio = 0.0;
	gint width = 0;
#line 127 "../src/widgets/AddImageButton.vala"
	self = (AddImageButton*) base;
#line 133 "../src/widgets/AddImageButton.vala"
	_tmp0_ = self->surface;
#line 133 "../src/widgets/AddImageButton.vala"
	if (_tmp0_ == NULL) {
#line 134 "../src/widgets/AddImageButton.vala"
		media_width = ADD_IMAGE_BUTTON_MIN_WIDTH;
#line 135 "../src/widgets/AddImageButton.vala"
		media_height = ADD_IMAGE_BUTTON_MAX_HEIGHT;
#line 655 "AddImageButton.c"
	} else {
		cairo_surface_t* _tmp1_;
		cairo_surface_t* _tmp2_;
#line 137 "../src/widgets/AddImageButton.vala"
		_tmp1_ = self->surface;
#line 137 "../src/widgets/AddImageButton.vala"
		media_width = cairo_image_surface_get_width (_tmp1_);
#line 138 "../src/widgets/AddImageButton.vala"
		_tmp2_ = self->surface;
#line 138 "../src/widgets/AddImageButton.vala"
		media_height = cairo_image_surface_get_height (_tmp2_);
#line 667 "AddImageButton.c"
	}
#line 141 "../src/widgets/AddImageButton.vala"
	height_ratio = ((gdouble) height) / ((gdouble) media_height);
#line 142 "../src/widgets/AddImageButton.vala"
	width = MIN (media_width, (gint) (media_width * height_ratio));
#line 143 "../src/widgets/AddImageButton.vala"
	width = MAX (ADD_IMAGE_BUTTON_MIN_WIDTH, width);
#line 144 "../src/widgets/AddImageButton.vala"
	_vala_natural = (gint) (width * self->priv->delete_factor);
#line 144 "../src/widgets/AddImageButton.vala"
	_vala_minimum = _vala_natural;
#line 127 "../src/widgets/AddImageButton.vala"
	if (minimum) {
#line 127 "../src/widgets/AddImageButton.vala"
		*minimum = _vala_minimum;
#line 683 "AddImageButton.c"
	}
#line 127 "../src/widgets/AddImageButton.vala"
	if (natural) {
#line 127 "../src/widgets/AddImageButton.vala"
		*natural = _vala_natural;
#line 689 "AddImageButton.c"
	}
}

static void
add_image_button_real_get_preferred_width (GtkWidget* base,
                                           gint* minimum,
                                           gint* natural)
{
	AddImageButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_width = 0;
	cairo_surface_t* _tmp0_;
#line 147 "../src/widgets/AddImageButton.vala"
	self = (AddImageButton*) base;
#line 150 "../src/widgets/AddImageButton.vala"
	_tmp0_ = self->surface;
#line 150 "../src/widgets/AddImageButton.vala"
	if (_tmp0_ == NULL) {
#line 151 "../src/widgets/AddImageButton.vala"
		media_width = 1;
#line 711 "AddImageButton.c"
	} else {
		cairo_surface_t* _tmp1_;
#line 153 "../src/widgets/AddImageButton.vala"
		_tmp1_ = self->surface;
#line 153 "../src/widgets/AddImageButton.vala"
		media_width = cairo_image_surface_get_width (_tmp1_);
#line 718 "AddImageButton.c"
	}
#line 156 "../src/widgets/AddImageButton.vala"
	_vala_minimum = (gint) (MIN (media_width, ADD_IMAGE_BUTTON_MIN_WIDTH) * self->priv->delete_factor);
#line 157 "../src/widgets/AddImageButton.vala"
	_vala_natural = (gint) (media_width * self->priv->delete_factor);
#line 147 "../src/widgets/AddImageButton.vala"
	if (minimum) {
#line 147 "../src/widgets/AddImageButton.vala"
		*minimum = _vala_minimum;
#line 728 "AddImageButton.c"
	}
#line 147 "../src/widgets/AddImageButton.vala"
	if (natural) {
#line 147 "../src/widgets/AddImageButton.vala"
		*natural = _vala_natural;
#line 734 "AddImageButton.c"
	}
}

static void
add_image_button_real_get_preferred_height (GtkWidget* base,
                                            gint* minimum,
                                            gint* natural)
{
	AddImageButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_height = 0;
	cairo_surface_t* _tmp0_;
#line 160 "../src/widgets/AddImageButton.vala"
	self = (AddImageButton*) base;
#line 163 "../src/widgets/AddImageButton.vala"
	_tmp0_ = self->surface;
#line 163 "../src/widgets/AddImageButton.vala"
	if (_tmp0_ == NULL) {
#line 164 "../src/widgets/AddImageButton.vala"
		media_height = 1;
#line 756 "AddImageButton.c"
	} else {
		cairo_surface_t* _tmp1_;
#line 166 "../src/widgets/AddImageButton.vala"
		_tmp1_ = self->surface;
#line 166 "../src/widgets/AddImageButton.vala"
		media_height = cairo_image_surface_get_height (_tmp1_);
#line 763 "AddImageButton.c"
	}
#line 169 "../src/widgets/AddImageButton.vala"
	_vala_minimum = (gint) (MIN (media_height, ADD_IMAGE_BUTTON_MIN_HEIGHT) * self->priv->delete_factor);
#line 170 "../src/widgets/AddImageButton.vala"
	_vala_natural = (gint) (media_height * self->priv->delete_factor);
#line 160 "../src/widgets/AddImageButton.vala"
	if (minimum) {
#line 160 "../src/widgets/AddImageButton.vala"
		*minimum = _vala_minimum;
#line 773 "AddImageButton.c"
	}
#line 160 "../src/widgets/AddImageButton.vala"
	if (natural) {
#line 160 "../src/widgets/AddImageButton.vala"
		*natural = _vala_natural;
#line 779 "AddImageButton.c"
	}
}

static gboolean
add_image_button_delete_tick_cb (AddImageButton* self,
                                 GtkWidget* widget,
                                 GdkFrameClock* frame_clock)
{
	guint64 now = 0ULL;
	gdouble t = 0.0;
	gboolean result;
#line 173 "../src/widgets/AddImageButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 173 "../src/widgets/AddImageButton.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 173 "../src/widgets/AddImageButton.vala"
	g_return_val_if_fail (frame_clock != NULL, FALSE);
#line 175 "../src/widgets/AddImageButton.vala"
	now = (guint64) gdk_frame_clock_get_frame_time (frame_clock);
#line 177 "../src/widgets/AddImageButton.vala"
	t = (now - self->priv->delete_transition_start) / ((gdouble) (TRANSITION_DURATION * 1));
#line 179 "../src/widgets/AddImageButton.vala"
	t = ease_out_cubic (t);
#line 180 "../src/widgets/AddImageButton.vala"
	self->priv->delete_factor = 1.0 - t;
#line 181 "../src/widgets/AddImageButton.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 183 "../src/widgets/AddImageButton.vala"
	if (t >= 1.0) {
#line 184 "../src/widgets/AddImageButton.vala"
		self->priv->delete_factor = 1.0;
#line 185 "../src/widgets/AddImageButton.vala"
		g_signal_emit (self, add_image_button_signals[ADD_IMAGE_BUTTON_DELETED_SIGNAL], 0);
#line 186 "../src/widgets/AddImageButton.vala"
		result = G_SOURCE_REMOVE;
#line 186 "../src/widgets/AddImageButton.vala"
		return result;
#line 817 "AddImageButton.c"
	}
#line 189 "../src/widgets/AddImageButton.vala"
	result = G_SOURCE_CONTINUE;
#line 189 "../src/widgets/AddImageButton.vala"
	return result;
#line 823 "AddImageButton.c"
}

static gboolean
_add_image_button_delete_tick_cb_gtk_tick_callback (GtkWidget* widget,
                                                    GdkFrameClock* frame_clock,
                                                    gpointer self)
{
	gboolean result;
	result = add_image_button_delete_tick_cb ((AddImageButton*) self, widget, frame_clock);
#line 196 "../src/widgets/AddImageButton.vala"
	return result;
#line 835 "AddImageButton.c"
}

void
add_image_button_start_remove (AddImageButton* self)
{
	GdkFrameClock* _tmp0_;
#line 192 "../src/widgets/AddImageButton.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/widgets/AddImageButton.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
#line 193 "../src/widgets/AddImageButton.vala"
		return;
#line 848 "AddImageButton.c"
	}
#line 195 "../src/widgets/AddImageButton.vala"
	_tmp0_ = gtk_widget_get_frame_clock ((GtkWidget*) self);
#line 195 "../src/widgets/AddImageButton.vala"
	self->priv->delete_transition_start = (guint64) gdk_frame_clock_get_frame_time (_tmp0_);
#line 196 "../src/widgets/AddImageButton.vala"
	gtk_widget_add_tick_callback ((GtkWidget*) self, _add_image_button_delete_tick_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 856 "AddImageButton.c"
}

gchar*
add_image_button_get_image_path (AddImageButton* self)
{
	gchar* result;
	MediaUpload* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 25 "../src/widgets/AddImageButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/widgets/AddImageButton.vala"
	_tmp0_ = self->priv->_media_upload;
#line 25 "../src/widgets/AddImageButton.vala"
	_tmp1_ = media_upload_get_filepath (_tmp0_);
#line 25 "../src/widgets/AddImageButton.vala"
	_tmp2_ = _tmp1_;
#line 25 "../src/widgets/AddImageButton.vala"
	result = _tmp2_;
#line 25 "../src/widgets/AddImageButton.vala"
	return result;
#line 878 "AddImageButton.c"
}

const gchar*
add_image_button_get_uuid (AddImageButton* self)
{
	const gchar* result;
	MediaUpload* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 28 "../src/widgets/AddImageButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/widgets/AddImageButton.vala"
	_tmp0_ = self->priv->_media_upload;
#line 28 "../src/widgets/AddImageButton.vala"
	_tmp1_ = media_upload_get_id (_tmp0_);
#line 28 "../src/widgets/AddImageButton.vala"
	_tmp2_ = _tmp1_;
#line 28 "../src/widgets/AddImageButton.vala"
	result = _tmp2_;
#line 28 "../src/widgets/AddImageButton.vala"
	return result;
#line 900 "AddImageButton.c"
}

gint64
add_image_button_get_media_id (AddImageButton* self)
{
	gint64 result;
	MediaUpload* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
#line 31 "../src/widgets/AddImageButton.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 31 "../src/widgets/AddImageButton.vala"
	_tmp0_ = self->priv->_media_upload;
#line 31 "../src/widgets/AddImageButton.vala"
	_tmp1_ = media_upload_get_media_id (_tmp0_);
#line 31 "../src/widgets/AddImageButton.vala"
	_tmp2_ = _tmp1_;
#line 31 "../src/widgets/AddImageButton.vala"
	result = _tmp2_;
#line 31 "../src/widgets/AddImageButton.vala"
	return result;
#line 922 "AddImageButton.c"
}

static GObject *
add_image_button_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AddImageButton * self;
#line 46 "../src/widgets/AddImageButton.vala"
	parent_class = G_OBJECT_CLASS (add_image_button_parent_class);
#line 46 "../src/widgets/AddImageButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 46 "../src/widgets/AddImageButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADD_IMAGE_BUTTON, AddImageButton);
#line 47 "../src/widgets/AddImageButton.vala"
	gtk_widget_set_has_window ((GtkWidget*) self, FALSE);
#line 46 "../src/widgets/AddImageButton.vala"
	return obj;
#line 943 "AddImageButton.c"
}

static void
add_image_button_class_init (AddImageButtonClass * klass,
                             gpointer klass_data)
{
#line 18 "../src/widgets/AddImageButton.vala"
	add_image_button_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/AddImageButton.vala"
	g_type_class_adjust_private_offset (klass, &AddImageButton_private_offset);
#line 18 "../src/widgets/AddImageButton.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) add_image_button_real_draw;
#line 18 "../src/widgets/AddImageButton.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) add_image_button_real_get_request_mode;
#line 18 "../src/widgets/AddImageButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) add_image_button_real_get_preferred_height_for_width;
#line 18 "../src/widgets/AddImageButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_width_for_height = (void (*) (GtkWidget*, gint, gint*, gint*)) add_image_button_real_get_preferred_width_for_height;
#line 18 "../src/widgets/AddImageButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) add_image_button_real_get_preferred_width;
#line 18 "../src/widgets/AddImageButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) add_image_button_real_get_preferred_height;
#line 18 "../src/widgets/AddImageButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_add_image_button_get_property;
#line 18 "../src/widgets/AddImageButton.vala"
	G_OBJECT_CLASS (klass)->constructor = add_image_button_constructor;
#line 18 "../src/widgets/AddImageButton.vala"
	G_OBJECT_CLASS (klass)->finalize = add_image_button_finalize;
#line 18 "../src/widgets/AddImageButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_IMAGE_BUTTON_IMAGE_PATH_PROPERTY, add_image_button_properties[ADD_IMAGE_BUTTON_IMAGE_PATH_PROPERTY] = g_param_spec_string ("image-path", "image-path", "image-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/widgets/AddImageButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_IMAGE_BUTTON_UUID_PROPERTY, add_image_button_properties[ADD_IMAGE_BUTTON_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/widgets/AddImageButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_IMAGE_BUTTON_MEDIA_ID_PROPERTY, add_image_button_properties[ADD_IMAGE_BUTTON_MEDIA_ID_PROPERTY] = g_param_spec_int64 ("media-id", "media-id", "media-id", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/widgets/AddImageButton.vala"
	add_image_button_signals[ADD_IMAGE_BUTTON_DELETED_SIGNAL] = g_signal_new ("deleted", TYPE_ADD_IMAGE_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 980 "AddImageButton.c"
}

static void
add_image_button_instance_init (AddImageButton * self,
                                gpointer klass)
{
	gchar* _tmp0_;
#line 18 "../src/widgets/AddImageButton.vala"
	self->priv = add_image_button_get_instance_private (self);
#line 33 "../src/widgets/AddImageButton.vala"
	_tmp0_ = g_strdup ("");
#line 33 "../src/widgets/AddImageButton.vala"
	self->description = _tmp0_;
#line 38 "../src/widgets/AddImageButton.vala"
	self->priv->delete_factor = 1.0;
#line 996 "AddImageButton.c"
}

static void
add_image_button_finalize (GObject * obj)
{
	AddImageButton * self;
#line 18 "../src/widgets/AddImageButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADD_IMAGE_BUTTON, AddImageButton);
#line 23 "../src/widgets/AddImageButton.vala"
	_g_object_unref0 (self->priv->_media_upload);
#line 33 "../src/widgets/AddImageButton.vala"
	_g_free0 (self->description);
#line 34 "../src/widgets/AddImageButton.vala"
	_cairo_surface_destroy0 (self->surface);
#line 18 "../src/widgets/AddImageButton.vala"
	G_OBJECT_CLASS (add_image_button_parent_class)->finalize (obj);
#line 1013 "AddImageButton.c"
}

static GType
add_image_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AddImageButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) add_image_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AddImageButton), 0, (GInstanceInitFunc) add_image_button_instance_init, NULL };
	GType add_image_button_type_id;
	add_image_button_type_id = g_type_register_static (gtk_button_get_type (), "AddImageButton", &g_define_type_info, 0);
	AddImageButton_private_offset = g_type_add_instance_private (add_image_button_type_id, sizeof (AddImageButtonPrivate));
	return add_image_button_type_id;
}

GType
add_image_button_get_type (void)
{
	static volatile gsize add_image_button_type_id__once = 0;
	if (g_once_init_enter (&add_image_button_type_id__once)) {
		GType add_image_button_type_id;
		add_image_button_type_id = add_image_button_get_type_once ();
		g_once_init_leave (&add_image_button_type_id__once, add_image_button_type_id);
	}
	return add_image_button_type_id__once;
}

static void
_vala_add_image_button_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	AddImageButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ADD_IMAGE_BUTTON, AddImageButton);
#line 18 "../src/widgets/AddImageButton.vala"
	switch (property_id) {
#line 18 "../src/widgets/AddImageButton.vala"
		case ADD_IMAGE_BUTTON_IMAGE_PATH_PROPERTY:
#line 18 "../src/widgets/AddImageButton.vala"
		g_value_take_string (value, add_image_button_get_image_path (self));
#line 18 "../src/widgets/AddImageButton.vala"
		break;
#line 18 "../src/widgets/AddImageButton.vala"
		case ADD_IMAGE_BUTTON_UUID_PROPERTY:
#line 18 "../src/widgets/AddImageButton.vala"
		g_value_set_string (value, add_image_button_get_uuid (self));
#line 18 "../src/widgets/AddImageButton.vala"
		break;
#line 18 "../src/widgets/AddImageButton.vala"
		case ADD_IMAGE_BUTTON_MEDIA_ID_PROPERTY:
#line 18 "../src/widgets/AddImageButton.vala"
		g_value_set_int64 (value, add_image_button_get_media_id (self));
#line 18 "../src/widgets/AddImageButton.vala"
		break;
#line 1066 "AddImageButton.c"
		default:
#line 18 "../src/widgets/AddImageButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/AddImageButton.vala"
		break;
#line 1072 "AddImageButton.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

