/* CompletionTextView.c generated by valac 0.56.15, the Vala compiler
 * generated from CompletionTextView.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include "CbUserCompletionModel.h"
#include "cawbird.h"
#include "CbUtils.h"
#include "CbSnippetManager.h"
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include "libtl/libtweetlength.h"
#include "CbUserCounter.h"
#include <sqlite3.h>
#include <rest/oauth-proxy.h>
#include <rest/rest-proxy.h>
#include "CbTypes.h"
#include <glib/gi18n-lib.h>
#include <gspell/gspell.h>
#include <pango/pango.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define COMPLETION_TEXT_VIEW_NO_SPELL_CHECK "gtksourceview:context-classes:no-spell-check"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_COMPLETION_TEXT_VIEW (completion_text_view_get_type ())
#define COMPLETION_TEXT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETION_TEXT_VIEW, CompletionTextView))
#define COMPLETION_TEXT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETION_TEXT_VIEW, CompletionTextViewClass))
#define IS_COMPLETION_TEXT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETION_TEXT_VIEW))
#define IS_COMPLETION_TEXT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETION_TEXT_VIEW))
#define COMPLETION_TEXT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETION_TEXT_VIEW, CompletionTextViewClass))

typedef struct _CompletionTextView CompletionTextView;
typedef struct _CompletionTextViewClass CompletionTextViewClass;
typedef struct _CompletionTextViewPrivate CompletionTextViewPrivate;
enum  {
	COMPLETION_TEXT_VIEW_0_PROPERTY,
	COMPLETION_TEXT_VIEW_COMPLETION_LISTBOX_PROPERTY,
	COMPLETION_TEXT_VIEW_NUM_PROPERTIES
};
static GParamSpec* completion_text_view_properties[COMPLETION_TEXT_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_USER_COMPLETION_ROW (user_completion_row_get_type ())
#define USER_COMPLETION_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_COMPLETION_ROW, UserCompletionRow))
#define USER_COMPLETION_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_COMPLETION_ROW, UserCompletionRowClass))
#define IS_USER_COMPLETION_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_COMPLETION_ROW))
#define IS_USER_COMPLETION_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_COMPLETION_ROW))
#define USER_COMPLETION_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_COMPLETION_ROW, UserCompletionRowClass))

typedef struct _UserCompletionRow UserCompletionRow;
typedef struct _UserCompletionRowClass UserCompletionRowClass;
#define __vala_GtkTextIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTextIter_free (var), NULL)))
typedef struct _Block80Data Block80Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	COMPLETION_TEXT_VIEW_SHOW_COMPLETION_SIGNAL,
	COMPLETION_TEXT_VIEW_HIDE_COMPLETION_SIGNAL,
	COMPLETION_TEXT_VIEW_UPDATE_COMPLETION_SIGNAL,
	COMPLETION_TEXT_VIEW_NUM_SIGNALS
};
static guint completion_text_view_signals[COMPLETION_TEXT_VIEW_NUM_SIGNALS] = {0};
typedef struct _UserCompletionRowPrivate UserCompletionRowPrivate;
enum  {
	USER_COMPLETION_ROW_0_PROPERTY,
	USER_COMPLETION_ROW_NUM_PROPERTIES
};
static GParamSpec* user_completion_row_properties[USER_COMPLETION_ROW_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _CompletionTextView {
	GtkTextView parent_instance;
	CompletionTextViewPrivate * priv;
};

struct _CompletionTextViewClass {
	GtkTextViewClass parent_class;
};

struct _CompletionTextViewPrivate {
	GtkWindow* completion_window;
	gchar* current_word;
	GCancellable* completion_cancellable;
	gboolean _default_listbox;
	GtkListBox* completion_list;
	CbUserCompletionModel* completion_model;
	Account* account;
};

struct _Block80Data {
	int _ref_count_;
	CompletionTextView* self;
	gboolean corpus_was_empty;
};

struct _UserCompletionRow {
	GtkListBoxRow parent_instance;
	UserCompletionRowPrivate * priv;
};

struct _UserCompletionRowClass {
	GtkListBoxRowClass parent_class;
};

struct _UserCompletionRowPrivate {
	GtkLabel* user_name_label;
	GtkLabel* screen_name_label;
};

static gint CompletionTextView_private_offset;
static gpointer completion_text_view_parent_class = NULL;
static gint UserCompletionRow_private_offset;
static gpointer user_completion_row_parent_class = NULL;
static cairo_surface_t* user_completion_row_verified_surface;
static cairo_surface_t* user_completion_row_verified_surface = NULL;
static cairo_surface_t* user_completion_row_protected_account_surface;
static cairo_surface_t* user_completion_row_protected_account_surface = NULL;

VALA_EXTERN GType completion_text_view_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void completion_text_view_set_account (CompletionTextView* self,
                                       Account* account);
static gboolean completion_text_view_insert_snippet (CompletionTextView* self);
static inline gboolean completion_text_view_snippets_configured (CompletionTextView* self);
static void completion_text_view_select_completion_row (CompletionTextView* self,
                                                 GtkListBoxRow* row);
static gboolean completion_text_view_key_press_event_cb (CompletionTextView* self,
                                                  GdkEventKey* evt);
static void completion_text_view_insert_user_completion (CompletionTextView* self);
static void completion_text_view_hide_completion_window (CompletionTextView* self);
VALA_EXTERN GType user_completion_row_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* user_completion_row_get_screen_name (UserCompletionRow* self);
static void completion_text_view_buffer_changed_cb (CompletionTextView* self);
static void _vala_GtkTextIter_free (GtkTextIter* self);
static GtkTextIter* _vala_GtkTextIter_copy (GtkTextIter* self);
static void completion_text_view_show_completion_window (CompletionTextView* self);
static gboolean completion_text_view_completion_window_focus_out_cb (CompletionTextView* self);
static void completion_text_view_update_completion_listbox (CompletionTextView* self);
static Block80Data* block80_data_ref (Block80Data* _data80_);
static void block80_data_unref (void * _userdata_);
static void _vala_CbUserInfo_array_free (CbUserInfo * array,
                                  gssize array_length);
static void ____lambda43_ (Block80Data* _data80_,
                    GObject* obj,
                    GAsyncResult* res);
static void _vala_CbUserIdentity_array_free (CbUserIdentity * array,
                                      gssize array_length);
static void _____lambda43__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static GtkWidget* completion_text_view_create_completion_row (CompletionTextView* self,
                                                       void* id_ptr);
VALA_EXTERN UserCompletionRow* user_completion_row_new (gint64 id,
                                            const gchar* user_name,
                                            const gchar* screen_name,
                                            gboolean verified,
                                            gboolean protected_account);
VALA_EXTERN UserCompletionRow* user_completion_row_construct (GType object_type,
                                                  gint64 id,
                                                  const gchar* user_name,
                                                  const gchar* screen_name,
                                                  gboolean verified,
                                                  gboolean protected_account);
VALA_EXTERN CompletionTextView* completion_text_view_new (void);
VALA_EXTERN CompletionTextView* completion_text_view_construct (GType object_type);
VALA_EXTERN void completion_text_view_set_completion_listbox (CompletionTextView* self,
                                                  GtkListBox* value);
static void _completion_text_view_insert_user_completion_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                              GtkListBoxRow* row,
                                                                              gpointer self);
static GtkWidget* _completion_text_view_create_completion_row_cbutils_createwidgetfunc (void* item,
                                                                                 gpointer self);
static GObject * completion_text_view_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static gboolean _completion_text_view_completion_window_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                          GdkEventFocus* event,
                                                                                          gpointer self);
static void _completion_text_view_update_completion_listbox_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self);
static void _completion_text_view_buffer_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                      gpointer self);
static gboolean _completion_text_view_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                              GdkEventKey* event,
                                                                              gpointer self);
static void completion_text_view_finalize (GObject * obj);
static GType completion_text_view_get_type_once (void);
static void _vala_completion_text_view_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void user_completion_row_finalize (GObject * obj);
static GType user_completion_row_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gchar* COMPLETION_TEXT_VIEW_TEXT_TAGS[4] = {"link", "mention", "hashtag", "snippet"};

static inline gpointer
completion_text_view_get_instance_private (CompletionTextView* self)
{
	return G_STRUCT_MEMBER_P (self, CompletionTextView_private_offset);
}

void
completion_text_view_set_account (CompletionTextView* self,
                                  Account* account)
{
#line 132 "../src/widgets/CompletionTextView.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/widgets/CompletionTextView.vala"
	g_return_if_fail (account != NULL);
#line 133 "../src/widgets/CompletionTextView.vala"
	self->priv->account = account;
#line 252 "CompletionTextView.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 273 "CompletionTextView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 153 "../src/widgets/CompletionTextView.vala"
	return self ? g_object_ref (self) : NULL;
#line 281 "CompletionTextView.c"
}

static gboolean
completion_text_view_insert_snippet (CompletionTextView* self)
{
	GtkTextIter cursor_word_start = {0};
	GtkTextIter cursor_word_end = {0};
	gchar* cursor_word = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextIter _tmp3_ = {0};
	gchar* _tmp4_;
	gchar* snippet = NULL;
	CbSnippetManager* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	GtkTextIter start_word_iter = {0};
	GtkTextBuffer* _tmp14_;
	GtkTextBuffer* _tmp15_;
	GtkTextBuffer* _tmp16_;
	GtkTextBuffer* _tmp17_;
	GtkTextIter _tmp18_;
	GtkTextIter _tmp19_;
	GtkTextMark* cursor_mark = NULL;
	GtkTextBuffer* _tmp20_;
	GtkTextBuffer* _tmp21_;
	GtkTextMark* _tmp22_;
	GtkTextMark* _tmp23_;
	GtkTextBuffer* _tmp24_;
	GtkTextBuffer* _tmp25_;
	GtkTextMark* _tmp26_;
	GtkTextIter _tmp27_ = {0};
	GtkTextBuffer* _tmp28_;
	GtkTextBuffer* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	GtkTextBuffer* _tmp34_;
	GtkTextBuffer* _tmp35_;
	gboolean result;
#line 136 "../src/widgets/CompletionTextView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 139 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 139 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = _tmp0_;
#line 139 "../src/widgets/CompletionTextView.vala"
	_tmp4_ = utils_get_cursor_word (_tmp1_, &_tmp2_, &_tmp3_);
#line 139 "../src/widgets/CompletionTextView.vala"
	cursor_word_start = _tmp2_;
#line 139 "../src/widgets/CompletionTextView.vala"
	cursor_word_end = _tmp3_;
#line 139 "../src/widgets/CompletionTextView.vala"
	cursor_word = _tmp4_;
#line 141 "../src/widgets/CompletionTextView.vala"
	_tmp5_ = cawbird_snippet_manager;
#line 141 "../src/widgets/CompletionTextView.vala"
	_tmp6_ = cursor_word;
#line 141 "../src/widgets/CompletionTextView.vala"
	_tmp7_ = string_strip (_tmp6_);
#line 141 "../src/widgets/CompletionTextView.vala"
	_tmp8_ = _tmp7_;
#line 141 "../src/widgets/CompletionTextView.vala"
	_tmp9_ = cb_snippet_manager_get_snippet (_tmp5_, _tmp8_);
#line 141 "../src/widgets/CompletionTextView.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 141 "../src/widgets/CompletionTextView.vala"
	_tmp11_ = _tmp10_;
#line 141 "../src/widgets/CompletionTextView.vala"
	_g_free0 (_tmp8_);
#line 141 "../src/widgets/CompletionTextView.vala"
	snippet = _tmp11_;
#line 143 "../src/widgets/CompletionTextView.vala"
	_tmp12_ = snippet;
#line 143 "../src/widgets/CompletionTextView.vala"
	if (_tmp12_ == NULL) {
#line 365 "CompletionTextView.c"
		const gchar* _tmp13_;
#line 144 "../src/widgets/CompletionTextView.vala"
		_tmp13_ = cursor_word;
#line 144 "../src/widgets/CompletionTextView.vala"
		g_debug ("CompletionTextView.vala:144: No snippet for cursor_word '%s' found.", _tmp13_);
#line 145 "../src/widgets/CompletionTextView.vala"
		result = FALSE;
#line 145 "../src/widgets/CompletionTextView.vala"
		_g_free0 (snippet);
#line 145 "../src/widgets/CompletionTextView.vala"
		_g_free0 (cursor_word);
#line 145 "../src/widgets/CompletionTextView.vala"
		return result;
#line 379 "CompletionTextView.c"
	}
#line 150 "../src/widgets/CompletionTextView.vala"
	_tmp14_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 150 "../src/widgets/CompletionTextView.vala"
	_tmp15_ = _tmp14_;
#line 150 "../src/widgets/CompletionTextView.vala"
	g_object_freeze_notify ((GObject*) _tmp15_);
#line 151 "../src/widgets/CompletionTextView.vala"
	_tmp16_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 151 "../src/widgets/CompletionTextView.vala"
	_tmp17_ = _tmp16_;
#line 151 "../src/widgets/CompletionTextView.vala"
	_tmp18_ = cursor_word_start;
#line 151 "../src/widgets/CompletionTextView.vala"
	_tmp19_ = cursor_word_end;
#line 151 "../src/widgets/CompletionTextView.vala"
	g_signal_emit_by_name (_tmp17_, "delete-range", &_tmp18_, &_tmp19_);
#line 153 "../src/widgets/CompletionTextView.vala"
	_tmp20_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 153 "../src/widgets/CompletionTextView.vala"
	_tmp21_ = _tmp20_;
#line 153 "../src/widgets/CompletionTextView.vala"
	_tmp22_ = gtk_text_buffer_get_insert (_tmp21_);
#line 153 "../src/widgets/CompletionTextView.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 153 "../src/widgets/CompletionTextView.vala"
	cursor_mark = _tmp23_;
#line 154 "../src/widgets/CompletionTextView.vala"
	_tmp24_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 154 "../src/widgets/CompletionTextView.vala"
	_tmp25_ = _tmp24_;
#line 154 "../src/widgets/CompletionTextView.vala"
	_tmp26_ = cursor_mark;
#line 154 "../src/widgets/CompletionTextView.vala"
	gtk_text_buffer_get_iter_at_mark (_tmp25_, &_tmp27_, _tmp26_);
#line 154 "../src/widgets/CompletionTextView.vala"
	start_word_iter = _tmp27_;
#line 156 "../src/widgets/CompletionTextView.vala"
	_tmp28_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 156 "../src/widgets/CompletionTextView.vala"
	_tmp29_ = _tmp28_;
#line 156 "../src/widgets/CompletionTextView.vala"
	_tmp30_ = snippet;
#line 156 "../src/widgets/CompletionTextView.vala"
	_tmp31_ = snippet;
#line 156 "../src/widgets/CompletionTextView.vala"
	_tmp32_ = strlen (_tmp31_);
#line 156 "../src/widgets/CompletionTextView.vala"
	_tmp33_ = _tmp32_;
#line 156 "../src/widgets/CompletionTextView.vala"
	g_signal_emit_by_name (_tmp29_, "insert-text", &start_word_iter, _tmp30_, _tmp33_);
#line 157 "../src/widgets/CompletionTextView.vala"
	_tmp34_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 157 "../src/widgets/CompletionTextView.vala"
	_tmp35_ = _tmp34_;
#line 157 "../src/widgets/CompletionTextView.vala"
	g_object_thaw_notify ((GObject*) _tmp35_);
#line 159 "../src/widgets/CompletionTextView.vala"
	result = TRUE;
#line 159 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (cursor_mark);
#line 159 "../src/widgets/CompletionTextView.vala"
	_g_free0 (snippet);
#line 159 "../src/widgets/CompletionTextView.vala"
	_g_free0 (cursor_word);
#line 159 "../src/widgets/CompletionTextView.vala"
	return result;
#line 447 "CompletionTextView.c"
}

static inline gboolean
completion_text_view_snippets_configured (CompletionTextView* self)
{
	CbSnippetManager* _tmp0_;
	gboolean result;
#line 162 "../src/widgets/CompletionTextView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = cawbird_snippet_manager;
#line 163 "../src/widgets/CompletionTextView.vala"
	result = cb_snippet_manager_n_snippets (_tmp0_) > ((guint) 0);
#line 163 "../src/widgets/CompletionTextView.vala"
	return result;
#line 463 "CompletionTextView.c"
}

static void
completion_text_view_select_completion_row (CompletionTextView* self,
                                            GtkListBoxRow* row)
{
	GtkContainer* _tmp0_;
	GtkListBox* _tmp1_;
	GtkAllocation alloc = {0};
	GtkAllocation _tmp2_ = {0};
	GtkListBox* _tmp3_;
	GtkViewport* viewport = NULL;
	GtkListBox* _tmp4_;
	GtkContainer* _tmp5_;
	GtkViewport* _tmp6_;
	GtkViewport* _tmp7_;
	GtkScrolledWindow* scroller = NULL;
	GtkViewport* _tmp8_;
	GtkContainer* _tmp9_;
	GtkScrolledWindow* _tmp10_;
	GtkScrolledWindow* _tmp11_;
#line 166 "../src/widgets/CompletionTextView.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/widgets/CompletionTextView.vala"
	if (row == NULL) {
#line 168 "../src/widgets/CompletionTextView.vala"
		return;
#line 491 "CompletionTextView.c"
	}
#line 170 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) row);
#line 170 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = self->priv->completion_list;
#line 170 "../src/widgets/CompletionTextView.vala"
	_vala_assert (_tmp0_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_container_get_type (), GtkContainer), "row.get_parent () == completion_list");
#line 173 "../src/widgets/CompletionTextView.vala"
	gtk_widget_get_allocation ((GtkWidget*) row, &_tmp2_);
#line 173 "../src/widgets/CompletionTextView.vala"
	alloc = _tmp2_;
#line 175 "../src/widgets/CompletionTextView.vala"
	_tmp3_ = self->priv->completion_list;
#line 175 "../src/widgets/CompletionTextView.vala"
	gtk_list_box_select_row (_tmp3_, row);
#line 177 "../src/widgets/CompletionTextView.vala"
	_tmp4_ = self->priv->completion_list;
#line 177 "../src/widgets/CompletionTextView.vala"
	_tmp5_ = gtk_widget_get_parent ((GtkWidget*) _tmp4_);
#line 177 "../src/widgets/CompletionTextView.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_viewport_get_type ()) ? ((GtkViewport*) _tmp5_) : NULL);
#line 177 "../src/widgets/CompletionTextView.vala"
	viewport = _tmp6_;
#line 179 "../src/widgets/CompletionTextView.vala"
	_tmp7_ = viewport;
#line 179 "../src/widgets/CompletionTextView.vala"
	if (_tmp7_ == NULL) {
#line 180 "../src/widgets/CompletionTextView.vala"
		_g_object_unref0 (viewport);
#line 180 "../src/widgets/CompletionTextView.vala"
		return;
#line 523 "CompletionTextView.c"
	}
#line 182 "../src/widgets/CompletionTextView.vala"
	_tmp8_ = viewport;
#line 182 "../src/widgets/CompletionTextView.vala"
	_tmp9_ = gtk_widget_get_parent ((GtkWidget*) _tmp8_);
#line 182 "../src/widgets/CompletionTextView.vala"
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, gtk_scrolled_window_get_type ()) ? ((GtkScrolledWindow*) _tmp9_) : NULL);
#line 182 "../src/widgets/CompletionTextView.vala"
	scroller = _tmp10_;
#line 184 "../src/widgets/CompletionTextView.vala"
	_tmp11_ = scroller;
#line 184 "../src/widgets/CompletionTextView.vala"
	if (_tmp11_ != NULL) {
#line 537 "CompletionTextView.c"
		GtkAdjustment* adjustment = NULL;
		GtkScrolledWindow* _tmp12_;
		GtkAdjustment* _tmp13_;
		GtkAdjustment* _tmp14_;
		GtkAdjustment* _tmp15_;
		GtkAllocation _tmp16_;
		GtkAllocation _tmp17_;
		GtkAllocation _tmp18_;
#line 185 "../src/widgets/CompletionTextView.vala"
		_tmp12_ = scroller;
#line 185 "../src/widgets/CompletionTextView.vala"
		_tmp13_ = gtk_scrolled_window_get_vadjustment (_tmp12_);
#line 185 "../src/widgets/CompletionTextView.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 185 "../src/widgets/CompletionTextView.vala"
		adjustment = _tmp14_;
#line 187 "../src/widgets/CompletionTextView.vala"
		_tmp15_ = adjustment;
#line 187 "../src/widgets/CompletionTextView.vala"
		_tmp16_ = alloc;
#line 187 "../src/widgets/CompletionTextView.vala"
		_tmp17_ = alloc;
#line 187 "../src/widgets/CompletionTextView.vala"
		_tmp18_ = alloc;
#line 187 "../src/widgets/CompletionTextView.vala"
		gtk_adjustment_clamp_page (_tmp15_, (gdouble) _tmp16_.y, (gdouble) (_tmp17_.y + _tmp18_.height));
#line 184 "../src/widgets/CompletionTextView.vala"
		_g_object_unref0 (adjustment);
#line 566 "CompletionTextView.c"
	}
#line 166 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (scroller);
#line 166 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (viewport);
#line 572 "CompletionTextView.c"
}

static gboolean
completion_text_view_key_press_event_cb (CompletionTextView* self,
                                         GdkEventKey* evt)
{
	gboolean _tmp0_ = FALSE;
	GtkListBox* _tmp1_;
	gint n_results = 0;
	CbUserCompletionModel* _tmp2_;
	gboolean result;
#line 191 "../src/widgets/CompletionTextView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 191 "../src/widgets/CompletionTextView.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 193 "../src/widgets/CompletionTextView.vala"
	if (evt->keyval == GDK_KEY_Tab) {
#line 193 "../src/widgets/CompletionTextView.vala"
		_tmp0_ = completion_text_view_snippets_configured (self);
#line 592 "CompletionTextView.c"
	} else {
#line 193 "../src/widgets/CompletionTextView.vala"
		_tmp0_ = FALSE;
#line 596 "CompletionTextView.c"
	}
#line 193 "../src/widgets/CompletionTextView.vala"
	if (_tmp0_) {
#line 194 "../src/widgets/CompletionTextView.vala"
		result = completion_text_view_insert_snippet (self);
#line 194 "../src/widgets/CompletionTextView.vala"
		return result;
#line 604 "CompletionTextView.c"
	}
#line 198 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = self->priv->completion_list;
#line 198 "../src/widgets/CompletionTextView.vala"
	if (!gtk_widget_get_mapped ((GtkWidget*) _tmp1_)) {
#line 199 "../src/widgets/CompletionTextView.vala"
		result = GDK_EVENT_PROPAGATE;
#line 199 "../src/widgets/CompletionTextView.vala"
		return result;
#line 614 "CompletionTextView.c"
	}
#line 202 "../src/widgets/CompletionTextView.vala"
	_tmp2_ = self->priv->completion_model;
#line 202 "../src/widgets/CompletionTextView.vala"
	n_results = (gint) g_list_model_get_n_items ((GListModel*) _tmp2_);
#line 204 "../src/widgets/CompletionTextView.vala"
	switch (evt->keyval) {
#line 204 "../src/widgets/CompletionTextView.vala"
		case GDK_KEY_Down:
#line 624 "CompletionTextView.c"
		{
			gint current_match = 0;
			GtkListBox* _tmp3_;
			GtkListBoxRow* _tmp4_;
			GtkListBoxRow* row = NULL;
			GtkListBox* _tmp5_;
			GtkListBoxRow* _tmp6_;
			GtkListBoxRow* _tmp7_;
			GtkListBoxRow* _tmp9_;
#line 206 "../src/widgets/CompletionTextView.vala"
			if (n_results == 0) {
#line 207 "../src/widgets/CompletionTextView.vala"
				result = GDK_EVENT_PROPAGATE;
#line 207 "../src/widgets/CompletionTextView.vala"
				return result;
#line 640 "CompletionTextView.c"
			}
#line 209 "../src/widgets/CompletionTextView.vala"
			_tmp3_ = self->priv->completion_list;
#line 209 "../src/widgets/CompletionTextView.vala"
			_tmp4_ = gtk_list_box_get_selected_row (_tmp3_);
#line 209 "../src/widgets/CompletionTextView.vala"
			current_match = gtk_list_box_row_get_index (_tmp4_);
#line 210 "../src/widgets/CompletionTextView.vala"
			current_match = (current_match + 1) % n_results;
#line 211 "../src/widgets/CompletionTextView.vala"
			_tmp5_ = self->priv->completion_list;
#line 211 "../src/widgets/CompletionTextView.vala"
			_tmp6_ = gtk_list_box_get_row_at_index (_tmp5_, current_match);
#line 211 "../src/widgets/CompletionTextView.vala"
			_tmp7_ = _g_object_ref0 (_tmp6_);
#line 211 "../src/widgets/CompletionTextView.vala"
			row = _tmp7_;
#line 212 "../src/widgets/CompletionTextView.vala"
			if (self->priv->_default_listbox) {
#line 660 "CompletionTextView.c"
				GtkListBoxRow* _tmp8_;
#line 213 "../src/widgets/CompletionTextView.vala"
				_tmp8_ = row;
#line 213 "../src/widgets/CompletionTextView.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
#line 666 "CompletionTextView.c"
			}
#line 215 "../src/widgets/CompletionTextView.vala"
			_tmp9_ = row;
#line 215 "../src/widgets/CompletionTextView.vala"
			completion_text_view_select_completion_row (self, _tmp9_);
#line 217 "../src/widgets/CompletionTextView.vala"
			result = GDK_EVENT_STOP;
#line 217 "../src/widgets/CompletionTextView.vala"
			_g_object_unref0 (row);
#line 217 "../src/widgets/CompletionTextView.vala"
			return result;
#line 678 "CompletionTextView.c"
		}
#line 204 "../src/widgets/CompletionTextView.vala"
		case GDK_KEY_Up:
#line 682 "CompletionTextView.c"
		{
			gint current_match = 0;
			GtkListBox* _tmp10_;
			GtkListBoxRow* _tmp11_;
			gint _tmp12_;
			GtkListBoxRow* row = NULL;
			GtkListBox* _tmp13_;
			GtkListBoxRow* _tmp14_;
			GtkListBoxRow* _tmp15_;
			GtkListBoxRow* _tmp17_;
#line 220 "../src/widgets/CompletionTextView.vala"
			_tmp10_ = self->priv->completion_list;
#line 220 "../src/widgets/CompletionTextView.vala"
			_tmp11_ = gtk_list_box_get_selected_row (_tmp10_);
#line 220 "../src/widgets/CompletionTextView.vala"
			current_match = gtk_list_box_row_get_index (_tmp11_);
#line 221 "../src/widgets/CompletionTextView.vala"
			_tmp12_ = current_match;
#line 221 "../src/widgets/CompletionTextView.vala"
			current_match = _tmp12_ - 1;
#line 222 "../src/widgets/CompletionTextView.vala"
			if (current_match < 0) {
#line 222 "../src/widgets/CompletionTextView.vala"
				current_match = n_results - 1;
#line 707 "CompletionTextView.c"
			}
#line 223 "../src/widgets/CompletionTextView.vala"
			_tmp13_ = self->priv->completion_list;
#line 223 "../src/widgets/CompletionTextView.vala"
			_tmp14_ = gtk_list_box_get_row_at_index (_tmp13_, current_match);
#line 223 "../src/widgets/CompletionTextView.vala"
			_tmp15_ = _g_object_ref0 (_tmp14_);
#line 223 "../src/widgets/CompletionTextView.vala"
			row = _tmp15_;
#line 224 "../src/widgets/CompletionTextView.vala"
			if (self->priv->_default_listbox) {
#line 719 "CompletionTextView.c"
				GtkListBoxRow* _tmp16_;
#line 225 "../src/widgets/CompletionTextView.vala"
				_tmp16_ = row;
#line 225 "../src/widgets/CompletionTextView.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp16_);
#line 725 "CompletionTextView.c"
			}
#line 227 "../src/widgets/CompletionTextView.vala"
			_tmp17_ = row;
#line 227 "../src/widgets/CompletionTextView.vala"
			completion_text_view_select_completion_row (self, _tmp17_);
#line 229 "../src/widgets/CompletionTextView.vala"
			result = GDK_EVENT_STOP;
#line 229 "../src/widgets/CompletionTextView.vala"
			_g_object_unref0 (row);
#line 229 "../src/widgets/CompletionTextView.vala"
			return result;
#line 737 "CompletionTextView.c"
		}
#line 204 "../src/widgets/CompletionTextView.vala"
		case GDK_KEY_Return:
#line 741 "CompletionTextView.c"
		{
#line 232 "../src/widgets/CompletionTextView.vala"
			if (n_results == 0) {
#line 233 "../src/widgets/CompletionTextView.vala"
				result = GDK_EVENT_PROPAGATE;
#line 233 "../src/widgets/CompletionTextView.vala"
				return result;
#line 749 "CompletionTextView.c"
			}
#line 234 "../src/widgets/CompletionTextView.vala"
			completion_text_view_insert_user_completion (self);
#line 235 "../src/widgets/CompletionTextView.vala"
			result = GDK_EVENT_STOP;
#line 235 "../src/widgets/CompletionTextView.vala"
			return result;
#line 757 "CompletionTextView.c"
		}
#line 204 "../src/widgets/CompletionTextView.vala"
		case GDK_KEY_Escape:
#line 761 "CompletionTextView.c"
		{
#line 238 "../src/widgets/CompletionTextView.vala"
			completion_text_view_hide_completion_window (self);
#line 239 "../src/widgets/CompletionTextView.vala"
			result = GDK_EVENT_STOP;
#line 239 "../src/widgets/CompletionTextView.vala"
			return result;
#line 769 "CompletionTextView.c"
		}
		default:
		{
#line 242 "../src/widgets/CompletionTextView.vala"
			result = GDK_EVENT_PROPAGATE;
#line 242 "../src/widgets/CompletionTextView.vala"
			return result;
#line 777 "CompletionTextView.c"
		}
	}
}

static void
completion_text_view_insert_user_completion (CompletionTextView* self)
{
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GtkListBoxRow* _tmp2_;
	gboolean list_had_focus = FALSE;
	GtkListBoxRow* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkListBoxRow* _tmp6_;
	gchar* compl = NULL;
	GtkListBoxRow* _tmp7_;
	gchar* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextBuffer* _tmp10_;
	GtkTextIter start_word_iter = {0};
	GtkTextIter end_word_iter = {0};
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextIter _tmp13_ = {0};
	GtkTextIter _tmp14_ = {0};
	gchar* _tmp15_;
	gchar* _tmp16_;
	gint start_offset = 0;
	GtkTextBuffer* _tmp17_;
	GtkTextBuffer* _tmp18_;
	GtkTextIter _tmp19_;
	GtkTextIter _tmp20_;
	GtkTextBuffer* _tmp21_;
	GtkTextBuffer* _tmp22_;
	GtkTextIter _tmp23_ = {0};
	gunichar next_char = 0U;
	gboolean _tmp24_ = FALSE;
	GtkTextBuffer* _tmp39_;
	GtkTextBuffer* _tmp40_;
#line 246 "../src/widgets/CompletionTextView.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = self->priv->completion_list;
#line 247 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
#line 247 "../src/widgets/CompletionTextView.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 247 "../src/widgets/CompletionTextView.vala"
	row = _tmp2_;
#line 248 "../src/widgets/CompletionTextView.vala"
	_tmp3_ = row;
#line 248 "../src/widgets/CompletionTextView.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 248 "../src/widgets/CompletionTextView.vala"
	_tmp5_ = _tmp4_;
#line 248 "../src/widgets/CompletionTextView.vala"
	list_had_focus = _tmp5_;
#line 249 "../src/widgets/CompletionTextView.vala"
	_tmp6_ = row;
#line 249 "../src/widgets/CompletionTextView.vala"
	_vala_assert (IS_USER_COMPLETION_ROW (_tmp6_), "row is UserCompletionRow");
#line 250 "../src/widgets/CompletionTextView.vala"
	_tmp7_ = row;
#line 250 "../src/widgets/CompletionTextView.vala"
	_tmp8_ = user_completion_row_get_screen_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_USER_COMPLETION_ROW, UserCompletionRow));
#line 250 "../src/widgets/CompletionTextView.vala"
	compl = _tmp8_;
#line 251 "../src/widgets/CompletionTextView.vala"
	_tmp9_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 251 "../src/widgets/CompletionTextView.vala"
	_tmp10_ = _tmp9_;
#line 251 "../src/widgets/CompletionTextView.vala"
	g_object_freeze_notify ((GObject*) _tmp10_);
#line 254 "../src/widgets/CompletionTextView.vala"
	_tmp11_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 254 "../src/widgets/CompletionTextView.vala"
	_tmp12_ = _tmp11_;
#line 254 "../src/widgets/CompletionTextView.vala"
	_tmp15_ = utils_get_cursor_mention_word (_tmp12_, &_tmp13_, &_tmp14_);
#line 254 "../src/widgets/CompletionTextView.vala"
	start_word_iter = _tmp13_;
#line 254 "../src/widgets/CompletionTextView.vala"
	end_word_iter = _tmp14_;
#line 254 "../src/widgets/CompletionTextView.vala"
	_tmp16_ = _tmp15_;
#line 254 "../src/widgets/CompletionTextView.vala"
	_g_free0 (_tmp16_);
#line 255 "../src/widgets/CompletionTextView.vala"
	start_offset = gtk_text_iter_get_offset (&start_word_iter);
#line 256 "../src/widgets/CompletionTextView.vala"
	_tmp17_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 256 "../src/widgets/CompletionTextView.vala"
	_tmp18_ = _tmp17_;
#line 256 "../src/widgets/CompletionTextView.vala"
	_tmp19_ = start_word_iter;
#line 256 "../src/widgets/CompletionTextView.vala"
	_tmp20_ = end_word_iter;
#line 256 "../src/widgets/CompletionTextView.vala"
	g_signal_emit_by_name (_tmp18_, "delete-range", &_tmp19_, &_tmp20_);
#line 257 "../src/widgets/CompletionTextView.vala"
	_tmp21_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 257 "../src/widgets/CompletionTextView.vala"
	_tmp22_ = _tmp21_;
#line 257 "../src/widgets/CompletionTextView.vala"
	gtk_text_buffer_get_iter_at_offset (_tmp22_, &_tmp23_, start_offset);
#line 257 "../src/widgets/CompletionTextView.vala"
	start_word_iter = _tmp23_;
#line 258 "../src/widgets/CompletionTextView.vala"
	next_char = gtk_text_iter_get_char (&start_word_iter);
#line 260 "../src/widgets/CompletionTextView.vala"
	if (next_char == ((gunichar) 0)) {
#line 260 "../src/widgets/CompletionTextView.vala"
		_tmp24_ = TRUE;
#line 893 "CompletionTextView.c"
	} else {
#line 260 "../src/widgets/CompletionTextView.vala"
		_tmp24_ = !g_unichar_ispunct (next_char);
#line 897 "CompletionTextView.c"
	}
#line 260 "../src/widgets/CompletionTextView.vala"
	if (_tmp24_) {
#line 901 "CompletionTextView.c"
		GtkTextBuffer* _tmp25_;
		GtkTextBuffer* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
#line 261 "../src/widgets/CompletionTextView.vala"
		_tmp25_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 261 "../src/widgets/CompletionTextView.vala"
		_tmp26_ = _tmp25_;
#line 261 "../src/widgets/CompletionTextView.vala"
		_tmp27_ = compl;
#line 261 "../src/widgets/CompletionTextView.vala"
		_tmp28_ = g_strconcat (_tmp27_, " ", NULL);
#line 261 "../src/widgets/CompletionTextView.vala"
		_tmp29_ = _tmp28_;
#line 261 "../src/widgets/CompletionTextView.vala"
		_tmp30_ = compl;
#line 261 "../src/widgets/CompletionTextView.vala"
		_tmp31_ = strlen (_tmp30_);
#line 261 "../src/widgets/CompletionTextView.vala"
		_tmp32_ = _tmp31_;
#line 261 "../src/widgets/CompletionTextView.vala"
		g_signal_emit_by_name (_tmp26_, "insert-text", &start_word_iter, _tmp29_, _tmp32_ + 1);
#line 261 "../src/widgets/CompletionTextView.vala"
		_g_free0 (_tmp29_);
#line 930 "CompletionTextView.c"
	} else {
		GtkTextBuffer* _tmp33_;
		GtkTextBuffer* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
#line 264 "../src/widgets/CompletionTextView.vala"
		_tmp33_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 264 "../src/widgets/CompletionTextView.vala"
		_tmp34_ = _tmp33_;
#line 264 "../src/widgets/CompletionTextView.vala"
		_tmp35_ = compl;
#line 264 "../src/widgets/CompletionTextView.vala"
		_tmp36_ = compl;
#line 264 "../src/widgets/CompletionTextView.vala"
		_tmp37_ = strlen (_tmp36_);
#line 264 "../src/widgets/CompletionTextView.vala"
		_tmp38_ = _tmp37_;
#line 264 "../src/widgets/CompletionTextView.vala"
		g_signal_emit_by_name (_tmp34_, "insert-text", &start_word_iter, _tmp35_, _tmp38_);
#line 952 "CompletionTextView.c"
	}
#line 266 "../src/widgets/CompletionTextView.vala"
	_tmp39_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 266 "../src/widgets/CompletionTextView.vala"
	_tmp40_ = _tmp39_;
#line 266 "../src/widgets/CompletionTextView.vala"
	g_object_thaw_notify ((GObject*) _tmp40_);
#line 267 "../src/widgets/CompletionTextView.vala"
	completion_text_view_hide_completion_window (self);
#line 268 "../src/widgets/CompletionTextView.vala"
	if (list_had_focus) {
#line 269 "../src/widgets/CompletionTextView.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 966 "CompletionTextView.c"
	}
#line 246 "../src/widgets/CompletionTextView.vala"
	_g_free0 (compl);
#line 246 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (row);
#line 972 "CompletionTextView.c"
}

static void
_vala_GtkTextIter_free (GtkTextIter* self)
{
#line 276 "../src/widgets/CompletionTextView.vala"
	g_boxed_free (gtk_text_iter_get_type (), self);
#line 980 "CompletionTextView.c"
}

static GtkTextIter*
_vala_GtkTextIter_copy (GtkTextIter* self)
{
#line 276 "../src/widgets/CompletionTextView.vala"
	return g_boxed_copy (gtk_text_iter_get_type (), self);
#line 988 "CompletionTextView.c"
}

static gpointer
__vala_GtkTextIter_copy0 (gpointer self)
{
#line 276 "../src/widgets/CompletionTextView.vala"
	return self ? _vala_GtkTextIter_copy (self) : NULL;
#line 996 "CompletionTextView.c"
}

static void
completion_text_view_buffer_changed_cb (CompletionTextView* self)
{
	GtkTextIter* start_iter = NULL;
	GtkTextIter* end_iter = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextIter _tmp3_;
	GtkTextIter* _tmp4_;
	GtkTextBuffer* _tmp5_;
	GtkTextBuffer* _tmp6_;
	GtkTextIter _tmp7_ = {0};
	GtkTextIter _tmp8_;
	GtkTextIter* _tmp9_;
	GtkTextTagTable* tag_table = NULL;
	GtkTextBuffer* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextTagTable* _tmp12_;
	GtkTextTagTable* _tmp13_;
	gchar* text = NULL;
	GtkTextBuffer* _tmp25_;
	GtkTextBuffer* _tmp26_;
	GtkTextIter* _tmp27_;
	GtkTextIter* _tmp28_;
	GtkTextIter _tmp29_;
	GtkTextIter _tmp30_;
	gchar* _tmp31_;
	gsize text_length = 0UL;
	TlEntity* entities = NULL;
	const gchar* _tmp32_;
	gsize _tmp33_ = 0UL;
	gint _tmp34_ = 0;
	TlEntity* _tmp35_;
	gint entities_length1;
	gint _entities_size_;
	TlEntity* _tmp36_;
	gint _tmp36__length1;
	GtkTextBuffer* _tmp103_;
	GtkTextBuffer* _tmp104_;
	gchar* _tmp105_;
	gchar* _tmp106_;
	gchar* _tmp107_;
	gint _tmp108_;
	gint _tmp109_;
	gboolean _tmp110_;
#line 273 "../src/widgets/CompletionTextView.vala"
	g_return_if_fail (self != NULL);
#line 276 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 276 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = _tmp0_;
#line 276 "../src/widgets/CompletionTextView.vala"
	gtk_text_buffer_get_start_iter (_tmp1_, &_tmp2_);
#line 276 "../src/widgets/CompletionTextView.vala"
	__vala_GtkTextIter_free0 (start_iter);
#line 276 "../src/widgets/CompletionTextView.vala"
	_tmp3_ = _tmp2_;
#line 276 "../src/widgets/CompletionTextView.vala"
	_tmp4_ = __vala_GtkTextIter_copy0 (&_tmp3_);
#line 276 "../src/widgets/CompletionTextView.vala"
	start_iter = _tmp4_;
#line 277 "../src/widgets/CompletionTextView.vala"
	_tmp5_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 277 "../src/widgets/CompletionTextView.vala"
	_tmp6_ = _tmp5_;
#line 277 "../src/widgets/CompletionTextView.vala"
	gtk_text_buffer_get_end_iter (_tmp6_, &_tmp7_);
#line 277 "../src/widgets/CompletionTextView.vala"
	__vala_GtkTextIter_free0 (end_iter);
#line 277 "../src/widgets/CompletionTextView.vala"
	_tmp8_ = _tmp7_;
#line 277 "../src/widgets/CompletionTextView.vala"
	_tmp9_ = __vala_GtkTextIter_copy0 (&_tmp8_);
#line 277 "../src/widgets/CompletionTextView.vala"
	end_iter = _tmp9_;
#line 278 "../src/widgets/CompletionTextView.vala"
	_tmp10_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 278 "../src/widgets/CompletionTextView.vala"
	_tmp11_ = _tmp10_;
#line 278 "../src/widgets/CompletionTextView.vala"
	_tmp12_ = gtk_text_buffer_get_tag_table (_tmp11_);
#line 278 "../src/widgets/CompletionTextView.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 278 "../src/widgets/CompletionTextView.vala"
	tag_table = _tmp13_;
#line 1085 "CompletionTextView.c"
	{
		gint i = 0;
#line 282 "../src/widgets/CompletionTextView.vala"
		i = 0;
#line 1090 "CompletionTextView.c"
		{
			gboolean _tmp14_ = FALSE;
#line 282 "../src/widgets/CompletionTextView.vala"
			_tmp14_ = TRUE;
#line 282 "../src/widgets/CompletionTextView.vala"
			while (TRUE) {
#line 1097 "CompletionTextView.c"
				GtkTextBuffer* _tmp16_;
				GtkTextBuffer* _tmp17_;
				GtkTextTagTable* _tmp18_;
				const gchar* _tmp19_;
				GtkTextTag* _tmp20_;
				GtkTextIter* _tmp21_;
				GtkTextIter* _tmp22_;
				GtkTextIter _tmp23_;
				GtkTextIter _tmp24_;
#line 282 "../src/widgets/CompletionTextView.vala"
				if (!_tmp14_) {
#line 1109 "CompletionTextView.c"
					gint _tmp15_;
#line 282 "../src/widgets/CompletionTextView.vala"
					_tmp15_ = i;
#line 282 "../src/widgets/CompletionTextView.vala"
					i = _tmp15_ + 1;
#line 1115 "CompletionTextView.c"
				}
#line 282 "../src/widgets/CompletionTextView.vala"
				_tmp14_ = FALSE;
#line 282 "../src/widgets/CompletionTextView.vala"
				if (!(i < G_N_ELEMENTS (COMPLETION_TEXT_VIEW_TEXT_TAGS))) {
#line 282 "../src/widgets/CompletionTextView.vala"
					break;
#line 1123 "CompletionTextView.c"
				}
#line 283 "../src/widgets/CompletionTextView.vala"
				_tmp16_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 283 "../src/widgets/CompletionTextView.vala"
				_tmp17_ = _tmp16_;
#line 283 "../src/widgets/CompletionTextView.vala"
				_tmp18_ = tag_table;
#line 283 "../src/widgets/CompletionTextView.vala"
				_tmp19_ = COMPLETION_TEXT_VIEW_TEXT_TAGS[i];
#line 283 "../src/widgets/CompletionTextView.vala"
				_tmp20_ = gtk_text_tag_table_lookup (_tmp18_, _tmp19_);
#line 283 "../src/widgets/CompletionTextView.vala"
				_tmp21_ = start_iter;
#line 283 "../src/widgets/CompletionTextView.vala"
				_tmp22_ = end_iter;
#line 283 "../src/widgets/CompletionTextView.vala"
				_tmp23_ = *_tmp21_;
#line 283 "../src/widgets/CompletionTextView.vala"
				_tmp24_ = *_tmp22_;
#line 283 "../src/widgets/CompletionTextView.vala"
				gtk_text_buffer_remove_tag (_tmp17_, _tmp20_, &_tmp23_, &_tmp24_);
#line 1145 "CompletionTextView.c"
			}
		}
	}
#line 285 "../src/widgets/CompletionTextView.vala"
	_tmp25_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 285 "../src/widgets/CompletionTextView.vala"
	_tmp26_ = _tmp25_;
#line 285 "../src/widgets/CompletionTextView.vala"
	_tmp27_ = start_iter;
#line 285 "../src/widgets/CompletionTextView.vala"
	_tmp28_ = end_iter;
#line 285 "../src/widgets/CompletionTextView.vala"
	_tmp29_ = *_tmp27_;
#line 285 "../src/widgets/CompletionTextView.vala"
	_tmp30_ = *_tmp28_;
#line 285 "../src/widgets/CompletionTextView.vala"
	_tmp31_ = gtk_text_buffer_get_text (_tmp26_, &_tmp29_, &_tmp30_, TRUE);
#line 285 "../src/widgets/CompletionTextView.vala"
	text = _tmp31_;
#line 287 "../src/widgets/CompletionTextView.vala"
	_tmp32_ = text;
#line 287 "../src/widgets/CompletionTextView.vala"
	_tmp35_ = tl_extract_entities_and_text (_tmp32_, &_tmp34_, &_tmp33_);
#line 287 "../src/widgets/CompletionTextView.vala"
	text_length = _tmp33_;
#line 287 "../src/widgets/CompletionTextView.vala"
	entities = _tmp35_;
#line 287 "../src/widgets/CompletionTextView.vala"
	entities_length1 = _tmp34_;
#line 287 "../src/widgets/CompletionTextView.vala"
	_entities_size_ = entities_length1;
#line 288 "../src/widgets/CompletionTextView.vala"
	_tmp36_ = entities;
#line 288 "../src/widgets/CompletionTextView.vala"
	_tmp36__length1 = entities_length1;
#line 1181 "CompletionTextView.c"
	{
		TlEntity* e_collection = NULL;
		gint e_collection_length1 = 0;
		gint _e_collection_size_ = 0;
		gint e_it = 0;
#line 288 "../src/widgets/CompletionTextView.vala"
		e_collection = _tmp36_;
#line 288 "../src/widgets/CompletionTextView.vala"
		e_collection_length1 = _tmp36__length1;
#line 288 "../src/widgets/CompletionTextView.vala"
		for (e_it = 0; e_it < e_collection_length1; e_it = e_it + 1) {
#line 1193 "CompletionTextView.c"
			TlEntity e = {0};
#line 288 "../src/widgets/CompletionTextView.vala"
			e = e_collection[e_it];
#line 1197 "CompletionTextView.c"
			{
				GtkTextIter* e_start_iter = NULL;
				GtkTextIter* e_end_iter = NULL;
				GtkTextBuffer* _tmp37_;
				GtkTextBuffer* _tmp38_;
				TlEntity _tmp39_;
				GtkTextIter _tmp40_ = {0};
				GtkTextIter _tmp41_;
				GtkTextIter* _tmp42_;
				GtkTextBuffer* _tmp43_;
				GtkTextBuffer* _tmp44_;
				TlEntity _tmp45_;
				TlEntity _tmp46_;
				GtkTextIter _tmp47_ = {0};
				GtkTextIter _tmp48_;
				GtkTextIter* _tmp49_;
				TlEntity _tmp50_;
#line 292 "../src/widgets/CompletionTextView.vala"
				_tmp37_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 292 "../src/widgets/CompletionTextView.vala"
				_tmp38_ = _tmp37_;
#line 292 "../src/widgets/CompletionTextView.vala"
				_tmp39_ = e;
#line 292 "../src/widgets/CompletionTextView.vala"
				gtk_text_buffer_get_iter_at_offset (_tmp38_, &_tmp40_, (gint) _tmp39_.start_character_index);
#line 292 "../src/widgets/CompletionTextView.vala"
				__vala_GtkTextIter_free0 (e_start_iter);
#line 292 "../src/widgets/CompletionTextView.vala"
				_tmp41_ = _tmp40_;
#line 292 "../src/widgets/CompletionTextView.vala"
				_tmp42_ = __vala_GtkTextIter_copy0 (&_tmp41_);
#line 292 "../src/widgets/CompletionTextView.vala"
				e_start_iter = _tmp42_;
#line 293 "../src/widgets/CompletionTextView.vala"
				_tmp43_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 293 "../src/widgets/CompletionTextView.vala"
				_tmp44_ = _tmp43_;
#line 293 "../src/widgets/CompletionTextView.vala"
				_tmp45_ = e;
#line 293 "../src/widgets/CompletionTextView.vala"
				_tmp46_ = e;
#line 293 "../src/widgets/CompletionTextView.vala"
				gtk_text_buffer_get_iter_at_offset (_tmp44_, &_tmp47_, (gint) (_tmp45_.start_character_index + _tmp46_.length_in_characters));
#line 293 "../src/widgets/CompletionTextView.vala"
				__vala_GtkTextIter_free0 (e_end_iter);
#line 293 "../src/widgets/CompletionTextView.vala"
				_tmp48_ = _tmp47_;
#line 293 "../src/widgets/CompletionTextView.vala"
				_tmp49_ = __vala_GtkTextIter_copy0 (&_tmp48_);
#line 293 "../src/widgets/CompletionTextView.vala"
				e_end_iter = _tmp49_;
#line 295 "../src/widgets/CompletionTextView.vala"
				_tmp50_ = e;
#line 295 "../src/widgets/CompletionTextView.vala"
				switch (_tmp50_.type) {
#line 295 "../src/widgets/CompletionTextView.vala"
					case TL_ENT_HASHTAG:
#line 1255 "CompletionTextView.c"
					{
						GtkTextBuffer* _tmp51_;
						GtkTextBuffer* _tmp52_;
						GtkTextIter* _tmp53_;
						GtkTextIter* _tmp54_;
						GtkTextIter _tmp55_;
						GtkTextIter _tmp56_;
						GtkTextBuffer* _tmp57_;
						GtkTextBuffer* _tmp58_;
						GtkTextIter* _tmp59_;
						GtkTextIter* _tmp60_;
						GtkTextIter _tmp61_;
						GtkTextIter _tmp62_;
#line 297 "../src/widgets/CompletionTextView.vala"
						_tmp51_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 297 "../src/widgets/CompletionTextView.vala"
						_tmp52_ = _tmp51_;
#line 297 "../src/widgets/CompletionTextView.vala"
						_tmp53_ = e_start_iter;
#line 297 "../src/widgets/CompletionTextView.vala"
						_tmp54_ = e_end_iter;
#line 297 "../src/widgets/CompletionTextView.vala"
						_tmp55_ = *_tmp53_;
#line 297 "../src/widgets/CompletionTextView.vala"
						_tmp56_ = *_tmp54_;
#line 297 "../src/widgets/CompletionTextView.vala"
						gtk_text_buffer_apply_tag_by_name (_tmp52_, COMPLETION_TEXT_VIEW_NO_SPELL_CHECK, &_tmp55_, &_tmp56_);
#line 298 "../src/widgets/CompletionTextView.vala"
						_tmp57_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 298 "../src/widgets/CompletionTextView.vala"
						_tmp58_ = _tmp57_;
#line 298 "../src/widgets/CompletionTextView.vala"
						_tmp59_ = e_start_iter;
#line 298 "../src/widgets/CompletionTextView.vala"
						_tmp60_ = e_end_iter;
#line 298 "../src/widgets/CompletionTextView.vala"
						_tmp61_ = *_tmp59_;
#line 298 "../src/widgets/CompletionTextView.vala"
						_tmp62_ = *_tmp60_;
#line 298 "../src/widgets/CompletionTextView.vala"
						gtk_text_buffer_apply_tag_by_name (_tmp58_, "hashtag", &_tmp61_, &_tmp62_);
#line 299 "../src/widgets/CompletionTextView.vala"
						break;
#line 1299 "CompletionTextView.c"
					}
#line 295 "../src/widgets/CompletionTextView.vala"
					case TL_ENT_MENTION:
#line 1303 "CompletionTextView.c"
					{
						GtkTextBuffer* _tmp63_;
						GtkTextBuffer* _tmp64_;
						GtkTextIter* _tmp65_;
						GtkTextIter* _tmp66_;
						GtkTextIter _tmp67_;
						GtkTextIter _tmp68_;
						GtkTextBuffer* _tmp69_;
						GtkTextBuffer* _tmp70_;
						GtkTextIter* _tmp71_;
						GtkTextIter* _tmp72_;
						GtkTextIter _tmp73_;
						GtkTextIter _tmp74_;
#line 301 "../src/widgets/CompletionTextView.vala"
						_tmp63_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 301 "../src/widgets/CompletionTextView.vala"
						_tmp64_ = _tmp63_;
#line 301 "../src/widgets/CompletionTextView.vala"
						_tmp65_ = e_start_iter;
#line 301 "../src/widgets/CompletionTextView.vala"
						_tmp66_ = e_end_iter;
#line 301 "../src/widgets/CompletionTextView.vala"
						_tmp67_ = *_tmp65_;
#line 301 "../src/widgets/CompletionTextView.vala"
						_tmp68_ = *_tmp66_;
#line 301 "../src/widgets/CompletionTextView.vala"
						gtk_text_buffer_apply_tag_by_name (_tmp64_, COMPLETION_TEXT_VIEW_NO_SPELL_CHECK, &_tmp67_, &_tmp68_);
#line 302 "../src/widgets/CompletionTextView.vala"
						_tmp69_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 302 "../src/widgets/CompletionTextView.vala"
						_tmp70_ = _tmp69_;
#line 302 "../src/widgets/CompletionTextView.vala"
						_tmp71_ = e_start_iter;
#line 302 "../src/widgets/CompletionTextView.vala"
						_tmp72_ = e_end_iter;
#line 302 "../src/widgets/CompletionTextView.vala"
						_tmp73_ = *_tmp71_;
#line 302 "../src/widgets/CompletionTextView.vala"
						_tmp74_ = *_tmp72_;
#line 302 "../src/widgets/CompletionTextView.vala"
						gtk_text_buffer_apply_tag_by_name (_tmp70_, "mention", &_tmp73_, &_tmp74_);
#line 303 "../src/widgets/CompletionTextView.vala"
						break;
#line 1347 "CompletionTextView.c"
					}
#line 295 "../src/widgets/CompletionTextView.vala"
					case TL_ENT_LINK:
#line 1351 "CompletionTextView.c"
					{
						GtkTextBuffer* _tmp75_;
						GtkTextBuffer* _tmp76_;
						GtkTextIter* _tmp77_;
						GtkTextIter* _tmp78_;
						GtkTextIter _tmp79_;
						GtkTextIter _tmp80_;
						GtkTextBuffer* _tmp81_;
						GtkTextBuffer* _tmp82_;
						GtkTextIter* _tmp83_;
						GtkTextIter* _tmp84_;
						GtkTextIter _tmp85_;
						GtkTextIter _tmp86_;
#line 305 "../src/widgets/CompletionTextView.vala"
						_tmp75_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 305 "../src/widgets/CompletionTextView.vala"
						_tmp76_ = _tmp75_;
#line 305 "../src/widgets/CompletionTextView.vala"
						_tmp77_ = e_start_iter;
#line 305 "../src/widgets/CompletionTextView.vala"
						_tmp78_ = e_end_iter;
#line 305 "../src/widgets/CompletionTextView.vala"
						_tmp79_ = *_tmp77_;
#line 305 "../src/widgets/CompletionTextView.vala"
						_tmp80_ = *_tmp78_;
#line 305 "../src/widgets/CompletionTextView.vala"
						gtk_text_buffer_apply_tag_by_name (_tmp76_, COMPLETION_TEXT_VIEW_NO_SPELL_CHECK, &_tmp79_, &_tmp80_);
#line 306 "../src/widgets/CompletionTextView.vala"
						_tmp81_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 306 "../src/widgets/CompletionTextView.vala"
						_tmp82_ = _tmp81_;
#line 306 "../src/widgets/CompletionTextView.vala"
						_tmp83_ = e_start_iter;
#line 306 "../src/widgets/CompletionTextView.vala"
						_tmp84_ = e_end_iter;
#line 306 "../src/widgets/CompletionTextView.vala"
						_tmp85_ = *_tmp83_;
#line 306 "../src/widgets/CompletionTextView.vala"
						_tmp86_ = *_tmp84_;
#line 306 "../src/widgets/CompletionTextView.vala"
						gtk_text_buffer_apply_tag_by_name (_tmp82_, "link", &_tmp85_, &_tmp86_);
#line 307 "../src/widgets/CompletionTextView.vala"
						break;
#line 1395 "CompletionTextView.c"
					}
#line 295 "../src/widgets/CompletionTextView.vala"
					case TL_ENT_TEXT:
#line 1399 "CompletionTextView.c"
					{
						CbSnippetManager* _tmp87_;
						TlEntity _tmp88_;
						const gchar* _tmp89_;
						TlEntity _tmp90_;
#line 310 "../src/widgets/CompletionTextView.vala"
						_tmp87_ = cawbird_snippet_manager;
#line 310 "../src/widgets/CompletionTextView.vala"
						_tmp88_ = e;
#line 310 "../src/widgets/CompletionTextView.vala"
						_tmp89_ = _tmp88_.start;
#line 310 "../src/widgets/CompletionTextView.vala"
						_tmp90_ = e;
#line 310 "../src/widgets/CompletionTextView.vala"
						if (cb_snippet_manager_has_snippet_n (_tmp87_, _tmp89_, _tmp90_.length_in_bytes)) {
#line 1415 "CompletionTextView.c"
							GtkTextBuffer* _tmp91_;
							GtkTextBuffer* _tmp92_;
							GtkTextIter* _tmp93_;
							GtkTextIter* _tmp94_;
							GtkTextIter _tmp95_;
							GtkTextIter _tmp96_;
							GtkTextBuffer* _tmp97_;
							GtkTextBuffer* _tmp98_;
							GtkTextIter* _tmp99_;
							GtkTextIter* _tmp100_;
							GtkTextIter _tmp101_;
							GtkTextIter _tmp102_;
#line 311 "../src/widgets/CompletionTextView.vala"
							_tmp91_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 311 "../src/widgets/CompletionTextView.vala"
							_tmp92_ = _tmp91_;
#line 311 "../src/widgets/CompletionTextView.vala"
							_tmp93_ = e_start_iter;
#line 311 "../src/widgets/CompletionTextView.vala"
							_tmp94_ = e_end_iter;
#line 311 "../src/widgets/CompletionTextView.vala"
							_tmp95_ = *_tmp93_;
#line 311 "../src/widgets/CompletionTextView.vala"
							_tmp96_ = *_tmp94_;
#line 311 "../src/widgets/CompletionTextView.vala"
							gtk_text_buffer_apply_tag_by_name (_tmp92_, COMPLETION_TEXT_VIEW_NO_SPELL_CHECK, &_tmp95_, &_tmp96_);
#line 312 "../src/widgets/CompletionTextView.vala"
							_tmp97_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 312 "../src/widgets/CompletionTextView.vala"
							_tmp98_ = _tmp97_;
#line 312 "../src/widgets/CompletionTextView.vala"
							_tmp99_ = e_start_iter;
#line 312 "../src/widgets/CompletionTextView.vala"
							_tmp100_ = e_end_iter;
#line 312 "../src/widgets/CompletionTextView.vala"
							_tmp101_ = *_tmp99_;
#line 312 "../src/widgets/CompletionTextView.vala"
							_tmp102_ = *_tmp100_;
#line 312 "../src/widgets/CompletionTextView.vala"
							gtk_text_buffer_apply_tag_by_name (_tmp98_, "snippet", &_tmp101_, &_tmp102_);
#line 1456 "CompletionTextView.c"
						}
#line 314 "../src/widgets/CompletionTextView.vala"
						break;
#line 1460 "CompletionTextView.c"
					}
					default:
					{
#line 317 "../src/widgets/CompletionTextView.vala"
						break;
#line 1466 "CompletionTextView.c"
					}
				}
#line 288 "../src/widgets/CompletionTextView.vala"
				__vala_GtkTextIter_free0 (e_end_iter);
#line 288 "../src/widgets/CompletionTextView.vala"
				__vala_GtkTextIter_free0 (e_start_iter);
#line 1473 "CompletionTextView.c"
			}
		}
	}
#line 321 "../src/widgets/CompletionTextView.vala"
	_tmp103_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 321 "../src/widgets/CompletionTextView.vala"
	_tmp104_ = _tmp103_;
#line 321 "../src/widgets/CompletionTextView.vala"
	g_object_get (_tmp104_, "text", &_tmp105_, NULL);
#line 321 "../src/widgets/CompletionTextView.vala"
	_tmp106_ = _tmp105_;
#line 321 "../src/widgets/CompletionTextView.vala"
	_tmp107_ = _tmp106_;
#line 321 "../src/widgets/CompletionTextView.vala"
	_tmp108_ = strlen (_tmp107_);
#line 321 "../src/widgets/CompletionTextView.vala"
	_tmp109_ = _tmp108_;
#line 321 "../src/widgets/CompletionTextView.vala"
	_tmp110_ = _tmp109_ == 0;
#line 321 "../src/widgets/CompletionTextView.vala"
	_g_free0 (_tmp107_);
#line 321 "../src/widgets/CompletionTextView.vala"
	if (_tmp110_) {
#line 322 "../src/widgets/CompletionTextView.vala"
		completion_text_view_hide_completion_window (self);
#line 1499 "CompletionTextView.c"
	}
#line 273 "../src/widgets/CompletionTextView.vala"
	entities = (g_free (entities), NULL);
#line 273 "../src/widgets/CompletionTextView.vala"
	_g_free0 (text);
#line 273 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (tag_table);
#line 273 "../src/widgets/CompletionTextView.vala"
	__vala_GtkTextIter_free0 (end_iter);
#line 273 "../src/widgets/CompletionTextView.vala"
	__vala_GtkTextIter_free0 (start_iter);
#line 1511 "CompletionTextView.c"
}

static void
completion_text_view_show_completion_window (CompletionTextView* self)
{
	CbUserCompletionModel* _tmp0_;
	gint x = 0;
	gint y = 0;
	GtkAllocation alloc = {0};
	GtkAllocation _tmp1_ = {0};
	GdkWindow* window = NULL;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GdkWindow* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GdkDisplay* default_display = NULL;
	GdkDisplay* _tmp7_;
	GdkDisplay* _tmp8_;
	GdkMonitor* current_monitor = NULL;
	GdkDisplay* _tmp9_;
	GdkWindow* _tmp10_;
	GdkMonitor* _tmp11_;
	GdkMonitor* _tmp12_;
	GdkRectangle workarea = {0};
	GdkMonitor* _tmp13_;
	GdkRectangle _tmp14_ = {0};
	gint completion_height = 0;
	GtkAllocation _tmp15_;
	GdkRectangle _tmp16_;
	GtkWindow* _tmp18_;
	GtkWindow* _tmp19_;
	GtkWidget* _tmp20_;
	GtkWindow* _tmp21_;
	GtkWindow* _tmp22_;
	GtkAllocation _tmp23_;
	GtkWindow* _tmp24_;
#line 325 "../src/widgets/CompletionTextView.vala"
	g_return_if_fail (self != NULL);
#line 326 "../src/widgets/CompletionTextView.vala"
	if (!gtk_widget_get_mapped ((GtkWidget*) self)) {
#line 327 "../src/widgets/CompletionTextView.vala"
		return;
#line 1555 "CompletionTextView.c"
	}
#line 329 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = self->priv->completion_model;
#line 329 "../src/widgets/CompletionTextView.vala"
	cb_user_completion_model_clear (_tmp0_);
#line 331 "../src/widgets/CompletionTextView.vala"
	if (!self->priv->_default_listbox) {
#line 332 "../src/widgets/CompletionTextView.vala"
		g_signal_emit (self, completion_text_view_signals[COMPLETION_TEXT_VIEW_SHOW_COMPLETION_SIGNAL], 0);
#line 333 "../src/widgets/CompletionTextView.vala"
		return;
#line 1567 "CompletionTextView.c"
	}
#line 338 "../src/widgets/CompletionTextView.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp1_);
#line 338 "../src/widgets/CompletionTextView.vala"
	alloc = _tmp1_;
#line 339 "../src/widgets/CompletionTextView.vala"
	_tmp2_ = gtk_text_view_get_window ((GtkTextView*) self, GTK_TEXT_WINDOW_WIDGET);
#line 339 "../src/widgets/CompletionTextView.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 339 "../src/widgets/CompletionTextView.vala"
	window = _tmp3_;
#line 340 "../src/widgets/CompletionTextView.vala"
	_tmp4_ = window;
#line 340 "../src/widgets/CompletionTextView.vala"
	gdk_window_get_origin (_tmp4_, &_tmp5_, &_tmp6_);
#line 340 "../src/widgets/CompletionTextView.vala"
	x = _tmp5_;
#line 340 "../src/widgets/CompletionTextView.vala"
	y = _tmp6_;
#line 341 "../src/widgets/CompletionTextView.vala"
	_tmp7_ = gdk_display_get_default ();
#line 341 "../src/widgets/CompletionTextView.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 341 "../src/widgets/CompletionTextView.vala"
	default_display = _tmp8_;
#line 342 "../src/widgets/CompletionTextView.vala"
	_tmp9_ = default_display;
#line 342 "../src/widgets/CompletionTextView.vala"
	_tmp10_ = window;
#line 342 "../src/widgets/CompletionTextView.vala"
	_tmp11_ = gdk_display_get_monitor_at_window (_tmp9_, _tmp10_);
#line 342 "../src/widgets/CompletionTextView.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 342 "../src/widgets/CompletionTextView.vala"
	current_monitor = _tmp12_;
#line 343 "../src/widgets/CompletionTextView.vala"
	_tmp13_ = current_monitor;
#line 343 "../src/widgets/CompletionTextView.vala"
	gdk_monitor_get_workarea (_tmp13_, &_tmp14_);
#line 343 "../src/widgets/CompletionTextView.vala"
	workarea = _tmp14_;
#line 344 "../src/widgets/CompletionTextView.vala"
	completion_height = 100;
#line 348 "../src/widgets/CompletionTextView.vala"
	_tmp15_ = alloc;
#line 348 "../src/widgets/CompletionTextView.vala"
	_tmp16_ = workarea;
#line 348 "../src/widgets/CompletionTextView.vala"
	if (((y + _tmp15_.height) + completion_height) <= _tmp16_.height) {
#line 1617 "CompletionTextView.c"
		GtkAllocation _tmp17_;
#line 349 "../src/widgets/CompletionTextView.vala"
		_tmp17_ = alloc;
#line 349 "../src/widgets/CompletionTextView.vala"
		y += _tmp17_.height;
#line 1623 "CompletionTextView.c"
	} else {
#line 352 "../src/widgets/CompletionTextView.vala"
		y -= completion_height;
#line 1627 "CompletionTextView.c"
	}
#line 357 "../src/widgets/CompletionTextView.vala"
	_tmp18_ = self->priv->completion_window;
#line 357 "../src/widgets/CompletionTextView.vala"
	gtk_window_set_attached_to (_tmp18_, (GtkWidget*) self);
#line 358 "../src/widgets/CompletionTextView.vala"
	_tmp19_ = self->priv->completion_window;
#line 358 "../src/widgets/CompletionTextView.vala"
	_tmp20_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 358 "../src/widgets/CompletionTextView.vala"
	gtk_window_set_transient_for (_tmp19_, G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_window_get_type (), GtkWindow));
#line 359 "../src/widgets/CompletionTextView.vala"
	_tmp21_ = self->priv->completion_window;
#line 359 "../src/widgets/CompletionTextView.vala"
	gtk_window_move (_tmp21_, x - 1, y);
#line 360 "../src/widgets/CompletionTextView.vala"
	_tmp22_ = self->priv->completion_window;
#line 360 "../src/widgets/CompletionTextView.vala"
	_tmp23_ = alloc;
#line 360 "../src/widgets/CompletionTextView.vala"
	gtk_window_resize (_tmp22_, _tmp23_.width + 2, completion_height);
#line 361 "../src/widgets/CompletionTextView.vala"
	_tmp24_ = self->priv->completion_window;
#line 361 "../src/widgets/CompletionTextView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp24_);
#line 325 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (current_monitor);
#line 325 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (default_display);
#line 325 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (window);
#line 1659 "CompletionTextView.c"
}

static void
completion_text_view_hide_completion_window (CompletionTextView* self)
{
	GtkWindow* _tmp0_;
#line 364 "../src/widgets/CompletionTextView.vala"
	g_return_if_fail (self != NULL);
#line 365 "../src/widgets/CompletionTextView.vala"
	_g_free0 (self->priv->current_word);
#line 365 "../src/widgets/CompletionTextView.vala"
	self->priv->current_word = NULL;
#line 367 "../src/widgets/CompletionTextView.vala"
	if (!self->priv->_default_listbox) {
#line 368 "../src/widgets/CompletionTextView.vala"
		g_signal_emit (self, completion_text_view_signals[COMPLETION_TEXT_VIEW_HIDE_COMPLETION_SIGNAL], 0);
#line 369 "../src/widgets/CompletionTextView.vala"
		return;
#line 1678 "CompletionTextView.c"
	}
#line 372 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = self->priv->completion_window;
#line 372 "../src/widgets/CompletionTextView.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 1684 "CompletionTextView.c"
}

static gboolean
completion_text_view_completion_window_focus_out_cb (CompletionTextView* self)
{
	gboolean result;
#line 375 "../src/widgets/CompletionTextView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 376 "../src/widgets/CompletionTextView.vala"
	if (self->priv->_default_listbox) {
#line 377 "../src/widgets/CompletionTextView.vala"
		completion_text_view_hide_completion_window (self);
#line 1697 "CompletionTextView.c"
	}
#line 380 "../src/widgets/CompletionTextView.vala"
	result = FALSE;
#line 380 "../src/widgets/CompletionTextView.vala"
	return result;
#line 1703 "CompletionTextView.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 1720 "CompletionTextView.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 1743 "CompletionTextView.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 1752 "CompletionTextView.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1771 "CompletionTextView.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1775 "CompletionTextView.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1781 "CompletionTextView.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1791 "CompletionTextView.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1799 "CompletionTextView.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1803 "CompletionTextView.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 1809 "CompletionTextView.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 1819 "CompletionTextView.c"
}

static Block80Data*
block80_data_ref (Block80Data* _data80_)
{
#line 397 "../src/widgets/CompletionTextView.vala"
	g_atomic_int_inc (&_data80_->_ref_count_);
#line 397 "../src/widgets/CompletionTextView.vala"
	return _data80_;
#line 1829 "CompletionTextView.c"
}

static void
block80_data_unref (void * _userdata_)
{
	Block80Data* _data80_;
	_data80_ = (Block80Data*) _userdata_;
#line 397 "../src/widgets/CompletionTextView.vala"
	if (g_atomic_int_dec_and_test (&_data80_->_ref_count_)) {
#line 1839 "CompletionTextView.c"
		CompletionTextView* self;
#line 397 "../src/widgets/CompletionTextView.vala"
		self = _data80_->self;
#line 397 "../src/widgets/CompletionTextView.vala"
		_g_object_unref0 (self);
#line 397 "../src/widgets/CompletionTextView.vala"
		g_slice_free (Block80Data, _data80_);
#line 1847 "CompletionTextView.c"
	}
}

static void
_vala_CbUserInfo_array_free (CbUserInfo * array,
                             gssize array_length)
{
#line 408 "../src/widgets/CompletionTextView.vala"
	if (array != NULL) {
#line 1857 "CompletionTextView.c"
		gssize i;
#line 408 "../src/widgets/CompletionTextView.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 408 "../src/widgets/CompletionTextView.vala"
			cb_user_info_destroy (&array[i]);
#line 1863 "CompletionTextView.c"
		}
	}
#line 408 "../src/widgets/CompletionTextView.vala"
	g_free (array);
#line 1868 "CompletionTextView.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1259 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1260 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1261 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 1884 "CompletionTextView.c"
		gchar* _tmp0_;
#line 1262 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1262 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1263 "glib-2.0.vapi"
		result = TRUE;
#line 1263 "glib-2.0.vapi"
		if (c) {
#line 1263 "glib-2.0.vapi"
			*c = _vala_c;
#line 1896 "CompletionTextView.c"
		}
#line 1263 "glib-2.0.vapi"
		return result;
#line 1900 "CompletionTextView.c"
	} else {
#line 1265 "glib-2.0.vapi"
		result = FALSE;
#line 1265 "glib-2.0.vapi"
		if (c) {
#line 1265 "glib-2.0.vapi"
			*c = _vala_c;
#line 1908 "CompletionTextView.c"
		}
#line 1265 "glib-2.0.vapi"
		return result;
#line 1912 "CompletionTextView.c"
	}
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1079 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1079 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1080 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1081 "glib-2.0.vapi"
	result = str;
#line 1081 "glib-2.0.vapi"
	return result;
#line 1932 "CompletionTextView.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1954 "CompletionTextView.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1958 "CompletionTextView.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1964 "CompletionTextView.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1968 "CompletionTextView.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1972 "CompletionTextView.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 1980 "CompletionTextView.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2008 "CompletionTextView.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 2017 "CompletionTextView.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2031 "CompletionTextView.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 2040 "CompletionTextView.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 2054 "CompletionTextView.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2063 "CompletionTextView.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 2072 "CompletionTextView.c"
}

static void
_vala_CbUserIdentity_array_free (CbUserIdentity * array,
                                 gssize array_length)
{
#line 439 "../src/widgets/CompletionTextView.vala"
	if (array != NULL) {
#line 2081 "CompletionTextView.c"
		gssize i;
#line 439 "../src/widgets/CompletionTextView.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 439 "../src/widgets/CompletionTextView.vala"
			cb_user_identity_free (&array[i]);
#line 2087 "CompletionTextView.c"
		}
	}
#line 439 "../src/widgets/CompletionTextView.vala"
	g_free (array);
#line 2092 "CompletionTextView.c"
}

static void
____lambda43_ (Block80Data* _data80_,
               GObject* obj,
               GAsyncResult* res)
{
	CompletionTextView* self;
	CbUserIdentity* users = NULL;
	gint users_length1 = 0;
	gint _users_size_ = 0;
	CbUserCompletionModel* _tmp7_;
	CbUserIdentity* _tmp8_;
	gint _tmp8__length1;
	gboolean _tmp9_ = FALSE;
	CbUserIdentity* _tmp10_;
	gint _tmp10__length1;
	GError* _inner_error0_ = NULL;
#line 436 "../src/widgets/CompletionTextView.vala"
	self = _data80_->self;
#line 436 "../src/widgets/CompletionTextView.vala"
	g_return_if_fail (res != NULL);
#line 2115 "CompletionTextView.c"
	{
		CbUserIdentity* _tmp0_ = NULL;
		gint _tmp1_ = 0;
		CbUserIdentity* _tmp2_;
		gint _tmp0__length1;
		gint __tmp0__size_;
		CbUserIdentity* _tmp3_;
		gint _tmp3__length1;
#line 439 "../src/widgets/CompletionTextView.vala"
		_tmp2_ = cb_utils_query_users_finish (res, &_tmp1_, &_inner_error0_);
#line 439 "../src/widgets/CompletionTextView.vala"
		_tmp0_ = _tmp2_;
#line 439 "../src/widgets/CompletionTextView.vala"
		_tmp0__length1 = _tmp1_;
#line 439 "../src/widgets/CompletionTextView.vala"
		__tmp0__size_ = _tmp0__length1;
#line 439 "../src/widgets/CompletionTextView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2134 "CompletionTextView.c"
			goto __catch0_g_error;
		}
#line 439 "../src/widgets/CompletionTextView.vala"
		_tmp3_ = _tmp0_;
#line 439 "../src/widgets/CompletionTextView.vala"
		_tmp3__length1 = _tmp0__length1;
#line 439 "../src/widgets/CompletionTextView.vala"
		_tmp0_ = NULL;
#line 439 "../src/widgets/CompletionTextView.vala"
		_tmp0__length1 = 0;
#line 439 "../src/widgets/CompletionTextView.vala"
		users = (_vala_CbUserIdentity_array_free (users, users_length1), NULL);
#line 439 "../src/widgets/CompletionTextView.vala"
		users = _tmp3_;
#line 439 "../src/widgets/CompletionTextView.vala"
		users_length1 = _tmp3__length1;
#line 439 "../src/widgets/CompletionTextView.vala"
		_users_size_ = users_length1;
#line 438 "../src/widgets/CompletionTextView.vala"
		_tmp0_ = (_vala_CbUserIdentity_array_free (_tmp0_, _tmp0__length1), NULL);
#line 2155 "CompletionTextView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
#line 438 "../src/widgets/CompletionTextView.vala"
		e = _inner_error0_;
#line 438 "../src/widgets/CompletionTextView.vala"
		_inner_error0_ = NULL;
#line 441 "../src/widgets/CompletionTextView.vala"
		_tmp4_ = e;
#line 441 "../src/widgets/CompletionTextView.vala"
		if (!g_error_matches (_tmp4_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 2170 "CompletionTextView.c"
			GError* _tmp5_;
			const gchar* _tmp6_;
#line 442 "../src/widgets/CompletionTextView.vala"
			_tmp5_ = e;
#line 442 "../src/widgets/CompletionTextView.vala"
			_tmp6_ = _tmp5_->message;
#line 442 "../src/widgets/CompletionTextView.vala"
			g_warning ("CompletionTextView.vala:442: User completion call error: %s", _tmp6_);
#line 2179 "CompletionTextView.c"
		}
#line 444 "../src/widgets/CompletionTextView.vala"
		_g_error_free0 (e);
#line 444 "../src/widgets/CompletionTextView.vala"
		users = (_vala_CbUserIdentity_array_free (users, users_length1), NULL);
#line 444 "../src/widgets/CompletionTextView.vala"
		return;
#line 2187 "CompletionTextView.c"
	}
	__finally0:
#line 438 "../src/widgets/CompletionTextView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 438 "../src/widgets/CompletionTextView.vala"
		users = (_vala_CbUserIdentity_array_free (users, users_length1), NULL);
#line 438 "../src/widgets/CompletionTextView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 438 "../src/widgets/CompletionTextView.vala"
		g_clear_error (&_inner_error0_);
#line 438 "../src/widgets/CompletionTextView.vala"
		return;
#line 2200 "CompletionTextView.c"
	}
#line 447 "../src/widgets/CompletionTextView.vala"
	_tmp7_ = self->priv->completion_model;
#line 447 "../src/widgets/CompletionTextView.vala"
	_tmp8_ = users;
#line 447 "../src/widgets/CompletionTextView.vala"
	_tmp8__length1 = users_length1;
#line 447 "../src/widgets/CompletionTextView.vala"
	cb_user_completion_model_insert_items (_tmp7_, _tmp8_, (gint) _tmp8__length1);
#line 448 "../src/widgets/CompletionTextView.vala"
	_tmp10_ = users;
#line 448 "../src/widgets/CompletionTextView.vala"
	_tmp10__length1 = users_length1;
#line 448 "../src/widgets/CompletionTextView.vala"
	if (_tmp10__length1 > 0) {
#line 448 "../src/widgets/CompletionTextView.vala"
		_tmp9_ = _data80_->corpus_was_empty;
#line 2218 "CompletionTextView.c"
	} else {
#line 448 "../src/widgets/CompletionTextView.vala"
		_tmp9_ = FALSE;
#line 2222 "CompletionTextView.c"
	}
#line 448 "../src/widgets/CompletionTextView.vala"
	if (_tmp9_) {
#line 2226 "CompletionTextView.c"
		GtkListBox* _tmp11_;
		GtkListBoxRow* _tmp12_;
#line 449 "../src/widgets/CompletionTextView.vala"
		_tmp11_ = self->priv->completion_list;
#line 449 "../src/widgets/CompletionTextView.vala"
		_tmp12_ = gtk_list_box_get_row_at_index (_tmp11_, 0);
#line 449 "../src/widgets/CompletionTextView.vala"
		completion_text_view_select_completion_row (self, _tmp12_);
#line 2235 "CompletionTextView.c"
	}
#line 436 "../src/widgets/CompletionTextView.vala"
	users = (_vala_CbUserIdentity_array_free (users, users_length1), NULL);
#line 2239 "CompletionTextView.c"
}

static void
_____lambda43__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 436 "../src/widgets/CompletionTextView.vala"
	____lambda43_ (self, source_object, res);
#line 436 "../src/widgets/CompletionTextView.vala"
	block80_data_unref (self);
#line 2251 "CompletionTextView.c"
}

static void
completion_text_view_update_completion_listbox (CompletionTextView* self)
{
	gchar* cur_word = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	gchar* _tmp2_;
	gint n_chars = 0;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
#line 384 "../src/widgets/CompletionTextView.vala"
	g_return_if_fail (self != NULL);
#line 385 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 385 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = _tmp0_;
#line 385 "../src/widgets/CompletionTextView.vala"
	_tmp2_ = utils_get_cursor_mention_word (_tmp1_, NULL, NULL);
#line 385 "../src/widgets/CompletionTextView.vala"
	cur_word = _tmp2_;
#line 386 "../src/widgets/CompletionTextView.vala"
	_tmp3_ = cur_word;
#line 386 "../src/widgets/CompletionTextView.vala"
	n_chars = g_utf8_strlen (_tmp3_, (gssize) -1);
#line 388 "../src/widgets/CompletionTextView.vala"
	if (n_chars < 2) {
#line 388 "../src/widgets/CompletionTextView.vala"
		_tmp5_ = TRUE;
#line 2287 "CompletionTextView.c"
	} else {
		const gchar* _tmp6_;
#line 388 "../src/widgets/CompletionTextView.vala"
		_tmp6_ = cur_word;
#line 388 "../src/widgets/CompletionTextView.vala"
		_tmp5_ = string_get (_tmp6_, (glong) 0) != '@';
#line 2294 "CompletionTextView.c"
	}
#line 388 "../src/widgets/CompletionTextView.vala"
	if (_tmp5_) {
#line 388 "../src/widgets/CompletionTextView.vala"
		_tmp4_ = TRUE;
#line 2300 "CompletionTextView.c"
	} else {
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 389 "../src/widgets/CompletionTextView.vala"
		_tmp7_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 389 "../src/widgets/CompletionTextView.vala"
		_tmp8_ = _tmp7_;
#line 389 "../src/widgets/CompletionTextView.vala"
		_tmp9_ = gtk_text_buffer_get_has_selection (_tmp8_);
#line 389 "../src/widgets/CompletionTextView.vala"
		_tmp10_ = _tmp9_;
#line 389 "../src/widgets/CompletionTextView.vala"
		_tmp4_ = _tmp10_;
#line 2316 "CompletionTextView.c"
	}
#line 388 "../src/widgets/CompletionTextView.vala"
	if (_tmp4_) {
#line 390 "../src/widgets/CompletionTextView.vala"
		completion_text_view_hide_completion_window (self);
#line 391 "../src/widgets/CompletionTextView.vala"
		_g_free0 (cur_word);
#line 391 "../src/widgets/CompletionTextView.vala"
		return;
#line 2326 "CompletionTextView.c"
	}
#line 395 "../src/widgets/CompletionTextView.vala"
	_tmp11_ = cur_word;
#line 395 "../src/widgets/CompletionTextView.vala"
	_tmp12_ = string_substring (_tmp11_, (glong) 1, (glong) -1);
#line 395 "../src/widgets/CompletionTextView.vala"
	_g_free0 (cur_word);
#line 395 "../src/widgets/CompletionTextView.vala"
	cur_word = _tmp12_;
#line 397 "../src/widgets/CompletionTextView.vala"
	_tmp13_ = cur_word;
#line 397 "../src/widgets/CompletionTextView.vala"
	_tmp14_ = self->priv->current_word;
#line 397 "../src/widgets/CompletionTextView.vala"
	if (g_strcmp0 (_tmp13_, _tmp14_) != 0) {
#line 2342 "CompletionTextView.c"
		Block80Data* _data80_;
		GCancellable* _tmp15_;
		CbUserInfo* corpus = NULL;
		gint corpus_length1 = 0;
		gint _corpus_size_ = 0;
		Account* _tmp17_;
		CbUserCounter* _tmp18_;
		Account* _tmp19_;
		SqlDatabase* _tmp20_;
		sqlite3* _tmp21_;
		const gchar* _tmp22_;
		CbUserInfo* _tmp23_ = NULL;
		gint _tmp24_ = 0;
		CbUserCompletionModel* _tmp25_;
		CbUserInfo* _tmp26_;
		gint _tmp26__length1;
		CbUserInfo* _tmp27_;
		gint _tmp27__length1;
		CbUserInfo* _tmp28_;
		gint _tmp28__length1;
		gboolean has_alnum = FALSE;
		gunichar c = 0U;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		GtkListBox* _tmp51_;
#line 397 "../src/widgets/CompletionTextView.vala"
		_data80_ = g_slice_new0 (Block80Data);
#line 397 "../src/widgets/CompletionTextView.vala"
		_data80_->_ref_count_ = 1;
#line 397 "../src/widgets/CompletionTextView.vala"
		_data80_->self = g_object_ref (self);
#line 398 "../src/widgets/CompletionTextView.vala"
		_tmp15_ = self->priv->completion_cancellable;
#line 398 "../src/widgets/CompletionTextView.vala"
		if (_tmp15_ != NULL) {
#line 2378 "CompletionTextView.c"
			GCancellable* _tmp16_;
#line 399 "../src/widgets/CompletionTextView.vala"
			g_debug ("CompletionTextView.vala:399: Cancelling earlier completion call...");
#line 400 "../src/widgets/CompletionTextView.vala"
			_tmp16_ = self->priv->completion_cancellable;
#line 400 "../src/widgets/CompletionTextView.vala"
			g_cancellable_cancel (_tmp16_);
#line 2386 "CompletionTextView.c"
		}
#line 404 "../src/widgets/CompletionTextView.vala"
		completion_text_view_show_completion_window (self);
#line 408 "../src/widgets/CompletionTextView.vala"
		_tmp17_ = self->priv->account;
#line 408 "../src/widgets/CompletionTextView.vala"
		_tmp18_ = _tmp17_->user_counter;
#line 408 "../src/widgets/CompletionTextView.vala"
		_tmp19_ = self->priv->account;
#line 408 "../src/widgets/CompletionTextView.vala"
		_tmp20_ = _tmp19_->db;
#line 408 "../src/widgets/CompletionTextView.vala"
		_tmp21_ = sql_database_get_sqlite_db (_tmp20_);
#line 408 "../src/widgets/CompletionTextView.vala"
		_tmp22_ = cur_word;
#line 408 "../src/widgets/CompletionTextView.vala"
		cb_user_counter_query_by_prefix (_tmp18_, _tmp21_, _tmp22_, 10, &_tmp23_, &_tmp24_);
#line 408 "../src/widgets/CompletionTextView.vala"
		corpus = (_vala_CbUserInfo_array_free (corpus, corpus_length1), NULL);
#line 408 "../src/widgets/CompletionTextView.vala"
		corpus = _tmp23_;
#line 408 "../src/widgets/CompletionTextView.vala"
		corpus_length1 = _tmp24_;
#line 408 "../src/widgets/CompletionTextView.vala"
		_corpus_size_ = corpus_length1;
#line 411 "../src/widgets/CompletionTextView.vala"
		_tmp25_ = self->priv->completion_model;
#line 411 "../src/widgets/CompletionTextView.vala"
		_tmp26_ = corpus;
#line 411 "../src/widgets/CompletionTextView.vala"
		_tmp26__length1 = corpus_length1;
#line 411 "../src/widgets/CompletionTextView.vala"
		cb_user_completion_model_insert_infos (_tmp25_, _tmp26_, (gint) _tmp26__length1);
#line 413 "../src/widgets/CompletionTextView.vala"
		_tmp27_ = corpus;
#line 413 "../src/widgets/CompletionTextView.vala"
		_tmp27__length1 = corpus_length1;
#line 413 "../src/widgets/CompletionTextView.vala"
		_data80_->corpus_was_empty = _tmp27__length1 == 0;
#line 414 "../src/widgets/CompletionTextView.vala"
		_tmp28_ = corpus;
#line 414 "../src/widgets/CompletionTextView.vala"
		_tmp28__length1 = corpus_length1;
#line 414 "../src/widgets/CompletionTextView.vala"
		if (_tmp28__length1 > 0) {
#line 2432 "CompletionTextView.c"
			GtkListBox* _tmp29_;
			GtkListBoxRow* _tmp30_;
#line 415 "../src/widgets/CompletionTextView.vala"
			_tmp29_ = self->priv->completion_list;
#line 415 "../src/widgets/CompletionTextView.vala"
			_tmp30_ = gtk_list_box_get_row_at_index (_tmp29_, 0);
#line 415 "../src/widgets/CompletionTextView.vala"
			completion_text_view_select_completion_row (self, _tmp30_);
#line 2441 "CompletionTextView.c"
		}
#line 417 "../src/widgets/CompletionTextView.vala"
		corpus = (_vala_CbUserInfo_array_free (corpus, corpus_length1), NULL);
#line 417 "../src/widgets/CompletionTextView.vala"
		corpus = NULL;
#line 417 "../src/widgets/CompletionTextView.vala"
		corpus_length1 = 0;
#line 417 "../src/widgets/CompletionTextView.vala"
		_corpus_size_ = corpus_length1;
#line 420 "../src/widgets/CompletionTextView.vala"
		has_alnum = FALSE;
#line 2453 "CompletionTextView.c"
		{
			gint i = 0;
#line 422 "../src/widgets/CompletionTextView.vala"
			i = 0;
#line 2458 "CompletionTextView.c"
			{
				gboolean _tmp31_ = FALSE;
#line 422 "../src/widgets/CompletionTextView.vala"
				_tmp31_ = TRUE;
#line 422 "../src/widgets/CompletionTextView.vala"
				while (TRUE) {
#line 2465 "CompletionTextView.c"
					const gchar* _tmp32_;
					gunichar _tmp33_ = 0U;
					gboolean _tmp34_;
#line 422 "../src/widgets/CompletionTextView.vala"
					if (!_tmp31_) {
#line 2471 "CompletionTextView.c"
					}
#line 422 "../src/widgets/CompletionTextView.vala"
					_tmp31_ = FALSE;
#line 422 "../src/widgets/CompletionTextView.vala"
					_tmp32_ = cur_word;
#line 422 "../src/widgets/CompletionTextView.vala"
					_tmp34_ = string_get_next_char (_tmp32_, &i, &_tmp33_);
#line 422 "../src/widgets/CompletionTextView.vala"
					c = _tmp33_;
#line 422 "../src/widgets/CompletionTextView.vala"
					if (!_tmp34_) {
#line 422 "../src/widgets/CompletionTextView.vala"
						break;
#line 2485 "CompletionTextView.c"
					}
#line 423 "../src/widgets/CompletionTextView.vala"
					if (g_unichar_isalnum (c)) {
#line 2489 "CompletionTextView.c"
						gchar* _tmp35_;
						gchar* _tmp36_;
#line 424 "../src/widgets/CompletionTextView.vala"
						_tmp35_ = g_unichar_to_string (c);
#line 424 "../src/widgets/CompletionTextView.vala"
						_tmp36_ = _tmp35_;
#line 424 "../src/widgets/CompletionTextView.vala"
						g_debug ("CompletionTextView.vala:424: Found alnum at %d: %s\n", i, _tmp36_);
#line 424 "../src/widgets/CompletionTextView.vala"
						_g_free0 (_tmp36_);
#line 425 "../src/widgets/CompletionTextView.vala"
						has_alnum = TRUE;
#line 426 "../src/widgets/CompletionTextView.vala"
						break;
#line 2504 "CompletionTextView.c"
					}
				}
			}
		}
#line 431 "../src/widgets/CompletionTextView.vala"
		if (has_alnum) {
#line 2511 "CompletionTextView.c"
			GCancellable* _tmp37_;
			gchar* cur_word_query = NULL;
			const gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			Account* _tmp45_;
			OAuthProxy* _tmp46_;
			const gchar* _tmp47_;
			GCancellable* _tmp48_;
#line 434 "../src/widgets/CompletionTextView.vala"
			_tmp37_ = g_cancellable_new ();
#line 434 "../src/widgets/CompletionTextView.vala"
			_g_object_unref0 (self->priv->completion_cancellable);
#line 434 "../src/widgets/CompletionTextView.vala"
			self->priv->completion_cancellable = _tmp37_;
#line 435 "../src/widgets/CompletionTextView.vala"
			_tmp38_ = cur_word;
#line 435 "../src/widgets/CompletionTextView.vala"
			_tmp39_ = string_replace (_tmp38_, "\\", "\\\\");
#line 435 "../src/widgets/CompletionTextView.vala"
			_tmp40_ = _tmp39_;
#line 435 "../src/widgets/CompletionTextView.vala"
			_tmp41_ = string_replace (_tmp40_, "\"", "\\\"");
#line 435 "../src/widgets/CompletionTextView.vala"
			_tmp42_ = _tmp41_;
#line 435 "../src/widgets/CompletionTextView.vala"
			_tmp43_ = g_strdup_printf ("\"%s\"", _tmp42_);
#line 435 "../src/widgets/CompletionTextView.vala"
			_tmp44_ = _tmp43_;
#line 435 "../src/widgets/CompletionTextView.vala"
			_g_free0 (_tmp42_);
#line 435 "../src/widgets/CompletionTextView.vala"
			_g_free0 (_tmp40_);
#line 435 "../src/widgets/CompletionTextView.vala"
			cur_word_query = _tmp44_;
#line 436 "../src/widgets/CompletionTextView.vala"
			_tmp45_ = self->priv->account;
#line 436 "../src/widgets/CompletionTextView.vala"
			_tmp46_ = _tmp45_->proxy;
#line 436 "../src/widgets/CompletionTextView.vala"
			_tmp47_ = cur_word_query;
#line 436 "../src/widgets/CompletionTextView.vala"
			_tmp48_ = self->priv->completion_cancellable;
#line 436 "../src/widgets/CompletionTextView.vala"
			cb_utils_query_users_async ((RestProxy*) _tmp46_, _tmp47_, _tmp48_, _____lambda43__gasync_ready_callback, block80_data_ref (_data80_));
#line 431 "../src/widgets/CompletionTextView.vala"
			_g_free0 (cur_word_query);
#line 2563 "CompletionTextView.c"
		}
#line 454 "../src/widgets/CompletionTextView.vala"
		_tmp49_ = cur_word;
#line 454 "../src/widgets/CompletionTextView.vala"
		_tmp50_ = g_strdup (_tmp49_);
#line 454 "../src/widgets/CompletionTextView.vala"
		_g_free0 (self->priv->current_word);
#line 454 "../src/widgets/CompletionTextView.vala"
		self->priv->current_word = _tmp50_;
#line 456 "../src/widgets/CompletionTextView.vala"
		_tmp51_ = self->priv->completion_list;
#line 456 "../src/widgets/CompletionTextView.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp51_);
#line 397 "../src/widgets/CompletionTextView.vala"
		corpus = (_vala_CbUserInfo_array_free (corpus, corpus_length1), NULL);
#line 397 "../src/widgets/CompletionTextView.vala"
		block80_data_unref (_data80_);
#line 397 "../src/widgets/CompletionTextView.vala"
		_data80_ = NULL;
#line 2583 "CompletionTextView.c"
	}
#line 384 "../src/widgets/CompletionTextView.vala"
	_g_free0 (cur_word);
#line 2587 "CompletionTextView.c"
}

static GtkWidget*
completion_text_view_create_completion_row (CompletionTextView* self,
                                            void* id_ptr)
{
	CbUserIdentity* id = NULL;
	UserCompletionRow* row = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	UserCompletionRow* _tmp2_;
	GtkWidget* result;
#line 460 "../src/widgets/CompletionTextView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 462 "../src/widgets/CompletionTextView.vala"
	id = (CbUserIdentity*) id_ptr;
#line 463 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = (*id).user_name;
#line 463 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = (*id).screen_name;
#line 463 "../src/widgets/CompletionTextView.vala"
	_tmp2_ = user_completion_row_new ((*id).id, _tmp0_, _tmp1_, (*id).verified, (*id).protected_account);
#line 463 "../src/widgets/CompletionTextView.vala"
	g_object_ref_sink (_tmp2_);
#line 463 "../src/widgets/CompletionTextView.vala"
	row = _tmp2_;
#line 465 "../src/widgets/CompletionTextView.vala"
	gtk_widget_show ((GtkWidget*) row);
#line 466 "../src/widgets/CompletionTextView.vala"
	result = (GtkWidget*) row;
#line 466 "../src/widgets/CompletionTextView.vala"
	return result;
#line 2620 "CompletionTextView.c"
}

CompletionTextView*
completion_text_view_construct (GType object_type)
{
	CompletionTextView * self = NULL;
#line 18 "../src/widgets/CompletionTextView.vala"
	self = (CompletionTextView*) g_object_new (object_type, NULL);
#line 18 "../src/widgets/CompletionTextView.vala"
	return self;
#line 2631 "CompletionTextView.c"
}

CompletionTextView*
completion_text_view_new (void)
{
#line 18 "../src/widgets/CompletionTextView.vala"
	return completion_text_view_construct (TYPE_COMPLETION_TEXT_VIEW);
#line 2639 "CompletionTextView.c"
}

static void
_completion_text_view_insert_user_completion_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                         GtkListBoxRow* row,
                                                                         gpointer self)
{
#line 35 "../src/widgets/CompletionTextView.vala"
	completion_text_view_insert_user_completion ((CompletionTextView*) self);
#line 2649 "CompletionTextView.c"
}

static GtkWidget*
_completion_text_view_create_completion_row_cbutils_createwidgetfunc (void* item,
                                                                      gpointer self)
{
	GtkWidget* result;
	result = completion_text_view_create_completion_row ((CompletionTextView*) self, item);
#line 37 "../src/widgets/CompletionTextView.vala"
	return result;
#line 2660 "CompletionTextView.c"
}

void
completion_text_view_set_completion_listbox (CompletionTextView* self,
                                             GtkListBox* value)
{
	GtkListBox* _tmp0_;
	CbUserCompletionModel* _tmp1_;
	GtkListBox* _tmp2_;
	guint _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	CbUserCompletionModel* _tmp6_;
	GtkListBox* _tmp7_;
#line 32 "../src/widgets/CompletionTextView.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/widgets/CompletionTextView.vala"
	self->priv->_default_listbox = FALSE;
#line 34 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = self->priv->completion_list;
#line 34 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = self->priv->completion_model;
#line 34 "../src/widgets/CompletionTextView.vala"
	cb_utils_unbind_non_gobject_model (_tmp0_, (GListModel*) _tmp1_);
#line 35 "../src/widgets/CompletionTextView.vala"
	_tmp2_ = self->priv->completion_list;
#line 35 "../src/widgets/CompletionTextView.vala"
	g_signal_parse_name ("row-activated", gtk_list_box_get_type (), &_tmp3_, NULL, FALSE);
#line 35 "../src/widgets/CompletionTextView.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _completion_text_view_insert_user_completion_gtk_list_box_row_activated, self);
#line 36 "../src/widgets/CompletionTextView.vala"
	_tmp4_ = _g_object_ref0 (value);
#line 36 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->completion_list);
#line 36 "../src/widgets/CompletionTextView.vala"
	self->priv->completion_list = _tmp4_;
#line 37 "../src/widgets/CompletionTextView.vala"
	_tmp5_ = self->priv->completion_list;
#line 37 "../src/widgets/CompletionTextView.vala"
	_tmp6_ = self->priv->completion_model;
#line 37 "../src/widgets/CompletionTextView.vala"
	cb_utils_bind_non_gobject_model ((GtkWidget*) _tmp5_, (GListModel*) _tmp6_, _completion_text_view_create_completion_row_cbutils_createwidgetfunc, self);
#line 38 "../src/widgets/CompletionTextView.vala"
	_tmp7_ = self->priv->completion_list;
#line 38 "../src/widgets/CompletionTextView.vala"
	g_signal_connect_object (_tmp7_, "row-activated", (GCallback) _completion_text_view_insert_user_completion_gtk_list_box_row_activated, self, 0);
#line 32 "../src/widgets/CompletionTextView.vala"
	g_object_notify_by_pspec ((GObject *) self, completion_text_view_properties[COMPLETION_TEXT_VIEW_COMPLETION_LISTBOX_PROPERTY]);
#line 2709 "CompletionTextView.c"
}

static gboolean
_completion_text_view_completion_window_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                 GdkEventFocus* event,
                                                                                 gpointer self)
{
	gboolean result;
	result = completion_text_view_completion_window_focus_out_cb ((CompletionTextView*) self);
#line 54 "../src/widgets/CompletionTextView.vala"
	return result;
#line 2721 "CompletionTextView.c"
}

static void
_completion_text_view_update_completion_listbox_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self)
{
#line 111 "../src/widgets/CompletionTextView.vala"
	completion_text_view_update_completion_listbox ((CompletionTextView*) self);
#line 2731 "CompletionTextView.c"
}

static void
_completion_text_view_buffer_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                 gpointer self)
{
#line 112 "../src/widgets/CompletionTextView.vala"
	completion_text_view_buffer_changed_cb ((CompletionTextView*) self);
#line 2740 "CompletionTextView.c"
}

static gboolean
_completion_text_view_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                     GdkEventKey* event,
                                                                     gpointer self)
{
	gboolean result;
	result = completion_text_view_key_press_event_cb ((CompletionTextView*) self, event);
#line 113 "../src/widgets/CompletionTextView.vala"
	return result;
#line 2752 "CompletionTextView.c"
}

static GObject *
completion_text_view_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CompletionTextView * self;
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp3_;
	GdkScreen* _tmp4_;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
	CbUserCompletionModel* _tmp7_;
	GtkListBox* _tmp8_;
	CbUserCompletionModel* _tmp9_;
	GtkLabel* placeholder_label = NULL;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkLabel* _tmp13_;
	GtkListBox* _tmp14_;
	GtkLabel* _tmp15_;
	GtkScrolledWindow* scroller = NULL;
	GtkScrolledWindow* _tmp16_;
	GtkScrolledWindow* _tmp17_;
	GtkListBox* _tmp18_;
	GtkFrame* frame = NULL;
	GtkFrame* _tmp19_;
	GtkFrame* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkWindow* _tmp22_;
	GtkFrame* _tmp23_;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkStyleContext* _tmp27_;
	GdkRGBA link_color = {0};
	GtkStyleContext* _tmp28_;
	GtkStyleContext* _tmp29_;
	GdkRGBA _tmp30_ = {0};
	GtkStyleContext* _tmp31_;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	GdkRGBA _tmp35_;
	GdkRGBA snippet_color = {0};
	GdkRGBA _tmp40_ = {0};
	GtkTextBuffer* _tmp41_;
	GtkTextBuffer* _tmp42_;
	const gchar* _tmp43_;
	GdkRGBA _tmp44_;
	GtkTextBuffer* _tmp45_;
	GtkTextBuffer* _tmp46_;
	const gchar* _tmp47_;
	GdkRGBA _tmp48_;
	GtkTextBuffer* _tmp49_;
	GtkTextBuffer* _tmp50_;
	const gchar* _tmp51_;
	GdkRGBA _tmp52_;
	GtkTextBuffer* _tmp53_;
	GtkTextBuffer* _tmp54_;
	const gchar* _tmp55_;
	GdkRGBA _tmp56_;
	GtkTextBuffer* _tmp57_;
	GtkTextBuffer* _tmp58_;
	GtkTextBuffer* _tmp59_;
	GtkTextBuffer* _tmp60_;
	GtkTextBuffer* _tmp61_;
	GtkTextBuffer* _tmp62_;
	GspellTextView* gspell_view = NULL;
	GspellTextView* _tmp63_;
	GspellTextView* _tmp64_;
	GspellTextView* _tmp65_;
	GspellTextView* _tmp66_;
	GspellTextBuffer* gspell_buffer = NULL;
	GtkTextBuffer* _tmp67_;
	GtkTextBuffer* _tmp68_;
	GspellTextBuffer* _tmp69_;
	GspellTextBuffer* _tmp70_;
	GspellChecker* checker = NULL;
	GspellLanguage* _tmp71_;
	GspellChecker* _tmp72_;
	GspellTextBuffer* _tmp73_;
	GspellChecker* _tmp74_;
#line 51 "../src/widgets/CompletionTextView.vala"
	parent_class = G_OBJECT_CLASS (completion_text_view_parent_class);
#line 51 "../src/widgets/CompletionTextView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../src/widgets/CompletionTextView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPLETION_TEXT_VIEW, CompletionTextView);
#line 52 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_POPUP);
#line 52 "../src/widgets/CompletionTextView.vala"
	g_object_ref_sink (_tmp0_);
#line 52 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->completion_window);
#line 52 "../src/widgets/CompletionTextView.vala"
	self->priv->completion_window = _tmp0_;
#line 53 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = self->priv->completion_window;
#line 53 "../src/widgets/CompletionTextView.vala"
	gtk_window_set_type_hint (_tmp1_, GDK_WINDOW_TYPE_HINT_COMBO);
#line 54 "../src/widgets/CompletionTextView.vala"
	_tmp2_ = self->priv->completion_window;
#line 54 "../src/widgets/CompletionTextView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp2_, "focus-out-event", (GCallback) _completion_text_view_completion_window_focus_out_cb_gtk_widget_focus_out_event, self, 0);
#line 55 "../src/widgets/CompletionTextView.vala"
	_tmp3_ = self->priv->completion_window;
#line 55 "../src/widgets/CompletionTextView.vala"
	_tmp4_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 55 "../src/widgets/CompletionTextView.vala"
	gtk_window_set_screen (_tmp3_, _tmp4_);
#line 57 "../src/widgets/CompletionTextView.vala"
	_tmp5_ = (GtkListBox*) gtk_list_box_new ();
#line 57 "../src/widgets/CompletionTextView.vala"
	g_object_ref_sink (_tmp5_);
#line 57 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->completion_list);
#line 57 "../src/widgets/CompletionTextView.vala"
	self->priv->completion_list = _tmp5_;
#line 58 "../src/widgets/CompletionTextView.vala"
	_tmp6_ = self->priv->completion_list;
#line 58 "../src/widgets/CompletionTextView.vala"
	g_signal_connect_object (_tmp6_, "row-activated", (GCallback) _completion_text_view_insert_user_completion_gtk_list_box_row_activated, self, 0);
#line 59 "../src/widgets/CompletionTextView.vala"
	_tmp7_ = cb_user_completion_model_new ();
#line 59 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->completion_model);
#line 59 "../src/widgets/CompletionTextView.vala"
	self->priv->completion_model = _tmp7_;
#line 60 "../src/widgets/CompletionTextView.vala"
	_tmp8_ = self->priv->completion_list;
#line 60 "../src/widgets/CompletionTextView.vala"
	_tmp9_ = self->priv->completion_model;
#line 60 "../src/widgets/CompletionTextView.vala"
	cb_utils_bind_non_gobject_model ((GtkWidget*) _tmp8_, (GListModel*) _tmp9_, _completion_text_view_create_completion_row_cbutils_createwidgetfunc, self);
#line 61 "../src/widgets/CompletionTextView.vala"
	_tmp10_ = (GtkLabel*) gtk_label_new (_ ("No users found"));
#line 61 "../src/widgets/CompletionTextView.vala"
	g_object_ref_sink (_tmp10_);
#line 61 "../src/widgets/CompletionTextView.vala"
	placeholder_label = _tmp10_;
#line 62 "../src/widgets/CompletionTextView.vala"
	_tmp11_ = placeholder_label;
#line 62 "../src/widgets/CompletionTextView.vala"
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
#line 62 "../src/widgets/CompletionTextView.vala"
	gtk_style_context_add_class (_tmp12_, "dim-label");
#line 63 "../src/widgets/CompletionTextView.vala"
	_tmp13_ = placeholder_label;
#line 63 "../src/widgets/CompletionTextView.vala"
	gtk_widget_show ((GtkWidget*) _tmp13_);
#line 64 "../src/widgets/CompletionTextView.vala"
	_tmp14_ = self->priv->completion_list;
#line 64 "../src/widgets/CompletionTextView.vala"
	_tmp15_ = placeholder_label;
#line 64 "../src/widgets/CompletionTextView.vala"
	gtk_list_box_set_placeholder (_tmp14_, (GtkWidget*) _tmp15_);
#line 66 "../src/widgets/CompletionTextView.vala"
	_tmp16_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 66 "../src/widgets/CompletionTextView.vala"
	g_object_ref_sink (_tmp16_);
#line 66 "../src/widgets/CompletionTextView.vala"
	scroller = _tmp16_;
#line 67 "../src/widgets/CompletionTextView.vala"
	_tmp17_ = scroller;
#line 67 "../src/widgets/CompletionTextView.vala"
	_tmp18_ = self->priv->completion_list;
#line 67 "../src/widgets/CompletionTextView.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 68 "../src/widgets/CompletionTextView.vala"
	_tmp19_ = (GtkFrame*) gtk_frame_new (NULL);
#line 68 "../src/widgets/CompletionTextView.vala"
	g_object_ref_sink (_tmp19_);
#line 68 "../src/widgets/CompletionTextView.vala"
	frame = _tmp19_;
#line 69 "../src/widgets/CompletionTextView.vala"
	_tmp20_ = frame;
#line 69 "../src/widgets/CompletionTextView.vala"
	_tmp21_ = scroller;
#line 69 "../src/widgets/CompletionTextView.vala"
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 70 "../src/widgets/CompletionTextView.vala"
	_tmp22_ = self->priv->completion_window;
#line 70 "../src/widgets/CompletionTextView.vala"
	_tmp23_ = frame;
#line 70 "../src/widgets/CompletionTextView.vala"
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 72 "../src/widgets/CompletionTextView.vala"
	g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) _completion_text_view_completion_window_focus_out_cb_gtk_widget_focus_out_event, self, 0);
#line 75 "../src/widgets/CompletionTextView.vala"
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 75 "../src/widgets/CompletionTextView.vala"
	_tmp25_ = _g_object_ref0 (_tmp24_);
#line 75 "../src/widgets/CompletionTextView.vala"
	style_context = _tmp25_;
#line 76 "../src/widgets/CompletionTextView.vala"
	_tmp26_ = style_context;
#line 76 "../src/widgets/CompletionTextView.vala"
	gtk_style_context_save (_tmp26_);
#line 77 "../src/widgets/CompletionTextView.vala"
	_tmp27_ = style_context;
#line 77 "../src/widgets/CompletionTextView.vala"
	gtk_style_context_set_state (_tmp27_, GTK_STATE_FLAG_LINK);
#line 78 "../src/widgets/CompletionTextView.vala"
	_tmp28_ = style_context;
#line 78 "../src/widgets/CompletionTextView.vala"
	_tmp29_ = style_context;
#line 78 "../src/widgets/CompletionTextView.vala"
	gtk_style_context_get_color (_tmp28_, gtk_style_context_get_state (_tmp29_), &_tmp30_);
#line 78 "../src/widgets/CompletionTextView.vala"
	link_color = _tmp30_;
#line 79 "../src/widgets/CompletionTextView.vala"
	_tmp31_ = style_context;
#line 79 "../src/widgets/CompletionTextView.vala"
	gtk_style_context_restore (_tmp31_);
#line 81 "../src/widgets/CompletionTextView.vala"
	_tmp35_ = link_color;
#line 81 "../src/widgets/CompletionTextView.vala"
	if (_tmp35_.red == 1.0) {
#line 2979 "CompletionTextView.c"
		GdkRGBA _tmp36_;
#line 82 "../src/widgets/CompletionTextView.vala"
		_tmp36_ = link_color;
#line 82 "../src/widgets/CompletionTextView.vala"
		_tmp34_ = _tmp36_.green == 1.0;
#line 2985 "CompletionTextView.c"
	} else {
#line 81 "../src/widgets/CompletionTextView.vala"
		_tmp34_ = FALSE;
#line 2989 "CompletionTextView.c"
	}
#line 81 "../src/widgets/CompletionTextView.vala"
	if (_tmp34_) {
#line 2993 "CompletionTextView.c"
		GdkRGBA _tmp37_;
#line 83 "../src/widgets/CompletionTextView.vala"
		_tmp37_ = link_color;
#line 83 "../src/widgets/CompletionTextView.vala"
		_tmp33_ = _tmp37_.blue == 1.0;
#line 2999 "CompletionTextView.c"
	} else {
#line 81 "../src/widgets/CompletionTextView.vala"
		_tmp33_ = FALSE;
#line 3003 "CompletionTextView.c"
	}
#line 81 "../src/widgets/CompletionTextView.vala"
	if (_tmp33_) {
#line 3007 "CompletionTextView.c"
		GdkRGBA _tmp38_;
#line 84 "../src/widgets/CompletionTextView.vala"
		_tmp38_ = link_color;
#line 84 "../src/widgets/CompletionTextView.vala"
		_tmp32_ = _tmp38_.alpha == 1.0;
#line 3013 "CompletionTextView.c"
	} else {
#line 81 "../src/widgets/CompletionTextView.vala"
		_tmp32_ = FALSE;
#line 3017 "CompletionTextView.c"
	}
#line 81 "../src/widgets/CompletionTextView.vala"
	if (_tmp32_) {
#line 3021 "CompletionTextView.c"
		GdkRGBA _tmp39_ = {0};
#line 86 "../src/widgets/CompletionTextView.vala"
		_tmp39_.red = 0.16470;
#line 86 "../src/widgets/CompletionTextView.vala"
		_tmp39_.green = 0.462735;
#line 86 "../src/widgets/CompletionTextView.vala"
		_tmp39_.blue = 0.77647;
#line 86 "../src/widgets/CompletionTextView.vala"
		_tmp39_.alpha = 1.0;
#line 86 "../src/widgets/CompletionTextView.vala"
		link_color = _tmp39_;
#line 3033 "CompletionTextView.c"
	}
#line 94 "../src/widgets/CompletionTextView.vala"
	_tmp40_.red = 0.0;
#line 94 "../src/widgets/CompletionTextView.vala"
	_tmp40_.green = 0.65;
#line 94 "../src/widgets/CompletionTextView.vala"
	_tmp40_.blue = 0.0627;
#line 94 "../src/widgets/CompletionTextView.vala"
	_tmp40_.alpha = 1.0;
#line 94 "../src/widgets/CompletionTextView.vala"
	snippet_color = _tmp40_;
#line 96 "../src/widgets/CompletionTextView.vala"
	_tmp41_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 96 "../src/widgets/CompletionTextView.vala"
	_tmp42_ = _tmp41_;
#line 96 "../src/widgets/CompletionTextView.vala"
	_tmp43_ = COMPLETION_TEXT_VIEW_TEXT_TAGS[0];
#line 96 "../src/widgets/CompletionTextView.vala"
	_tmp44_ = link_color;
#line 96 "../src/widgets/CompletionTextView.vala"
	gtk_text_buffer_create_tag (_tmp42_, _tmp43_, "foreground_rgba", &_tmp44_, NULL, NULL);
#line 99 "../src/widgets/CompletionTextView.vala"
	_tmp45_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 99 "../src/widgets/CompletionTextView.vala"
	_tmp46_ = _tmp45_;
#line 99 "../src/widgets/CompletionTextView.vala"
	_tmp47_ = COMPLETION_TEXT_VIEW_TEXT_TAGS[1];
#line 99 "../src/widgets/CompletionTextView.vala"
	_tmp48_ = link_color;
#line 99 "../src/widgets/CompletionTextView.vala"
	gtk_text_buffer_create_tag (_tmp46_, _tmp47_, "foreground_rgba", &_tmp48_, NULL, NULL);
#line 102 "../src/widgets/CompletionTextView.vala"
	_tmp49_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 102 "../src/widgets/CompletionTextView.vala"
	_tmp50_ = _tmp49_;
#line 102 "../src/widgets/CompletionTextView.vala"
	_tmp51_ = COMPLETION_TEXT_VIEW_TEXT_TAGS[2];
#line 102 "../src/widgets/CompletionTextView.vala"
	_tmp52_ = link_color;
#line 102 "../src/widgets/CompletionTextView.vala"
	gtk_text_buffer_create_tag (_tmp50_, _tmp51_, "foreground_rgba", &_tmp52_, NULL, NULL);
#line 105 "../src/widgets/CompletionTextView.vala"
	_tmp53_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 105 "../src/widgets/CompletionTextView.vala"
	_tmp54_ = _tmp53_;
#line 105 "../src/widgets/CompletionTextView.vala"
	_tmp55_ = COMPLETION_TEXT_VIEW_TEXT_TAGS[3];
#line 105 "../src/widgets/CompletionTextView.vala"
	_tmp56_ = snippet_color;
#line 105 "../src/widgets/CompletionTextView.vala"
	gtk_text_buffer_create_tag (_tmp54_, _tmp55_, "foreground_rgba", &_tmp56_, NULL, NULL);
#line 109 "../src/widgets/CompletionTextView.vala"
	_tmp57_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 109 "../src/widgets/CompletionTextView.vala"
	_tmp58_ = _tmp57_;
#line 109 "../src/widgets/CompletionTextView.vala"
	gtk_text_buffer_create_tag (_tmp58_, COMPLETION_TEXT_VIEW_NO_SPELL_CHECK, NULL, NULL);
#line 111 "../src/widgets/CompletionTextView.vala"
	_tmp59_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 111 "../src/widgets/CompletionTextView.vala"
	_tmp60_ = _tmp59_;
#line 111 "../src/widgets/CompletionTextView.vala"
	g_signal_connect_object ((GObject*) _tmp60_, "notify::cursor-position", (GCallback) _completion_text_view_update_completion_listbox_g_object_notify, self, 0);
#line 112 "../src/widgets/CompletionTextView.vala"
	_tmp61_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 112 "../src/widgets/CompletionTextView.vala"
	_tmp62_ = _tmp61_;
#line 112 "../src/widgets/CompletionTextView.vala"
	g_signal_connect_object (_tmp62_, "changed", (GCallback) _completion_text_view_buffer_changed_cb_gtk_text_buffer_changed, self, 0);
#line 113 "../src/widgets/CompletionTextView.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) _completion_text_view_key_press_event_cb_gtk_widget_key_press_event, self, 0);
#line 116 "../src/widgets/CompletionTextView.vala"
	gtk_text_view_set_right_margin ((GtkTextView*) self, 6);
#line 117 "../src/widgets/CompletionTextView.vala"
	gtk_text_view_set_left_margin ((GtkTextView*) self, 6);
#line 118 "../src/widgets/CompletionTextView.vala"
	gtk_text_view_set_top_margin ((GtkTextView*) self, 6);
#line 119 "../src/widgets/CompletionTextView.vala"
	gtk_text_view_set_bottom_margin ((GtkTextView*) self, 6);
#line 122 "../src/widgets/CompletionTextView.vala"
	_tmp63_ = gspell_text_view_get_from_gtk_text_view ((GtkTextView*) self);
#line 122 "../src/widgets/CompletionTextView.vala"
	_tmp64_ = _g_object_ref0 (_tmp63_);
#line 122 "../src/widgets/CompletionTextView.vala"
	gspell_view = _tmp64_;
#line 123 "../src/widgets/CompletionTextView.vala"
	_tmp65_ = gspell_view;
#line 123 "../src/widgets/CompletionTextView.vala"
	gspell_text_view_set_inline_spell_checking (_tmp65_, TRUE);
#line 124 "../src/widgets/CompletionTextView.vala"
	_tmp66_ = gspell_view;
#line 124 "../src/widgets/CompletionTextView.vala"
	gspell_text_view_set_enable_language_menu (_tmp66_, TRUE);
#line 126 "../src/widgets/CompletionTextView.vala"
	_tmp67_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 126 "../src/widgets/CompletionTextView.vala"
	_tmp68_ = _tmp67_;
#line 126 "../src/widgets/CompletionTextView.vala"
	_tmp69_ = gspell_text_buffer_get_from_gtk_text_buffer (_tmp68_);
#line 126 "../src/widgets/CompletionTextView.vala"
	_tmp70_ = _g_object_ref0 (_tmp69_);
#line 126 "../src/widgets/CompletionTextView.vala"
	gspell_buffer = _tmp70_;
#line 127 "../src/widgets/CompletionTextView.vala"
	_tmp71_ = gspell_language_get_default ();
#line 127 "../src/widgets/CompletionTextView.vala"
	_tmp72_ = gspell_checker_new (_tmp71_);
#line 127 "../src/widgets/CompletionTextView.vala"
	checker = _tmp72_;
#line 128 "../src/widgets/CompletionTextView.vala"
	_tmp73_ = gspell_buffer;
#line 128 "../src/widgets/CompletionTextView.vala"
	_tmp74_ = checker;
#line 128 "../src/widgets/CompletionTextView.vala"
	gspell_text_buffer_set_spell_checker (_tmp73_, _tmp74_);
#line 51 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (checker);
#line 51 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (gspell_buffer);
#line 51 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (gspell_view);
#line 51 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (style_context);
#line 51 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (frame);
#line 51 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (scroller);
#line 51 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (placeholder_label);
#line 51 "../src/widgets/CompletionTextView.vala"
	return obj;
#line 3165 "CompletionTextView.c"
}

static void
completion_text_view_class_init (CompletionTextViewClass * klass,
                                 gpointer klass_data)
{
#line 18 "../src/widgets/CompletionTextView.vala"
	completion_text_view_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/CompletionTextView.vala"
	g_type_class_adjust_private_offset (klass, &CompletionTextView_private_offset);
#line 18 "../src/widgets/CompletionTextView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_completion_text_view_set_property;
#line 18 "../src/widgets/CompletionTextView.vala"
	G_OBJECT_CLASS (klass)->constructor = completion_text_view_constructor;
#line 18 "../src/widgets/CompletionTextView.vala"
	G_OBJECT_CLASS (klass)->finalize = completion_text_view_finalize;
#line 18 "../src/widgets/CompletionTextView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPLETION_TEXT_VIEW_COMPLETION_LISTBOX_PROPERTY, completion_text_view_properties[COMPLETION_TEXT_VIEW_COMPLETION_LISTBOX_PROPERTY] = g_param_spec_object ("completion-listbox", "completion-listbox", "completion-listbox", gtk_list_box_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 18 "../src/widgets/CompletionTextView.vala"
	completion_text_view_signals[COMPLETION_TEXT_VIEW_SHOW_COMPLETION_SIGNAL] = g_signal_new ("show-completion", TYPE_COMPLETION_TEXT_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18 "../src/widgets/CompletionTextView.vala"
	completion_text_view_signals[COMPLETION_TEXT_VIEW_HIDE_COMPLETION_SIGNAL] = g_signal_new ("hide-completion", TYPE_COMPLETION_TEXT_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18 "../src/widgets/CompletionTextView.vala"
	completion_text_view_signals[COMPLETION_TEXT_VIEW_UPDATE_COMPLETION_SIGNAL] = g_signal_new ("update-completion", TYPE_COMPLETION_TEXT_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 3190 "CompletionTextView.c"
}

static void
completion_text_view_instance_init (CompletionTextView * self,
                                    gpointer klass)
{
#line 18 "../src/widgets/CompletionTextView.vala"
	self->priv = completion_text_view_get_instance_private (self);
#line 27 "../src/widgets/CompletionTextView.vala"
	self->priv->current_word = NULL;
#line 28 "../src/widgets/CompletionTextView.vala"
	self->priv->completion_cancellable = NULL;
#line 30 "../src/widgets/CompletionTextView.vala"
	self->priv->_default_listbox = TRUE;
#line 3205 "CompletionTextView.c"
}

static void
completion_text_view_finalize (GObject * obj)
{
	CompletionTextView * self;
	GtkListBox* _tmp0_;
	CbUserCompletionModel* _tmp1_;
#line 18 "../src/widgets/CompletionTextView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPLETION_TEXT_VIEW, CompletionTextView);
#line 470 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = self->priv->completion_list;
#line 470 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = self->priv->completion_model;
#line 470 "../src/widgets/CompletionTextView.vala"
	cb_utils_unbind_non_gobject_model (_tmp0_, (GListModel*) _tmp1_);
#line 26 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->completion_window);
#line 27 "../src/widgets/CompletionTextView.vala"
	_g_free0 (self->priv->current_word);
#line 28 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->completion_cancellable);
#line 42 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->completion_list);
#line 43 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->completion_model);
#line 18 "../src/widgets/CompletionTextView.vala"
	G_OBJECT_CLASS (completion_text_view_parent_class)->finalize (obj);
#line 3234 "CompletionTextView.c"
}

static GType
completion_text_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CompletionTextViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) completion_text_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CompletionTextView), 0, (GInstanceInitFunc) completion_text_view_instance_init, NULL };
	GType completion_text_view_type_id;
	completion_text_view_type_id = g_type_register_static (gtk_text_view_get_type (), "CompletionTextView", &g_define_type_info, 0);
	CompletionTextView_private_offset = g_type_add_instance_private (completion_text_view_type_id, sizeof (CompletionTextViewPrivate));
	return completion_text_view_type_id;
}

GType
completion_text_view_get_type (void)
{
	static volatile gsize completion_text_view_type_id__once = 0;
	if (g_once_init_enter (&completion_text_view_type_id__once)) {
		GType completion_text_view_type_id;
		completion_text_view_type_id = completion_text_view_get_type_once ();
		g_once_init_leave (&completion_text_view_type_id__once, completion_text_view_type_id);
	}
	return completion_text_view_type_id__once;
}

static void
_vala_completion_text_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	CompletionTextView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPLETION_TEXT_VIEW, CompletionTextView);
#line 18 "../src/widgets/CompletionTextView.vala"
	switch (property_id) {
#line 18 "../src/widgets/CompletionTextView.vala"
		case COMPLETION_TEXT_VIEW_COMPLETION_LISTBOX_PROPERTY:
#line 18 "../src/widgets/CompletionTextView.vala"
		completion_text_view_set_completion_listbox (self, g_value_get_object (value));
#line 18 "../src/widgets/CompletionTextView.vala"
		break;
#line 3275 "CompletionTextView.c"
		default:
#line 18 "../src/widgets/CompletionTextView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/CompletionTextView.vala"
		break;
#line 3281 "CompletionTextView.c"
	}
}

static inline gpointer
user_completion_row_get_instance_private (UserCompletionRow* self)
{
	return G_STRUCT_MEMBER_P (self, UserCompletionRow_private_offset);
}

UserCompletionRow*
user_completion_row_construct (GType object_type,
                               gint64 id,
                               const gchar* user_name,
                               const gchar* screen_name,
                               gboolean verified,
                               gboolean protected_account)
{
	UserCompletionRow * self = NULL;
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GtkBox* box = NULL;
	GtkBox* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkBox* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkBox* _tmp12_;
	GtkLabel* _tmp13_;
	GtkBox* _tmp22_;
	GtkBox* _tmp23_;
#line 493 "../src/widgets/CompletionTextView.vala"
	g_return_val_if_fail (user_name != NULL, NULL);
#line 493 "../src/widgets/CompletionTextView.vala"
	g_return_val_if_fail (screen_name != NULL, NULL);
#line 493 "../src/widgets/CompletionTextView.vala"
	self = (UserCompletionRow*) g_object_new (object_type, NULL);
#line 494 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (user_name);
#line 494 "../src/widgets/CompletionTextView.vala"
	g_object_ref_sink (_tmp0_);
#line 494 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->user_name_label);
#line 494 "../src/widgets/CompletionTextView.vala"
	self->priv->user_name_label = _tmp0_;
#line 495 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = g_strconcat ("@", screen_name, NULL);
#line 495 "../src/widgets/CompletionTextView.vala"
	_tmp2_ = _tmp1_;
#line 495 "../src/widgets/CompletionTextView.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
#line 495 "../src/widgets/CompletionTextView.vala"
	g_object_ref_sink (_tmp3_);
#line 495 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->screen_name_label);
#line 495 "../src/widgets/CompletionTextView.vala"
	self->priv->screen_name_label = _tmp3_;
#line 495 "../src/widgets/CompletionTextView.vala"
	_g_free0 (_tmp2_);
#line 497 "../src/widgets/CompletionTextView.vala"
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, TRUE);
#line 499 "../src/widgets/CompletionTextView.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 499 "../src/widgets/CompletionTextView.vala"
	g_object_ref_sink (_tmp4_);
#line 499 "../src/widgets/CompletionTextView.vala"
	box = _tmp4_;
#line 500 "../src/widgets/CompletionTextView.vala"
	_tmp5_ = self->priv->user_name_label;
#line 500 "../src/widgets/CompletionTextView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_BASELINE);
#line 501 "../src/widgets/CompletionTextView.vala"
	_tmp6_ = self->priv->user_name_label;
#line 501 "../src/widgets/CompletionTextView.vala"
	gtk_label_set_ellipsize (_tmp6_, PANGO_ELLIPSIZE_END);
#line 502 "../src/widgets/CompletionTextView.vala"
	_tmp7_ = box;
#line 502 "../src/widgets/CompletionTextView.vala"
	_tmp8_ = self->priv->user_name_label;
#line 502 "../src/widgets/CompletionTextView.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 503 "../src/widgets/CompletionTextView.vala"
	_tmp9_ = self->priv->screen_name_label;
#line 503 "../src/widgets/CompletionTextView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_BASELINE);
#line 504 "../src/widgets/CompletionTextView.vala"
	_tmp10_ = self->priv->screen_name_label;
#line 504 "../src/widgets/CompletionTextView.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 504 "../src/widgets/CompletionTextView.vala"
	gtk_style_context_add_class (_tmp11_, "dim-label");
#line 505 "../src/widgets/CompletionTextView.vala"
	_tmp12_ = box;
#line 505 "../src/widgets/CompletionTextView.vala"
	_tmp13_ = self->priv->screen_name_label;
#line 505 "../src/widgets/CompletionTextView.vala"
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 507 "../src/widgets/CompletionTextView.vala"
	if (verified) {
#line 3385 "CompletionTextView.c"
		GtkImage* verified_image = NULL;
		cairo_surface_t* _tmp14_;
		GtkImage* _tmp15_;
		GtkBox* _tmp16_;
		GtkImage* _tmp17_;
#line 508 "../src/widgets/CompletionTextView.vala"
		_tmp14_ = user_completion_row_verified_surface;
#line 508 "../src/widgets/CompletionTextView.vala"
		_tmp15_ = (GtkImage*) gtk_image_new_from_surface (_tmp14_);
#line 508 "../src/widgets/CompletionTextView.vala"
		g_object_ref_sink (_tmp15_);
#line 508 "../src/widgets/CompletionTextView.vala"
		verified_image = _tmp15_;
#line 509 "../src/widgets/CompletionTextView.vala"
		_tmp16_ = box;
#line 509 "../src/widgets/CompletionTextView.vala"
		_tmp17_ = verified_image;
#line 509 "../src/widgets/CompletionTextView.vala"
		gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
#line 507 "../src/widgets/CompletionTextView.vala"
		_g_object_unref0 (verified_image);
#line 3407 "CompletionTextView.c"
	}
#line 512 "../src/widgets/CompletionTextView.vala"
	if (protected_account) {
#line 3411 "CompletionTextView.c"
		GtkImage* protected_account_image = NULL;
		cairo_surface_t* _tmp18_;
		GtkImage* _tmp19_;
		GtkBox* _tmp20_;
		GtkImage* _tmp21_;
#line 513 "../src/widgets/CompletionTextView.vala"
		_tmp18_ = user_completion_row_protected_account_surface;
#line 513 "../src/widgets/CompletionTextView.vala"
		_tmp19_ = (GtkImage*) gtk_image_new_from_surface (_tmp18_);
#line 513 "../src/widgets/CompletionTextView.vala"
		g_object_ref_sink (_tmp19_);
#line 513 "../src/widgets/CompletionTextView.vala"
		protected_account_image = _tmp19_;
#line 514 "../src/widgets/CompletionTextView.vala"
		_tmp20_ = box;
#line 514 "../src/widgets/CompletionTextView.vala"
		_tmp21_ = protected_account_image;
#line 514 "../src/widgets/CompletionTextView.vala"
		gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 512 "../src/widgets/CompletionTextView.vala"
		_g_object_unref0 (protected_account_image);
#line 3433 "CompletionTextView.c"
	}
#line 517 "../src/widgets/CompletionTextView.vala"
	_tmp22_ = box;
#line 517 "../src/widgets/CompletionTextView.vala"
	g_object_set ((GtkWidget*) _tmp22_, "margin", 2, NULL);
#line 518 "../src/widgets/CompletionTextView.vala"
	_tmp23_ = box;
#line 518 "../src/widgets/CompletionTextView.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp23_);
#line 519 "../src/widgets/CompletionTextView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 493 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (box);
#line 493 "../src/widgets/CompletionTextView.vala"
	return self;
#line 3449 "CompletionTextView.c"
}

UserCompletionRow*
user_completion_row_new (gint64 id,
                         const gchar* user_name,
                         const gchar* screen_name,
                         gboolean verified,
                         gboolean protected_account)
{
#line 493 "../src/widgets/CompletionTextView.vala"
	return user_completion_row_construct (TYPE_USER_COMPLETION_ROW, id, user_name, screen_name, verified, protected_account);
#line 3461 "CompletionTextView.c"
}

gchar*
user_completion_row_get_screen_name (UserCompletionRow* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 522 "../src/widgets/CompletionTextView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 523 "../src/widgets/CompletionTextView.vala"
	_tmp0_ = self->priv->screen_name_label;
#line 523 "../src/widgets/CompletionTextView.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 523 "../src/widgets/CompletionTextView.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 523 "../src/widgets/CompletionTextView.vala"
	result = _tmp2_;
#line 523 "../src/widgets/CompletionTextView.vala"
	return result;
#line 3483 "CompletionTextView.c"
}

static void
user_completion_row_class_init (UserCompletionRowClass * klass,
                                gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 474 "../src/widgets/CompletionTextView.vala"
	user_completion_row_parent_class = g_type_class_peek_parent (klass);
#line 474 "../src/widgets/CompletionTextView.vala"
	g_type_class_adjust_private_offset (klass, &UserCompletionRow_private_offset);
#line 474 "../src/widgets/CompletionTextView.vala"
	G_OBJECT_CLASS (klass)->finalize = user_completion_row_finalize;
#line 3497 "CompletionTextView.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		cairo_surface_t* _tmp2_;
		GdkPixbuf* _tmp3_ = NULL;
		GdkPixbuf* _tmp4_;
		cairo_surface_t* _tmp5_;
#line 483 "../src/widgets/CompletionTextView.vala"
		_tmp1_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/verified-small.png", &_inner_error0_);
#line 483 "../src/widgets/CompletionTextView.vala"
		_tmp0_ = _tmp1_;
#line 483 "../src/widgets/CompletionTextView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3511 "CompletionTextView.c"
			goto __catch0_g_error;
		}
#line 482 "../src/widgets/CompletionTextView.vala"
		_tmp2_ = gdk_cairo_surface_create_from_pixbuf (_tmp0_, 1, NULL);
#line 482 "../src/widgets/CompletionTextView.vala"
		_cairo_surface_destroy0 (user_completion_row_verified_surface);
#line 482 "../src/widgets/CompletionTextView.vala"
		user_completion_row_verified_surface = _tmp2_;
#line 486 "../src/widgets/CompletionTextView.vala"
		_tmp4_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/protected-account-small.png", &_inner_error0_);
#line 486 "../src/widgets/CompletionTextView.vala"
		_tmp3_ = _tmp4_;
#line 486 "../src/widgets/CompletionTextView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 486 "../src/widgets/CompletionTextView.vala"
			_g_object_unref0 (_tmp0_);
#line 3528 "CompletionTextView.c"
			goto __catch0_g_error;
		}
#line 485 "../src/widgets/CompletionTextView.vala"
		_tmp5_ = gdk_cairo_surface_create_from_pixbuf (_tmp3_, 1, NULL);
#line 485 "../src/widgets/CompletionTextView.vala"
		_cairo_surface_destroy0 (user_completion_row_protected_account_surface);
#line 485 "../src/widgets/CompletionTextView.vala"
		user_completion_row_protected_account_surface = _tmp5_;
#line 481 "../src/widgets/CompletionTextView.vala"
		_g_object_unref0 (_tmp3_);
#line 481 "../src/widgets/CompletionTextView.vala"
		_g_object_unref0 (_tmp0_);
#line 3541 "CompletionTextView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 481 "../src/widgets/CompletionTextView.vala"
		e = _inner_error0_;
#line 481 "../src/widgets/CompletionTextView.vala"
		_inner_error0_ = NULL;
#line 489 "../src/widgets/CompletionTextView.vala"
		_tmp6_ = e;
#line 489 "../src/widgets/CompletionTextView.vala"
		_tmp7_ = _tmp6_->message;
#line 489 "../src/widgets/CompletionTextView.vala"
		g_error ("CompletionTextView.vala:489: %s", _tmp7_);
#line 481 "../src/widgets/CompletionTextView.vala"
		_g_error_free0 (e);
#line 3561 "CompletionTextView.c"
	}
	__finally0:
#line 481 "../src/widgets/CompletionTextView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "../src/widgets/CompletionTextView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 481 "../src/widgets/CompletionTextView.vala"
		g_clear_error (&_inner_error0_);
#line 3570 "CompletionTextView.c"
	}
}

static void
user_completion_row_instance_init (UserCompletionRow * self,
                                   gpointer klass)
{
#line 474 "../src/widgets/CompletionTextView.vala"
	self->priv = user_completion_row_get_instance_private (self);
#line 3580 "CompletionTextView.c"
}

static void
user_completion_row_finalize (GObject * obj)
{
	UserCompletionRow * self;
#line 474 "../src/widgets/CompletionTextView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_COMPLETION_ROW, UserCompletionRow);
#line 477 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->user_name_label);
#line 478 "../src/widgets/CompletionTextView.vala"
	_g_object_unref0 (self->priv->screen_name_label);
#line 474 "../src/widgets/CompletionTextView.vala"
	G_OBJECT_CLASS (user_completion_row_parent_class)->finalize (obj);
#line 3595 "CompletionTextView.c"
}

static GType
user_completion_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UserCompletionRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_completion_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserCompletionRow), 0, (GInstanceInitFunc) user_completion_row_instance_init, NULL };
	GType user_completion_row_type_id;
	user_completion_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "UserCompletionRow", &g_define_type_info, 0);
	UserCompletionRow_private_offset = g_type_add_instance_private (user_completion_row_type_id, sizeof (UserCompletionRowPrivate));
	return user_completion_row_type_id;
}

GType
user_completion_row_get_type (void)
{
	static volatile gsize user_completion_row_type_id__once = 0;
	if (g_once_init_enter (&user_completion_row_type_id__once)) {
		GType user_completion_row_type_id;
		user_completion_row_type_id = user_completion_row_get_type_once ();
		g_once_init_leave (&user_completion_row_type_id__once, user_completion_row_type_id);
	}
	return user_completion_row_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

