/* TweetListBox.c generated by valac 0.56.15, the Vala compiler
 * generated from TweetListBox.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include <gtk/gtk.h>
#include "CbTweetModel.h"
#include <glib-object.h>
#include <glib.h>
#include "CbTweet.h"
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include "CbDeltaUpdater.h"
#include "CbUtils.h"
#include <gio/gio.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	TWEET_LIST_BOX_0_PROPERTY,
	TWEET_LIST_BOX_ACTION_ENTRY_PROPERTY,
	TWEET_LIST_BOX_MAIN_WINDOW_PROPERTY,
	TWEET_LIST_BOX_NUM_PROPERTIES
};
static GParamSpec* tweet_list_box_properties[TWEET_LIST_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GdkEventButton_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventButton_free (var), NULL)))
#define __vala_GdkEventSequence_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventSequence_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TweetListBoxPrivate {
	GtkGestureMultiPress* press_gesture;
	TweetListEntry* _action_entry;
	MainWindow* _main_window;
};

static gint TweetListBox_private_offset;
static gpointer tweet_list_box_parent_class = NULL;

static GtkWidget* tweet_list_box_widget_create_func (TweetListBox* self,
                                              GObject* obj);
static MainWindow* tweet_list_box_get_main_window (TweetListBox* self);
static void tweet_list_box_gesture_pressed_cb (TweetListBox* self,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y);
static GdkEventButton* _vala_GdkEventButton_copy (GdkEventButton* self);
static void tweet_list_box_set_action_entry (TweetListBox* self,
                                      TweetListEntry* entry);
static void _vala_GdkEventButton_free (GdkEventButton* self);
static void _vala_GdkEventSequence_free (GdkEventSequence* self);
static void tweet_list_box_action_entry_destroyed_cb (TweetListBox* self);
static void _tweet_list_box_action_entry_destroyed_cb_gtk_widget_destroy (GtkWidget* _sender,
                                                                   gpointer self);
static GObject * tweet_list_box_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _tweet_list_box_gesture_pressed_cb_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                         gint n_press,
                                                                         gdouble x,
                                                                         gdouble y,
                                                                         gpointer self);
static GtkWidget* _tweet_list_box_widget_create_func_gtk_list_box_create_widget_func (GObject* item,
                                                                               gpointer self);
static void tweet_list_box_finalize (GObject * obj);
static GType tweet_list_box_get_type_once (void);
static void _vala_tweet_list_box_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_tweet_list_box_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
tweet_list_box_get_instance_private (TweetListBox* self)
{
	return G_STRUCT_MEMBER_P (self, TweetListBox_private_offset);
}

TweetListBox*
tweet_list_box_construct (GType object_type)
{
	TweetListBox * self = NULL;
#line 31 "../src/widgets/TweetListBox.vala"
	self = (TweetListBox*) list_box_construct (object_type);
#line 31 "../src/widgets/TweetListBox.vala"
	return self;
#line 121 "TweetListBox.c"
}

TweetListBox*
tweet_list_box_new (void)
{
#line 31 "../src/widgets/TweetListBox.vala"
	return tweet_list_box_construct (TYPE_TWEET_LIST_BOX);
#line 129 "TweetListBox.c"
}

void
tweet_list_box_set_thread_mode (TweetListBox* self,
                                gboolean thread_mode)
{
	CbTweetModel* _tmp0_;
#line 44 "../src/widgets/TweetListBox.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->model;
#line 45 "../src/widgets/TweetListBox.vala"
	cb_tweet_model_set_thread_mode (_tmp0_, thread_mode);
#line 143 "TweetListBox.c"
}

static GtkWidget*
tweet_list_box_widget_create_func (TweetListBox* self,
                                   GObject* obj)
{
	TweetListEntry* row = NULL;
	MainWindow* _tmp0_;
	Account* _tmp1_;
	TweetListEntry* _tmp2_;
	GtkWidget* result;
#line 48 "../src/widgets/TweetListBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/widgets/TweetListBox.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 49 "../src/widgets/TweetListBox.vala"
	_vala_assert (G_TYPE_CHECK_INSTANCE_TYPE (obj, CB_TYPE_TWEET), "obj is Cb.Tweet");
#line 51 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->priv->_main_window;
#line 51 "../src/widgets/TweetListBox.vala"
	_tmp1_ = self->account;
#line 51 "../src/widgets/TweetListBox.vala"
	_tmp2_ = tweet_list_entry_new (G_TYPE_CHECK_INSTANCE_CAST (obj, CB_TYPE_TWEET, CbTweet), _tmp0_, _tmp1_, FALSE);
#line 51 "../src/widgets/TweetListBox.vala"
	g_object_ref_sink (_tmp2_);
#line 51 "../src/widgets/TweetListBox.vala"
	row = _tmp2_;
#line 54 "../src/widgets/TweetListBox.vala"
	tweet_list_entry_fade_in (row);
#line 55 "../src/widgets/TweetListBox.vala"
	result = (GtkWidget*) row;
#line 55 "../src/widgets/TweetListBox.vala"
	return result;
#line 177 "TweetListBox.c"
}

static GdkEventButton*
_vala_GdkEventButton_copy (GdkEventButton* self)
{
#line 62 "../src/widgets/TweetListBox.vala"
	return g_boxed_copy (gdk_event_get_type (), self);
#line 185 "TweetListBox.c"
}

static gpointer
__vala_GdkEventButton_copy0 (gpointer self)
{
#line 62 "../src/widgets/TweetListBox.vala"
	return self ? _vala_GdkEventButton_copy (self) : NULL;
#line 193 "TweetListBox.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 66 "../src/widgets/TweetListBox.vala"
	return self ? g_object_ref (self) : NULL;
#line 201 "TweetListBox.c"
}

static void
_vala_GdkEventButton_free (GdkEventButton* self)
{
#line 58 "../src/widgets/TweetListBox.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 209 "TweetListBox.c"
}

static void
_vala_GdkEventSequence_free (GdkEventSequence* self)
{
#line 58 "../src/widgets/TweetListBox.vala"
	g_boxed_free (gdk_event_sequence_get_type (), self);
#line 217 "TweetListBox.c"
}

static void
tweet_list_box_gesture_pressed_cb (TweetListBox* self,
                                   gint n_press,
                                   gdouble x,
                                   gdouble y)
{
	GdkEventSequence* sequence = NULL;
	GtkGestureMultiPress* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEventButton* event = NULL;
	GtkGestureMultiPress* _tmp2_;
	GdkEventSequence* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEventButton* _tmp5_;
	GdkEventButton* _tmp6_;
#line 58 "../src/widgets/TweetListBox.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->priv->press_gesture;
#line 61 "../src/widgets/TweetListBox.vala"
	_tmp1_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) _tmp0_);
#line 61 "../src/widgets/TweetListBox.vala"
	sequence = _tmp1_;
#line 62 "../src/widgets/TweetListBox.vala"
	_tmp2_ = self->priv->press_gesture;
#line 62 "../src/widgets/TweetListBox.vala"
	_tmp3_ = sequence;
#line 62 "../src/widgets/TweetListBox.vala"
	_tmp4_ = gtk_gesture_get_last_event ((GtkGesture*) _tmp2_, _tmp3_);
#line 62 "../src/widgets/TweetListBox.vala"
	_tmp5_ = __vala_GdkEventButton_copy0 ((GdkEventButton*) _tmp4_);
#line 62 "../src/widgets/TweetListBox.vala"
	event = _tmp5_;
#line 64 "../src/widgets/TweetListBox.vala"
	_tmp6_ = event;
#line 64 "../src/widgets/TweetListBox.vala"
	if (gdk_event_triggers_context_menu ((GdkEvent*) _tmp6_)) {
#line 257 "TweetListBox.c"
		GdkWindow* event_window = NULL;
		GdkEventButton* _tmp7_;
		GdkWindow* _tmp8_;
		GdkWindow* _tmp9_;
		GdkWindow* window = NULL;
		GdkWindow* _tmp10_;
		GdkWindow* _tmp11_;
		gdouble relative_y = 0.0;
		GdkEventButton* _tmp12_;
		gdouble parent_y = 0.0;
		GtkWidget* row = NULL;
		GtkListBoxRow* _tmp22_;
		GtkWidget* _tmp23_;
		gboolean _tmp24_ = FALSE;
		GtkWidget* _tmp25_;
#line 66 "../src/widgets/TweetListBox.vala"
		_tmp7_ = event;
#line 66 "../src/widgets/TweetListBox.vala"
		_tmp8_ = _tmp7_->window;
#line 66 "../src/widgets/TweetListBox.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 66 "../src/widgets/TweetListBox.vala"
		event_window = _tmp9_;
#line 67 "../src/widgets/TweetListBox.vala"
		_tmp10_ = gtk_widget_get_window ((GtkWidget*) self);
#line 67 "../src/widgets/TweetListBox.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 67 "../src/widgets/TweetListBox.vala"
		window = _tmp11_;
#line 68 "../src/widgets/TweetListBox.vala"
		_tmp12_ = event;
#line 68 "../src/widgets/TweetListBox.vala"
		relative_y = _tmp12_->y;
#line 71 "../src/widgets/TweetListBox.vala"
		while (TRUE) {
#line 293 "TweetListBox.c"
			gboolean _tmp13_ = FALSE;
			GdkWindow* _tmp14_;
			GdkWindow* _tmp17_;
			gdouble _tmp18_ = 0.0;
			GdkWindow* _tmp19_;
			GdkWindow* _tmp20_;
			GdkWindow* _tmp21_;
#line 71 "../src/widgets/TweetListBox.vala"
			_tmp14_ = event_window;
#line 71 "../src/widgets/TweetListBox.vala"
			if (_tmp14_ != NULL) {
#line 305 "TweetListBox.c"
				GdkWindow* _tmp15_;
				GdkWindow* _tmp16_;
#line 71 "../src/widgets/TweetListBox.vala"
				_tmp15_ = event_window;
#line 71 "../src/widgets/TweetListBox.vala"
				_tmp16_ = window;
#line 71 "../src/widgets/TweetListBox.vala"
				_tmp13_ = _tmp15_ != _tmp16_;
#line 314 "TweetListBox.c"
			} else {
#line 71 "../src/widgets/TweetListBox.vala"
				_tmp13_ = FALSE;
#line 318 "TweetListBox.c"
			}
#line 71 "../src/widgets/TweetListBox.vala"
			if (!_tmp13_) {
#line 71 "../src/widgets/TweetListBox.vala"
				break;
#line 324 "TweetListBox.c"
			}
#line 72 "../src/widgets/TweetListBox.vala"
			_tmp17_ = event_window;
#line 72 "../src/widgets/TweetListBox.vala"
			gdk_window_coords_to_parent (_tmp17_, (gdouble) 0, relative_y, NULL, &_tmp18_);
#line 72 "../src/widgets/TweetListBox.vala"
			parent_y = _tmp18_;
#line 73 "../src/widgets/TweetListBox.vala"
			relative_y = parent_y;
#line 74 "../src/widgets/TweetListBox.vala"
			_tmp19_ = event_window;
#line 74 "../src/widgets/TweetListBox.vala"
			_tmp20_ = gdk_window_get_effective_parent (_tmp19_);
#line 74 "../src/widgets/TweetListBox.vala"
			_tmp21_ = _g_object_ref0 (_tmp20_);
#line 74 "../src/widgets/TweetListBox.vala"
			_g_object_unref0 (event_window);
#line 74 "../src/widgets/TweetListBox.vala"
			event_window = _tmp21_;
#line 344 "TweetListBox.c"
		}
#line 76 "../src/widgets/TweetListBox.vala"
		_tmp22_ = gtk_list_box_get_row_at_y ((GtkListBox*) self, (gint) relative_y);
#line 76 "../src/widgets/TweetListBox.vala"
		_tmp23_ = _g_object_ref0 ((GtkWidget*) _tmp22_);
#line 76 "../src/widgets/TweetListBox.vala"
		row = _tmp23_;
#line 77 "../src/widgets/TweetListBox.vala"
		_tmp25_ = row;
#line 77 "../src/widgets/TweetListBox.vala"
		if (IS_TWEET_LIST_ENTRY (_tmp25_)) {
#line 356 "TweetListBox.c"
			GtkWidget* _tmp26_;
			gboolean _tmp27_;
			gboolean _tmp28_;
#line 77 "../src/widgets/TweetListBox.vala"
			_tmp26_ = row;
#line 77 "../src/widgets/TweetListBox.vala"
			_tmp27_ = gtk_widget_get_sensitive (_tmp26_);
#line 77 "../src/widgets/TweetListBox.vala"
			_tmp28_ = _tmp27_;
#line 77 "../src/widgets/TweetListBox.vala"
			_tmp24_ = _tmp28_;
#line 368 "TweetListBox.c"
		} else {
#line 77 "../src/widgets/TweetListBox.vala"
			_tmp24_ = FALSE;
#line 372 "TweetListBox.c"
		}
#line 77 "../src/widgets/TweetListBox.vala"
		if (_tmp24_) {
#line 376 "TweetListBox.c"
			TweetListEntry* tle = NULL;
			GtkWidget* _tmp29_;
			TweetListEntry* _tmp30_;
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_ = FALSE;
			TweetListEntry* _tmp33_;
			TweetListEntry* _tmp34_;
			TweetListEntry* _tmp40_;
			TweetListEntry* _tmp41_;
			gboolean _tmp42_;
			gboolean _tmp43_;
			GtkGestureMultiPress* _tmp45_;
#line 78 "../src/widgets/TweetListBox.vala"
			_tmp29_ = row;
#line 78 "../src/widgets/TweetListBox.vala"
			_tmp30_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_TWEET_LIST_ENTRY, TweetListEntry));
#line 78 "../src/widgets/TweetListBox.vala"
			tle = _tmp30_;
#line 79 "../src/widgets/TweetListBox.vala"
			_tmp33_ = tle;
#line 79 "../src/widgets/TweetListBox.vala"
			_tmp34_ = self->priv->_action_entry;
#line 79 "../src/widgets/TweetListBox.vala"
			if (_tmp33_ != _tmp34_) {
#line 401 "TweetListBox.c"
				TweetListEntry* _tmp35_;
#line 79 "../src/widgets/TweetListBox.vala"
				_tmp35_ = self->priv->_action_entry;
#line 79 "../src/widgets/TweetListBox.vala"
				_tmp32_ = _tmp35_ != NULL;
#line 407 "TweetListBox.c"
			} else {
#line 79 "../src/widgets/TweetListBox.vala"
				_tmp32_ = FALSE;
#line 411 "TweetListBox.c"
			}
#line 79 "../src/widgets/TweetListBox.vala"
			if (_tmp32_) {
#line 415 "TweetListBox.c"
				TweetListEntry* _tmp36_;
				gboolean _tmp37_;
				gboolean _tmp38_;
#line 80 "../src/widgets/TweetListBox.vala"
				_tmp36_ = self->priv->_action_entry;
#line 80 "../src/widgets/TweetListBox.vala"
				_tmp37_ = tweet_list_entry_get_shows_actions (_tmp36_);
#line 80 "../src/widgets/TweetListBox.vala"
				_tmp38_ = _tmp37_;
#line 80 "../src/widgets/TweetListBox.vala"
				_tmp31_ = _tmp38_;
#line 427 "TweetListBox.c"
			} else {
#line 79 "../src/widgets/TweetListBox.vala"
				_tmp31_ = FALSE;
#line 431 "TweetListBox.c"
			}
#line 79 "../src/widgets/TweetListBox.vala"
			if (_tmp31_) {
#line 435 "TweetListBox.c"
				TweetListEntry* _tmp39_;
#line 81 "../src/widgets/TweetListBox.vala"
				_tmp39_ = self->priv->_action_entry;
#line 81 "../src/widgets/TweetListBox.vala"
				tweet_list_entry_toggle_mode (_tmp39_);
#line 441 "TweetListBox.c"
			}
#line 83 "../src/widgets/TweetListBox.vala"
			_tmp40_ = tle;
#line 83 "../src/widgets/TweetListBox.vala"
			tweet_list_entry_toggle_mode (_tmp40_);
#line 84 "../src/widgets/TweetListBox.vala"
			_tmp41_ = tle;
#line 84 "../src/widgets/TweetListBox.vala"
			_tmp42_ = tweet_list_entry_get_shows_actions (_tmp41_);
#line 84 "../src/widgets/TweetListBox.vala"
			_tmp43_ = _tmp42_;
#line 84 "../src/widgets/TweetListBox.vala"
			if (_tmp43_) {
#line 455 "TweetListBox.c"
				TweetListEntry* _tmp44_;
#line 85 "../src/widgets/TweetListBox.vala"
				_tmp44_ = tle;
#line 85 "../src/widgets/TweetListBox.vala"
				tweet_list_box_set_action_entry (self, _tmp44_);
#line 461 "TweetListBox.c"
			} else {
#line 87 "../src/widgets/TweetListBox.vala"
				tweet_list_box_set_action_entry (self, NULL);
#line 465 "TweetListBox.c"
			}
#line 89 "../src/widgets/TweetListBox.vala"
			_tmp45_ = self->priv->press_gesture;
#line 89 "../src/widgets/TweetListBox.vala"
			gtk_gesture_set_state ((GtkGesture*) _tmp45_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 77 "../src/widgets/TweetListBox.vala"
			_g_object_unref0 (tle);
#line 473 "TweetListBox.c"
		}
#line 64 "../src/widgets/TweetListBox.vala"
		_g_object_unref0 (row);
#line 64 "../src/widgets/TweetListBox.vala"
		_g_object_unref0 (window);
#line 64 "../src/widgets/TweetListBox.vala"
		_g_object_unref0 (event_window);
#line 481 "TweetListBox.c"
	}
#line 58 "../src/widgets/TweetListBox.vala"
	__vala_GdkEventButton_free0 (event);
#line 58 "../src/widgets/TweetListBox.vala"
	__vala_GdkEventSequence_free0 (sequence);
#line 487 "TweetListBox.c"
}

static void
_tweet_list_box_action_entry_destroyed_cb_gtk_widget_destroy (GtkWidget* _sender,
                                                              gpointer self)
{
#line 96 "../src/widgets/TweetListBox.vala"
	tweet_list_box_action_entry_destroyed_cb ((TweetListBox*) self);
#line 496 "TweetListBox.c"
}

static void
tweet_list_box_set_action_entry (TweetListBox* self,
                                 TweetListEntry* entry)
{
	TweetListEntry* _tmp0_;
#line 94 "../src/widgets/TweetListBox.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->priv->_action_entry;
#line 95 "../src/widgets/TweetListBox.vala"
	if (_tmp0_ != NULL) {
#line 510 "TweetListBox.c"
		TweetListEntry* _tmp1_;
		guint _tmp2_;
#line 96 "../src/widgets/TweetListBox.vala"
		_tmp1_ = self->priv->_action_entry;
#line 96 "../src/widgets/TweetListBox.vala"
		g_signal_parse_name ("destroy", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
#line 96 "../src/widgets/TweetListBox.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _tweet_list_box_action_entry_destroyed_cb_gtk_widget_destroy, self);
#line 97 "../src/widgets/TweetListBox.vala"
		_g_object_unref0 (self->priv->_action_entry);
#line 97 "../src/widgets/TweetListBox.vala"
		self->priv->_action_entry = NULL;
#line 523 "TweetListBox.c"
	}
#line 100 "../src/widgets/TweetListBox.vala"
	if (entry != NULL) {
#line 527 "TweetListBox.c"
		TweetListEntry* _tmp3_;
		TweetListEntry* _tmp4_;
#line 101 "../src/widgets/TweetListBox.vala"
		_tmp3_ = _g_object_ref0 (entry);
#line 101 "../src/widgets/TweetListBox.vala"
		_g_object_unref0 (self->priv->_action_entry);
#line 101 "../src/widgets/TweetListBox.vala"
		self->priv->_action_entry = _tmp3_;
#line 102 "../src/widgets/TweetListBox.vala"
		_tmp4_ = self->priv->_action_entry;
#line 102 "../src/widgets/TweetListBox.vala"
		g_signal_connect_object ((GtkWidget*) _tmp4_, "destroy", (GCallback) _tweet_list_box_action_entry_destroyed_cb_gtk_widget_destroy, self, 0);
#line 540 "TweetListBox.c"
	}
}

static void
tweet_list_box_action_entry_destroyed_cb (TweetListBox* self)
{
#line 106 "../src/widgets/TweetListBox.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/widgets/TweetListBox.vala"
	_g_object_unref0 (self->priv->_action_entry);
#line 107 "../src/widgets/TweetListBox.vala"
	self->priv->_action_entry = NULL;
#line 553 "TweetListBox.c"
}

void
tweet_list_box_remove_all (TweetListBox* self)
{
	CbTweetModel* _tmp0_;
#line 110 "../src/widgets/TweetListBox.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->model;
#line 111 "../src/widgets/TweetListBox.vala"
	cb_tweet_model_clear (_tmp0_);
#line 566 "TweetListBox.c"
}

void
tweet_list_box_hide_tweets_from (TweetListBox* self,
                                 gint64 user_id,
                                 CbTweetState reason)
{
	CbTweetModel* _tmp0_;
#line 114 "../src/widgets/TweetListBox.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->model;
#line 115 "../src/widgets/TweetListBox.vala"
	cb_tweet_model_toggle_flag_on_user_tweets (_tmp0_, user_id, reason, TRUE);
#line 581 "TweetListBox.c"
}

void
tweet_list_box_show_tweets_from (TweetListBox* self,
                                 gint64 user_id,
                                 CbTweetState reason)
{
	CbTweetModel* _tmp0_;
#line 118 "../src/widgets/TweetListBox.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->model;
#line 119 "../src/widgets/TweetListBox.vala"
	cb_tweet_model_toggle_flag_on_user_tweets (_tmp0_, user_id, reason, FALSE);
#line 596 "TweetListBox.c"
}

void
tweet_list_box_hide_retweets_from (TweetListBox* self,
                                   gint64 user_id,
                                   CbTweetState reason)
{
	CbTweetModel* _tmp0_;
#line 122 "../src/widgets/TweetListBox.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->model;
#line 123 "../src/widgets/TweetListBox.vala"
	cb_tweet_model_toggle_flag_on_user_retweets (_tmp0_, user_id, reason, TRUE);
#line 611 "TweetListBox.c"
}

void
tweet_list_box_show_retweets_from (TweetListBox* self,
                                   gint64 user_id,
                                   CbTweetState reason)
{
	CbTweetModel* _tmp0_;
#line 126 "../src/widgets/TweetListBox.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->model;
#line 127 "../src/widgets/TweetListBox.vala"
	cb_tweet_model_toggle_flag_on_user_retweets (_tmp0_, user_id, reason, FALSE);
#line 626 "TweetListBox.c"
}

TweetListEntry*
tweet_list_box_get_action_entry (TweetListBox* self)
{
	TweetListEntry* result;
	TweetListEntry* _tmp0_;
#line 25 "../src/widgets/TweetListBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->priv->_action_entry;
#line 26 "../src/widgets/TweetListBox.vala"
	result = _tmp0_;
#line 26 "../src/widgets/TweetListBox.vala"
	return result;
#line 642 "TweetListBox.c"
}

static MainWindow*
tweet_list_box_get_main_window (TweetListBox* self)
{
	MainWindow* result;
	MainWindow* _tmp0_;
#line 29 "../src/widgets/TweetListBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/widgets/TweetListBox.vala"
	_tmp0_ = self->priv->_main_window;
#line 29 "../src/widgets/TweetListBox.vala"
	result = _tmp0_;
#line 29 "../src/widgets/TweetListBox.vala"
	return result;
#line 658 "TweetListBox.c"
}

void
tweet_list_box_set_main_window (TweetListBox* self,
                                MainWindow* value)
{
	MainWindow* old_value;
#line 29 "../src/widgets/TweetListBox.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/widgets/TweetListBox.vala"
	old_value = tweet_list_box_get_main_window (self);
#line 29 "../src/widgets/TweetListBox.vala"
	if (old_value != value) {
#line 672 "TweetListBox.c"
		MainWindow* _tmp0_;
#line 29 "../src/widgets/TweetListBox.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/widgets/TweetListBox.vala"
		_g_object_unref0 (self->priv->_main_window);
#line 29 "../src/widgets/TweetListBox.vala"
		self->priv->_main_window = _tmp0_;
#line 29 "../src/widgets/TweetListBox.vala"
		g_object_notify_by_pspec ((GObject *) self, tweet_list_box_properties[TWEET_LIST_BOX_MAIN_WINDOW_PROPERTY]);
#line 682 "TweetListBox.c"
	}
}

static void
_tweet_list_box_gesture_pressed_cb_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self)
{
#line 38 "../src/widgets/TweetListBox.vala"
	tweet_list_box_gesture_pressed_cb ((TweetListBox*) self, n_press, x, y);
#line 695 "TweetListBox.c"
}

static GtkWidget*
_tweet_list_box_widget_create_func_gtk_list_box_create_widget_func (GObject* item,
                                                                    gpointer self)
{
	GtkWidget* result;
	result = tweet_list_box_widget_create_func ((TweetListBox*) self, item);
#line 41 "../src/widgets/TweetListBox.vala"
	return result;
#line 706 "TweetListBox.c"
}

static GObject *
tweet_list_box_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TweetListBox * self;
	GtkGestureMultiPress* _tmp0_;
	GtkGestureMultiPress* _tmp1_;
	GtkGestureMultiPress* _tmp2_;
	GtkGestureMultiPress* _tmp3_;
	CbDeltaUpdater* _tmp4_;
	CbTweetModel* _tmp5_;
#line 34 "../src/widgets/TweetListBox.vala"
	parent_class = G_OBJECT_CLASS (tweet_list_box_parent_class);
#line 34 "../src/widgets/TweetListBox.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 34 "../src/widgets/TweetListBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TWEET_LIST_BOX, TweetListBox);
#line 35 "../src/widgets/TweetListBox.vala"
	_tmp0_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 35 "../src/widgets/TweetListBox.vala"
	_g_object_unref0 (self->priv->press_gesture);
#line 35 "../src/widgets/TweetListBox.vala"
	self->priv->press_gesture = _tmp0_;
#line 36 "../src/widgets/TweetListBox.vala"
	_tmp1_ = self->priv->press_gesture;
#line 36 "../src/widgets/TweetListBox.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp1_, (guint) 0);
#line 37 "../src/widgets/TweetListBox.vala"
	_tmp2_ = self->priv->press_gesture;
#line 37 "../src/widgets/TweetListBox.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp2_, GTK_PHASE_BUBBLE);
#line 38 "../src/widgets/TweetListBox.vala"
	_tmp3_ = self->priv->press_gesture;
#line 38 "../src/widgets/TweetListBox.vala"
	g_signal_connect_object (_tmp3_, "pressed", (GCallback) _tweet_list_box_gesture_pressed_cb_gtk_gesture_multi_press_pressed, self, 0);
#line 39 "../src/widgets/TweetListBox.vala"
	_tmp4_ = cb_delta_updater_new ((GtkWidget*) self);
#line 39 "../src/widgets/TweetListBox.vala"
	_g_object_unref0 (self->delta_updater);
#line 39 "../src/widgets/TweetListBox.vala"
	self->delta_updater = _tmp4_;
#line 41 "../src/widgets/TweetListBox.vala"
	_tmp5_ = self->model;
#line 41 "../src/widgets/TweetListBox.vala"
	cb_utils_bind_model ((GtkWidget*) self, (GListModel*) _tmp5_, _tweet_list_box_widget_create_func_gtk_list_box_create_widget_func, self);
#line 34 "../src/widgets/TweetListBox.vala"
	return obj;
#line 759 "TweetListBox.c"
}

static void
tweet_list_box_class_init (TweetListBoxClass * klass,
                           gpointer klass_data)
{
#line 18 "../src/widgets/TweetListBox.vala"
	tweet_list_box_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/TweetListBox.vala"
	g_type_class_adjust_private_offset (klass, &TweetListBox_private_offset);
#line 18 "../src/widgets/TweetListBox.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tweet_list_box_get_property;
#line 18 "../src/widgets/TweetListBox.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tweet_list_box_set_property;
#line 18 "../src/widgets/TweetListBox.vala"
	G_OBJECT_CLASS (klass)->constructor = tweet_list_box_constructor;
#line 18 "../src/widgets/TweetListBox.vala"
	G_OBJECT_CLASS (klass)->finalize = tweet_list_box_finalize;
#line 18 "../src/widgets/TweetListBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TWEET_LIST_BOX_ACTION_ENTRY_PROPERTY, tweet_list_box_properties[TWEET_LIST_BOX_ACTION_ENTRY_PROPERTY] = g_param_spec_object ("action-entry", "action-entry", "action-entry", TYPE_TWEET_LIST_ENTRY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/widgets/TweetListBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TWEET_LIST_BOX_MAIN_WINDOW_PROPERTY, tweet_list_box_properties[TWEET_LIST_BOX_MAIN_WINDOW_PROPERTY] = g_param_spec_object ("main-window", "main-window", "main-window", TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 782 "TweetListBox.c"
}

static void
tweet_list_box_instance_init (TweetListBox * self,
                              gpointer klass)
{
	CbTweetModel* _tmp0_;
#line 18 "../src/widgets/TweetListBox.vala"
	self->priv = tweet_list_box_get_instance_private (self);
#line 21 "../src/widgets/TweetListBox.vala"
	_tmp0_ = cb_tweet_model_new ();
#line 21 "../src/widgets/TweetListBox.vala"
	self->model = _tmp0_;
#line 796 "TweetListBox.c"
}

static void
tweet_list_box_finalize (GObject * obj)
{
	TweetListBox * self;
#line 18 "../src/widgets/TweetListBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TWEET_LIST_BOX, TweetListBox);
#line 19 "../src/widgets/TweetListBox.vala"
	_g_object_unref0 (self->delta_updater);
#line 21 "../src/widgets/TweetListBox.vala"
	_g_object_unref0 (self->model);
#line 22 "../src/widgets/TweetListBox.vala"
	_g_object_unref0 (self->priv->press_gesture);
#line 23 "../src/widgets/TweetListBox.vala"
	_g_object_unref0 (self->priv->_action_entry);
#line 29 "../src/widgets/TweetListBox.vala"
	_g_object_unref0 (self->priv->_main_window);
#line 18 "../src/widgets/TweetListBox.vala"
	G_OBJECT_CLASS (tweet_list_box_parent_class)->finalize (obj);
#line 817 "TweetListBox.c"
}

static GType
tweet_list_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TweetListBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tweet_list_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TweetListBox), 0, (GInstanceInitFunc) tweet_list_box_instance_init, NULL };
	GType tweet_list_box_type_id;
	tweet_list_box_type_id = g_type_register_static (TYPE_LIST_BOX, "TweetListBox", &g_define_type_info, 0);
	TweetListBox_private_offset = g_type_add_instance_private (tweet_list_box_type_id, sizeof (TweetListBoxPrivate));
	return tweet_list_box_type_id;
}

GType
tweet_list_box_get_type (void)
{
	static volatile gsize tweet_list_box_type_id__once = 0;
	if (g_once_init_enter (&tweet_list_box_type_id__once)) {
		GType tweet_list_box_type_id;
		tweet_list_box_type_id = tweet_list_box_get_type_once ();
		g_once_init_leave (&tweet_list_box_type_id__once, tweet_list_box_type_id);
	}
	return tweet_list_box_type_id__once;
}

static void
_vala_tweet_list_box_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	TweetListBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TWEET_LIST_BOX, TweetListBox);
#line 18 "../src/widgets/TweetListBox.vala"
	switch (property_id) {
#line 18 "../src/widgets/TweetListBox.vala"
		case TWEET_LIST_BOX_ACTION_ENTRY_PROPERTY:
#line 18 "../src/widgets/TweetListBox.vala"
		g_value_set_object (value, tweet_list_box_get_action_entry (self));
#line 18 "../src/widgets/TweetListBox.vala"
		break;
#line 18 "../src/widgets/TweetListBox.vala"
		case TWEET_LIST_BOX_MAIN_WINDOW_PROPERTY:
#line 18 "../src/widgets/TweetListBox.vala"
		g_value_set_object (value, tweet_list_box_get_main_window (self));
#line 18 "../src/widgets/TweetListBox.vala"
		break;
#line 864 "TweetListBox.c"
		default:
#line 18 "../src/widgets/TweetListBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/TweetListBox.vala"
		break;
#line 870 "TweetListBox.c"
	}
}

static void
_vala_tweet_list_box_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	TweetListBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TWEET_LIST_BOX, TweetListBox);
#line 18 "../src/widgets/TweetListBox.vala"
	switch (property_id) {
#line 18 "../src/widgets/TweetListBox.vala"
		case TWEET_LIST_BOX_MAIN_WINDOW_PROPERTY:
#line 18 "../src/widgets/TweetListBox.vala"
		tweet_list_box_set_main_window (self, g_value_get_object (value));
#line 18 "../src/widgets/TweetListBox.vala"
		break;
#line 890 "TweetListBox.c"
		default:
#line 18 "../src/widgets/TweetListBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/TweetListBox.vala"
		break;
#line 896 "TweetListBox.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

