/* TweetUtils.c generated by valac 0.56.15, the Vala compiler
 * generated from TweetUtils.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include "cawbird.h"
#include <rest/rest-proxy-call.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include "CbTweet.h"
#include <rest/oauth-proxy.h>
#include <rest/rest-proxy.h>
#include <glib-object.h>
#include "CbUserStream.h"
#include "CbUtils.h"
#include "CbTypes.h"
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>
#include <rest/rest-param.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <libsoup/soup.h>
#include "CbBundle.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "CbUserCounter.h"
#include "CbTweetModel.h"
#include "CbMedia.h"
#include <cairo-gobject.h>

#define PROFILE_PAGE_KEY_USER_ID 1
#define PROFILE_PAGE_KEY_SCREEN_NAME 0
#define SEARCH_PAGE_KEY_QUERY 0
#define TWEET_INFO_PAGE_KEY_MODE 0
#define TWEET_INFO_PAGE_BY_ID 2
#define TWEET_INFO_PAGE_KEY_TWEET_ID 3
#define TWEET_INFO_PAGE_KEY_SCREEN_NAME 4
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block60Data Block60Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _TweetUtilsGetTweetData TweetUtilsGetTweetData;
#define _composed_tweet_unref0(var) ((var == NULL) ? NULL : (var = (composed_tweet_unref (var), NULL)))

#define TYPE_COMPOSED_TWEET (composed_tweet_get_type ())
#define COMPOSED_TWEET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPOSED_TWEET, ComposedTweet))
#define COMPOSED_TWEET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPOSED_TWEET, ComposedTweetClass))
#define IS_COMPOSED_TWEET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPOSED_TWEET))
#define IS_COMPOSED_TWEET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPOSED_TWEET))
#define COMPOSED_TWEET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPOSED_TWEET, ComposedTweetClass))

typedef struct _ComposedTweet ComposedTweet;
typedef struct _ComposedTweetClass ComposedTweetClass;
typedef struct _Block61Data Block61Data;

#define TYPE_MEDIA_UPLOAD (media_upload_get_type ())
#define MEDIA_UPLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_UPLOAD, MediaUpload))
#define MEDIA_UPLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_UPLOAD, MediaUploadClass))
#define IS_MEDIA_UPLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_UPLOAD))
#define IS_MEDIA_UPLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_UPLOAD))
#define MEDIA_UPLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_UPLOAD, MediaUploadClass))

typedef struct _MediaUpload MediaUpload;
typedef struct _MediaUploadClass MediaUploadClass;
typedef struct _Block62Data Block62Data;
typedef struct _Block63Data Block63Data;
typedef struct _TweetUtilsPostTweetData TweetUtilsPostTweetData;
typedef struct _TweetUtilsDoPostTweetData TweetUtilsDoPostTweetData;
typedef struct _Block64Data Block64Data;
typedef struct _TweetUtilsDeleteTweetData TweetUtilsDeleteTweetData;
typedef struct _Block65Data Block65Data;
typedef struct _TweetUtilsSetFavoriteStatusData TweetUtilsSetFavoriteStatusData;
typedef struct _Block66Data Block66Data;
typedef struct _TweetUtilsSetRetweetStatusData TweetUtilsSetRetweetStatusData;
typedef struct _Block67Data Block67Data;
typedef struct _Block68Data Block68Data;
typedef struct _TweetUtilsSearchForTweetsJsonData TweetUtilsSearchForTweetsJsonData;
typedef struct _Block69Data Block69Data;
typedef struct _TweetUtilsSearchForTweetsData TweetUtilsSearchForTweetsData;
typedef gboolean (*TweetUtilsUploadMediaCallback) (gpointer user_data);

#define TWEET_UTILS_TYPE_UPLOAD_PROGRESS (tweet_utils_upload_progress_get_type ())
#define TWEET_UTILS_UPLOAD_PROGRESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TWEET_UTILS_TYPE_UPLOAD_PROGRESS, TweetUtilsUploadProgress))
#define TWEET_UTILS_UPLOAD_PROGRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TWEET_UTILS_TYPE_UPLOAD_PROGRESS, TweetUtilsUploadProgressClass))
#define TWEET_UTILS_IS_UPLOAD_PROGRESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TWEET_UTILS_TYPE_UPLOAD_PROGRESS))
#define TWEET_UTILS_IS_UPLOAD_PROGRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TWEET_UTILS_TYPE_UPLOAD_PROGRESS))
#define TWEET_UTILS_UPLOAD_PROGRESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TWEET_UTILS_TYPE_UPLOAD_PROGRESS, TweetUtilsUploadProgressClass))

typedef struct _TweetUtilsUploadProgress TweetUtilsUploadProgress;
typedef struct _TweetUtilsUploadProgressClass TweetUtilsUploadProgressClass;
typedef struct _TweetUtilsUploadProgressPrivate TweetUtilsUploadProgressPrivate;
typedef struct _TweetUtilsParamSpecUploadProgress TweetUtilsParamSpecUploadProgress;
typedef struct _Block70Data Block70Data;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _tweet_utils_upload_progress_unref0(var) ((var == NULL) ? NULL : (var = (tweet_utils_upload_progress_unref (var), NULL)))
#define _rest_param_unref0(var) ((var == NULL) ? NULL : (var = (rest_param_unref (var), NULL)))
typedef struct _TweetUtilsUploadMediaData TweetUtilsUploadMediaData;
typedef struct _Block71Data Block71Data;
typedef struct _TweetUtilsDownloadAvatarData TweetUtilsDownloadAvatarData;
typedef enum  {
	PAGE_STREAM = 0,
	PAGE_MENTIONS,
	PAGE_FAVORITES,
	PAGE_DM_THREADS,
	PAGE_LISTS,
	PAGE_FILTERS,
	PAGE_SEARCH,
	PAGE_PROFILE,
	PAGE_TWEET_INFO,
	PAGE_DM,
	PAGE_LIST_STATUSES,
	PAGE_PREVIOUS = 1024,
	PAGE_NEXT = 2048
} Page;

#define TYPE_PAGE (page_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define TYPE_MEDIA_DIALOG (media_dialog_get_type ())
#define MEDIA_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_DIALOG, MediaDialog))
#define MEDIA_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_DIALOG, MediaDialogClass))
#define IS_MEDIA_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_DIALOG))
#define IS_MEDIA_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_DIALOG))
#define MEDIA_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_DIALOG, MediaDialogClass))

typedef struct _MediaDialog MediaDialog;
typedef struct _MediaDialogClass MediaDialogClass;

struct _Block60Data {
	int _ref_count_;
	RestProxyCall* call;
	CbTweet* tweet;
	GError* err;
	Account* account;
	gpointer _async_data_;
};

struct _TweetUtilsGetTweetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 tweet_id;
	CbTweet* result;
	Block60Data* _data60_;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	RestProxyCall* _tmp7_;
	RestProxyCall* _tmp8_;
	RestProxyCall* _tmp9_;
	RestProxyCall* _tmp10_;
	GError* _tmp11_;
	GError* _tmp12_;
	GError* _tmp13_;
	CbTweet* _tmp14_;
	CbTweet* _tmp15_;
	GError* _inner_error0_;
};

struct _Block61Data {
	int _ref_count_;
	gpointer _async_data_;
};

struct _Block62Data {
	int _ref_count_;
	Block61Data * _data61_;
	GError* err;
	GMutex mutex;
	CollectById* collect;
	gboolean yielded;
};

struct _Block63Data {
	int _ref_count_;
	Block62Data * _data62_;
	MediaUpload* upload;
	gulong handler_id;
};

struct _TweetUtilsPostTweetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	ComposedTweet* tweet;
	gboolean result;
	Block61Data* _data61_;
	MediaUpload** media_attachments;
	gint _tmp0_;
	MediaUpload** _tmp1_;
	gint media_attachments_length1;
	gint _media_attachments_size_;
	MediaUpload** _tmp2_;
	gint _tmp2__length1;
	Block62Data* _data62_;
	CollectById* _tmp3_;
	CollectById* _tmp4_;
	MediaUpload** _tmp5_;
	gint _tmp5__length1;
	MediaUpload** upload_collection;
	gint upload_collection_length1;
	gint _upload_collection_size_;
	gint upload_it;
	MediaUpload* _tmp6_;
	MediaUpload* upload;
	Block63Data* _data63_;
	CollectById* _tmp7_;
	MediaUpload* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	MediaUpload* _tmp11_;
	gulong _tmp12_;
	MediaUpload* _tmp13_;
	MediaUpload* _tmp14_;
	CollectById* _tmp15_;
	MediaUpload* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gboolean _tmp19_;
	CollectById* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	CollectById* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	GError* _tmp26_;
	GError* _tmp27_;
	GError* _tmp28_;
	gboolean _tmp29_;
	GError* _inner_error0_;
};

struct _TweetUtilsDoPostTweetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	ComposedTweet* tweet;
	gboolean result;
	RestProxyCall* call;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	RestProxyCall* _tmp6_;
	gint64 _tmp7_;
	gint64 _tmp8_;
	RestProxyCall* _tmp9_;
	gint64 _tmp10_;
	gint64 _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	RestProxyCall* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	MediaUpload** media_attachments;
	gint _tmp17_;
	MediaUpload** _tmp18_;
	gint media_attachments_length1;
	gint _media_attachments_size_;
	MediaUpload** _tmp19_;
	gint _tmp19__length1;
	gchar** ids;
	MediaUpload** _tmp20_;
	gint _tmp20__length1;
	gint _tmp21_;
	gpointer* _tmp22_;
	gint ids_length1;
	gint _ids_size_;
	RestProxyCall* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
	gchar* _tmp26_;
	RestProxyCall* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	RestProxyCall* _tmp30_;
	GError* e;
	RestProxyCall* _tmp31_;
	GError* _tmp32_;
	GError* _tmp33_;
	RestProxyCall* _tmp34_;
	const gchar* _tmp35_;
	GError* _inner_error0_;
};

struct _Block64Data {
	int _ref_count_;
	RestProxyCall* call;
	gboolean success;
	GError* err;
	Account* account;
	CbTweet* tweet;
	gpointer _async_data_;
};

struct _TweetUtilsDeleteTweetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	CbTweet* tweet;
	gboolean result;
	Block64Data* _data64_;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	RestProxyCall* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	RestProxyCall* _tmp13_;
	GError* _tmp14_;
	GError* _tmp15_;
	GError* _tmp16_;
	GError* _inner_error0_;
};

struct _Block65Data {
	int _ref_count_;
	RestProxyCall* call;
	gboolean success;
	GError* err;
	CbTweet* tweet;
	gboolean status;
	gpointer _async_data_;
};

struct _TweetUtilsSetFavoriteStatusData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	CbTweet* tweet;
	gboolean status;
	gboolean result;
	Block65Data* _data65_;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	RestProxyCall* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	GError* _inner_error0_;
};

struct _Block66Data {
	int _ref_count_;
	RestProxyCall* call;
	gboolean success;
	GError* err;
	Account* account;
	CbTweet* tweet;
	gboolean status;
	gpointer _async_data_;
};

struct _TweetUtilsSetRetweetStatusData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	CbTweet* tweet;
	gboolean status;
	gboolean result;
	Block66Data* _data66_;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	RestProxyCall* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	RestProxyCall* _tmp13_;
	RestProxyCall* _tmp14_;
	RestProxyCall* _tmp15_;
	RestProxyCall* _tmp16_;
	GError* _tmp17_;
	GError* _tmp18_;
	GError* _tmp19_;
	GError* _inner_error0_;
};

struct _Block67Data {
	int _ref_count_;
	GList* statuses;
	GError* err;
	Account* account;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _Block68Data {
	int _ref_count_;
	Block67Data * _data67_;
	gchar** ids;
	gint ids_length1;
	gint _ids_size_;
};

struct _TweetUtilsSearchForTweetsJsonData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gchar* search_query;
	gint64 max_id;
	gint64 since_id;
	guint count;
	GCancellable* cancellable;
	GList* result;
	Block67Data* _data67_;
	RestProxyCall* search_call;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	RestProxyCall* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	RestProxyCall* _tmp11_;
	RestProxyCall* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	RestProxyCall* _tmp15_;
	GError* _tmp16_;
	GError* _tmp17_;
	GError* _tmp18_;
	GList* _tmp19_;
	GList* _tmp20_;
	GList* _tmp21_;
	GList* _tmp22_;
	GError* _inner_error0_;
};

struct _Block69Data {
	int _ref_count_;
	CbTweet** tweets;
	gint tweets_length1;
	gint _tweets_size_;
	GDateTime* now;
	Account* account;
	gpointer _async_data_;
};

struct _TweetUtilsSearchForTweetsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gchar* search_query;
	gint64 max_id;
	gint64 since_id;
	guint count;
	GCancellable* cancellable;
	CbTweet** result;
	gint result_length1;
	Block69Data* _data69_;
	GList* statuses;
	GList* _tmp0_;
	CbTweet** _tmp1_;
	GDateTime* _tmp2_;
	CbTweet** _tmp3_;
	gint _tmp3__length1;
	CbTweet** _tmp4_;
	gint _tmp4__length1;
	CbTweet** _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_;
};

struct _TweetUtilsUploadProgress {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TweetUtilsUploadProgressPrivate * priv;
};

struct _TweetUtilsUploadProgressClass {
	GTypeClass parent_class;
	void (*finalize) (TweetUtilsUploadProgress *self);
};

struct _TweetUtilsUploadProgressPrivate {
	MediaUpload* _upload;
	gdouble _filesize;
	gdouble _total_uploaded;
	TweetUtilsUploadMediaCallback _cb;
	gpointer _cb_target;
	GDestroyNotify _cb_target_destroy_notify;
};

struct _TweetUtilsParamSpecUploadProgress {
	GParamSpec parent_instance;
};

struct _Block70Data {
	int _ref_count_;
	gpointer _async_data_;
};

struct _TweetUtilsUploadMediaData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MediaUpload* media_upload;
	Account* account;
	GCancellable* cancellable;
	gboolean result;
	Block70Data* _data70_;
	OAuthProxy* upload_proxy;
	OAuthProxy* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	OAuthProxy* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	OAuthProxy* _tmp8_;
	OAuthProxy* _tmp9_;
	OAuthProxy* _tmp10_;
	OAuthProxy* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	OAuthProxy* _tmp14_;
	OAuthProxy* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	RestProxyCall* init_call;
	OAuthProxy* _tmp18_;
	RestProxyCall* _tmp19_;
	RestProxyCall* _tmp20_;
	RestProxyCall* _tmp21_;
	RestProxyCall* _tmp22_;
	RestProxyCall* _tmp23_;
	gint64 _tmp24_;
	gint64 _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	RestProxyCall* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	RestProxyCall* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	JsonNode* root;
	JsonNode* _tmp35_;
	RestProxyCall* _tmp36_;
	JsonNode* _tmp37_;
	JsonNode* _tmp38_;
	GError* e;
	RestProxyCall* _tmp39_;
	GError* _tmp40_;
	GError* _tmp41_;
	GError* _tmp42_;
	JsonNode* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	JsonNode* _tmp47_;
	JsonObject* _tmp48_;
	GFileInputStream* file_reader;
	GFileInputStream* _tmp49_;
	GFileInputStream* _tmp50_;
	GFileInputStream* _tmp51_;
	GError* _vala1_e;
	GError* _tmp52_;
	gint chunk_idx;
	gsize total_uploaded;
	gint64 filesize;
	gint64 _tmp53_;
	gint64 _tmp54_;
	RestProxyCall* append_call;
	OAuthProxy* _tmp55_;
	RestProxyCall* _tmp56_;
	GBytes* chunk;
	GBytes* _tmp57_;
	GFileInputStream* _tmp58_;
	GBytes* _tmp59_;
	GBytes* _tmp60_;
	GError* _vala2_e;
	GError* _tmp61_;
	RestProxyCall* _tmp62_;
	RestProxyCall* _tmp63_;
	RestProxyCall* _tmp64_;
	RestProxyCall* _tmp65_;
	gint64 _tmp66_;
	gint64 _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	RestProxyCall* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	RestParam* media_param;
	GBytes* _tmp73_;
	gsize _tmp74_;
	guint8* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	RestParam* _tmp79_;
	RestParam* _tmp80_;
	RestProxyCall* _tmp81_;
	RestParam* _tmp82_;
	RestParam* _tmp83_;
	TweetUtilsUploadProgress* upload_progress;
	TweetUtilsUploadProgress* _tmp84_;
	RestProxyCall* _tmp85_;
	TweetUtilsUploadProgress* _tmp86_;
	GError* _vala3_e;
	RestProxyCall* _tmp87_;
	GError* _tmp88_;
	GError* _tmp89_;
	GError* _tmp90_;
	GBytes* _tmp91_;
	gint _tmp92_;
	RestProxyCall* finalise_call;
	OAuthProxy* _tmp93_;
	RestProxyCall* _tmp94_;
	RestProxyCall* _tmp95_;
	RestProxyCall* _tmp96_;
	RestProxyCall* _tmp97_;
	RestProxyCall* _tmp98_;
	gint64 _tmp99_;
	gint64 _tmp100_;
	gchar* _tmp101_;
	gchar* _tmp102_;
	JsonNode* _tmp103_;
	RestProxyCall* _tmp104_;
	JsonNode* _tmp105_;
	JsonNode* _tmp106_;
	GError* _vala4_e;
	RestProxyCall* _tmp107_;
	GError* _tmp108_;
	GError* _tmp109_;
	GError* _tmp110_;
	JsonNode* _tmp111_;
	gchar* _tmp112_;
	gchar* _tmp113_;
	gchar* _tmp114_;
	JsonObject* object;
	JsonNode* _tmp115_;
	JsonObject* _tmp116_;
	JsonObject* _tmp117_;
	JsonObject* _tmp118_;
	JsonObject* processing_info;
	JsonObject* _tmp119_;
	JsonObject* _tmp120_;
	JsonObject* _tmp121_;
	gchar* state;
	JsonObject* _tmp122_;
	const gchar* _tmp123_;
	gchar* _tmp124_;
	const gchar* _tmp125_;
	const gchar* _tmp126_;
	JsonObject* _error_;
	JsonObject* _tmp127_;
	JsonObject* _tmp128_;
	JsonObject* _tmp129_;
	gint64 error_code;
	JsonObject* _tmp130_;
	gchar* message;
	gchar* _tmp131_;
	JsonObject* _tmp132_;
	JsonObject* _tmp133_;
	const gchar* _tmp134_;
	gchar* _tmp135_;
	JsonObject* _tmp136_;
	gchar* error_name;
	JsonObject* _tmp137_;
	const gchar* _tmp138_;
	gchar* _tmp139_;
	const gchar* _tmp140_;
	gchar* _tmp141_;
	gchar* _tmp142_;
	const gchar* _tmp143_;
	GError* _tmp144_;
	GError* _tmp145_;
	guint delay;
	JsonObject* _tmp146_;
	JsonObject* _tmp147_;
	RestProxyCall* status_call;
	OAuthProxy* _tmp148_;
	RestProxyCall* _tmp149_;
	RestProxyCall* _tmp150_;
	RestProxyCall* _tmp151_;
	RestProxyCall* _tmp152_;
	RestProxyCall* _tmp153_;
	gint64 _tmp154_;
	gint64 _tmp155_;
	gchar* _tmp156_;
	gchar* _tmp157_;
	JsonNode* _tmp158_;
	RestProxyCall* _tmp159_;
	JsonNode* _tmp160_;
	JsonNode* _tmp161_;
	GError* _vala5_e;
	RestProxyCall* _tmp162_;
	GError* _tmp163_;
	GError* _tmp164_;
	GError* _tmp165_;
	JsonNode* _tmp166_;
	gchar* _tmp167_;
	gchar* _tmp168_;
	gchar* _tmp169_;
	JsonNode* _tmp170_;
	JsonObject* _tmp171_;
	JsonObject* _tmp172_;
	GError* _inner_error0_;
};

struct _Block71Data {
	int _ref_count_;
	GdkPixbuf* avatar;
	SoupMessage* msg;
	GError* err;
	gint size;
	gpointer _async_data_;
};

struct _TweetUtilsDownloadAvatarData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar* avatar_url;
	gint size;
	GCancellable* cancellable;
	GdkPixbuf* result;
	Block71Data* _data71_;
	SoupMessage* _tmp0_;
	SoupSession* _tmp1_;
	SoupMessage* _tmp2_;
	SoupMessage* _tmp3_;
	GError* _tmp4_;
	GError* _tmp5_;
	GError* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp8_;
	GError* _inner_error0_;
};

VALA_EXTERN gint MAX_CHUNK_SIZE;
gint MAX_CHUNK_SIZE = (5 * 1024) * 1024;
static gint TweetUtilsUploadProgress_private_offset;
static gpointer tweet_utils_upload_progress_parent_class = NULL;
VALA_EXTERN SoupSession* SOUP_SESSION;

static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
VALA_EXTERN gchar* tweet_utils_code_to_message (gint code,
                                    const gchar* default_message);
static void tweet_utils_get_tweet_data_free (gpointer _data);
VALA_EXTERN void tweet_utils_get_tweet (Account* account,
                            gint64 tweet_id,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_);
VALA_EXTERN CbTweet* tweet_utils_get_tweet_finish (GAsyncResult* _res_,
                                       GError** error);
static gboolean tweet_utils_get_tweet_co (TweetUtilsGetTweetData* _data_);
static Block60Data* block60_data_ref (Block60Data* _data60_);
static void block60_data_unref (void * _userdata_);
static void __lambda59_ (Block60Data* _data60_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda59__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void tweet_utils_post_tweet_data_free (gpointer _data);
VALA_EXTERN gpointer composed_tweet_ref (gpointer instance);
VALA_EXTERN void composed_tweet_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_composed_tweet (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_composed_tweet (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_composed_tweet (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_composed_tweet (const GValue* value);
VALA_EXTERN GType composed_tweet_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void tweet_utils_post_tweet (Account* account,
                             ComposedTweet* tweet,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
VALA_EXTERN gboolean tweet_utils_post_tweet_finish (GAsyncResult* _res_,
                                        GError** error);
static gboolean tweet_utils_post_tweet_co (TweetUtilsPostTweetData* _data_);
static Block61Data* block61_data_ref (Block61Data* _data61_);
static void block61_data_unref (void * _userdata_);
VALA_EXTERN GType media_upload_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MediaUpload** composed_tweet_get_attachments (ComposedTweet* self,
                                              gint* result_length1);
static Block62Data* block62_data_ref (Block62Data* _data62_);
static void block62_data_unref (void * _userdata_);
static void ___lambda65_ (Block62Data* _data62_,
                   GError* _error_);
static void ____lambda65__collect_by_id_finished (CollectById* _sender,
                                           GError* _error_,
                                           gpointer self);
static Block63Data* block63_data_ref (Block63Data* _data63_);
static void block63_data_unref (void * _userdata_);
VALA_EXTERN const gchar* media_upload_get_id (MediaUpload* self);
static void _____lambda66_ (Block63Data* _data63_,
                     GError* _error_);
static void ______lambda66__media_upload_progress_complete (MediaUpload* _sender,
                                                     GError* _error_,
                                                     gpointer self);
VALA_EXTERN gboolean media_upload_is_uploaded (MediaUpload* self);
VALA_EXTERN void tweet_utils_do_post_tweet (Account* account,
                                ComposedTweet* tweet,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
VALA_EXTERN gboolean tweet_utils_do_post_tweet_finish (GAsyncResult* _res_,
                                           GError** error);
static void tweet_utils_post_tweet_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_);
VALA_EXTERN gchar* tweet_utils_map_upload_to_id (MediaUpload* upload);
VALA_EXTERN gint64 media_upload_get_media_id (MediaUpload* self);
static void tweet_utils_do_post_tweet_data_free (gpointer _data);
static gboolean tweet_utils_do_post_tweet_co (TweetUtilsDoPostTweetData* _data_);
VALA_EXTERN gint64 composed_tweet_get_reply_to_id (ComposedTweet* self);
VALA_EXTERN gboolean composed_tweet_has_quote_attachment (ComposedTweet* self);
VALA_EXTERN gchar* composed_tweet_get_quoted_url (ComposedTweet* self);
VALA_EXTERN gpointer* map (GType source_type,
               GBoxedCopyFunc source_dup_func,
               GDestroyNotify source_destroy_func,
               GType target_type,
               GBoxedCopyFunc target_dup_func,
               GDestroyNotify target_destroy_func,
               gpointer* arr,
               gint arr_length1,
               MapFunction map_func,
               gpointer map_func_target,
               gint* result_length1);
VALA_EXTERN gchar* composed_tweet_get_text (ComposedTweet* self);
static void tweet_utils_do_post_tweet_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void tweet_utils_delete_tweet_data_free (gpointer _data);
VALA_EXTERN void tweet_utils_delete_tweet (Account* account,
                               CbTweet* tweet,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN gboolean tweet_utils_delete_tweet_finish (GAsyncResult* _res_,
                                          GError** error);
static gboolean tweet_utils_delete_tweet_co (TweetUtilsDeleteTweetData* _data_);
static Block64Data* block64_data_ref (Block64Data* _data64_);
static void block64_data_unref (void * _userdata_);
static void __lambda77_ (Block64Data* _data64_,
                  GObject* obj,
                  GAsyncResult* res);
VALA_EXTERN void tweet_utils_inject_deletion (gint64 id,
                                  Account* account);
static void ___lambda77__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void tweet_utils_set_favorite_status_data_free (gpointer _data);
VALA_EXTERN void tweet_utils_set_favorite_status (Account* account,
                                      CbTweet* tweet,
                                      gboolean status,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gboolean tweet_utils_set_favorite_status_finish (GAsyncResult* _res_,
                                                 GError** error);
static gboolean tweet_utils_set_favorite_status_co (TweetUtilsSetFavoriteStatusData* _data_);
static Block65Data* block65_data_ref (Block65Data* _data65_);
static void block65_data_unref (void * _userdata_);
static void __lambda75_ (Block65Data* _data65_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda75__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void tweet_utils_set_retweet_status_data_free (gpointer _data);
VALA_EXTERN void tweet_utils_set_retweet_status (Account* account,
                                     CbTweet* tweet,
                                     gboolean status,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
VALA_EXTERN gboolean tweet_utils_set_retweet_status_finish (GAsyncResult* _res_,
                                                GError** error);
static gboolean tweet_utils_set_retweet_status_co (TweetUtilsSetRetweetStatusData* _data_);
static Block66Data* block66_data_ref (Block66Data* _data66_);
static void block66_data_unref (void * _userdata_);
static void __lambda98_ (Block66Data* _data66_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda98__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void tweet_utils_search_for_tweets_json_data_free (gpointer _data);
VALA_EXTERN void tweet_utils_search_for_tweets_json (Account* account,
                                         const gchar* search_query,
                                         gint64 max_id,
                                         gint64 since_id,
                                         guint count,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN GList* tweet_utils_search_for_tweets_json_finish (GAsyncResult* _res_,
                                                  GError** error);
static gboolean tweet_utils_search_for_tweets_json_co (TweetUtilsSearchForTweetsJsonData* _data_);
static Block67Data* block67_data_ref (Block67Data* _data67_);
static void block67_data_unref (void * _userdata_);
static void __lambda92_ (Block67Data* _data67_,
                  GObject* _,
                  GAsyncResult* res);
static Block68Data* block68_data_ref (Block68Data* _data68_);
static void block68_data_unref (void * _userdata_);
static void __lambda93_ (Block68Data* _data68_,
                  JsonArray* array,
                  guint index,
                  JsonNode* node);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ___lambda93__json_array_foreach (JsonArray* array,
                                      guint index_,
                                      JsonNode* element_node,
                                      gpointer self);
static void __lambda94_ (Block68Data* _data68_,
                  GObject* _,
                  GAsyncResult* res);
static gint __lambda95_ (JsonNode* a,
                  JsonNode* b);
static gint ___lambda95__gcompare_func (gconstpointer a,
                                 gconstpointer b);
static void ___lambda94__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ___lambda92__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
VALA_EXTERN void tweet_utils_set_tweet_hidden_flags (CbTweet* t,
                                         Account* account);
static void tweet_utils_search_for_tweets_data_free (gpointer _data);
VALA_EXTERN void tweet_utils_search_for_tweets (Account* account,
                                    const gchar* search_query,
                                    gint64 max_id,
                                    gint64 since_id,
                                    guint count,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
VALA_EXTERN CbTweet** tweet_utils_search_for_tweets_finish (GAsyncResult* _res_,
                                                gint* result_length1,
                                                GError** error);
static gboolean tweet_utils_search_for_tweets_co (TweetUtilsSearchForTweetsData* _data_);
static Block69Data* block69_data_ref (Block69Data* _data69_);
static void block69_data_unref (void * _userdata_);
static void tweet_utils_search_for_tweets_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static void __lambda206_ (Block69Data* _data69_,
                   JsonNode* node);
static void _vala_array_add3 (CbTweet** * array,
                       gint* length,
                       gint* size,
                       CbTweet* value);
static void ___lambda206__gfunc (gconstpointer data,
                          gpointer self);
static CbTweet** _vala_array_dup13 (CbTweet** self,
                             gssize length);
VALA_EXTERN void tweet_utils_inject_user_action_json (const gchar* user_json,
                                          Account* account,
                                          CbStreamMessageType action);
VALA_EXTERN void tweet_utils_inject_user_action (gint64 user_id,
                                     Account* account,
                                     CbStreamMessageType action);
VALA_EXTERN gpointer tweet_utils_upload_progress_ref (gpointer instance);
VALA_EXTERN void tweet_utils_upload_progress_unref (gpointer instance);
VALA_EXTERN GParamSpec* tweet_utils_param_spec_upload_progress (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
VALA_EXTERN void tweet_utils_value_set_upload_progress (GValue* value,
                                            gpointer v_object);
VALA_EXTERN void tweet_utils_value_take_upload_progress (GValue* value,
                                             gpointer v_object);
VALA_EXTERN gpointer tweet_utils_value_get_upload_progress (const GValue* value);
VALA_EXTERN GType tweet_utils_upload_progress_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TweetUtilsUploadProgress* tweet_utils_upload_progress_new (MediaUpload* media_upload,
                                                           gint64 filesize,
                                                           gsize total_uploaded,
                                                           TweetUtilsUploadMediaCallback callback,
                                                           gpointer callback_target);
VALA_EXTERN TweetUtilsUploadProgress* tweet_utils_upload_progress_construct (GType object_type,
                                                                 MediaUpload* media_upload,
                                                                 gint64 filesize,
                                                                 gsize total_uploaded,
                                                                 TweetUtilsUploadMediaCallback callback,
                                                                 gpointer callback_target);
VALA_EXTERN void tweet_utils_upload_progress_callback (TweetUtilsUploadProgress* self,
                                           RestProxyCall* call,
                                           gsize total,
                                           gsize uploaded,
                                           GError* _error_,
                                           GObject* weak_object);
VALA_EXTERN void media_upload_set_progress (MediaUpload* self,
                                gdouble value);
static void tweet_utils_upload_progress_finalize (TweetUtilsUploadProgress * obj);
static GType tweet_utils_upload_progress_get_type_once (void);
static void tweet_utils_upload_media_data_free (gpointer _data);
VALA_EXTERN void tweet_utils_upload_media (MediaUpload* media_upload,
                               Account* account,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN gboolean tweet_utils_upload_media_finish (GAsyncResult* _res_);
static gboolean tweet_utils_upload_media_co (TweetUtilsUploadMediaData* _data_);
static Block70Data* block70_data_ref (Block70Data* _data70_);
static void block70_data_unref (void * _userdata_);
VALA_EXTERN gint64 media_upload_get_filesize (MediaUpload* self);
VALA_EXTERN const gchar* media_upload_get_filetype (MediaUpload* self);
VALA_EXTERN gchar* media_upload_get_media_category (MediaUpload* self);
static void tweet_utils_upload_media_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
VALA_EXTERN gchar* media_upload_get_filepath (MediaUpload* self);
VALA_EXTERN void media_upload_set_media_id (MediaUpload* self,
                                gint64 value);
VALA_EXTERN GFileInputStream* media_upload_read (MediaUpload* self,
                                     GError** error);
static gboolean _tweet_utils_upload_media_co_tweet_utils_upload_media_callback (gpointer self);
static void _tweet_utils_upload_progress_callback_rest_proxy_call_upload_callback (RestProxyCall* call,
                                                                            gsize total,
                                                                            gsize uploaded,
                                                                            GError* _error_,
                                                                            GObject* weak_object,
                                                                            gpointer self);
static gboolean _____lambda71_ (Block70Data* _data70_);
static gboolean ______lambda71__gsource_func (gpointer self);
VALA_EXTERN void media_upload_finalize_upload (MediaUpload* self);
static void tweet_utils_download_avatar_data_free (gpointer _data);
VALA_EXTERN void tweet_utils_download_avatar (const gchar* avatar_url,
                                  gint size,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
VALA_EXTERN GdkPixbuf* tweet_utils_download_avatar_finish (GAsyncResult* _res_,
                                               GError** error);
static gboolean tweet_utils_download_avatar_co (TweetUtilsDownloadAvatarData* _data_);
static Block71Data* block71_data_ref (Block71Data* _data71_);
static void block71_data_unref (void * _userdata_);
static void ___lambda9_ (Block71Data* _data71_);
static void ____lambda9__g_cancellable_cancelled (GCancellable* _sender,
                                           gpointer self);
static void __lambda10_ (Block71Data* _data71_,
                  SoupSession* s,
                  SoupMessage* _msg);
static guint8* _vala_array_dup14 (guint8* self,
                           gssize length);
static void ___lambda10__soup_session_callback (SoupSession* session,
                                         SoupMessage* msg,
                                         gpointer self);
VALA_EXTERN gboolean tweet_utils_activate_link (const gchar* uri,
                                    MainWindow* window);
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void utils_show_error_dialog (GError* e,
                              GtkWindow* transient_for,
                              const gchar* file,
                              gint line);
VALA_EXTERN void tweet_utils_work_array (JsonArray* json_array,
                             TweetListBox* tweet_list,
                             Account* account);
VALA_EXTERN GType media_dialog_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MediaDialog* media_dialog_new (CbMedia** media,
                               gint media_length1,
                               gint start_media_index,
                               GdkRectangle* max_dimensions);
VALA_EXTERN MediaDialog* media_dialog_construct (GType object_type,
                                     CbMedia** media,
                                     gint media_length1,
                                     gint start_media_index,
                                     GdkRectangle* max_dimensions);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
tweet_utils_get_error_domain (void)
{
	GQuark result;
#line 23 "../src/util/TweetUtils.vala"
	result = g_quark_from_string ("tweet-action");
#line 23 "../src/util/TweetUtils.vala"
	return result;
#line 1177 "TweetUtils.c"
}

/**
   * Turns Twitter's JSON error messages into a GLib.Error object, unless
   * the exception was caused by a libsoup error
   *
   * Example JSON:
   * {"errors":[{"message":"Sorry, that page does not exist","code":34}]}
   */
static gpointer
_g_error_copy0 (gpointer self)
{
#line 37 "../src/util/TweetUtils.vala"
	return self ? g_error_copy (self) : NULL;
#line 1192 "TweetUtils.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 63 "../src/util/TweetUtils.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 1200 "TweetUtils.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 63 "../src/util/TweetUtils.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 1208 "TweetUtils.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 65 "../src/util/TweetUtils.vala"
	g_boxed_free (json_node_get_type (), self);
#line 1216 "TweetUtils.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 67 "../src/util/TweetUtils.vala"
	return self ? json_object_ref (self) : NULL;
#line 1224 "TweetUtils.c"
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 68 "../src/util/TweetUtils.vala"
	return self ? json_array_ref (self) : NULL;
#line 1232 "TweetUtils.c"
}

GError*
tweet_utils_failed_request_to_error (RestProxyCall* call,
                                     GError* e)
{
	const gchar* json = NULL;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	GError* result;
#line 32 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (call != NULL, NULL);
#line 32 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (e != NULL, NULL);
#line 33 "../src/util/TweetUtils.vala"
	if (e->code < 100) {
#line 1249 "TweetUtils.c"
		GError* _tmp0_;
#line 37 "../src/util/TweetUtils.vala"
		_tmp0_ = _g_error_copy0 (e);
#line 37 "../src/util/TweetUtils.vala"
		result = _tmp0_;
#line 37 "../src/util/TweetUtils.vala"
		return result;
#line 1257 "TweetUtils.c"
	}
#line 40 "../src/util/TweetUtils.vala"
	_tmp1_ = rest_proxy_call_get_payload (call);
#line 40 "../src/util/TweetUtils.vala"
	json = _tmp1_;
#line 1263 "TweetUtils.c"
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp2_;
		JsonParser* _tmp3_;
		const gchar* _tmp4_;
		JsonNode* node = NULL;
		JsonParser* _tmp5_;
		JsonNode* _tmp6_;
		JsonNode* _tmp7_;
		JsonNode* _tmp8_;
		JsonObject* obj = NULL;
		JsonNode* _tmp11_;
		JsonObject* _tmp12_;
		JsonObject* _tmp13_;
		JsonArray* errors = NULL;
		JsonObject* _tmp14_;
		JsonArray* _tmp15_;
		JsonArray* _tmp16_;
		JsonObject* _error_ = NULL;
		JsonArray* _tmp17_;
		JsonNode* _tmp18_;
		JsonObject* _tmp19_;
		JsonObject* _tmp20_;
		gint code = 0;
		JsonObject* _tmp21_;
		gchar* message = NULL;
		JsonObject* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		GError* _tmp26_;
#line 61 "../src/util/TweetUtils.vala"
		_tmp2_ = json_parser_new ();
#line 61 "../src/util/TweetUtils.vala"
		parser = _tmp2_;
#line 62 "../src/util/TweetUtils.vala"
		_tmp3_ = parser;
#line 62 "../src/util/TweetUtils.vala"
		_tmp4_ = json;
#line 62 "../src/util/TweetUtils.vala"
		json_parser_load_from_data (_tmp3_, _tmp4_, (gssize) -1, &_inner_error0_);
#line 62 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 62 "../src/util/TweetUtils.vala"
			_g_object_unref0 (parser);
#line 1309 "TweetUtils.c"
			goto __catch0_g_error;
		}
#line 63 "../src/util/TweetUtils.vala"
		_tmp5_ = parser;
#line 63 "../src/util/TweetUtils.vala"
		_tmp6_ = json_parser_get_root (_tmp5_);
#line 63 "../src/util/TweetUtils.vala"
		_tmp7_ = __vala_JsonNode_copy0 (_tmp6_);
#line 63 "../src/util/TweetUtils.vala"
		node = _tmp7_;
#line 64 "../src/util/TweetUtils.vala"
		_tmp8_ = node;
#line 64 "../src/util/TweetUtils.vala"
		if (_tmp8_ == NULL) {
#line 1324 "TweetUtils.c"
			const gchar* _tmp9_;
			GError* _tmp10_;
#line 65 "../src/util/TweetUtils.vala"
			_tmp9_ = json;
#line 65 "../src/util/TweetUtils.vala"
			_tmp10_ = g_error_new (tweet_utils_get_error_domain (), 0, "Twitter error is not valid JSON: %s", _tmp9_);
#line 65 "../src/util/TweetUtils.vala"
			result = _tmp10_;
#line 65 "../src/util/TweetUtils.vala"
			__vala_JsonNode_free0 (node);
#line 65 "../src/util/TweetUtils.vala"
			_g_object_unref0 (parser);
#line 65 "../src/util/TweetUtils.vala"
			return result;
#line 1339 "TweetUtils.c"
		}
#line 67 "../src/util/TweetUtils.vala"
		_tmp11_ = node;
#line 67 "../src/util/TweetUtils.vala"
		_tmp12_ = json_node_get_object (_tmp11_);
#line 67 "../src/util/TweetUtils.vala"
		_tmp13_ = _json_object_ref0 (_tmp12_);
#line 67 "../src/util/TweetUtils.vala"
		obj = _tmp13_;
#line 68 "../src/util/TweetUtils.vala"
		_tmp14_ = obj;
#line 68 "../src/util/TweetUtils.vala"
		_tmp15_ = json_object_get_array_member (_tmp14_, "errors");
#line 68 "../src/util/TweetUtils.vala"
		_tmp16_ = _json_array_ref0 (_tmp15_);
#line 68 "../src/util/TweetUtils.vala"
		errors = _tmp16_;
#line 70 "../src/util/TweetUtils.vala"
		_tmp17_ = errors;
#line 70 "../src/util/TweetUtils.vala"
		_tmp18_ = json_array_get_element (_tmp17_, (guint) 0);
#line 70 "../src/util/TweetUtils.vala"
		_tmp19_ = json_node_get_object (_tmp18_);
#line 70 "../src/util/TweetUtils.vala"
		_tmp20_ = _json_object_ref0 (_tmp19_);
#line 70 "../src/util/TweetUtils.vala"
		_error_ = _tmp20_;
#line 72 "../src/util/TweetUtils.vala"
		_tmp21_ = _error_;
#line 72 "../src/util/TweetUtils.vala"
		code = (gint) json_object_get_int_member (_tmp21_, "code");
#line 73 "../src/util/TweetUtils.vala"
		_tmp22_ = _error_;
#line 73 "../src/util/TweetUtils.vala"
		_tmp23_ = json_object_get_string_member (_tmp22_, "message");
#line 73 "../src/util/TweetUtils.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 73 "../src/util/TweetUtils.vala"
		message = _tmp24_;
#line 74 "../src/util/TweetUtils.vala"
		_tmp25_ = message;
#line 74 "../src/util/TweetUtils.vala"
		_tmp26_ = g_error_new_literal (tweet_utils_get_error_domain (), code, _tmp25_);
#line 74 "../src/util/TweetUtils.vala"
		result = _tmp26_;
#line 74 "../src/util/TweetUtils.vala"
		_g_free0 (message);
#line 74 "../src/util/TweetUtils.vala"
		_json_object_unref0 (_error_);
#line 74 "../src/util/TweetUtils.vala"
		_json_array_unref0 (errors);
#line 74 "../src/util/TweetUtils.vala"
		_json_object_unref0 (obj);
#line 74 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (node);
#line 74 "../src/util/TweetUtils.vala"
		_g_object_unref0 (parser);
#line 74 "../src/util/TweetUtils.vala"
		return result;
#line 1399 "TweetUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
#line 42 "../src/util/TweetUtils.vala"
		e = _inner_error0_;
#line 42 "../src/util/TweetUtils.vala"
		_inner_error0_ = NULL;
#line 76 "../src/util/TweetUtils.vala"
		result = e;
#line 76 "../src/util/TweetUtils.vala"
		return result;
#line 1413 "TweetUtils.c"
	}
	__finally0:
#line 42 "../src/util/TweetUtils.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 42 "../src/util/TweetUtils.vala"
	g_clear_error (&_inner_error0_);
#line 42 "../src/util/TweetUtils.vala"
	return NULL;
#line 1422 "TweetUtils.c"
}

gchar*
tweet_utils_code_to_message (gint code,
                             const gchar* default_message)
{
	gchar* result;
#line 84 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (default_message != NULL, NULL);
#line 88 "../src/util/TweetUtils.vala"
	switch (code) {
#line 88 "../src/util/TweetUtils.vala"
		case 32:
#line 1436 "TweetUtils.c"
		{
			gchar* _tmp0_;
#line 92 "../src/util/TweetUtils.vala"
			_tmp0_ = g_strdup (_ ("Could not authenticate you"));
#line 92 "../src/util/TweetUtils.vala"
			result = _tmp0_;
#line 92 "../src/util/TweetUtils.vala"
			return result;
#line 1445 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 34:
#line 1449 "TweetUtils.c"
		{
			gchar* _tmp1_;
#line 93 "../src/util/TweetUtils.vala"
			_tmp1_ = g_strdup (_ ("Sorry, that page does not exist"));
#line 93 "../src/util/TweetUtils.vala"
			result = _tmp1_;
#line 93 "../src/util/TweetUtils.vala"
			return result;
#line 1458 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 50:
#line 1462 "TweetUtils.c"
		{
			gchar* _tmp2_;
#line 97 "../src/util/TweetUtils.vala"
			_tmp2_ = g_strdup (_ ("User not found."));
#line 97 "../src/util/TweetUtils.vala"
			result = _tmp2_;
#line 97 "../src/util/TweetUtils.vala"
			return result;
#line 1471 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 63:
#line 1475 "TweetUtils.c"
		{
			gchar* _tmp3_;
#line 98 "../src/util/TweetUtils.vala"
			_tmp3_ = g_strdup (_ ("User has been suspended."));
#line 98 "../src/util/TweetUtils.vala"
			result = _tmp3_;
#line 98 "../src/util/TweetUtils.vala"
			return result;
#line 1484 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 64:
#line 1488 "TweetUtils.c"
		{
			gchar* _tmp4_;
#line 99 "../src/util/TweetUtils.vala"
			_tmp4_ = g_strdup (_ ("Your account is suspended and is not permitted to access this feature"));
#line 99 "../src/util/TweetUtils.vala"
			result = _tmp4_;
#line 99 "../src/util/TweetUtils.vala"
			return result;
#line 1497 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 88:
#line 1501 "TweetUtils.c"
		{
			gchar* _tmp5_;
#line 102 "../src/util/TweetUtils.vala"
			_tmp5_ = g_strdup (_ ("Rate limit exceeded"));
#line 102 "../src/util/TweetUtils.vala"
			result = _tmp5_;
#line 102 "../src/util/TweetUtils.vala"
			return result;
#line 1510 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 89:
#line 1514 "TweetUtils.c"
		{
			gchar* _tmp6_;
#line 103 "../src/util/TweetUtils.vala"
			_tmp6_ = g_strdup (_ ("Invalid or expired token"));
#line 103 "../src/util/TweetUtils.vala"
			result = _tmp6_;
#line 103 "../src/util/TweetUtils.vala"
			return result;
#line 1523 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 109:
#line 1527 "TweetUtils.c"
		{
			gchar* _tmp7_;
#line 106 "../src/util/TweetUtils.vala"
			_tmp7_ = g_strdup (_ ("The specified user is not a subscriber of this list."));
#line 106 "../src/util/TweetUtils.vala"
			result = _tmp7_;
#line 106 "../src/util/TweetUtils.vala"
			return result;
#line 1536 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 110:
#line 1540 "TweetUtils.c"
		{
			gchar* _tmp8_;
#line 107 "../src/util/TweetUtils.vala"
			_tmp8_ = g_strdup (_ ("The user you are trying to remove from the list is not a member."));
#line 107 "../src/util/TweetUtils.vala"
			result = _tmp8_;
#line 107 "../src/util/TweetUtils.vala"
			return result;
#line 1549 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 120:
#line 1553 "TweetUtils.c"
		{
			gchar* _tmp9_;
#line 108 "../src/util/TweetUtils.vala"
			_tmp9_ = g_strdup (_ ("Account update failed: value is too long."));
#line 108 "../src/util/TweetUtils.vala"
			result = _tmp9_;
#line 108 "../src/util/TweetUtils.vala"
			return result;
#line 1562 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 130:
#line 1566 "TweetUtils.c"
		{
			gchar* _tmp10_;
#line 109 "../src/util/TweetUtils.vala"
			_tmp10_ = g_strdup (_ ("Over capacity"));
#line 109 "../src/util/TweetUtils.vala"
			result = _tmp10_;
#line 109 "../src/util/TweetUtils.vala"
			return result;
#line 1575 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 131:
#line 1579 "TweetUtils.c"
		{
			gchar* _tmp11_;
#line 110 "../src/util/TweetUtils.vala"
			_tmp11_ = g_strdup (_ ("Internal error"));
#line 110 "../src/util/TweetUtils.vala"
			result = _tmp11_;
#line 110 "../src/util/TweetUtils.vala"
			return result;
#line 1588 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 135:
#line 1592 "TweetUtils.c"
		{
			gchar* _tmp12_;
#line 111 "../src/util/TweetUtils.vala"
			_tmp12_ = g_strdup (_ ("Could not authenticate you"));
#line 111 "../src/util/TweetUtils.vala"
			result = _tmp12_;
#line 111 "../src/util/TweetUtils.vala"
			return result;
#line 1601 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 139:
#line 1605 "TweetUtils.c"
		{
			gchar* _tmp13_;
#line 112 "../src/util/TweetUtils.vala"
			_tmp13_ = g_strdup (_ ("You have already favorited this status."));
#line 112 "../src/util/TweetUtils.vala"
			result = _tmp13_;
#line 112 "../src/util/TweetUtils.vala"
			return result;
#line 1614 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 144:
#line 1618 "TweetUtils.c"
		{
			gchar* _tmp14_;
#line 113 "../src/util/TweetUtils.vala"
			_tmp14_ = g_strdup (_ ("No status found with that ID."));
#line 113 "../src/util/TweetUtils.vala"
			result = _tmp14_;
#line 113 "../src/util/TweetUtils.vala"
			return result;
#line 1627 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 150:
#line 1631 "TweetUtils.c"
		{
			gchar* _tmp15_;
#line 114 "../src/util/TweetUtils.vala"
			_tmp15_ = g_strdup (_ ("You cannot send messages to users who are not following you."));
#line 114 "../src/util/TweetUtils.vala"
			result = _tmp15_;
#line 114 "../src/util/TweetUtils.vala"
			return result;
#line 1640 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 151:
#line 1644 "TweetUtils.c"
		{
			gchar* _tmp16_;
#line 115 "../src/util/TweetUtils.vala"
			_tmp16_ = g_strdup (_ ("There was an error sending your message."));
#line 115 "../src/util/TweetUtils.vala"
			result = _tmp16_;
#line 115 "../src/util/TweetUtils.vala"
			return result;
#line 1653 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 160:
#line 1657 "TweetUtils.c"
		{
			gchar* _tmp17_;
#line 116 "../src/util/TweetUtils.vala"
			_tmp17_ = g_strdup (_ ("You've already requested to follow this user."));
#line 116 "../src/util/TweetUtils.vala"
			result = _tmp17_;
#line 116 "../src/util/TweetUtils.vala"
			return result;
#line 1666 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 161:
#line 1670 "TweetUtils.c"
		{
			gchar* _tmp18_;
#line 117 "../src/util/TweetUtils.vala"
			_tmp18_ = g_strdup (_ ("You are unable to follow more people at this time"));
#line 117 "../src/util/TweetUtils.vala"
			result = _tmp18_;
#line 117 "../src/util/TweetUtils.vala"
			return result;
#line 1679 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 179:
#line 1683 "TweetUtils.c"
		{
			gchar* _tmp19_;
#line 118 "../src/util/TweetUtils.vala"
			_tmp19_ = g_strdup (_ ("Sorry, you are not authorized to see this status"));
#line 118 "../src/util/TweetUtils.vala"
			result = _tmp19_;
#line 118 "../src/util/TweetUtils.vala"
			return result;
#line 1692 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 185:
#line 1696 "TweetUtils.c"
		{
			gchar* _tmp20_;
#line 119 "../src/util/TweetUtils.vala"
			_tmp20_ = g_strdup (_ ("User is over daily status update limit"));
#line 119 "../src/util/TweetUtils.vala"
			result = _tmp20_;
#line 119 "../src/util/TweetUtils.vala"
			return result;
#line 1705 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 186:
#line 1709 "TweetUtils.c"
		{
			gchar* _tmp21_;
#line 120 "../src/util/TweetUtils.vala"
			_tmp21_ = g_strdup (_ ("Tweet needs to be a bit shorter."));
#line 120 "../src/util/TweetUtils.vala"
			result = _tmp21_;
#line 120 "../src/util/TweetUtils.vala"
			return result;
#line 1718 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 187:
#line 1722 "TweetUtils.c"
		{
			gchar* _tmp22_;
#line 121 "../src/util/TweetUtils.vala"
			_tmp22_ = g_strdup (_ ("Status is a duplicate"));
#line 121 "../src/util/TweetUtils.vala"
			result = _tmp22_;
#line 121 "../src/util/TweetUtils.vala"
			return result;
#line 1731 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 214:
#line 1735 "TweetUtils.c"
		{
			gchar* _tmp23_;
#line 124 "../src/util/TweetUtils.vala"
			_tmp23_ = g_strdup (_ ("Owner must allow dms from anyone."));
#line 124 "../src/util/TweetUtils.vala"
			result = _tmp23_;
#line 124 "../src/util/TweetUtils.vala"
			return result;
#line 1744 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 215:
#line 1748 "TweetUtils.c"
		{
			gchar* _tmp24_;
#line 125 "../src/util/TweetUtils.vala"
			_tmp24_ = g_strdup (_ ("Bad authentication data"));
#line 125 "../src/util/TweetUtils.vala"
			result = _tmp24_;
#line 125 "../src/util/TweetUtils.vala"
			return result;
#line 1757 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 220:
#line 1761 "TweetUtils.c"
		{
			gchar* _tmp25_;
#line 126 "../src/util/TweetUtils.vala"
			_tmp25_ = g_strdup (_ ("Your credentials do not allow access to this resource."));
#line 126 "../src/util/TweetUtils.vala"
			result = _tmp25_;
#line 126 "../src/util/TweetUtils.vala"
			return result;
#line 1770 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 226:
#line 1774 "TweetUtils.c"
		{
			gchar* _tmp26_;
#line 127 "../src/util/TweetUtils.vala"
			_tmp26_ = g_strdup (_ ("This request looks like it might be automated. To protect our users fr" \
"om spam and other malicious activity, we can’t complete this action ri" \
"ght now."));
#line 127 "../src/util/TweetUtils.vala"
			result = _tmp26_;
#line 127 "../src/util/TweetUtils.vala"
			return result;
#line 1783 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 231:
#line 1787 "TweetUtils.c"
		{
			gchar* _tmp27_;
#line 128 "../src/util/TweetUtils.vala"
			_tmp27_ = g_strdup (_ ("User must verify login"));
#line 128 "../src/util/TweetUtils.vala"
			result = _tmp27_;
#line 128 "../src/util/TweetUtils.vala"
			return result;
#line 1796 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 261:
#line 1800 "TweetUtils.c"
		{
			gchar* _tmp28_;
#line 129 "../src/util/TweetUtils.vala"
			_tmp28_ = g_strdup (_ ("Application cannot perform write actions."));
#line 129 "../src/util/TweetUtils.vala"
			result = _tmp28_;
#line 129 "../src/util/TweetUtils.vala"
			return result;
#line 1809 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 271:
#line 1813 "TweetUtils.c"
		{
			gchar* _tmp29_;
#line 130 "../src/util/TweetUtils.vala"
			_tmp29_ = g_strdup (_ ("You can’t mute yourself."));
#line 130 "../src/util/TweetUtils.vala"
			result = _tmp29_;
#line 130 "../src/util/TweetUtils.vala"
			return result;
#line 1822 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 272:
#line 1826 "TweetUtils.c"
		{
			gchar* _tmp30_;
#line 131 "../src/util/TweetUtils.vala"
			_tmp30_ = g_strdup (_ ("You are not muting the specified user."));
#line 131 "../src/util/TweetUtils.vala"
			result = _tmp30_;
#line 131 "../src/util/TweetUtils.vala"
			return result;
#line 1835 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 323:
#line 1839 "TweetUtils.c"
		{
			gchar* _tmp31_;
#line 132 "../src/util/TweetUtils.vala"
			_tmp31_ = g_strdup (_ ("Animated GIFs are not allowed when uploading multiple images."));
#line 132 "../src/util/TweetUtils.vala"
			result = _tmp31_;
#line 132 "../src/util/TweetUtils.vala"
			return result;
#line 1848 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 324:
#line 1852 "TweetUtils.c"
		{
			gchar* _tmp32_;
#line 133 "../src/util/TweetUtils.vala"
			_tmp32_ = g_strdup (_ ("The validation of media ids failed."));
#line 133 "../src/util/TweetUtils.vala"
			result = _tmp32_;
#line 133 "../src/util/TweetUtils.vala"
			return result;
#line 1861 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 325:
#line 1865 "TweetUtils.c"
		{
			gchar* _tmp33_;
#line 134 "../src/util/TweetUtils.vala"
			_tmp33_ = g_strdup (_ ("A media id was not found."));
#line 134 "../src/util/TweetUtils.vala"
			result = _tmp33_;
#line 134 "../src/util/TweetUtils.vala"
			return result;
#line 1874 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 326:
#line 1878 "TweetUtils.c"
		{
			gchar* _tmp34_;
#line 135 "../src/util/TweetUtils.vala"
			_tmp34_ = g_strdup (_ ("To protect our users from spam and other malicious activity, this acco" \
"unt is temporarily locked."));
#line 135 "../src/util/TweetUtils.vala"
			result = _tmp34_;
#line 135 "../src/util/TweetUtils.vala"
			return result;
#line 1887 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 327:
#line 1891 "TweetUtils.c"
		{
			gchar* _tmp35_;
#line 136 "../src/util/TweetUtils.vala"
			_tmp35_ = g_strdup (_ ("You have already retweeted this Tweet."));
#line 136 "../src/util/TweetUtils.vala"
			result = _tmp35_;
#line 136 "../src/util/TweetUtils.vala"
			return result;
#line 1900 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 349:
#line 1904 "TweetUtils.c"
		{
			gchar* _tmp36_;
#line 137 "../src/util/TweetUtils.vala"
			_tmp36_ = g_strdup (_ ("You cannot send messages to this user."));
#line 137 "../src/util/TweetUtils.vala"
			result = _tmp36_;
#line 137 "../src/util/TweetUtils.vala"
			return result;
#line 1913 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 354:
#line 1917 "TweetUtils.c"
		{
			gchar* _tmp37_;
#line 138 "../src/util/TweetUtils.vala"
			_tmp37_ = g_strdup (_ ("The text of your direct message is over the max character limit."));
#line 138 "../src/util/TweetUtils.vala"
			result = _tmp37_;
#line 138 "../src/util/TweetUtils.vala"
			return result;
#line 1926 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 355:
#line 1930 "TweetUtils.c"
		{
			gchar* _tmp38_;
#line 139 "../src/util/TweetUtils.vala"
			_tmp38_ = g_strdup (_ ("Subscription already exists."));
#line 139 "../src/util/TweetUtils.vala"
			result = _tmp38_;
#line 139 "../src/util/TweetUtils.vala"
			return result;
#line 1939 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 385:
#line 1943 "TweetUtils.c"
		{
			gchar* _tmp39_;
#line 140 "../src/util/TweetUtils.vala"
			_tmp39_ = g_strdup (_ ("You attempted to reply to a Tweet that is deleted or not visible to yo" \
"u."));
#line 140 "../src/util/TweetUtils.vala"
			result = _tmp39_;
#line 140 "../src/util/TweetUtils.vala"
			return result;
#line 1952 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 386:
#line 1956 "TweetUtils.c"
		{
			gchar* _tmp40_;
#line 141 "../src/util/TweetUtils.vala"
			_tmp40_ = g_strdup (_ ("The Tweet exceeds the number of allowed attachment types."));
#line 141 "../src/util/TweetUtils.vala"
			result = _tmp40_;
#line 141 "../src/util/TweetUtils.vala"
			return result;
#line 1965 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 407:
#line 1969 "TweetUtils.c"
		{
			gchar* _tmp41_;
#line 142 "../src/util/TweetUtils.vala"
			_tmp41_ = g_strdup (_ ("The given URL is invalid."));
#line 142 "../src/util/TweetUtils.vala"
			result = _tmp41_;
#line 142 "../src/util/TweetUtils.vala"
			return result;
#line 1978 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 416:
#line 1982 "TweetUtils.c"
		{
			gchar* _tmp42_;
#line 143 "../src/util/TweetUtils.vala"
			_tmp42_ = g_strdup (_ ("Invalid / suspended application"));
#line 143 "../src/util/TweetUtils.vala"
			result = _tmp42_;
#line 143 "../src/util/TweetUtils.vala"
			return result;
#line 1991 "TweetUtils.c"
		}
#line 88 "../src/util/TweetUtils.vala"
		case 433:
#line 1995 "TweetUtils.c"
		{
			gchar* _tmp43_;
#line 145 "../src/util/TweetUtils.vala"
			_tmp43_ = g_strdup (_ ("The original Tweet author restricted who can reply to this Tweet."));
#line 145 "../src/util/TweetUtils.vala"
			result = _tmp43_;
#line 145 "../src/util/TweetUtils.vala"
			return result;
#line 2004 "TweetUtils.c"
		}
		default:
		{
			gchar* _tmp44_;
#line 147 "../src/util/TweetUtils.vala"
			_tmp44_ = g_strdup (default_message);
#line 147 "../src/util/TweetUtils.vala"
			result = _tmp44_;
#line 147 "../src/util/TweetUtils.vala"
			return result;
#line 2015 "TweetUtils.c"
		}
	}
}

static void
tweet_utils_get_tweet_data_free (gpointer _data)
{
	TweetUtilsGetTweetData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->result);
	g_slice_free (TweetUtilsGetTweetData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
tweet_utils_get_tweet (Account* account,
                       gint64 tweet_id,
                       GAsyncReadyCallback _callback_,
                       gpointer _user_data_)
{
	TweetUtilsGetTweetData* _data_;
	Account* _tmp0_;
	g_return_if_fail (account != NULL);
	_data_ = g_slice_new0 (TweetUtilsGetTweetData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tweet_utils_get_tweet_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->tweet_id = tweet_id;
	tweet_utils_get_tweet_co (_data_);
}

CbTweet*
tweet_utils_get_tweet_finish (GAsyncResult* _res_,
                              GError** error)
{
	CbTweet* result;
	TweetUtilsGetTweetData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

/**
   * Fetches the given tweet by ID.
   *
   * Note: This should not be used frequently as we should (in most situations)
   * have all of the information that we need already.
   *
   * @param account The account to fetch the tweet as
   * @param tweet_id The ID of the tweet to fetch
   * @return the tweet object or null if it failed
   */
static Block60Data*
block60_data_ref (Block60Data* _data60_)
{
#line 161 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data60_->_ref_count_);
#line 161 "../src/util/TweetUtils.vala"
	return _data60_;
#line 2086 "TweetUtils.c"
}

static void
block60_data_unref (void * _userdata_)
{
	Block60Data* _data60_;
	_data60_ = (Block60Data*) _userdata_;
#line 161 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data60_->_ref_count_)) {
#line 161 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data60_->err);
#line 161 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data60_->tweet);
#line 161 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data60_->call);
#line 161 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data60_->account);
#line 161 "../src/util/TweetUtils.vala"
		g_slice_free (Block60Data, _data60_);
#line 2106 "TweetUtils.c"
	}
}

static void
__lambda59_ (Block60Data* _data60_,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 176 "../src/util/TweetUtils.vala"
	g_return_if_fail (res != NULL);
#line 2118 "TweetUtils.c"
	{
		RestProxyCall* _tmp0_;
		const gchar* content = NULL;
		RestProxyCall* _tmp1_;
		const gchar* _tmp2_;
		JsonParser* parser = NULL;
		JsonParser* _tmp3_;
		const gchar* _tmp4_;
		JsonParser* _tmp5_;
		const gchar* _tmp6_;
		GDateTime* now = NULL;
		GDateTime* _tmp7_;
		CbTweet* _tmp8_;
		CbTweet* _tmp9_;
		JsonParser* _tmp10_;
		JsonNode* _tmp11_;
		GDateTime* _tmp12_;
#line 178 "../src/util/TweetUtils.vala"
		_tmp0_ = _data60_->call;
#line 178 "../src/util/TweetUtils.vala"
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
#line 178 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2142 "TweetUtils.c"
			goto __catch0_g_error;
		}
#line 179 "../src/util/TweetUtils.vala"
		_tmp1_ = _data60_->call;
#line 179 "../src/util/TweetUtils.vala"
		_tmp2_ = rest_proxy_call_get_payload (_tmp1_);
#line 179 "../src/util/TweetUtils.vala"
		content = _tmp2_;
#line 180 "../src/util/TweetUtils.vala"
		_tmp3_ = json_parser_new ();
#line 180 "../src/util/TweetUtils.vala"
		parser = _tmp3_;
#line 181 "../src/util/TweetUtils.vala"
		_tmp4_ = content;
#line 181 "../src/util/TweetUtils.vala"
		g_debug ("TweetUtils.vala:181: Load tweet got: %s", _tmp4_);
#line 182 "../src/util/TweetUtils.vala"
		_tmp5_ = parser;
#line 182 "../src/util/TweetUtils.vala"
		_tmp6_ = content;
#line 182 "../src/util/TweetUtils.vala"
		json_parser_load_from_data (_tmp5_, _tmp6_, (gssize) -1, &_inner_error0_);
#line 182 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 182 "../src/util/TweetUtils.vala"
			_g_object_unref0 (parser);
#line 2169 "TweetUtils.c"
			goto __catch0_g_error;
		}
#line 183 "../src/util/TweetUtils.vala"
		_tmp7_ = g_date_time_new_now_local ();
#line 183 "../src/util/TweetUtils.vala"
		now = _tmp7_;
#line 184 "../src/util/TweetUtils.vala"
		_tmp8_ = cb_tweet_new ();
#line 184 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data60_->tweet);
#line 184 "../src/util/TweetUtils.vala"
		_data60_->tweet = _tmp8_;
#line 185 "../src/util/TweetUtils.vala"
		_tmp9_ = _data60_->tweet;
#line 185 "../src/util/TweetUtils.vala"
		_tmp10_ = parser;
#line 185 "../src/util/TweetUtils.vala"
		_tmp11_ = json_parser_get_root (_tmp10_);
#line 185 "../src/util/TweetUtils.vala"
		_tmp12_ = now;
#line 185 "../src/util/TweetUtils.vala"
		cb_tweet_load_from_json (_tmp9_, _tmp11_, _data60_->account->id, _tmp12_);
#line 186 "../src/util/TweetUtils.vala"
		tweet_utils_get_tweet_co (_data60_->_async_data_);
#line 177 "../src/util/TweetUtils.vala"
		_g_date_time_unref0 (now);
#line 177 "../src/util/TweetUtils.vala"
		_g_object_unref0 (parser);
#line 2198 "TweetUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		RestProxyCall* _tmp13_;
		GError* _tmp14_;
		GError* _tmp15_;
#line 177 "../src/util/TweetUtils.vala"
		e = _inner_error0_;
#line 177 "../src/util/TweetUtils.vala"
		_inner_error0_ = NULL;
#line 188 "../src/util/TweetUtils.vala"
		_tmp13_ = _data60_->call;
#line 188 "../src/util/TweetUtils.vala"
		_tmp14_ = e;
#line 188 "../src/util/TweetUtils.vala"
		_tmp15_ = tweet_utils_failed_request_to_error (_tmp13_, _tmp14_);
#line 188 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data60_->err);
#line 188 "../src/util/TweetUtils.vala"
		_data60_->err = _tmp15_;
#line 189 "../src/util/TweetUtils.vala"
		tweet_utils_get_tweet_co (_data60_->_async_data_);
#line 190 "../src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 190 "../src/util/TweetUtils.vala"
		return;
#line 2227 "TweetUtils.c"
	}
	__finally0:
#line 177 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 177 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 177 "../src/util/TweetUtils.vala"
		g_clear_error (&_inner_error0_);
#line 177 "../src/util/TweetUtils.vala"
		return;
#line 2238 "TweetUtils.c"
	}
}

static void
___lambda59__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 176 "../src/util/TweetUtils.vala"
	__lambda59_ (self, source_object, res);
#line 176 "../src/util/TweetUtils.vala"
	block60_data_unref (self);
#line 2251 "TweetUtils.c"
}

static gboolean
tweet_utils_get_tweet_co (TweetUtilsGetTweetData* _data_)
{
#line 161 "../src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 161 "../src/util/TweetUtils.vala"
		case 0:
#line 2261 "TweetUtils.c"
		goto _state_0;
#line 161 "../src/util/TweetUtils.vala"
		case 1:
#line 2265 "TweetUtils.c"
		goto _state_1;
		default:
#line 161 "../src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 2270 "TweetUtils.c"
	}
	_state_0:
#line 161 "../src/util/TweetUtils.vala"
	_data_->_data60_ = g_slice_new0 (Block60Data);
#line 161 "../src/util/TweetUtils.vala"
	_data_->_data60_->_ref_count_ = 1;
#line 161 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data60_->account);
#line 161 "../src/util/TweetUtils.vala"
	_data_->_data60_->account = _data_->account;
#line 161 "../src/util/TweetUtils.vala"
	_data_->_data60_->_async_data_ = _data_;
#line 162 "../src/util/TweetUtils.vala"
	if (_data_->tweet_id <= ((gint64) 0)) {
#line 163 "../src/util/TweetUtils.vala"
		_data_->result = NULL;
#line 163 "../src/util/TweetUtils.vala"
		block60_data_unref (_data_->_data60_);
#line 163 "../src/util/TweetUtils.vala"
		_data_->_data60_ = NULL;
#line 163 "../src/util/TweetUtils.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 163 "../src/util/TweetUtils.vala"
		if (_data_->_state_ != 0) {
#line 163 "../src/util/TweetUtils.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 163 "../src/util/TweetUtils.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2299 "TweetUtils.c"
			}
		}
#line 163 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 163 "../src/util/TweetUtils.vala"
		return FALSE;
#line 2306 "TweetUtils.c"
	}
#line 166 "../src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->_data60_->account->proxy;
#line 166 "../src/util/TweetUtils.vala"
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
#line 166 "../src/util/TweetUtils.vala"
	_data_->_data60_->call = _data_->_tmp1_;
#line 167 "../src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->_data60_->call;
#line 167 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_tmp2_, "GET");
#line 168 "../src/util/TweetUtils.vala"
	_data_->_tmp3_ = _data_->_data60_->call;
#line 168 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_function (_data_->_tmp3_, "1.1/statuses/show.json");
#line 169 "../src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->_data60_->call;
#line 169 "../src/util/TweetUtils.vala"
	_data_->_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->tweet_id);
#line 169 "../src/util/TweetUtils.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 169 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp4_, "id", _data_->_tmp6_);
#line 169 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp6_);
#line 170 "../src/util/TweetUtils.vala"
	_data_->_tmp7_ = _data_->_data60_->call;
#line 170 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp7_, "include_my_retweet", "true");
#line 171 "../src/util/TweetUtils.vala"
	_data_->_tmp8_ = _data_->_data60_->call;
#line 171 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp8_, "tweet_mode", "extended");
#line 172 "../src/util/TweetUtils.vala"
	_data_->_tmp9_ = _data_->_data60_->call;
#line 172 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp9_, "include_ext_alt_text", "true");
#line 173 "../src/util/TweetUtils.vala"
	_data_->_data60_->tweet = NULL;
#line 174 "../src/util/TweetUtils.vala"
	_data_->_data60_->err = NULL;
#line 176 "../src/util/TweetUtils.vala"
	_data_->_tmp10_ = _data_->_data60_->call;
#line 176 "../src/util/TweetUtils.vala"
	rest_proxy_call_invoke_async (_data_->_tmp10_, NULL, ___lambda59__gasync_ready_callback, block60_data_ref (_data_->_data60_));
#line 193 "../src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 193 "../src/util/TweetUtils.vala"
	return FALSE;
#line 2356 "TweetUtils.c"
	_state_1:
	;
#line 194 "../src/util/TweetUtils.vala"
	_data_->_tmp11_ = _data_->_data60_->err;
#line 194 "../src/util/TweetUtils.vala"
	if (_data_->_tmp11_ != NULL) {
#line 195 "../src/util/TweetUtils.vala"
		_data_->_tmp12_ = _data_->_data60_->err;
#line 195 "../src/util/TweetUtils.vala"
		_data_->_tmp13_ = _g_error_copy0 (_data_->_tmp12_);
#line 195 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = _data_->_tmp13_;
#line 195 "../src/util/TweetUtils.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 195 "../src/util/TweetUtils.vala"
		block60_data_unref (_data_->_data60_);
#line 195 "../src/util/TweetUtils.vala"
		_data_->_data60_ = NULL;
#line 195 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 195 "../src/util/TweetUtils.vala"
		return FALSE;
#line 2379 "TweetUtils.c"
	}
#line 197 "../src/util/TweetUtils.vala"
	_data_->_tmp14_ = _data_->_data60_->tweet;
#line 197 "../src/util/TweetUtils.vala"
	_data_->_tmp15_ = _g_object_ref0 (_data_->_tmp14_);
#line 197 "../src/util/TweetUtils.vala"
	_data_->result = _data_->_tmp15_;
#line 197 "../src/util/TweetUtils.vala"
	block60_data_unref (_data_->_data60_);
#line 197 "../src/util/TweetUtils.vala"
	_data_->_data60_ = NULL;
#line 197 "../src/util/TweetUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 197 "../src/util/TweetUtils.vala"
	if (_data_->_state_ != 0) {
#line 197 "../src/util/TweetUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 197 "../src/util/TweetUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2399 "TweetUtils.c"
		}
	}
#line 197 "../src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 197 "../src/util/TweetUtils.vala"
	return FALSE;
#line 2406 "TweetUtils.c"
}

static void
tweet_utils_post_tweet_data_free (gpointer _data)
{
	TweetUtilsPostTweetData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_composed_tweet_unref0 (_data_->tweet);
	g_slice_free (TweetUtilsPostTweetData, _data_);
}

static gpointer
_composed_tweet_ref0 (gpointer self)
{
	return self ? composed_tweet_ref (self) : NULL;
}

void
tweet_utils_post_tweet (Account* account,
                        ComposedTweet* tweet,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	TweetUtilsPostTweetData* _data_;
	Account* _tmp0_;
	ComposedTweet* _tmp1_;
	g_return_if_fail (account != NULL);
	g_return_if_fail (tweet != NULL);
	_data_ = g_slice_new0 (TweetUtilsPostTweetData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tweet_utils_post_tweet_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_tmp1_ = _composed_tweet_ref0 (tweet);
	_composed_tweet_unref0 (_data_->tweet);
	_data_->tweet = _tmp1_;
	tweet_utils_post_tweet_co (_data_);
}

gboolean
tweet_utils_post_tweet_finish (GAsyncResult* _res_,
                               GError** error)
{
	gboolean result;
	TweetUtilsPostTweetData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		gboolean _tmp0_ = FALSE;
		return _tmp0_;
	}
	result = _data_->result;
	return result;
}

/**
   * Posts a new tweet.
   */
static Block61Data*
block61_data_ref (Block61Data* _data61_)
{
#line 203 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data61_->_ref_count_);
#line 203 "../src/util/TweetUtils.vala"
	return _data61_;
#line 2473 "TweetUtils.c"
}

static void
block61_data_unref (void * _userdata_)
{
	Block61Data* _data61_;
	_data61_ = (Block61Data*) _userdata_;
#line 203 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data61_->_ref_count_)) {
#line 203 "../src/util/TweetUtils.vala"
		g_slice_free (Block61Data, _data61_);
#line 2485 "TweetUtils.c"
	}
}

static Block62Data*
block62_data_ref (Block62Data* _data62_)
{
#line 206 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data62_->_ref_count_);
#line 206 "../src/util/TweetUtils.vala"
	return _data62_;
#line 2496 "TweetUtils.c"
}

static void
block62_data_unref (void * _userdata_)
{
	Block62Data* _data62_;
	_data62_ = (Block62Data*) _userdata_;
#line 206 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data62_->_ref_count_)) {
#line 206 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data62_->collect);
#line 206 "../src/util/TweetUtils.vala"
		_vala_clear_GMutex (&_data62_->mutex);
#line 206 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data62_->err);
#line 206 "../src/util/TweetUtils.vala"
		block61_data_unref (_data62_->_data61_);
#line 206 "../src/util/TweetUtils.vala"
		_data62_->_data61_ = NULL;
#line 206 "../src/util/TweetUtils.vala"
		g_slice_free (Block62Data, _data62_);
#line 2518 "TweetUtils.c"
	}
}

static void
___lambda65_ (Block62Data* _data62_,
              GError* _error_)
{
	Block61Data* _data61_;
	GError* _inner_error0_ = NULL;
#line 211 "../src/util/TweetUtils.vala"
	_data61_ = _data62_->_data61_;
#line 212 "../src/util/TweetUtils.vala"
	if (_error_ != NULL) {
#line 2532 "TweetUtils.c"
		GError* _tmp0_;
#line 213 "../src/util/TweetUtils.vala"
		_tmp0_ = _g_error_copy0 (_error_);
#line 213 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data62_->err);
#line 213 "../src/util/TweetUtils.vala"
		_data62_->err = _tmp0_;
#line 2540 "TweetUtils.c"
	}
#line 215 "../src/util/TweetUtils.vala"
	g_mutex_lock (&_data62_->mutex);
#line 2544 "TweetUtils.c"
	{
#line 217 "../src/util/TweetUtils.vala"
		if (_data62_->yielded) {
#line 218 "../src/util/TweetUtils.vala"
			tweet_utils_post_tweet_co (_data61_->_async_data_);
#line 2550 "TweetUtils.c"
		}
	}
	__finally0:
	{
#line 222 "../src/util/TweetUtils.vala"
		g_mutex_unlock (&_data62_->mutex);
#line 2557 "TweetUtils.c"
	}
#line 216 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 216 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 216 "../src/util/TweetUtils.vala"
		g_clear_error (&_inner_error0_);
#line 216 "../src/util/TweetUtils.vala"
		return;
#line 2567 "TweetUtils.c"
	}
}

static void
____lambda65__collect_by_id_finished (CollectById* _sender,
                                      GError* _error_,
                                      gpointer self)
{
#line 211 "../src/util/TweetUtils.vala"
	___lambda65_ (self, _error_);
#line 2578 "TweetUtils.c"
}

static Block63Data*
block63_data_ref (Block63Data* _data63_)
{
#line 226 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data63_->_ref_count_);
#line 226 "../src/util/TweetUtils.vala"
	return _data63_;
#line 2588 "TweetUtils.c"
}

static void
block63_data_unref (void * _userdata_)
{
	Block63Data* _data63_;
	_data63_ = (Block63Data*) _userdata_;
#line 226 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data63_->_ref_count_)) {
#line 226 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data63_->upload);
#line 226 "../src/util/TweetUtils.vala"
		block62_data_unref (_data63_->_data62_);
#line 226 "../src/util/TweetUtils.vala"
		_data63_->_data62_ = NULL;
#line 226 "../src/util/TweetUtils.vala"
		g_slice_free (Block63Data, _data63_);
#line 2606 "TweetUtils.c"
	}
}

static void
_____lambda66_ (Block63Data* _data63_,
                GError* _error_)
{
	Block62Data* _data62_;
	Block61Data* _data61_;
	CollectById* _tmp1_;
	MediaUpload* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GError* _tmp5_;
	MediaUpload* _tmp6_;
#line 231 "../src/util/TweetUtils.vala"
	_data62_ = _data63_->_data62_;
#line 231 "../src/util/TweetUtils.vala"
	_data61_ = _data62_->_data61_;
#line 232 "../src/util/TweetUtils.vala"
	if (_error_ != NULL) {
#line 2628 "TweetUtils.c"
		GError* _tmp0_;
#line 233 "../src/util/TweetUtils.vala"
		_tmp0_ = _g_error_copy0 (_error_);
#line 233 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data62_->err);
#line 233 "../src/util/TweetUtils.vala"
		_data62_->err = _tmp0_;
#line 2636 "TweetUtils.c"
	}
#line 235 "../src/util/TweetUtils.vala"
	_tmp1_ = _data62_->collect;
#line 235 "../src/util/TweetUtils.vala"
	_tmp2_ = _data63_->upload;
#line 235 "../src/util/TweetUtils.vala"
	_tmp3_ = media_upload_get_id (_tmp2_);
#line 235 "../src/util/TweetUtils.vala"
	_tmp4_ = _tmp3_;
#line 235 "../src/util/TweetUtils.vala"
	_tmp5_ = _data62_->err;
#line 235 "../src/util/TweetUtils.vala"
	collect_by_id_emit (_tmp1_, _tmp4_, _tmp5_);
#line 236 "../src/util/TweetUtils.vala"
	_tmp6_ = _data63_->upload;
#line 236 "../src/util/TweetUtils.vala"
	g_signal_handler_disconnect ((GObject*) _tmp6_, _data63_->handler_id);
#line 2654 "TweetUtils.c"
}

static void
______lambda66__media_upload_progress_complete (MediaUpload* _sender,
                                                GError* _error_,
                                                gpointer self)
{
#line 231 "../src/util/TweetUtils.vala"
	_____lambda66_ (self, _error_);
#line 2664 "TweetUtils.c"
}

static void
tweet_utils_post_tweet_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_)
{
	TweetUtilsPostTweetData* _data_;
#line 259 "../src/util/TweetUtils.vala"
	_data_ = _user_data_;
#line 259 "../src/util/TweetUtils.vala"
	_data_->_source_object_ = source_object;
#line 259 "../src/util/TweetUtils.vala"
	_data_->_res_ = _res_;
#line 259 "../src/util/TweetUtils.vala"
	tweet_utils_post_tweet_co (_data_);
#line 2681 "TweetUtils.c"
}

static gboolean
tweet_utils_post_tweet_co (TweetUtilsPostTweetData* _data_)
{
#line 203 "../src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 203 "../src/util/TweetUtils.vala"
		case 0:
#line 2691 "TweetUtils.c"
		goto _state_0;
#line 203 "../src/util/TweetUtils.vala"
		case 1:
#line 2695 "TweetUtils.c"
		goto _state_1;
#line 203 "../src/util/TweetUtils.vala"
		case 2:
#line 2699 "TweetUtils.c"
		goto _state_2;
		default:
#line 203 "../src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 2704 "TweetUtils.c"
	}
	_state_0:
#line 203 "../src/util/TweetUtils.vala"
	_data_->_data61_ = g_slice_new0 (Block61Data);
#line 203 "../src/util/TweetUtils.vala"
	_data_->_data61_->_ref_count_ = 1;
#line 203 "../src/util/TweetUtils.vala"
	_data_->_data61_->_async_data_ = _data_;
#line 204 "../src/util/TweetUtils.vala"
	_data_->_tmp0_ = 0;
#line 204 "../src/util/TweetUtils.vala"
	_data_->_tmp1_ = composed_tweet_get_attachments (_data_->tweet, &_data_->_tmp0_);
#line 204 "../src/util/TweetUtils.vala"
	_data_->media_attachments = _data_->_tmp1_;
#line 204 "../src/util/TweetUtils.vala"
	_data_->media_attachments_length1 = _data_->_tmp0_;
#line 204 "../src/util/TweetUtils.vala"
	_data_->_media_attachments_size_ = _data_->media_attachments_length1;
#line 206 "../src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->media_attachments;
#line 206 "../src/util/TweetUtils.vala"
	_data_->_tmp2__length1 = _data_->media_attachments_length1;
#line 206 "../src/util/TweetUtils.vala"
	if (_data_->_tmp2__length1 > 0) {
#line 206 "../src/util/TweetUtils.vala"
		_data_->_data62_ = g_slice_new0 (Block62Data);
#line 206 "../src/util/TweetUtils.vala"
		_data_->_data62_->_ref_count_ = 1;
#line 206 "../src/util/TweetUtils.vala"
		_data_->_data62_->_data61_ = block61_data_ref (_data_->_data61_);
#line 207 "../src/util/TweetUtils.vala"
		_data_->_data62_->err = NULL;
#line 208 "../src/util/TweetUtils.vala"
		g_mutex_init (&_data_->_data62_->mutex);
#line 209 "../src/util/TweetUtils.vala"
		_data_->_tmp3_ = collect_by_id_new ();
#line 209 "../src/util/TweetUtils.vala"
		_data_->_data62_->collect = _data_->_tmp3_;
#line 210 "../src/util/TweetUtils.vala"
		_data_->_data62_->yielded = FALSE;
#line 211 "../src/util/TweetUtils.vala"
		_data_->_tmp4_ = _data_->_data62_->collect;
#line 211 "../src/util/TweetUtils.vala"
		g_signal_connect_data (_data_->_tmp4_, "finished", (GCallback) ____lambda65__collect_by_id_finished, block62_data_ref (_data_->_data62_), (GClosureNotify) block62_data_unref, 0);
#line 226 "../src/util/TweetUtils.vala"
		_data_->_tmp5_ = _data_->media_attachments;
#line 226 "../src/util/TweetUtils.vala"
		_data_->_tmp5__length1 = _data_->media_attachments_length1;
#line 2753 "TweetUtils.c"
		{
#line 226 "../src/util/TweetUtils.vala"
			_data_->upload_collection_length1 = 0;
#line 226 "../src/util/TweetUtils.vala"
			_data_->_upload_collection_size_ = 0;
#line 226 "../src/util/TweetUtils.vala"
			_data_->upload_collection = _data_->_tmp5_;
#line 226 "../src/util/TweetUtils.vala"
			_data_->upload_collection_length1 = _data_->_tmp5__length1;
#line 226 "../src/util/TweetUtils.vala"
			for (_data_->upload_it = 0; _data_->upload_it < _data_->upload_collection_length1; _data_->upload_it = _data_->upload_it + 1) {
#line 226 "../src/util/TweetUtils.vala"
				_data_->_tmp6_ = _g_object_ref0 (_data_->upload_collection[_data_->upload_it]);
#line 226 "../src/util/TweetUtils.vala"
				_data_->upload = _data_->_tmp6_;
#line 2769 "TweetUtils.c"
				{
#line 226 "../src/util/TweetUtils.vala"
					_data_->_data63_ = g_slice_new0 (Block63Data);
#line 226 "../src/util/TweetUtils.vala"
					_data_->_data63_->_ref_count_ = 1;
#line 226 "../src/util/TweetUtils.vala"
					_data_->_data63_->_data62_ = block62_data_ref (_data_->_data62_);
#line 226 "../src/util/TweetUtils.vala"
					_data_->_data63_->upload = _data_->upload;
#line 227 "../src/util/TweetUtils.vala"
					_data_->_tmp7_ = _data_->_data62_->collect;
#line 227 "../src/util/TweetUtils.vala"
					_data_->_tmp8_ = _data_->_data63_->upload;
#line 227 "../src/util/TweetUtils.vala"
					_data_->_tmp9_ = media_upload_get_id (_data_->_tmp8_);
#line 227 "../src/util/TweetUtils.vala"
					_data_->_tmp10_ = _data_->_tmp9_;
#line 227 "../src/util/TweetUtils.vala"
					collect_by_id_add (_data_->_tmp7_, _data_->_tmp10_);
#line 230 "../src/util/TweetUtils.vala"
					_data_->_data63_->handler_id = (gulong) 0;
#line 231 "../src/util/TweetUtils.vala"
					_data_->_tmp11_ = _data_->_data63_->upload;
#line 231 "../src/util/TweetUtils.vala"
					_data_->_tmp12_ = g_signal_connect_data (_data_->_tmp11_, "progress-complete", (GCallback) ______lambda66__media_upload_progress_complete, block63_data_ref (_data_->_data63_), (GClosureNotify) block63_data_unref, 0);
#line 231 "../src/util/TweetUtils.vala"
					_data_->_data63_->handler_id = _data_->_tmp12_;
#line 238 "../src/util/TweetUtils.vala"
					_data_->_tmp13_ = _data_->_data63_->upload;
#line 238 "../src/util/TweetUtils.vala"
					if (media_upload_is_uploaded (_data_->_tmp13_)) {
#line 239 "../src/util/TweetUtils.vala"
						_data_->_tmp14_ = _data_->_data63_->upload;
#line 239 "../src/util/TweetUtils.vala"
						g_signal_handler_disconnect ((GObject*) _data_->_tmp14_, _data_->_data63_->handler_id);
#line 240 "../src/util/TweetUtils.vala"
						_data_->_tmp15_ = _data_->_data62_->collect;
#line 240 "../src/util/TweetUtils.vala"
						_data_->_tmp16_ = _data_->_data63_->upload;
#line 240 "../src/util/TweetUtils.vala"
						_data_->_tmp17_ = media_upload_get_id (_data_->_tmp16_);
#line 240 "../src/util/TweetUtils.vala"
						_data_->_tmp18_ = _data_->_tmp17_;
#line 240 "../src/util/TweetUtils.vala"
						collect_by_id_emit (_data_->_tmp15_, _data_->_tmp18_, NULL);
#line 2815 "TweetUtils.c"
					}
#line 226 "../src/util/TweetUtils.vala"
					block63_data_unref (_data_->_data63_);
#line 226 "../src/util/TweetUtils.vala"
					_data_->_data63_ = NULL;
#line 2821 "TweetUtils.c"
				}
			}
		}
#line 247 "../src/util/TweetUtils.vala"
		g_mutex_lock (&_data_->_data62_->mutex);
#line 248 "../src/util/TweetUtils.vala"
		_data_->_tmp20_ = _data_->_data62_->collect;
#line 248 "../src/util/TweetUtils.vala"
		_data_->_tmp21_ = collect_by_id_get_done (_data_->_tmp20_);
#line 248 "../src/util/TweetUtils.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 248 "../src/util/TweetUtils.vala"
		if (!_data_->_tmp22_) {
#line 248 "../src/util/TweetUtils.vala"
			_data_->_tmp23_ = _data_->_data62_->collect;
#line 248 "../src/util/TweetUtils.vala"
			_data_->_tmp24_ = collect_by_id_get_errored (_data_->_tmp23_);
#line 248 "../src/util/TweetUtils.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 248 "../src/util/TweetUtils.vala"
			_data_->_tmp19_ = !_data_->_tmp25_;
#line 2843 "TweetUtils.c"
		} else {
#line 248 "../src/util/TweetUtils.vala"
			_data_->_tmp19_ = FALSE;
#line 2847 "TweetUtils.c"
		}
#line 248 "../src/util/TweetUtils.vala"
		if (_data_->_tmp19_) {
#line 249 "../src/util/TweetUtils.vala"
			_data_->_data62_->yielded = TRUE;
#line 250 "../src/util/TweetUtils.vala"
			g_mutex_unlock (&_data_->_data62_->mutex);
#line 251 "../src/util/TweetUtils.vala"
			_data_->_state_ = 1;
#line 251 "../src/util/TweetUtils.vala"
			return FALSE;
#line 2859 "TweetUtils.c"
			_state_1:
			;
		}
#line 254 "../src/util/TweetUtils.vala"
		_data_->_tmp26_ = _data_->_data62_->err;
#line 254 "../src/util/TweetUtils.vala"
		if (_data_->_tmp26_ != NULL) {
#line 255 "../src/util/TweetUtils.vala"
			_data_->_tmp27_ = _data_->_data62_->err;
#line 255 "../src/util/TweetUtils.vala"
			_data_->_tmp28_ = _g_error_copy0 (_data_->_tmp27_);
#line 255 "../src/util/TweetUtils.vala"
			_data_->_inner_error0_ = _data_->_tmp28_;
#line 255 "../src/util/TweetUtils.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 255 "../src/util/TweetUtils.vala"
			block62_data_unref (_data_->_data62_);
#line 255 "../src/util/TweetUtils.vala"
			_data_->_data62_ = NULL;
#line 255 "../src/util/TweetUtils.vala"
			_data_->media_attachments = (_vala_array_free (_data_->media_attachments, _data_->media_attachments_length1, (GDestroyNotify) g_object_unref), NULL);
#line 255 "../src/util/TweetUtils.vala"
			block61_data_unref (_data_->_data61_);
#line 255 "../src/util/TweetUtils.vala"
			_data_->_data61_ = NULL;
#line 255 "../src/util/TweetUtils.vala"
			g_object_unref (_data_->_async_result);
#line 255 "../src/util/TweetUtils.vala"
			return FALSE;
#line 2889 "TweetUtils.c"
		}
#line 206 "../src/util/TweetUtils.vala"
		block62_data_unref (_data_->_data62_);
#line 206 "../src/util/TweetUtils.vala"
		_data_->_data62_ = NULL;
#line 2895 "TweetUtils.c"
	}
#line 259 "../src/util/TweetUtils.vala"
	_data_->_state_ = 2;
#line 259 "../src/util/TweetUtils.vala"
	tweet_utils_do_post_tweet (_data_->account, _data_->tweet, tweet_utils_post_tweet_ready, _data_);
#line 259 "../src/util/TweetUtils.vala"
	return FALSE;
#line 2903 "TweetUtils.c"
	_state_2:
#line 259 "../src/util/TweetUtils.vala"
	_data_->_tmp29_ = tweet_utils_do_post_tweet_finish (_data_->_res_, &_data_->_inner_error0_);
#line 259 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 259 "../src/util/TweetUtils.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 259 "../src/util/TweetUtils.vala"
		_data_->media_attachments = (_vala_array_free (_data_->media_attachments, _data_->media_attachments_length1, (GDestroyNotify) g_object_unref), NULL);
#line 259 "../src/util/TweetUtils.vala"
		block61_data_unref (_data_->_data61_);
#line 259 "../src/util/TweetUtils.vala"
		_data_->_data61_ = NULL;
#line 259 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 259 "../src/util/TweetUtils.vala"
		return FALSE;
#line 2921 "TweetUtils.c"
	}
#line 259 "../src/util/TweetUtils.vala"
	_data_->result = _data_->_tmp29_;
#line 259 "../src/util/TweetUtils.vala"
	_data_->media_attachments = (_vala_array_free (_data_->media_attachments, _data_->media_attachments_length1, (GDestroyNotify) g_object_unref), NULL);
#line 259 "../src/util/TweetUtils.vala"
	block61_data_unref (_data_->_data61_);
#line 259 "../src/util/TweetUtils.vala"
	_data_->_data61_ = NULL;
#line 259 "../src/util/TweetUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 259 "../src/util/TweetUtils.vala"
	if (_data_->_state_ != 0) {
#line 259 "../src/util/TweetUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 259 "../src/util/TweetUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2939 "TweetUtils.c"
		}
	}
#line 259 "../src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 259 "../src/util/TweetUtils.vala"
	return FALSE;
#line 2946 "TweetUtils.c"
}

gchar*
tweet_utils_map_upload_to_id (MediaUpload* upload)
{
	gint64 _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 262 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (upload != NULL, NULL);
#line 263 "../src/util/TweetUtils.vala"
	_tmp0_ = media_upload_get_media_id (upload);
#line 263 "../src/util/TweetUtils.vala"
	_tmp1_ = _tmp0_;
#line 263 "../src/util/TweetUtils.vala"
	_tmp2_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp1_);
#line 263 "../src/util/TweetUtils.vala"
	result = _tmp2_;
#line 263 "../src/util/TweetUtils.vala"
	return result;
#line 2968 "TweetUtils.c"
}

static void
tweet_utils_do_post_tweet_data_free (gpointer _data)
{
	TweetUtilsDoPostTweetData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_composed_tweet_unref0 (_data_->tweet);
	g_slice_free (TweetUtilsDoPostTweetData, _data_);
}

void
tweet_utils_do_post_tweet (Account* account,
                           ComposedTweet* tweet,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	TweetUtilsDoPostTweetData* _data_;
	Account* _tmp0_;
	ComposedTweet* _tmp1_;
	g_return_if_fail (account != NULL);
	g_return_if_fail (tweet != NULL);
	_data_ = g_slice_new0 (TweetUtilsDoPostTweetData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tweet_utils_do_post_tweet_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_tmp1_ = _composed_tweet_ref0 (tweet);
	_composed_tweet_unref0 (_data_->tweet);
	_data_->tweet = _tmp1_;
	tweet_utils_do_post_tweet_co (_data_);
}

gboolean
tweet_utils_do_post_tweet_finish (GAsyncResult* _res_,
                                  GError** error)
{
	gboolean result;
	TweetUtilsDoPostTweetData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		gboolean _tmp0_ = FALSE;
		return _tmp0_;
	}
	result = _data_->result;
	return result;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 3030 "TweetUtils.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 3034 "TweetUtils.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 3040 "TweetUtils.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 3045 "TweetUtils.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 3051 "TweetUtils.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 3055 "TweetUtils.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 3059 "TweetUtils.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 3063 "TweetUtils.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3067 "TweetUtils.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3071 "TweetUtils.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 3086 "TweetUtils.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 3095 "TweetUtils.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 3102 "TweetUtils.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 3108 "TweetUtils.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 3116 "TweetUtils.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 3120 "TweetUtils.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 3126 "TweetUtils.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 3131 "TweetUtils.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 3137 "TweetUtils.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 3141 "TweetUtils.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 3145 "TweetUtils.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 3151 "TweetUtils.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 3157 "TweetUtils.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 3169 "TweetUtils.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 3173 "TweetUtils.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 3177 "TweetUtils.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 3182 "TweetUtils.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 3190 "TweetUtils.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 3208 "TweetUtils.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 3214 "TweetUtils.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 3218 "TweetUtils.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 3226 "TweetUtils.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 3235 "TweetUtils.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 3244 "TweetUtils.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 3250 "TweetUtils.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 3258 "TweetUtils.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 3270 "TweetUtils.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 3276 "TweetUtils.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 3280 "TweetUtils.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 3288 "TweetUtils.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 3299 "TweetUtils.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 3308 "TweetUtils.c"
	}
}

static void
tweet_utils_do_post_tweet_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	TweetUtilsDoPostTweetData* _data_;
#line 292 "../src/util/TweetUtils.vala"
	_data_ = _user_data_;
#line 292 "../src/util/TweetUtils.vala"
	_data_->_source_object_ = source_object;
#line 292 "../src/util/TweetUtils.vala"
	_data_->_res_ = _res_;
#line 292 "../src/util/TweetUtils.vala"
	tweet_utils_do_post_tweet_co (_data_);
#line 3326 "TweetUtils.c"
}

static gboolean
tweet_utils_do_post_tweet_co (TweetUtilsDoPostTweetData* _data_)
{
#line 266 "../src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 266 "../src/util/TweetUtils.vala"
		case 0:
#line 3336 "TweetUtils.c"
		goto _state_0;
#line 266 "../src/util/TweetUtils.vala"
		case 1:
#line 3340 "TweetUtils.c"
		goto _state_1;
		default:
#line 266 "../src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 3345 "TweetUtils.c"
	}
	_state_0:
#line 267 "../src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->account->proxy;
#line 267 "../src/util/TweetUtils.vala"
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
#line 267 "../src/util/TweetUtils.vala"
	_data_->call = _data_->_tmp1_;
#line 268 "../src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->call;
#line 268 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_tmp2_, "POST");
#line 269 "../src/util/TweetUtils.vala"
	_data_->_tmp3_ = _data_->call;
#line 269 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_function (_data_->_tmp3_, "1.1/statuses/update.json");
#line 270 "../src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->call;
#line 270 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp4_, "auto_populate_reply_metadata", "true");
#line 271 "../src/util/TweetUtils.vala"
	_data_->_tmp5_ = _data_->call;
#line 271 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp5_, "tweet_mode", "extended");
#line 272 "../src/util/TweetUtils.vala"
	_data_->_tmp6_ = _data_->call;
#line 272 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp6_, "include_ext_alt_text", "true");
#line 274 "../src/util/TweetUtils.vala"
	_data_->_tmp7_ = composed_tweet_get_reply_to_id (_data_->tweet);
#line 274 "../src/util/TweetUtils.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 274 "../src/util/TweetUtils.vala"
	if (_data_->_tmp8_ > ((gint64) 0)) {
#line 275 "../src/util/TweetUtils.vala"
		_data_->_tmp9_ = _data_->call;
#line 275 "../src/util/TweetUtils.vala"
		_data_->_tmp10_ = composed_tweet_get_reply_to_id (_data_->tweet);
#line 275 "../src/util/TweetUtils.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 275 "../src/util/TweetUtils.vala"
		_data_->_tmp12_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp11_);
#line 275 "../src/util/TweetUtils.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 275 "../src/util/TweetUtils.vala"
		rest_proxy_call_add_param (_data_->_tmp9_, "in_reply_to_status_id", _data_->_tmp13_);
#line 275 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp13_);
#line 3394 "TweetUtils.c"
	} else {
#line 277 "../src/util/TweetUtils.vala"
		if (composed_tweet_has_quote_attachment (_data_->tweet)) {
#line 278 "../src/util/TweetUtils.vala"
			_data_->_tmp14_ = _data_->call;
#line 278 "../src/util/TweetUtils.vala"
			_data_->_tmp15_ = composed_tweet_get_quoted_url (_data_->tweet);
#line 278 "../src/util/TweetUtils.vala"
			_data_->_tmp16_ = _data_->_tmp15_;
#line 278 "../src/util/TweetUtils.vala"
			rest_proxy_call_add_param (_data_->_tmp14_, "attachment_url", _data_->_tmp16_);
#line 278 "../src/util/TweetUtils.vala"
			_g_free0 (_data_->_tmp16_);
#line 3408 "TweetUtils.c"
		}
	}
#line 281 "../src/util/TweetUtils.vala"
	_data_->_tmp17_ = 0;
#line 281 "../src/util/TweetUtils.vala"
	_data_->_tmp18_ = composed_tweet_get_attachments (_data_->tweet, &_data_->_tmp17_);
#line 281 "../src/util/TweetUtils.vala"
	_data_->media_attachments = _data_->_tmp18_;
#line 281 "../src/util/TweetUtils.vala"
	_data_->media_attachments_length1 = _data_->_tmp17_;
#line 281 "../src/util/TweetUtils.vala"
	_data_->_media_attachments_size_ = _data_->media_attachments_length1;
#line 283 "../src/util/TweetUtils.vala"
	_data_->_tmp19_ = _data_->media_attachments;
#line 283 "../src/util/TweetUtils.vala"
	_data_->_tmp19__length1 = _data_->media_attachments_length1;
#line 283 "../src/util/TweetUtils.vala"
	if (_data_->_tmp19__length1 > 0) {
#line 285 "../src/util/TweetUtils.vala"
		_data_->_tmp20_ = _data_->media_attachments;
#line 285 "../src/util/TweetUtils.vala"
		_data_->_tmp20__length1 = _data_->media_attachments_length1;
#line 285 "../src/util/TweetUtils.vala"
		_data_->_tmp21_ = 0;
#line 285 "../src/util/TweetUtils.vala"
		_data_->_tmp22_ = map (TYPE_MEDIA_UPLOAD, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _data_->_tmp20_, (gint) _data_->_tmp20__length1, (MapFunction) tweet_utils_map_upload_to_id, NULL, &_data_->_tmp21_);
#line 285 "../src/util/TweetUtils.vala"
		_data_->ids = _data_->_tmp22_;
#line 285 "../src/util/TweetUtils.vala"
		_data_->ids_length1 = _data_->_tmp21_;
#line 285 "../src/util/TweetUtils.vala"
		_data_->_ids_size_ = _data_->ids_length1;
#line 286 "../src/util/TweetUtils.vala"
		_data_->_tmp23_ = _data_->call;
#line 286 "../src/util/TweetUtils.vala"
		_data_->_tmp24_ = _data_->ids;
#line 286 "../src/util/TweetUtils.vala"
		_data_->_tmp24__length1 = _data_->ids_length1;
#line 286 "../src/util/TweetUtils.vala"
		_data_->_tmp25_ = _vala_g_strjoinv (",", _data_->_tmp24_, (gint) _data_->_tmp24__length1);
#line 286 "../src/util/TweetUtils.vala"
		_data_->_tmp26_ = _data_->_tmp25_;
#line 286 "../src/util/TweetUtils.vala"
		rest_proxy_call_add_param (_data_->_tmp23_, "media_ids", _data_->_tmp26_);
#line 286 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp26_);
#line 283 "../src/util/TweetUtils.vala"
		_data_->ids = (_vala_array_free (_data_->ids, _data_->ids_length1, (GDestroyNotify) g_free), NULL);
#line 3457 "TweetUtils.c"
	}
#line 289 "../src/util/TweetUtils.vala"
	_data_->_tmp27_ = _data_->call;
#line 289 "../src/util/TweetUtils.vala"
	_data_->_tmp28_ = composed_tweet_get_text (_data_->tweet);
#line 289 "../src/util/TweetUtils.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 289 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp27_, "status", _data_->_tmp29_);
#line 289 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp29_);
#line 3469 "TweetUtils.c"
	{
#line 292 "../src/util/TweetUtils.vala"
		_data_->_tmp30_ = _data_->call;
#line 292 "../src/util/TweetUtils.vala"
		_data_->_state_ = 1;
#line 292 "../src/util/TweetUtils.vala"
		rest_proxy_call_invoke_async (_data_->_tmp30_, NULL, tweet_utils_do_post_tweet_ready, _data_);
#line 292 "../src/util/TweetUtils.vala"
		return FALSE;
#line 3479 "TweetUtils.c"
		_state_1:
#line 292 "../src/util/TweetUtils.vala"
		rest_proxy_call_invoke_finish (_data_->_tmp30_, _data_->_res_, &_data_->_inner_error0_);
#line 292 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3485 "TweetUtils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 291 "../src/util/TweetUtils.vala"
		_data_->e = _data_->_inner_error0_;
#line 291 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = NULL;
#line 295 "../src/util/TweetUtils.vala"
		_data_->_tmp31_ = _data_->call;
#line 295 "../src/util/TweetUtils.vala"
		_data_->_tmp32_ = _data_->e;
#line 295 "../src/util/TweetUtils.vala"
		_data_->_tmp33_ = tweet_utils_failed_request_to_error (_data_->_tmp31_, _data_->_tmp32_);
#line 295 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = _data_->_tmp33_;
#line 295 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data_->e);
#line 3506 "TweetUtils.c"
		goto __finally0;
	}
	__finally0:
#line 291 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 291 "../src/util/TweetUtils.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 291 "../src/util/TweetUtils.vala"
		_data_->media_attachments = (_vala_array_free (_data_->media_attachments, _data_->media_attachments_length1, (GDestroyNotify) g_object_unref), NULL);
#line 291 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->call);
#line 291 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 291 "../src/util/TweetUtils.vala"
		return FALSE;
#line 3522 "TweetUtils.c"
	}
#line 297 "../src/util/TweetUtils.vala"
	_data_->_tmp34_ = _data_->call;
#line 297 "../src/util/TweetUtils.vala"
	_data_->_tmp35_ = rest_proxy_call_get_payload (_data_->_tmp34_);
#line 297 "../src/util/TweetUtils.vala"
	tweet_utils_inject_tweet (_data_->_tmp35_, _data_->account);
#line 298 "../src/util/TweetUtils.vala"
	_data_->result = TRUE;
#line 298 "../src/util/TweetUtils.vala"
	_data_->media_attachments = (_vala_array_free (_data_->media_attachments, _data_->media_attachments_length1, (GDestroyNotify) g_object_unref), NULL);
#line 298 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->call);
#line 298 "../src/util/TweetUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 298 "../src/util/TweetUtils.vala"
	if (_data_->_state_ != 0) {
#line 298 "../src/util/TweetUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 298 "../src/util/TweetUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3544 "TweetUtils.c"
		}
	}
#line 298 "../src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 298 "../src/util/TweetUtils.vala"
	return FALSE;
#line 3551 "TweetUtils.c"
}

static void
tweet_utils_delete_tweet_data_free (gpointer _data)
{
	TweetUtilsDeleteTweetData* _data_;
	_data_ = _data;
	g_slice_free (TweetUtilsDeleteTweetData, _data_);
}

void
tweet_utils_delete_tweet (Account* account,
                          CbTweet* tweet,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	TweetUtilsDeleteTweetData* _data_;
	Account* _tmp0_;
	CbTweet* _tmp1_;
	g_return_if_fail (account != NULL);
	g_return_if_fail (tweet != NULL);
	_data_ = g_slice_new0 (TweetUtilsDeleteTweetData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tweet_utils_delete_tweet_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_tmp1_ = _g_object_ref0 (tweet);
	_g_object_unref0 (_data_->tweet);
	_data_->tweet = _tmp1_;
	tweet_utils_delete_tweet_co (_data_);
}

gboolean
tweet_utils_delete_tweet_finish (GAsyncResult* _res_,
                                 GError** error)
{
	gboolean result;
	TweetUtilsDeleteTweetData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		gboolean _tmp0_ = FALSE;
		return _tmp0_;
	}
	result = _data_->result;
	return result;
}

/**
   * Deletes the given tweet.
   *
   * @param account The account to delete the tweet from
   * @param tweet the tweet to delete
   * @return True if tweet was successfully deleted, else False
   */
static Block64Data*
block64_data_ref (Block64Data* _data64_)
{
#line 308 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data64_->_ref_count_);
#line 308 "../src/util/TweetUtils.vala"
	return _data64_;
#line 3614 "TweetUtils.c"
}

static void
block64_data_unref (void * _userdata_)
{
	Block64Data* _data64_;
	_data64_ = (Block64Data*) _userdata_;
#line 308 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data64_->_ref_count_)) {
#line 308 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data64_->err);
#line 308 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data64_->call);
#line 308 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data64_->account);
#line 308 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data64_->tweet);
#line 308 "../src/util/TweetUtils.vala"
		g_slice_free (Block64Data, _data64_);
#line 3634 "TweetUtils.c"
	}
}

static void
__lambda77_ (Block64Data* _data64_,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 315 "../src/util/TweetUtils.vala"
	g_return_if_fail (res != NULL);
#line 3646 "TweetUtils.c"
	{
		RestProxyCall* _tmp0_;
#line 317 "../src/util/TweetUtils.vala"
		_tmp0_ = _data64_->call;
#line 317 "../src/util/TweetUtils.vala"
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
#line 317 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3655 "TweetUtils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* tmp_error = NULL;
		RestProxyCall* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 316 "../src/util/TweetUtils.vala"
		e = _inner_error0_;
#line 316 "../src/util/TweetUtils.vala"
		_inner_error0_ = NULL;
#line 319 "../src/util/TweetUtils.vala"
		_tmp1_ = _data64_->call;
#line 319 "../src/util/TweetUtils.vala"
		_tmp2_ = e;
#line 319 "../src/util/TweetUtils.vala"
		_tmp3_ = tweet_utils_failed_request_to_error (_tmp1_, _tmp2_);
#line 319 "../src/util/TweetUtils.vala"
		tmp_error = _tmp3_;
#line 320 "../src/util/TweetUtils.vala"
		_tmp4_ = tmp_error;
#line 320 "../src/util/TweetUtils.vala"
		if (_tmp4_->code != 144) {
#line 3684 "TweetUtils.c"
			GError* _tmp5_;
			GError* _tmp6_;
			GError* _tmp7_;
#line 321 "../src/util/TweetUtils.vala"
			_tmp5_ = tmp_error;
#line 321 "../src/util/TweetUtils.vala"
			_tmp6_ = _g_error_copy0 (_tmp5_);
#line 321 "../src/util/TweetUtils.vala"
			_g_error_free0 (_data64_->err);
#line 321 "../src/util/TweetUtils.vala"
			_data64_->err = _tmp6_;
#line 322 "../src/util/TweetUtils.vala"
			_tmp7_ = _data64_->err;
#line 322 "../src/util/TweetUtils.vala"
			g_debug ("TweetUtils.vala:322: Delete failed: %d", _tmp7_->code);
#line 323 "../src/util/TweetUtils.vala"
			tweet_utils_delete_tweet_co (_data64_->_async_data_);
#line 324 "../src/util/TweetUtils.vala"
			_g_error_free0 (tmp_error);
#line 324 "../src/util/TweetUtils.vala"
			_g_error_free0 (e);
#line 324 "../src/util/TweetUtils.vala"
			return;
#line 3708 "TweetUtils.c"
		}
#line 316 "../src/util/TweetUtils.vala"
		_g_error_free0 (tmp_error);
#line 316 "../src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 3714 "TweetUtils.c"
	}
	__finally0:
#line 316 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 316 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 316 "../src/util/TweetUtils.vala"
		g_clear_error (&_inner_error0_);
#line 316 "../src/util/TweetUtils.vala"
		return;
#line 3725 "TweetUtils.c"
	}
#line 327 "../src/util/TweetUtils.vala"
	tweet_utils_inject_deletion (_data64_->tweet->id, _data64_->account);
#line 328 "../src/util/TweetUtils.vala"
	_data64_->success = TRUE;
#line 329 "../src/util/TweetUtils.vala"
	tweet_utils_delete_tweet_co (_data64_->_async_data_);
#line 3733 "TweetUtils.c"
}

static void
___lambda77__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 315 "../src/util/TweetUtils.vala"
	__lambda77_ (self, source_object, res);
#line 315 "../src/util/TweetUtils.vala"
	block64_data_unref (self);
#line 3745 "TweetUtils.c"
}

static gboolean
tweet_utils_delete_tweet_co (TweetUtilsDeleteTweetData* _data_)
{
#line 308 "../src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 308 "../src/util/TweetUtils.vala"
		case 0:
#line 3755 "TweetUtils.c"
		goto _state_0;
#line 308 "../src/util/TweetUtils.vala"
		case 1:
#line 3759 "TweetUtils.c"
		goto _state_1;
		default:
#line 308 "../src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 3764 "TweetUtils.c"
	}
	_state_0:
#line 308 "../src/util/TweetUtils.vala"
	_data_->_data64_ = g_slice_new0 (Block64Data);
#line 308 "../src/util/TweetUtils.vala"
	_data_->_data64_->_ref_count_ = 1;
#line 308 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data64_->account);
#line 308 "../src/util/TweetUtils.vala"
	_data_->_data64_->account = _data_->account;
#line 308 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data64_->tweet);
#line 308 "../src/util/TweetUtils.vala"
	_data_->_data64_->tweet = _data_->tweet;
#line 308 "../src/util/TweetUtils.vala"
	_data_->_data64_->_async_data_ = _data_;
#line 309 "../src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->_data64_->account->proxy;
#line 309 "../src/util/TweetUtils.vala"
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
#line 309 "../src/util/TweetUtils.vala"
	_data_->_data64_->call = _data_->_tmp1_;
#line 310 "../src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->_data64_->call;
#line 310 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_tmp2_, "POST");
#line 311 "../src/util/TweetUtils.vala"
	_data_->_tmp3_ = _data_->_data64_->call;
#line 311 "../src/util/TweetUtils.vala"
	_data_->_tmp4_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_data64_->tweet->id);
#line 311 "../src/util/TweetUtils.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 311 "../src/util/TweetUtils.vala"
	_data_->_tmp6_ = g_strconcat ("1.1/statuses/destroy/", _data_->_tmp5_, NULL);
#line 311 "../src/util/TweetUtils.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 311 "../src/util/TweetUtils.vala"
	_data_->_tmp8_ = g_strconcat (_data_->_tmp7_, ".json", NULL);
#line 311 "../src/util/TweetUtils.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 311 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_function (_data_->_tmp3_, _data_->_tmp9_);
#line 311 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp9_);
#line 311 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp7_);
#line 311 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp5_);
#line 312 "../src/util/TweetUtils.vala"
	_data_->_tmp10_ = _data_->_data64_->call;
#line 312 "../src/util/TweetUtils.vala"
	_data_->_tmp11_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_data64_->tweet->id);
#line 312 "../src/util/TweetUtils.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 312 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp10_, "id", _data_->_tmp12_);
#line 312 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp12_);
#line 313 "../src/util/TweetUtils.vala"
	_data_->_data64_->success = FALSE;
#line 314 "../src/util/TweetUtils.vala"
	_data_->_data64_->err = NULL;
#line 315 "../src/util/TweetUtils.vala"
	_data_->_tmp13_ = _data_->_data64_->call;
#line 315 "../src/util/TweetUtils.vala"
	rest_proxy_call_invoke_async (_data_->_tmp13_, NULL, ___lambda77__gasync_ready_callback, block64_data_ref (_data_->_data64_));
#line 331 "../src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 331 "../src/util/TweetUtils.vala"
	return FALSE;
#line 3835 "TweetUtils.c"
	_state_1:
	;
#line 332 "../src/util/TweetUtils.vala"
	_data_->_tmp14_ = _data_->_data64_->err;
#line 332 "../src/util/TweetUtils.vala"
	if (_data_->_tmp14_ != NULL) {
#line 333 "../src/util/TweetUtils.vala"
		_data_->_tmp15_ = _data_->_data64_->err;
#line 333 "../src/util/TweetUtils.vala"
		_data_->_tmp16_ = _g_error_copy0 (_data_->_tmp15_);
#line 333 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = _data_->_tmp16_;
#line 333 "../src/util/TweetUtils.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 333 "../src/util/TweetUtils.vala"
		block64_data_unref (_data_->_data64_);
#line 333 "../src/util/TweetUtils.vala"
		_data_->_data64_ = NULL;
#line 333 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 333 "../src/util/TweetUtils.vala"
		return FALSE;
#line 3858 "TweetUtils.c"
	}
#line 335 "../src/util/TweetUtils.vala"
	_data_->result = _data_->_data64_->success;
#line 335 "../src/util/TweetUtils.vala"
	block64_data_unref (_data_->_data64_);
#line 335 "../src/util/TweetUtils.vala"
	_data_->_data64_ = NULL;
#line 335 "../src/util/TweetUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 335 "../src/util/TweetUtils.vala"
	if (_data_->_state_ != 0) {
#line 335 "../src/util/TweetUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 335 "../src/util/TweetUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3874 "TweetUtils.c"
		}
	}
#line 335 "../src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 335 "../src/util/TweetUtils.vala"
	return FALSE;
#line 3881 "TweetUtils.c"
}

static void
tweet_utils_set_favorite_status_data_free (gpointer _data)
{
	TweetUtilsSetFavoriteStatusData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	g_slice_free (TweetUtilsSetFavoriteStatusData, _data_);
}

void
tweet_utils_set_favorite_status (Account* account,
                                 CbTweet* tweet,
                                 gboolean status,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	TweetUtilsSetFavoriteStatusData* _data_;
	Account* _tmp0_;
	CbTweet* _tmp1_;
	g_return_if_fail (account != NULL);
	g_return_if_fail (tweet != NULL);
	_data_ = g_slice_new0 (TweetUtilsSetFavoriteStatusData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tweet_utils_set_favorite_status_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_tmp1_ = _g_object_ref0 (tweet);
	_g_object_unref0 (_data_->tweet);
	_data_->tweet = _tmp1_;
	_data_->status = status;
	tweet_utils_set_favorite_status_co (_data_);
}

gboolean
tweet_utils_set_favorite_status_finish (GAsyncResult* _res_,
                                        GError** error)
{
	gboolean result;
	TweetUtilsSetFavoriteStatusData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		gboolean _tmp0_ = FALSE;
		return _tmp0_;
	}
	result = _data_->result;
	return result;
}

/**
   * (Un)favorites the given tweet.
   *
   * @param account The account to (un)favorite from
   * @param tweet The tweet to (un)favorite
   * @param status %true to favorite the tweet, %false to unfavorite it.
   * @return True if favourited status was successfully changed, else False
   */
static Block65Data*
block65_data_ref (Block65Data* _data65_)
{
#line 346 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data65_->_ref_count_);
#line 346 "../src/util/TweetUtils.vala"
	return _data65_;
#line 3948 "TweetUtils.c"
}

static void
block65_data_unref (void * _userdata_)
{
	Block65Data* _data65_;
	_data65_ = (Block65Data*) _userdata_;
#line 346 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data65_->_ref_count_)) {
#line 346 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data65_->err);
#line 346 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data65_->call);
#line 346 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data65_->tweet);
#line 346 "../src/util/TweetUtils.vala"
		g_slice_free (Block65Data, _data65_);
#line 3966 "TweetUtils.c"
	}
}

static void
__lambda75_ (Block65Data* _data65_,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 363 "../src/util/TweetUtils.vala"
	g_return_if_fail (res != NULL);
#line 3978 "TweetUtils.c"
	{
		RestProxyCall* _tmp0_;
#line 365 "../src/util/TweetUtils.vala"
		_tmp0_ = _data65_->call;
#line 365 "../src/util/TweetUtils.vala"
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
#line 365 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3987 "TweetUtils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* tmp_error = NULL;
		RestProxyCall* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
#line 364 "../src/util/TweetUtils.vala"
		e = _inner_error0_;
#line 364 "../src/util/TweetUtils.vala"
		_inner_error0_ = NULL;
#line 367 "../src/util/TweetUtils.vala"
		_tmp1_ = _data65_->call;
#line 367 "../src/util/TweetUtils.vala"
		_tmp2_ = e;
#line 367 "../src/util/TweetUtils.vala"
		_tmp3_ = tweet_utils_failed_request_to_error (_tmp1_, _tmp2_);
#line 367 "../src/util/TweetUtils.vala"
		tmp_error = _tmp3_;
#line 369 "../src/util/TweetUtils.vala"
		if (_data65_->status) {
#line 4015 "TweetUtils.c"
			GError* _tmp6_;
#line 369 "../src/util/TweetUtils.vala"
			_tmp6_ = tmp_error;
#line 369 "../src/util/TweetUtils.vala"
			_tmp5_ = _tmp6_->code != 139;
#line 4021 "TweetUtils.c"
		} else {
#line 369 "../src/util/TweetUtils.vala"
			_tmp5_ = FALSE;
#line 4025 "TweetUtils.c"
		}
#line 369 "../src/util/TweetUtils.vala"
		if (_tmp5_) {
#line 369 "../src/util/TweetUtils.vala"
			_tmp4_ = TRUE;
#line 4031 "TweetUtils.c"
		} else {
			gboolean _tmp7_ = FALSE;
#line 371 "../src/util/TweetUtils.vala"
			if (!_data65_->status) {
#line 4036 "TweetUtils.c"
				GError* _tmp8_;
#line 371 "../src/util/TweetUtils.vala"
				_tmp8_ = tmp_error;
#line 371 "../src/util/TweetUtils.vala"
				_tmp7_ = _tmp8_->code != 144;
#line 4042 "TweetUtils.c"
			} else {
#line 371 "../src/util/TweetUtils.vala"
				_tmp7_ = FALSE;
#line 4046 "TweetUtils.c"
			}
#line 371 "../src/util/TweetUtils.vala"
			_tmp4_ = _tmp7_;
#line 4050 "TweetUtils.c"
		}
#line 369 "../src/util/TweetUtils.vala"
		if (_tmp4_) {
#line 4054 "TweetUtils.c"
			GError* _tmp9_;
			GError* _tmp10_;
#line 372 "../src/util/TweetUtils.vala"
			_tmp9_ = tmp_error;
#line 372 "../src/util/TweetUtils.vala"
			_tmp10_ = _g_error_copy0 (_tmp9_);
#line 372 "../src/util/TweetUtils.vala"
			_g_error_free0 (_data65_->err);
#line 372 "../src/util/TweetUtils.vala"
			_data65_->err = _tmp10_;
#line 373 "../src/util/TweetUtils.vala"
			tweet_utils_set_favorite_status_co (_data65_->_async_data_);
#line 374 "../src/util/TweetUtils.vala"
			_g_error_free0 (tmp_error);
#line 374 "../src/util/TweetUtils.vala"
			_g_error_free0 (e);
#line 374 "../src/util/TweetUtils.vala"
			return;
#line 4073 "TweetUtils.c"
		}
#line 364 "../src/util/TweetUtils.vala"
		_g_error_free0 (tmp_error);
#line 364 "../src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 4079 "TweetUtils.c"
	}
	__finally0:
#line 364 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 364 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 364 "../src/util/TweetUtils.vala"
		g_clear_error (&_inner_error0_);
#line 364 "../src/util/TweetUtils.vala"
		return;
#line 4090 "TweetUtils.c"
	}
#line 377 "../src/util/TweetUtils.vala"
	if (_data65_->status) {
#line 378 "../src/util/TweetUtils.vala"
		cb_tweet_set_flag (_data65_->tweet, (guint) CB_TWEET_STATE_FAVORITED);
#line 4096 "TweetUtils.c"
	} else {
#line 380 "../src/util/TweetUtils.vala"
		cb_tweet_unset_flag (_data65_->tweet, (guint) CB_TWEET_STATE_FAVORITED);
#line 4100 "TweetUtils.c"
	}
#line 382 "../src/util/TweetUtils.vala"
	_data65_->success = TRUE;
#line 383 "../src/util/TweetUtils.vala"
	tweet_utils_set_favorite_status_co (_data65_->_async_data_);
#line 4106 "TweetUtils.c"
}

static void
___lambda75__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 363 "../src/util/TweetUtils.vala"
	__lambda75_ (self, source_object, res);
#line 363 "../src/util/TweetUtils.vala"
	block65_data_unref (self);
#line 4118 "TweetUtils.c"
}

static gboolean
tweet_utils_set_favorite_status_co (TweetUtilsSetFavoriteStatusData* _data_)
{
#line 346 "../src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 346 "../src/util/TweetUtils.vala"
		case 0:
#line 4128 "TweetUtils.c"
		goto _state_0;
#line 346 "../src/util/TweetUtils.vala"
		case 1:
#line 4132 "TweetUtils.c"
		goto _state_1;
		default:
#line 346 "../src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 4137 "TweetUtils.c"
	}
	_state_0:
#line 346 "../src/util/TweetUtils.vala"
	_data_->_data65_ = g_slice_new0 (Block65Data);
#line 346 "../src/util/TweetUtils.vala"
	_data_->_data65_->_ref_count_ = 1;
#line 346 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data65_->tweet);
#line 346 "../src/util/TweetUtils.vala"
	_data_->_data65_->tweet = _data_->tweet;
#line 346 "../src/util/TweetUtils.vala"
	_data_->_data65_->status = _data_->status;
#line 346 "../src/util/TweetUtils.vala"
	_data_->_data65_->_async_data_ = _data_;
#line 347 "../src/util/TweetUtils.vala"
	if (cb_tweet_is_flag_set (_data_->_data65_->tweet, (guint) CB_TWEET_STATE_FAVORITED) == _data_->_data65_->status) {
#line 349 "../src/util/TweetUtils.vala"
		_data_->result = FALSE;
#line 349 "../src/util/TweetUtils.vala"
		block65_data_unref (_data_->_data65_);
#line 349 "../src/util/TweetUtils.vala"
		_data_->_data65_ = NULL;
#line 349 "../src/util/TweetUtils.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 349 "../src/util/TweetUtils.vala"
		if (_data_->_state_ != 0) {
#line 349 "../src/util/TweetUtils.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 349 "../src/util/TweetUtils.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4168 "TweetUtils.c"
			}
		}
#line 349 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 349 "../src/util/TweetUtils.vala"
		return FALSE;
#line 4175 "TweetUtils.c"
	}
#line 352 "../src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->account->proxy;
#line 352 "../src/util/TweetUtils.vala"
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
#line 352 "../src/util/TweetUtils.vala"
	_data_->_data65_->call = _data_->_tmp1_;
#line 353 "../src/util/TweetUtils.vala"
	if (_data_->_data65_->status) {
#line 354 "../src/util/TweetUtils.vala"
		_data_->_tmp2_ = _data_->_data65_->call;
#line 354 "../src/util/TweetUtils.vala"
		rest_proxy_call_set_function (_data_->_tmp2_, "1.1/favorites/create.json");
#line 4189 "TweetUtils.c"
	} else {
#line 356 "../src/util/TweetUtils.vala"
		_data_->_tmp3_ = _data_->_data65_->call;
#line 356 "../src/util/TweetUtils.vala"
		rest_proxy_call_set_function (_data_->_tmp3_, "1.1/favorites/destroy.json");
#line 4195 "TweetUtils.c"
	}
#line 358 "../src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->_data65_->call;
#line 358 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_tmp4_, "POST");
#line 359 "../src/util/TweetUtils.vala"
	_data_->_tmp5_ = _data_->_data65_->call;
#line 359 "../src/util/TweetUtils.vala"
	_data_->_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_data65_->tweet->id);
#line 359 "../src/util/TweetUtils.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 359 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp5_, "id", _data_->_tmp7_);
#line 359 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp7_);
#line 361 "../src/util/TweetUtils.vala"
	_data_->_data65_->success = FALSE;
#line 362 "../src/util/TweetUtils.vala"
	_data_->_data65_->err = NULL;
#line 363 "../src/util/TweetUtils.vala"
	_data_->_tmp8_ = _data_->_data65_->call;
#line 363 "../src/util/TweetUtils.vala"
	rest_proxy_call_invoke_async (_data_->_tmp8_, NULL, ___lambda75__gasync_ready_callback, block65_data_ref (_data_->_data65_));
#line 385 "../src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 385 "../src/util/TweetUtils.vala"
	return FALSE;
#line 4223 "TweetUtils.c"
	_state_1:
	;
#line 386 "../src/util/TweetUtils.vala"
	_data_->_tmp9_ = _data_->_data65_->err;
#line 386 "../src/util/TweetUtils.vala"
	if (_data_->_tmp9_ != NULL) {
#line 387 "../src/util/TweetUtils.vala"
		_data_->_tmp10_ = _data_->_data65_->err;
#line 387 "../src/util/TweetUtils.vala"
		_data_->_tmp11_ = _g_error_copy0 (_data_->_tmp10_);
#line 387 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = _data_->_tmp11_;
#line 387 "../src/util/TweetUtils.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 387 "../src/util/TweetUtils.vala"
		block65_data_unref (_data_->_data65_);
#line 387 "../src/util/TweetUtils.vala"
		_data_->_data65_ = NULL;
#line 387 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 387 "../src/util/TweetUtils.vala"
		return FALSE;
#line 4246 "TweetUtils.c"
	}
#line 389 "../src/util/TweetUtils.vala"
	_data_->result = _data_->_data65_->success;
#line 389 "../src/util/TweetUtils.vala"
	block65_data_unref (_data_->_data65_);
#line 389 "../src/util/TweetUtils.vala"
	_data_->_data65_ = NULL;
#line 389 "../src/util/TweetUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 389 "../src/util/TweetUtils.vala"
	if (_data_->_state_ != 0) {
#line 389 "../src/util/TweetUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 389 "../src/util/TweetUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4262 "TweetUtils.c"
		}
	}
#line 389 "../src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 389 "../src/util/TweetUtils.vala"
	return FALSE;
#line 4269 "TweetUtils.c"
}

static void
tweet_utils_set_retweet_status_data_free (gpointer _data)
{
	TweetUtilsSetRetweetStatusData* _data_;
	_data_ = _data;
	g_slice_free (TweetUtilsSetRetweetStatusData, _data_);
}

void
tweet_utils_set_retweet_status (Account* account,
                                CbTweet* tweet,
                                gboolean status,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	TweetUtilsSetRetweetStatusData* _data_;
	Account* _tmp0_;
	CbTweet* _tmp1_;
	g_return_if_fail (account != NULL);
	g_return_if_fail (tweet != NULL);
	_data_ = g_slice_new0 (TweetUtilsSetRetweetStatusData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tweet_utils_set_retweet_status_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_tmp1_ = _g_object_ref0 (tweet);
	_g_object_unref0 (_data_->tweet);
	_data_->tweet = _tmp1_;
	_data_->status = status;
	tweet_utils_set_retweet_status_co (_data_);
}

gboolean
tweet_utils_set_retweet_status_finish (GAsyncResult* _res_,
                                       GError** error)
{
	gboolean result;
	TweetUtilsSetRetweetStatusData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		gboolean _tmp0_ = FALSE;
		return _tmp0_;
	}
	result = _data_->result;
	return result;
}

/**
   * (Un)retweets the given tweet.
   *
   * @param account The account to (un)retweet from
   * @param tweet The tweet to (un)retweet
   * @param status %true to retweet it, false to unretweet it.
   * @return True if retweet status was successfully changed, else False
   */
static Block66Data*
block66_data_ref (Block66Data* _data66_)
{
#line 400 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data66_->_ref_count_);
#line 400 "../src/util/TweetUtils.vala"
	return _data66_;
#line 4335 "TweetUtils.c"
}

static void
block66_data_unref (void * _userdata_)
{
	Block66Data* _data66_;
	_data66_ = (Block66Data*) _userdata_;
#line 400 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data66_->_ref_count_)) {
#line 400 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data66_->err);
#line 400 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data66_->call);
#line 400 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data66_->account);
#line 400 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data66_->tweet);
#line 400 "../src/util/TweetUtils.vala"
		g_slice_free (Block66Data, _data66_);
#line 4355 "TweetUtils.c"
	}
}

static void
__lambda98_ (Block66Data* _data66_,
             GObject* obj,
             GAsyncResult* res)
{
	const gchar* back = NULL;
	RestProxyCall* _tmp13_;
	const gchar* _tmp14_;
	JsonParser* parser = NULL;
	JsonParser* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 418 "../src/util/TweetUtils.vala"
	g_return_if_fail (res != NULL);
#line 4372 "TweetUtils.c"
	{
		RestProxyCall* _tmp0_;
#line 420 "../src/util/TweetUtils.vala"
		_tmp0_ = _data66_->call;
#line 420 "../src/util/TweetUtils.vala"
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
#line 420 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4381 "TweetUtils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* tmp_error = NULL;
		RestProxyCall* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
#line 419 "../src/util/TweetUtils.vala"
		e = _inner_error0_;
#line 419 "../src/util/TweetUtils.vala"
		_inner_error0_ = NULL;
#line 422 "../src/util/TweetUtils.vala"
		_tmp1_ = _data66_->call;
#line 422 "../src/util/TweetUtils.vala"
		_tmp2_ = e;
#line 422 "../src/util/TweetUtils.vala"
		_tmp3_ = tweet_utils_failed_request_to_error (_tmp1_, _tmp2_);
#line 422 "../src/util/TweetUtils.vala"
		tmp_error = _tmp3_;
#line 424 "../src/util/TweetUtils.vala"
		if (_data66_->status) {
#line 4409 "TweetUtils.c"
			GError* _tmp6_;
#line 424 "../src/util/TweetUtils.vala"
			_tmp6_ = tmp_error;
#line 424 "../src/util/TweetUtils.vala"
			_tmp5_ = _tmp6_->code == 327;
#line 4415 "TweetUtils.c"
		} else {
#line 424 "../src/util/TweetUtils.vala"
			_tmp5_ = FALSE;
#line 4419 "TweetUtils.c"
		}
#line 424 "../src/util/TweetUtils.vala"
		if (_tmp5_) {
#line 424 "../src/util/TweetUtils.vala"
			_tmp4_ = TRUE;
#line 4425 "TweetUtils.c"
		} else {
			gboolean _tmp7_ = FALSE;
#line 426 "../src/util/TweetUtils.vala"
			if (!_data66_->status) {
#line 4430 "TweetUtils.c"
				GError* _tmp8_;
#line 426 "../src/util/TweetUtils.vala"
				_tmp8_ = tmp_error;
#line 426 "../src/util/TweetUtils.vala"
				_tmp7_ = _tmp8_->code == 144;
#line 4436 "TweetUtils.c"
			} else {
#line 426 "../src/util/TweetUtils.vala"
				_tmp7_ = FALSE;
#line 4440 "TweetUtils.c"
			}
#line 426 "../src/util/TweetUtils.vala"
			_tmp4_ = _tmp7_;
#line 4444 "TweetUtils.c"
		}
#line 424 "../src/util/TweetUtils.vala"
		if (_tmp4_) {
#line 4448 "TweetUtils.c"
			GError* _tmp9_;
#line 429 "../src/util/TweetUtils.vala"
			_tmp9_ = tmp_error;
#line 429 "../src/util/TweetUtils.vala"
			g_debug ("TweetUtils.vala:429: Succeeded by %d", _tmp9_->code);
#line 430 "../src/util/TweetUtils.vala"
			if (_data66_->status) {
#line 431 "../src/util/TweetUtils.vala"
				cb_tweet_set_flag (_data66_->tweet, (guint) CB_TWEET_STATE_RETWEETED);
#line 4458 "TweetUtils.c"
			} else {
#line 433 "../src/util/TweetUtils.vala"
				cb_tweet_unset_flag (_data66_->tweet, (guint) CB_TWEET_STATE_RETWEETED);
#line 4462 "TweetUtils.c"
			}
#line 435 "../src/util/TweetUtils.vala"
			_data66_->success = TRUE;
#line 4466 "TweetUtils.c"
		} else {
			GError* _tmp10_;
			GError* _tmp11_;
			GError* _tmp12_;
#line 437 "../src/util/TweetUtils.vala"
			_tmp10_ = tmp_error;
#line 437 "../src/util/TweetUtils.vala"
			g_debug ("TweetUtils.vala:437: Failed with %d", _tmp10_->code);
#line 438 "../src/util/TweetUtils.vala"
			_tmp11_ = tmp_error;
#line 438 "../src/util/TweetUtils.vala"
			_tmp12_ = _g_error_copy0 (_tmp11_);
#line 438 "../src/util/TweetUtils.vala"
			_g_error_free0 (_data66_->err);
#line 438 "../src/util/TweetUtils.vala"
			_data66_->err = _tmp12_;
#line 4483 "TweetUtils.c"
		}
#line 440 "../src/util/TweetUtils.vala"
		tweet_utils_set_retweet_status_co (_data66_->_async_data_);
#line 441 "../src/util/TweetUtils.vala"
		_g_error_free0 (tmp_error);
#line 441 "../src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 441 "../src/util/TweetUtils.vala"
		return;
#line 4493 "TweetUtils.c"
	}
	__finally0:
#line 419 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 419 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 419 "../src/util/TweetUtils.vala"
		g_clear_error (&_inner_error0_);
#line 419 "../src/util/TweetUtils.vala"
		return;
#line 4504 "TweetUtils.c"
	}
#line 443 "../src/util/TweetUtils.vala"
	_tmp13_ = _data66_->call;
#line 443 "../src/util/TweetUtils.vala"
	_tmp14_ = rest_proxy_call_get_payload (_tmp13_);
#line 443 "../src/util/TweetUtils.vala"
	back = _tmp14_;
#line 444 "../src/util/TweetUtils.vala"
	_tmp15_ = json_parser_new ();
#line 444 "../src/util/TweetUtils.vala"
	parser = _tmp15_;
#line 4516 "TweetUtils.c"
	{
		JsonParser* _tmp16_;
		const gchar* _tmp17_;
		gchar* message = NULL;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		CbStreamMessageType message_type = 0;
		CbUserStream* _tmp23_;
		const gchar* _tmp24_;
#line 446 "../src/util/TweetUtils.vala"
		_tmp16_ = parser;
#line 446 "../src/util/TweetUtils.vala"
		_tmp17_ = back;
#line 446 "../src/util/TweetUtils.vala"
		json_parser_load_from_data (_tmp16_, _tmp17_, (gssize) -1, &_inner_error0_);
#line 446 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4534 "TweetUtils.c"
			goto __catch1_g_error;
		}
#line 447 "../src/util/TweetUtils.vala"
		_tmp18_ = back;
#line 447 "../src/util/TweetUtils.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 447 "../src/util/TweetUtils.vala"
		message = _tmp19_;
#line 449 "../src/util/TweetUtils.vala"
		if (_data66_->status) {
#line 4545 "TweetUtils.c"
			gint64 new_id = 0LL;
			JsonParser* _tmp20_;
			JsonNode* _tmp21_;
			JsonObject* _tmp22_;
#line 450 "../src/util/TweetUtils.vala"
			_tmp20_ = parser;
#line 450 "../src/util/TweetUtils.vala"
			_tmp21_ = json_parser_get_root (_tmp20_);
#line 450 "../src/util/TweetUtils.vala"
			_tmp22_ = json_node_get_object (_tmp21_);
#line 450 "../src/util/TweetUtils.vala"
			new_id = json_object_get_int_member (_tmp22_, "id");
#line 451 "../src/util/TweetUtils.vala"
			_data66_->tweet->my_retweet = new_id;
#line 452 "../src/util/TweetUtils.vala"
			cb_tweet_set_flag (_data66_->tweet, (guint) CB_TWEET_STATE_RETWEETED);
#line 453 "../src/util/TweetUtils.vala"
			message_type = CB_STREAM_MESSAGE_TWEET;
#line 4564 "TweetUtils.c"
		} else {
#line 455 "../src/util/TweetUtils.vala"
			tweet_utils_inject_deletion (_data66_->tweet->my_retweet, _data66_->account);
#line 456 "../src/util/TweetUtils.vala"
			_data66_->tweet->my_retweet = (gint64) 0;
#line 457 "../src/util/TweetUtils.vala"
			cb_tweet_unset_flag (_data66_->tweet, (guint) CB_TWEET_STATE_RETWEETED);
#line 458 "../src/util/TweetUtils.vala"
			message_type = CB_STREAM_MESSAGE_RT_DELETE;
#line 4574 "TweetUtils.c"
		}
#line 461 "../src/util/TweetUtils.vala"
		_tmp23_ = _data66_->account->user_stream;
#line 461 "../src/util/TweetUtils.vala"
		_tmp24_ = message;
#line 461 "../src/util/TweetUtils.vala"
		cb_user_stream_inject_tweet (_tmp23_, message_type, _tmp24_);
#line 445 "../src/util/TweetUtils.vala"
		_g_free0 (message);
#line 4584 "TweetUtils.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp25_;
		GError* _tmp26_;
		GError* _tmp27_;
#line 445 "../src/util/TweetUtils.vala"
		e = _inner_error0_;
#line 445 "../src/util/TweetUtils.vala"
		_inner_error0_ = NULL;
#line 463 "../src/util/TweetUtils.vala"
		_tmp25_ = back;
#line 463 "../src/util/TweetUtils.vala"
		g_info ("TweetUtils.vala:463: %s", _tmp25_);
#line 464 "../src/util/TweetUtils.vala"
		_tmp26_ = e;
#line 464 "../src/util/TweetUtils.vala"
		_tmp27_ = _g_error_copy0 (_tmp26_);
#line 464 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data66_->err);
#line 464 "../src/util/TweetUtils.vala"
		_data66_->err = _tmp27_;
#line 465 "../src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 465 "../src/util/TweetUtils.vala"
		_g_object_unref0 (parser);
#line 465 "../src/util/TweetUtils.vala"
		return;
#line 4615 "TweetUtils.c"
	}
	__finally1:
#line 445 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 445 "../src/util/TweetUtils.vala"
		_g_object_unref0 (parser);
#line 445 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 445 "../src/util/TweetUtils.vala"
		g_clear_error (&_inner_error0_);
#line 445 "../src/util/TweetUtils.vala"
		return;
#line 4628 "TweetUtils.c"
	}
#line 467 "../src/util/TweetUtils.vala"
	_data66_->success = TRUE;
#line 468 "../src/util/TweetUtils.vala"
	tweet_utils_set_retweet_status_co (_data66_->_async_data_);
#line 418 "../src/util/TweetUtils.vala"
	_g_object_unref0 (parser);
#line 4636 "TweetUtils.c"
}

static void
___lambda98__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 418 "../src/util/TweetUtils.vala"
	__lambda98_ (self, source_object, res);
#line 418 "../src/util/TweetUtils.vala"
	block66_data_unref (self);
#line 4648 "TweetUtils.c"
}

static gboolean
tweet_utils_set_retweet_status_co (TweetUtilsSetRetweetStatusData* _data_)
{
#line 400 "../src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 400 "../src/util/TweetUtils.vala"
		case 0:
#line 4658 "TweetUtils.c"
		goto _state_0;
#line 400 "../src/util/TweetUtils.vala"
		case 1:
#line 4662 "TweetUtils.c"
		goto _state_1;
		default:
#line 400 "../src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 4667 "TweetUtils.c"
	}
	_state_0:
#line 400 "../src/util/TweetUtils.vala"
	_data_->_data66_ = g_slice_new0 (Block66Data);
#line 400 "../src/util/TweetUtils.vala"
	_data_->_data66_->_ref_count_ = 1;
#line 400 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data66_->account);
#line 400 "../src/util/TweetUtils.vala"
	_data_->_data66_->account = _data_->account;
#line 400 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data66_->tweet);
#line 400 "../src/util/TweetUtils.vala"
	_data_->_data66_->tweet = _data_->tweet;
#line 400 "../src/util/TweetUtils.vala"
	_data_->_data66_->status = _data_->status;
#line 400 "../src/util/TweetUtils.vala"
	_data_->_data66_->_async_data_ = _data_;
#line 401 "../src/util/TweetUtils.vala"
	if (cb_tweet_is_flag_set (_data_->_data66_->tweet, (guint) CB_TWEET_STATE_RETWEETED) == _data_->_data66_->status) {
#line 403 "../src/util/TweetUtils.vala"
		_data_->result = FALSE;
#line 403 "../src/util/TweetUtils.vala"
		block66_data_unref (_data_->_data66_);
#line 403 "../src/util/TweetUtils.vala"
		_data_->_data66_ = NULL;
#line 403 "../src/util/TweetUtils.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 403 "../src/util/TweetUtils.vala"
		if (_data_->_state_ != 0) {
#line 403 "../src/util/TweetUtils.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 403 "../src/util/TweetUtils.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4702 "TweetUtils.c"
			}
		}
#line 403 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 403 "../src/util/TweetUtils.vala"
		return FALSE;
#line 4709 "TweetUtils.c"
	}
#line 406 "../src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->_data66_->account->proxy;
#line 406 "../src/util/TweetUtils.vala"
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
#line 406 "../src/util/TweetUtils.vala"
	_data_->_data66_->call = _data_->_tmp1_;
#line 407 "../src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->_data66_->call;
#line 407 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_tmp2_, "POST");
#line 408 "../src/util/TweetUtils.vala"
	if (_data_->_data66_->status) {
#line 409 "../src/util/TweetUtils.vala"
		_data_->_tmp3_ = _data_->_data66_->call;
#line 409 "../src/util/TweetUtils.vala"
		_data_->_tmp4_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_data66_->tweet->id);
#line 409 "../src/util/TweetUtils.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 409 "../src/util/TweetUtils.vala"
		_data_->_tmp6_ = g_strconcat ("1.1/statuses/retweet/", _data_->_tmp5_, ".json", NULL);
#line 409 "../src/util/TweetUtils.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 409 "../src/util/TweetUtils.vala"
		rest_proxy_call_set_function (_data_->_tmp3_, _data_->_tmp7_);
#line 409 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp7_);
#line 409 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp5_);
#line 4739 "TweetUtils.c"
	} else {
#line 411 "../src/util/TweetUtils.vala"
		_data_->_tmp8_ = _data_->_data66_->call;
#line 411 "../src/util/TweetUtils.vala"
		_data_->_tmp9_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_data66_->tweet->my_retweet);
#line 411 "../src/util/TweetUtils.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 411 "../src/util/TweetUtils.vala"
		_data_->_tmp11_ = g_strconcat ("1.1/statuses/unretweet/", _data_->_tmp10_, ".json", NULL);
#line 411 "../src/util/TweetUtils.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 411 "../src/util/TweetUtils.vala"
		rest_proxy_call_set_function (_data_->_tmp8_, _data_->_tmp12_);
#line 411 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp12_);
#line 411 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp10_);
#line 4757 "TweetUtils.c"
	}
#line 412 "../src/util/TweetUtils.vala"
	_data_->_tmp13_ = _data_->_data66_->call;
#line 412 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp13_, "tweet_mode", "extended");
#line 413 "../src/util/TweetUtils.vala"
	_data_->_tmp14_ = _data_->_data66_->call;
#line 413 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp14_, "include_my_retweet", "true");
#line 414 "../src/util/TweetUtils.vala"
	_data_->_tmp15_ = _data_->_data66_->call;
#line 414 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp15_, "include_ext_alt_text", "true");
#line 416 "../src/util/TweetUtils.vala"
	_data_->_data66_->success = FALSE;
#line 417 "../src/util/TweetUtils.vala"
	_data_->_data66_->err = NULL;
#line 418 "../src/util/TweetUtils.vala"
	_data_->_tmp16_ = _data_->_data66_->call;
#line 418 "../src/util/TweetUtils.vala"
	rest_proxy_call_invoke_async (_data_->_tmp16_, NULL, ___lambda98__gasync_ready_callback, block66_data_ref (_data_->_data66_));
#line 470 "../src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 470 "../src/util/TweetUtils.vala"
	return FALSE;
#line 4783 "TweetUtils.c"
	_state_1:
	;
#line 471 "../src/util/TweetUtils.vala"
	_data_->_tmp17_ = _data_->_data66_->err;
#line 471 "../src/util/TweetUtils.vala"
	if (_data_->_tmp17_ != NULL) {
#line 472 "../src/util/TweetUtils.vala"
		_data_->_tmp18_ = _data_->_data66_->err;
#line 472 "../src/util/TweetUtils.vala"
		_data_->_tmp19_ = _g_error_copy0 (_data_->_tmp18_);
#line 472 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = _data_->_tmp19_;
#line 472 "../src/util/TweetUtils.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 472 "../src/util/TweetUtils.vala"
		block66_data_unref (_data_->_data66_);
#line 472 "../src/util/TweetUtils.vala"
		_data_->_data66_ = NULL;
#line 472 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 472 "../src/util/TweetUtils.vala"
		return FALSE;
#line 4806 "TweetUtils.c"
	}
#line 474 "../src/util/TweetUtils.vala"
	_data_->result = _data_->_data66_->success;
#line 474 "../src/util/TweetUtils.vala"
	block66_data_unref (_data_->_data66_);
#line 474 "../src/util/TweetUtils.vala"
	_data_->_data66_ = NULL;
#line 474 "../src/util/TweetUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 474 "../src/util/TweetUtils.vala"
	if (_data_->_state_ != 0) {
#line 474 "../src/util/TweetUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 474 "../src/util/TweetUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4822 "TweetUtils.c"
		}
	}
#line 474 "../src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 474 "../src/util/TweetUtils.vala"
	return FALSE;
#line 4829 "TweetUtils.c"
}

static void
tweet_utils_search_for_tweets_json_data_free (gpointer _data)
{
	TweetUtilsSearchForTweetsJsonData* _data_;
	_data_ = _data;
	_g_free0 (_data_->search_query);
	(_data_->result == NULL) ? NULL : (_data_->result = (g_list_free (_data_->result), NULL));
	g_slice_free (TweetUtilsSearchForTweetsJsonData, _data_);
}

void
tweet_utils_search_for_tweets_json (Account* account,
                                    const gchar* search_query,
                                    gint64 max_id,
                                    gint64 since_id,
                                    guint count,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	TweetUtilsSearchForTweetsJsonData* _data_;
	Account* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
	g_return_if_fail (account != NULL);
	g_return_if_fail (search_query != NULL);
	_data_ = g_slice_new0 (TweetUtilsSearchForTweetsJsonData);
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tweet_utils_search_for_tweets_json_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_tmp1_ = g_strdup (search_query);
	_g_free0 (_data_->search_query);
	_data_->search_query = _tmp1_;
	_data_->max_id = max_id;
	_data_->since_id = since_id;
	_data_->count = count;
	_tmp2_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp2_;
	tweet_utils_search_for_tweets_json_co (_data_);
}

GList*
tweet_utils_search_for_tweets_json_finish (GAsyncResult* _res_,
                                           GError** error)
{
	GList* result;
	TweetUtilsSearchForTweetsJsonData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static Block67Data*
block67_data_ref (Block67Data* _data67_)
{
#line 477 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data67_->_ref_count_);
#line 477 "../src/util/TweetUtils.vala"
	return _data67_;
#line 4898 "TweetUtils.c"
}

static void
block67_data_unref (void * _userdata_)
{
	Block67Data* _data67_;
	_data67_ = (Block67Data*) _userdata_;
#line 477 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data67_->_ref_count_)) {
#line 477 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data67_->err);
#line 477 "../src/util/TweetUtils.vala"
		(_data67_->statuses == NULL) ? NULL : (_data67_->statuses = (g_list_free (_data67_->statuses), NULL));
#line 477 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data67_->account);
#line 477 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data67_->cancellable);
#line 477 "../src/util/TweetUtils.vala"
		g_slice_free (Block67Data, _data67_);
#line 4918 "TweetUtils.c"
	}
}

static Block68Data*
block68_data_ref (Block68Data* _data68_)
{
#line 494 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data68_->_ref_count_);
#line 494 "../src/util/TweetUtils.vala"
	return _data68_;
#line 4929 "TweetUtils.c"
}

static void
block68_data_unref (void * _userdata_)
{
	Block68Data* _data68_;
	_data68_ = (Block68Data*) _userdata_;
#line 494 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data68_->_ref_count_)) {
#line 494 "../src/util/TweetUtils.vala"
		_data68_->ids = (_vala_array_free (_data68_->ids, _data68_->ids_length1, (GDestroyNotify) g_free), NULL);
#line 494 "../src/util/TweetUtils.vala"
		block67_data_unref (_data68_->_data67_);
#line 494 "../src/util/TweetUtils.vala"
		_data68_->_data67_ = NULL;
#line 494 "../src/util/TweetUtils.vala"
		g_slice_free (Block68Data, _data68_);
#line 4947 "TweetUtils.c"
	}
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 518 "../src/util/TweetUtils.vala"
	if ((*length) == (*size)) {
#line 518 "../src/util/TweetUtils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 518 "../src/util/TweetUtils.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4963 "TweetUtils.c"
	}
#line 518 "../src/util/TweetUtils.vala"
	(*array)[(*length)++] = value;
#line 518 "../src/util/TweetUtils.vala"
	(*array)[*length] = NULL;
#line 4969 "TweetUtils.c"
}

static void
__lambda93_ (Block68Data* _data68_,
             JsonArray* array,
             guint index,
             JsonNode* node)
{
	Block67Data* _data67_;
	JsonObject* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 517 "../src/util/TweetUtils.vala"
	_data67_ = _data68_->_data67_;
#line 517 "../src/util/TweetUtils.vala"
	g_return_if_fail (array != NULL);
#line 517 "../src/util/TweetUtils.vala"
	g_return_if_fail (node != NULL);
#line 518 "../src/util/TweetUtils.vala"
	_tmp0_ = json_node_get_object (node);
#line 518 "../src/util/TweetUtils.vala"
	_tmp1_ = json_object_get_string_member (_tmp0_, "id_str");
#line 518 "../src/util/TweetUtils.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 518 "../src/util/TweetUtils.vala"
	_vala_array_add2 (&_data68_->ids, &_data68_->ids_length1, &_data68_->_ids_size_, _tmp2_);
#line 4996 "TweetUtils.c"
}

static void
___lambda93__json_array_foreach (JsonArray* array,
                                 guint index_,
                                 JsonNode* element_node,
                                 gpointer self)
{
#line 517 "../src/util/TweetUtils.vala"
	__lambda93_ (self, array, index_, element_node);
#line 5007 "TweetUtils.c"
}

static gint
__lambda95_ (JsonNode* a,
             JsonNode* b)
{
	gchar* a_id = NULL;
	JsonObject* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* b_id = NULL;
	JsonObject* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GCompareFunc _tmp6_;
	gint result;
#line 546 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 546 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 547 "../src/util/TweetUtils.vala"
	_tmp0_ = json_node_get_object (a);
#line 547 "../src/util/TweetUtils.vala"
	_tmp1_ = json_object_get_string_member (_tmp0_, "id_str");
#line 547 "../src/util/TweetUtils.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 547 "../src/util/TweetUtils.vala"
	a_id = _tmp2_;
#line 548 "../src/util/TweetUtils.vala"
	_tmp3_ = json_node_get_object (b);
#line 548 "../src/util/TweetUtils.vala"
	_tmp4_ = json_object_get_string_member (_tmp3_, "id_str");
#line 548 "../src/util/TweetUtils.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 548 "../src/util/TweetUtils.vala"
	b_id = _tmp5_;
#line 550 "../src/util/TweetUtils.vala"
	_tmp6_ = ((GCompareFunc) g_strcmp0);
#line 550 "../src/util/TweetUtils.vala"
	result = _tmp6_ (b_id, a_id);
#line 550 "../src/util/TweetUtils.vala"
	_g_free0 (b_id);
#line 550 "../src/util/TweetUtils.vala"
	_g_free0 (a_id);
#line 550 "../src/util/TweetUtils.vala"
	return result;
#line 5054 "TweetUtils.c"
}

static gint
___lambda95__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = __lambda95_ ((JsonNode*) a, (JsonNode*) b);
#line 546 "../src/util/TweetUtils.vala"
	return result;
#line 5065 "TweetUtils.c"
}

static void
__lambda94_ (Block68Data* _data68_,
             GObject* _,
             GAsyncResult* res)
{
	Block67Data* _data67_;
	JsonNode* root = NULL;
	JsonNode* _tmp5_;
	JsonNode* _tmp6_;
	JsonArray* _tmp7_;
	GList* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 529 "../src/util/TweetUtils.vala"
	_data67_ = _data68_->_data67_;
#line 529 "../src/util/TweetUtils.vala"
	g_return_if_fail (res != NULL);
#line 530 "../src/util/TweetUtils.vala"
	root = NULL;
#line 5086 "TweetUtils.c"
	{
		JsonNode* _tmp0_ = NULL;
		JsonNode* _tmp1_;
		JsonNode* _tmp2_;
#line 532 "../src/util/TweetUtils.vala"
		_tmp1_ = cb_utils_load_threaded_finish (res, &_inner_error0_);
#line 532 "../src/util/TweetUtils.vala"
		_tmp0_ = _tmp1_;
#line 532 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5097 "TweetUtils.c"
			goto __catch0_g_error;
		}
#line 532 "../src/util/TweetUtils.vala"
		_tmp2_ = _tmp0_;
#line 532 "../src/util/TweetUtils.vala"
		_tmp0_ = NULL;
#line 532 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (root);
#line 532 "../src/util/TweetUtils.vala"
		root = _tmp2_;
#line 531 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_tmp0_);
#line 5110 "TweetUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		GError* _tmp4_;
#line 531 "../src/util/TweetUtils.vala"
		e = _inner_error0_;
#line 531 "../src/util/TweetUtils.vala"
		_inner_error0_ = NULL;
#line 534 "../src/util/TweetUtils.vala"
		_tmp3_ = e;
#line 534 "../src/util/TweetUtils.vala"
		_tmp4_ = _g_error_copy0 (_tmp3_);
#line 534 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data67_->err);
#line 534 "../src/util/TweetUtils.vala"
		_data67_->err = _tmp4_;
#line 535 "../src/util/TweetUtils.vala"
		tweet_utils_search_for_tweets_json_co (_data67_->_async_data_);
#line 536 "../src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 536 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (root);
#line 536 "../src/util/TweetUtils.vala"
		return;
#line 5138 "TweetUtils.c"
	}
	__finally0:
#line 531 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 531 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (root);
#line 531 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 531 "../src/util/TweetUtils.vala"
		g_clear_error (&_inner_error0_);
#line 531 "../src/util/TweetUtils.vala"
		return;
#line 5151 "TweetUtils.c"
	}
#line 539 "../src/util/TweetUtils.vala"
	_tmp5_ = root;
#line 539 "../src/util/TweetUtils.vala"
	if (_tmp5_ == NULL) {
#line 540 "../src/util/TweetUtils.vala"
		g_debug ("TweetUtils.vala:540: load tweets: root is null");
#line 541 "../src/util/TweetUtils.vala"
		tweet_utils_search_for_tweets_json_co (_data67_->_async_data_);
#line 542 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (root);
#line 542 "../src/util/TweetUtils.vala"
		return;
#line 5165 "TweetUtils.c"
	}
#line 545 "../src/util/TweetUtils.vala"
	_tmp6_ = root;
#line 545 "../src/util/TweetUtils.vala"
	_tmp7_ = json_node_get_array (_tmp6_);
#line 545 "../src/util/TweetUtils.vala"
	_tmp8_ = json_array_get_elements (_tmp7_);
#line 545 "../src/util/TweetUtils.vala"
	(_data67_->statuses == NULL) ? NULL : (_data67_->statuses = (g_list_free (_data67_->statuses), NULL));
#line 545 "../src/util/TweetUtils.vala"
	_data67_->statuses = _tmp8_;
#line 546 "../src/util/TweetUtils.vala"
	_data67_->statuses = g_list_sort (_data67_->statuses, ___lambda95__gcompare_func);
#line 552 "../src/util/TweetUtils.vala"
	tweet_utils_search_for_tweets_json_co (_data67_->_async_data_);
#line 529 "../src/util/TweetUtils.vala"
	__vala_JsonNode_free0 (root);
#line 5183 "TweetUtils.c"
}

static void
___lambda94__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 529 "../src/util/TweetUtils.vala"
	__lambda94_ (self, source_object, res);
#line 529 "../src/util/TweetUtils.vala"
	block68_data_unref (self);
#line 5195 "TweetUtils.c"
}

static void
__lambda92_ (Block67Data* _data67_,
             GObject* _,
             GAsyncResult* res)
{
	Block68Data* _data68_;
	JsonNode* search_root = NULL;
	JsonNode* _tmp5_;
	JsonArray* search_statuses = NULL;
	JsonNode* _tmp6_;
	JsonObject* _tmp7_;
	JsonArray* _tmp8_;
	JsonArray* _tmp9_;
	JsonArray* _tmp10_;
	gchar** _tmp11_;
	JsonArray* _tmp12_;
	RestProxyCall* call = NULL;
	OAuthProxy* _tmp13_;
	RestProxyCall* _tmp14_;
	RestProxyCall* _tmp15_;
	RestProxyCall* _tmp16_;
	RestProxyCall* _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	gchar* _tmp19_;
	gchar* _tmp20_;
	RestProxyCall* _tmp21_;
	RestProxyCall* _tmp22_;
	RestProxyCall* _tmp23_;
	RestProxyCall* _tmp24_;
	GError* _inner_error0_ = NULL;
#line 494 "../src/util/TweetUtils.vala"
	g_return_if_fail (res != NULL);
#line 494 "../src/util/TweetUtils.vala"
	_data68_ = g_slice_new0 (Block68Data);
#line 494 "../src/util/TweetUtils.vala"
	_data68_->_ref_count_ = 1;
#line 494 "../src/util/TweetUtils.vala"
	_data68_->_data67_ = block67_data_ref (_data67_);
#line 495 "../src/util/TweetUtils.vala"
	search_root = NULL;
#line 5239 "TweetUtils.c"
	{
		JsonNode* _tmp0_ = NULL;
		JsonNode* _tmp1_;
		JsonNode* _tmp2_;
#line 497 "../src/util/TweetUtils.vala"
		_tmp1_ = cb_utils_load_threaded_finish (res, &_inner_error0_);
#line 497 "../src/util/TweetUtils.vala"
		_tmp0_ = _tmp1_;
#line 497 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5250 "TweetUtils.c"
			goto __catch0_g_error;
		}
#line 497 "../src/util/TweetUtils.vala"
		_tmp2_ = _tmp0_;
#line 497 "../src/util/TweetUtils.vala"
		_tmp0_ = NULL;
#line 497 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (search_root);
#line 497 "../src/util/TweetUtils.vala"
		search_root = _tmp2_;
#line 496 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_tmp0_);
#line 5263 "TweetUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		GError* _tmp4_;
#line 496 "../src/util/TweetUtils.vala"
		e = _inner_error0_;
#line 496 "../src/util/TweetUtils.vala"
		_inner_error0_ = NULL;
#line 499 "../src/util/TweetUtils.vala"
		_tmp3_ = e;
#line 499 "../src/util/TweetUtils.vala"
		_tmp4_ = _g_error_copy0 (_tmp3_);
#line 499 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data67_->err);
#line 499 "../src/util/TweetUtils.vala"
		_data67_->err = _tmp4_;
#line 500 "../src/util/TweetUtils.vala"
		tweet_utils_search_for_tweets_json_co (_data67_->_async_data_);
#line 501 "../src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 501 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (search_root);
#line 501 "../src/util/TweetUtils.vala"
		block68_data_unref (_data68_);
#line 501 "../src/util/TweetUtils.vala"
		_data68_ = NULL;
#line 501 "../src/util/TweetUtils.vala"
		return;
#line 5295 "TweetUtils.c"
	}
	__finally0:
#line 496 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 496 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (search_root);
#line 496 "../src/util/TweetUtils.vala"
		block68_data_unref (_data68_);
#line 496 "../src/util/TweetUtils.vala"
		_data68_ = NULL;
#line 496 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 496 "../src/util/TweetUtils.vala"
		g_clear_error (&_inner_error0_);
#line 496 "../src/util/TweetUtils.vala"
		return;
#line 5312 "TweetUtils.c"
	}
#line 504 "../src/util/TweetUtils.vala"
	_tmp5_ = search_root;
#line 504 "../src/util/TweetUtils.vala"
	if (_tmp5_ == NULL) {
#line 505 "../src/util/TweetUtils.vala"
		tweet_utils_search_for_tweets_json_co (_data67_->_async_data_);
#line 506 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (search_root);
#line 506 "../src/util/TweetUtils.vala"
		block68_data_unref (_data68_);
#line 506 "../src/util/TweetUtils.vala"
		_data68_ = NULL;
#line 506 "../src/util/TweetUtils.vala"
		return;
#line 5328 "TweetUtils.c"
	}
#line 509 "../src/util/TweetUtils.vala"
	_tmp6_ = search_root;
#line 509 "../src/util/TweetUtils.vala"
	_tmp7_ = json_node_get_object (_tmp6_);
#line 509 "../src/util/TweetUtils.vala"
	_tmp8_ = json_object_get_array_member (_tmp7_, "statuses");
#line 509 "../src/util/TweetUtils.vala"
	_tmp9_ = _json_array_ref0 (_tmp8_);
#line 509 "../src/util/TweetUtils.vala"
	search_statuses = _tmp9_;
#line 511 "../src/util/TweetUtils.vala"
	_tmp10_ = search_statuses;
#line 511 "../src/util/TweetUtils.vala"
	if (json_array_get_length (_tmp10_) == ((guint) 0)) {
#line 512 "../src/util/TweetUtils.vala"
		tweet_utils_search_for_tweets_json_co (_data67_->_async_data_);
#line 513 "../src/util/TweetUtils.vala"
		_json_array_unref0 (search_statuses);
#line 513 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (search_root);
#line 513 "../src/util/TweetUtils.vala"
		block68_data_unref (_data68_);
#line 513 "../src/util/TweetUtils.vala"
		_data68_ = NULL;
#line 513 "../src/util/TweetUtils.vala"
		return;
#line 5356 "TweetUtils.c"
	}
#line 516 "../src/util/TweetUtils.vala"
	_tmp11_ = g_new0 (gchar*, 0 + 1);
#line 516 "../src/util/TweetUtils.vala"
	_data68_->ids = _tmp11_;
#line 516 "../src/util/TweetUtils.vala"
	_data68_->ids_length1 = 0;
#line 516 "../src/util/TweetUtils.vala"
	_data68_->_ids_size_ = _data68_->ids_length1;
#line 517 "../src/util/TweetUtils.vala"
	_tmp12_ = search_statuses;
#line 517 "../src/util/TweetUtils.vala"
	json_array_foreach_element (_tmp12_, ___lambda93__json_array_foreach, _data68_);
#line 521 "../src/util/TweetUtils.vala"
	_tmp13_ = _data67_->account->proxy;
#line 521 "../src/util/TweetUtils.vala"
	_tmp14_ = rest_proxy_new_call ((RestProxy*) _tmp13_);
#line 521 "../src/util/TweetUtils.vala"
	call = _tmp14_;
#line 522 "../src/util/TweetUtils.vala"
	_tmp15_ = call;
#line 522 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_function (_tmp15_, "1.1/statuses/lookup.json");
#line 523 "../src/util/TweetUtils.vala"
	_tmp16_ = call;
#line 523 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_tmp16_, "POST");
#line 524 "../src/util/TweetUtils.vala"
	_tmp17_ = call;
#line 524 "../src/util/TweetUtils.vala"
	_tmp18_ = _data68_->ids;
#line 524 "../src/util/TweetUtils.vala"
	_tmp18__length1 = _data68_->ids_length1;
#line 524 "../src/util/TweetUtils.vala"
	_tmp19_ = _vala_g_strjoinv (",", _tmp18_, (gint) _tmp18__length1);
#line 524 "../src/util/TweetUtils.vala"
	_tmp20_ = _tmp19_;
#line 524 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_tmp17_, "id", _tmp20_);
#line 524 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp20_);
#line 525 "../src/util/TweetUtils.vala"
	_tmp21_ = call;
#line 525 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_tmp21_, "include_entities", "true");
#line 526 "../src/util/TweetUtils.vala"
	_tmp22_ = call;
#line 526 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_tmp22_, "tweet_mode", "extended");
#line 527 "../src/util/TweetUtils.vala"
	_tmp23_ = call;
#line 527 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_tmp23_, "include_ext_alt_text", "true");
#line 529 "../src/util/TweetUtils.vala"
	_tmp24_ = call;
#line 529 "../src/util/TweetUtils.vala"
	cb_utils_load_threaded_async (_tmp24_, _data67_->cancellable, ___lambda94__gasync_ready_callback, block68_data_ref (_data68_));
#line 494 "../src/util/TweetUtils.vala"
	_g_object_unref0 (call);
#line 494 "../src/util/TweetUtils.vala"
	_json_array_unref0 (search_statuses);
#line 494 "../src/util/TweetUtils.vala"
	__vala_JsonNode_free0 (search_root);
#line 494 "../src/util/TweetUtils.vala"
	block68_data_unref (_data68_);
#line 494 "../src/util/TweetUtils.vala"
	_data68_ = NULL;
#line 5424 "TweetUtils.c"
}

static void
___lambda92__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 494 "../src/util/TweetUtils.vala"
	__lambda92_ (self, source_object, res);
#line 494 "../src/util/TweetUtils.vala"
	block67_data_unref (self);
#line 5436 "TweetUtils.c"
}

static gboolean
tweet_utils_search_for_tweets_json_co (TweetUtilsSearchForTweetsJsonData* _data_)
{
#line 477 "../src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 477 "../src/util/TweetUtils.vala"
		case 0:
#line 5446 "TweetUtils.c"
		goto _state_0;
#line 477 "../src/util/TweetUtils.vala"
		case 1:
#line 5450 "TweetUtils.c"
		goto _state_1;
		default:
#line 477 "../src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 5455 "TweetUtils.c"
	}
	_state_0:
#line 477 "../src/util/TweetUtils.vala"
	_data_->_data67_ = g_slice_new0 (Block67Data);
#line 477 "../src/util/TweetUtils.vala"
	_data_->_data67_->_ref_count_ = 1;
#line 477 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data67_->account);
#line 477 "../src/util/TweetUtils.vala"
	_data_->_data67_->account = _data_->account;
#line 477 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data67_->cancellable);
#line 477 "../src/util/TweetUtils.vala"
	_data_->_data67_->cancellable = _data_->cancellable;
#line 477 "../src/util/TweetUtils.vala"
	_data_->_data67_->_async_data_ = _data_;
#line 478 "../src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->_data67_->account->proxy;
#line 478 "../src/util/TweetUtils.vala"
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
#line 478 "../src/util/TweetUtils.vala"
	_data_->search_call = _data_->_tmp1_;
#line 479 "../src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->search_call;
#line 479 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_function (_data_->_tmp2_, "1.1/search/tweets.json");
#line 480 "../src/util/TweetUtils.vala"
	_data_->_tmp3_ = _data_->search_call;
#line 480 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_tmp3_, "GET");
#line 481 "../src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->search_call;
#line 481 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp4_, "q", _data_->search_query);
#line 482 "../src/util/TweetUtils.vala"
	if (_data_->max_id > ((gint64) 0)) {
#line 483 "../src/util/TweetUtils.vala"
		_data_->_tmp5_ = _data_->search_call;
#line 483 "../src/util/TweetUtils.vala"
		_data_->_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->max_id - 1);
#line 483 "../src/util/TweetUtils.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 483 "../src/util/TweetUtils.vala"
		rest_proxy_call_add_param (_data_->_tmp5_, "max_id", _data_->_tmp7_);
#line 483 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp7_);
#line 5502 "TweetUtils.c"
	} else {
#line 485 "../src/util/TweetUtils.vala"
		if (_data_->since_id > ((gint64) 0)) {
#line 486 "../src/util/TweetUtils.vala"
			_data_->_tmp8_ = _data_->search_call;
#line 486 "../src/util/TweetUtils.vala"
			_data_->_tmp9_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->since_id);
#line 486 "../src/util/TweetUtils.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 486 "../src/util/TweetUtils.vala"
			rest_proxy_call_add_param (_data_->_tmp8_, "since_id", _data_->_tmp10_);
#line 486 "../src/util/TweetUtils.vala"
			_g_free0 (_data_->_tmp10_);
#line 5516 "TweetUtils.c"
		}
	}
#line 488 "../src/util/TweetUtils.vala"
	_data_->_tmp11_ = _data_->search_call;
#line 488 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp11_, "include_entities", "false");
#line 489 "../src/util/TweetUtils.vala"
	_data_->_tmp12_ = _data_->search_call;
#line 489 "../src/util/TweetUtils.vala"
	_data_->_tmp13_ = g_strdup_printf ("%u", _data_->count);
#line 489 "../src/util/TweetUtils.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 489 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp12_, "count", _data_->_tmp14_);
#line 489 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp14_);
#line 491 "../src/util/TweetUtils.vala"
	_data_->_data67_->statuses = NULL;
#line 492 "../src/util/TweetUtils.vala"
	_data_->_data67_->err = NULL;
#line 494 "../src/util/TweetUtils.vala"
	_data_->_tmp15_ = _data_->search_call;
#line 494 "../src/util/TweetUtils.vala"
	cb_utils_load_threaded_async (_data_->_tmp15_, _data_->_data67_->cancellable, ___lambda92__gasync_ready_callback, block67_data_ref (_data_->_data67_));
#line 555 "../src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 555 "../src/util/TweetUtils.vala"
	return FALSE;
#line 5545 "TweetUtils.c"
	_state_1:
	;
#line 556 "../src/util/TweetUtils.vala"
	_data_->_tmp16_ = _data_->_data67_->err;
#line 556 "../src/util/TweetUtils.vala"
	if (_data_->_tmp16_ != NULL) {
#line 557 "../src/util/TweetUtils.vala"
		_data_->_tmp17_ = _data_->_data67_->err;
#line 557 "../src/util/TweetUtils.vala"
		_data_->_tmp18_ = _g_error_copy0 (_data_->_tmp17_);
#line 557 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = _data_->_tmp18_;
#line 557 "../src/util/TweetUtils.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 557 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->search_call);
#line 557 "../src/util/TweetUtils.vala"
		block67_data_unref (_data_->_data67_);
#line 557 "../src/util/TweetUtils.vala"
		_data_->_data67_ = NULL;
#line 557 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 557 "../src/util/TweetUtils.vala"
		return FALSE;
#line 5570 "TweetUtils.c"
	}
#line 560 "../src/util/TweetUtils.vala"
	_data_->_tmp20_ = _data_->_data67_->statuses;
#line 560 "../src/util/TweetUtils.vala"
	if (_data_->_tmp20_ == NULL) {
#line 560 "../src/util/TweetUtils.vala"
		(_data_->_tmp19_ == NULL) ? NULL : (_data_->_tmp19_ = (g_list_free (_data_->_tmp19_), NULL));
#line 560 "../src/util/TweetUtils.vala"
		_data_->_tmp19_ = NULL;
#line 5580 "TweetUtils.c"
	} else {
#line 560 "../src/util/TweetUtils.vala"
		_data_->_tmp21_ = _data_->_data67_->statuses;
#line 560 "../src/util/TweetUtils.vala"
		_data_->_tmp22_ = g_list_copy (_data_->_tmp21_);
#line 560 "../src/util/TweetUtils.vala"
		(_data_->_tmp19_ == NULL) ? NULL : (_data_->_tmp19_ = (g_list_free (_data_->_tmp19_), NULL));
#line 560 "../src/util/TweetUtils.vala"
		_data_->_tmp19_ = _data_->_tmp22_;
#line 5590 "TweetUtils.c"
	}
#line 560 "../src/util/TweetUtils.vala"
	_data_->result = _data_->_tmp19_;
#line 560 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->search_call);
#line 560 "../src/util/TweetUtils.vala"
	block67_data_unref (_data_->_data67_);
#line 560 "../src/util/TweetUtils.vala"
	_data_->_data67_ = NULL;
#line 560 "../src/util/TweetUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 560 "../src/util/TweetUtils.vala"
	if (_data_->_state_ != 0) {
#line 560 "../src/util/TweetUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 560 "../src/util/TweetUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5608 "TweetUtils.c"
		}
	}
#line 560 "../src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 560 "../src/util/TweetUtils.vala"
	return FALSE;
#line 5615 "TweetUtils.c"
}

void
tweet_utils_set_tweet_hidden_flags (CbTweet* t,
                                    Account* account)
{
	CbMiniTweet* _tmp0_;
#line 563 "../src/util/TweetUtils.vala"
	g_return_if_fail (t != NULL);
#line 563 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 564 "../src/util/TweetUtils.vala"
	if (account_filter_matches (account, t)) {
#line 565 "../src/util/TweetUtils.vala"
		cb_tweet_set_flag (t, (guint) CB_TWEET_STATE_HIDDEN_FILTERED);
#line 5631 "TweetUtils.c"
	}
#line 567 "../src/util/TweetUtils.vala"
	_tmp0_ = t->retweeted_tweet;
#line 567 "../src/util/TweetUtils.vala"
	if (_tmp0_ != NULL) {
#line 5637 "TweetUtils.c"
		CbMiniTweet _tmp1_;
		CbUserIdentity _tmp2_;
		CbMiniTweet _tmp3_;
		CbUserIdentity _tmp4_;
		CbMiniTweet* _tmp5_;
		CbUserIdentity _tmp6_;
		CbMiniTweet* _tmp7_;
		CbUserIdentity _tmp8_;
		CbMiniTweet _tmp9_;
		CbUserIdentity _tmp10_;
#line 568 "../src/util/TweetUtils.vala"
		_tmp1_ = t->source_tweet;
#line 568 "../src/util/TweetUtils.vala"
		_tmp2_ = _tmp1_.author;
#line 568 "../src/util/TweetUtils.vala"
		if (account_is_blocked (account, _tmp2_.id)) {
#line 569 "../src/util/TweetUtils.vala"
			cb_tweet_set_flag (t, (guint) CB_TWEET_STATE_HIDDEN_RETWEETER_BLOCKED);
#line 5656 "TweetUtils.c"
		}
#line 571 "../src/util/TweetUtils.vala"
		_tmp3_ = t->source_tweet;
#line 571 "../src/util/TweetUtils.vala"
		_tmp4_ = _tmp3_.author;
#line 571 "../src/util/TweetUtils.vala"
		if (account_is_muted (account, _tmp4_.id)) {
#line 572 "../src/util/TweetUtils.vala"
			cb_tweet_set_flag (t, (guint) CB_TWEET_STATE_HIDDEN_RETWEETER_MUTED);
#line 5666 "TweetUtils.c"
		}
#line 574 "../src/util/TweetUtils.vala"
		_tmp5_ = t->retweeted_tweet;
#line 574 "../src/util/TweetUtils.vala"
		_tmp6_ = (*_tmp5_).author;
#line 574 "../src/util/TweetUtils.vala"
		if (account_is_blocked (account, _tmp6_.id)) {
#line 575 "../src/util/TweetUtils.vala"
			cb_tweet_set_flag (t, (guint) CB_TWEET_STATE_HIDDEN_AUTHOR_BLOCKED);
#line 5676 "TweetUtils.c"
		}
#line 577 "../src/util/TweetUtils.vala"
		_tmp7_ = t->retweeted_tweet;
#line 577 "../src/util/TweetUtils.vala"
		_tmp8_ = (*_tmp7_).author;
#line 577 "../src/util/TweetUtils.vala"
		if (account_is_muted (account, _tmp8_.id)) {
#line 578 "../src/util/TweetUtils.vala"
			cb_tweet_set_flag (t, (guint) CB_TWEET_STATE_HIDDEN_AUTHOR_MUTED);
#line 5686 "TweetUtils.c"
		}
#line 580 "../src/util/TweetUtils.vala"
		_tmp9_ = t->source_tweet;
#line 580 "../src/util/TweetUtils.vala"
		_tmp10_ = _tmp9_.author;
#line 580 "../src/util/TweetUtils.vala"
		if (account_disabled_rts_for (account, _tmp10_.id)) {
#line 581 "../src/util/TweetUtils.vala"
			cb_tweet_set_flag (t, (guint) CB_TWEET_STATE_HIDDEN_RTS_DISABLED);
#line 5696 "TweetUtils.c"
		}
	} else {
		CbMiniTweet _tmp11_;
		CbUserIdentity _tmp12_;
		CbMiniTweet _tmp13_;
		CbUserIdentity _tmp14_;
#line 585 "../src/util/TweetUtils.vala"
		_tmp11_ = t->source_tweet;
#line 585 "../src/util/TweetUtils.vala"
		_tmp12_ = _tmp11_.author;
#line 585 "../src/util/TweetUtils.vala"
		if (account_is_blocked (account, _tmp12_.id)) {
#line 586 "../src/util/TweetUtils.vala"
			cb_tweet_set_flag (t, (guint) CB_TWEET_STATE_HIDDEN_AUTHOR_BLOCKED);
#line 5711 "TweetUtils.c"
		}
#line 588 "../src/util/TweetUtils.vala"
		_tmp13_ = t->source_tweet;
#line 588 "../src/util/TweetUtils.vala"
		_tmp14_ = _tmp13_.author;
#line 588 "../src/util/TweetUtils.vala"
		if (account_is_muted (account, _tmp14_.id)) {
#line 589 "../src/util/TweetUtils.vala"
			cb_tweet_set_flag (t, (guint) CB_TWEET_STATE_HIDDEN_AUTHOR_MUTED);
#line 5721 "TweetUtils.c"
		}
	}
}

static void
tweet_utils_search_for_tweets_data_free (gpointer _data)
{
	TweetUtilsSearchForTweetsData* _data_;
	_data_ = _data;
	_g_free0 (_data_->search_query);
	_g_object_unref0 (_data_->cancellable);
	_data_->result = (_vala_array_free (_data_->result, _data_->result_length1, (GDestroyNotify) g_object_unref), NULL);
	g_slice_free (TweetUtilsSearchForTweetsData, _data_);
}

void
tweet_utils_search_for_tweets (Account* account,
                               const gchar* search_query,
                               gint64 max_id,
                               gint64 since_id,
                               guint count,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	TweetUtilsSearchForTweetsData* _data_;
	Account* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
	g_return_if_fail (account != NULL);
	g_return_if_fail (search_query != NULL);
	_data_ = g_slice_new0 (TweetUtilsSearchForTweetsData);
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tweet_utils_search_for_tweets_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_tmp1_ = g_strdup (search_query);
	_g_free0 (_data_->search_query);
	_data_->search_query = _tmp1_;
	_data_->max_id = max_id;
	_data_->since_id = since_id;
	_data_->count = count;
	_tmp2_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp2_;
	tweet_utils_search_for_tweets_co (_data_);
}

CbTweet**
tweet_utils_search_for_tweets_finish (GAsyncResult* _res_,
                                      gint* result_length1,
                                      GError** error)
{
	CbTweet** result;
	TweetUtilsSearchForTweetsData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	*result_length1 = _data_->result_length1;
	_data_->result = NULL;
	return result;
}

static Block69Data*
block69_data_ref (Block69Data* _data69_)
{
#line 594 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data69_->_ref_count_);
#line 594 "../src/util/TweetUtils.vala"
	return _data69_;
#line 5795 "TweetUtils.c"
}

static void
block69_data_unref (void * _userdata_)
{
	Block69Data* _data69_;
	_data69_ = (Block69Data*) _userdata_;
#line 594 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data69_->_ref_count_)) {
#line 594 "../src/util/TweetUtils.vala"
		_g_date_time_unref0 (_data69_->now);
#line 594 "../src/util/TweetUtils.vala"
		_data69_->tweets = (_vala_array_free (_data69_->tweets, _data69_->tweets_length1, (GDestroyNotify) g_object_unref), NULL);
#line 594 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data69_->account);
#line 594 "../src/util/TweetUtils.vala"
		g_slice_free (Block69Data, _data69_);
#line 5813 "TweetUtils.c"
	}
}

static void
tweet_utils_search_for_tweets_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	TweetUtilsSearchForTweetsData* _data_;
#line 595 "../src/util/TweetUtils.vala"
	_data_ = _user_data_;
#line 595 "../src/util/TweetUtils.vala"
	_data_->_source_object_ = source_object;
#line 595 "../src/util/TweetUtils.vala"
	_data_->_res_ = _res_;
#line 595 "../src/util/TweetUtils.vala"
	tweet_utils_search_for_tweets_co (_data_);
#line 5831 "TweetUtils.c"
}

static void
_vala_array_add3 (CbTweet** * array,
                  gint* length,
                  gint* size,
                  CbTweet* value)
{
#line 603 "../src/util/TweetUtils.vala"
	if ((*length) == (*size)) {
#line 603 "../src/util/TweetUtils.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 603 "../src/util/TweetUtils.vala"
		*array = g_renew (CbTweet*, *array, (*size) + 1);
#line 5846 "TweetUtils.c"
	}
#line 603 "../src/util/TweetUtils.vala"
	(*array)[(*length)++] = value;
#line 603 "../src/util/TweetUtils.vala"
	(*array)[*length] = NULL;
#line 5852 "TweetUtils.c"
}

static void
__lambda206_ (Block69Data* _data69_,
              JsonNode* node)
{
	CbTweet* tweet = NULL;
	CbTweet* _tmp0_;
	GDateTime* _tmp1_;
	CbTweet* _tmp2_;
#line 599 "../src/util/TweetUtils.vala"
	g_return_if_fail (node != NULL);
#line 600 "../src/util/TweetUtils.vala"
	_tmp0_ = cb_tweet_new ();
#line 600 "../src/util/TweetUtils.vala"
	tweet = _tmp0_;
#line 601 "../src/util/TweetUtils.vala"
	_tmp1_ = _data69_->now;
#line 601 "../src/util/TweetUtils.vala"
	cb_tweet_load_from_json (tweet, node, _data69_->account->id, _tmp1_);
#line 602 "../src/util/TweetUtils.vala"
	tweet_utils_set_tweet_hidden_flags (tweet, _data69_->account);
#line 603 "../src/util/TweetUtils.vala"
	_tmp2_ = _g_object_ref0 (tweet);
#line 603 "../src/util/TweetUtils.vala"
	_vala_array_add3 (&_data69_->tweets, &_data69_->tweets_length1, &_data69_->_tweets_size_, _tmp2_);
#line 599 "../src/util/TweetUtils.vala"
	_g_object_unref0 (tweet);
#line 5881 "TweetUtils.c"
}

static void
___lambda206__gfunc (gconstpointer data,
                     gpointer self)
{
#line 599 "../src/util/TweetUtils.vala"
	__lambda206_ (self, (JsonNode*) data);
#line 5890 "TweetUtils.c"
}

static CbTweet**
_vala_array_dup13 (CbTweet** self,
                   gssize length)
{
#line 606 "../src/util/TweetUtils.vala"
	if (length >= 0) {
#line 5899 "TweetUtils.c"
		CbTweet** result;
		gssize i;
#line 606 "../src/util/TweetUtils.vala"
		result = g_new0 (CbTweet*, length + 1);
#line 606 "../src/util/TweetUtils.vala"
		for (i = 0; i < length; i++) {
#line 5906 "TweetUtils.c"
			CbTweet* _tmp0_;
#line 606 "../src/util/TweetUtils.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 606 "../src/util/TweetUtils.vala"
			result[i] = _tmp0_;
#line 5912 "TweetUtils.c"
		}
#line 606 "../src/util/TweetUtils.vala"
		return result;
#line 5916 "TweetUtils.c"
	}
#line 606 "../src/util/TweetUtils.vala"
	return NULL;
#line 5920 "TweetUtils.c"
}

static gboolean
tweet_utils_search_for_tweets_co (TweetUtilsSearchForTweetsData* _data_)
{
#line 594 "../src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 594 "../src/util/TweetUtils.vala"
		case 0:
#line 5930 "TweetUtils.c"
		goto _state_0;
#line 594 "../src/util/TweetUtils.vala"
		case 1:
#line 5934 "TweetUtils.c"
		goto _state_1;
		default:
#line 594 "../src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 5939 "TweetUtils.c"
	}
	_state_0:
#line 594 "../src/util/TweetUtils.vala"
	_data_->_data69_ = g_slice_new0 (Block69Data);
#line 594 "../src/util/TweetUtils.vala"
	_data_->_data69_->_ref_count_ = 1;
#line 594 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data69_->account);
#line 594 "../src/util/TweetUtils.vala"
	_data_->_data69_->account = _data_->account;
#line 594 "../src/util/TweetUtils.vala"
	_data_->_data69_->_async_data_ = _data_;
#line 595 "../src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 595 "../src/util/TweetUtils.vala"
	tweet_utils_search_for_tweets_json (_data_->_data69_->account, _data_->search_query, _data_->max_id, _data_->since_id, _data_->count, _data_->cancellable, tweet_utils_search_for_tweets_ready, _data_);
#line 595 "../src/util/TweetUtils.vala"
	return FALSE;
#line 5958 "TweetUtils.c"
	_state_1:
#line 595 "../src/util/TweetUtils.vala"
	_data_->_tmp0_ = tweet_utils_search_for_tweets_json_finish (_data_->_res_, &_data_->_inner_error0_);
#line 595 "../src/util/TweetUtils.vala"
	_data_->statuses = _data_->_tmp0_;
#line 595 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 595 "../src/util/TweetUtils.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 595 "../src/util/TweetUtils.vala"
		block69_data_unref (_data_->_data69_);
#line 595 "../src/util/TweetUtils.vala"
		_data_->_data69_ = NULL;
#line 595 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 595 "../src/util/TweetUtils.vala"
		return FALSE;
#line 5976 "TweetUtils.c"
	}
#line 596 "../src/util/TweetUtils.vala"
	_data_->_tmp1_ = g_new0 (CbTweet*, 0 + 1);
#line 596 "../src/util/TweetUtils.vala"
	_data_->_data69_->tweets = _data_->_tmp1_;
#line 596 "../src/util/TweetUtils.vala"
	_data_->_data69_->tweets_length1 = 0;
#line 596 "../src/util/TweetUtils.vala"
	_data_->_data69_->_tweets_size_ = _data_->_data69_->tweets_length1;
#line 597 "../src/util/TweetUtils.vala"
	_data_->_tmp2_ = g_date_time_new_now_local ();
#line 597 "../src/util/TweetUtils.vala"
	_data_->_data69_->now = _data_->_tmp2_;
#line 599 "../src/util/TweetUtils.vala"
	g_list_foreach (_data_->statuses, ___lambda206__gfunc, _data_->_data69_);
#line 606 "../src/util/TweetUtils.vala"
	_data_->_tmp3_ = _data_->_data69_->tweets;
#line 606 "../src/util/TweetUtils.vala"
	_data_->_tmp3__length1 = _data_->_data69_->tweets_length1;
#line 606 "../src/util/TweetUtils.vala"
	_data_->_tmp4_ = (_data_->_tmp3_ != NULL) ? _vala_array_dup13 (_data_->_tmp3_, _data_->_tmp3__length1) : _data_->_tmp3_;
#line 606 "../src/util/TweetUtils.vala"
	_data_->_tmp4__length1 = _data_->_tmp3__length1;
#line 606 "../src/util/TweetUtils.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 606 "../src/util/TweetUtils.vala"
	_data_->_tmp5__length1 = _data_->_tmp4__length1;
#line 606 "../src/util/TweetUtils.vala"
	_data_->result_length1 = _data_->_tmp5__length1;
#line 606 "../src/util/TweetUtils.vala"
	_data_->result = _data_->_tmp5_;
#line 606 "../src/util/TweetUtils.vala"
	(_data_->statuses == NULL) ? NULL : (_data_->statuses = (g_list_free (_data_->statuses), NULL));
#line 606 "../src/util/TweetUtils.vala"
	block69_data_unref (_data_->_data69_);
#line 606 "../src/util/TweetUtils.vala"
	_data_->_data69_ = NULL;
#line 606 "../src/util/TweetUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 606 "../src/util/TweetUtils.vala"
	if (_data_->_state_ != 0) {
#line 606 "../src/util/TweetUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 606 "../src/util/TweetUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6022 "TweetUtils.c"
		}
	}
#line 606 "../src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 606 "../src/util/TweetUtils.vala"
	return FALSE;
#line 6029 "TweetUtils.c"
}

void
tweet_utils_inject_tweet (const gchar* json,
                          Account* account)
{
	CbUserStream* _tmp0_;
#line 609 "../src/util/TweetUtils.vala"
	g_return_if_fail (json != NULL);
#line 609 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 610 "../src/util/TweetUtils.vala"
	_tmp0_ = account->user_stream;
#line 610 "../src/util/TweetUtils.vala"
	cb_user_stream_inject_tweet (_tmp0_, CB_STREAM_MESSAGE_TWEET, json);
#line 6045 "TweetUtils.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 6058 "TweetUtils.c"
}

void
tweet_utils_inject_user_action_json (const gchar* user_json,
                                     Account* account,
                                     CbStreamMessageType action)
{
	gchar* message = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	CbUserStream* _tmp2_;
#line 613 "../src/util/TweetUtils.vala"
	g_return_if_fail (user_json != NULL);
#line 613 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 614 "../src/util/TweetUtils.vala"
	_tmp0_ = string_to_string (user_json);
#line 614 "../src/util/TweetUtils.vala"
	_tmp1_ = g_strconcat ("{ \"target\": ", _tmp0_, " }", NULL);
#line 614 "../src/util/TweetUtils.vala"
	message = _tmp1_;
#line 615 "../src/util/TweetUtils.vala"
	_tmp2_ = account->user_stream;
#line 615 "../src/util/TweetUtils.vala"
	cb_user_stream_inject_tweet (_tmp2_, action, message);
#line 613 "../src/util/TweetUtils.vala"
	_g_free0 (message);
#line 6086 "TweetUtils.c"
}

void
tweet_utils_inject_user_action (gint64 user_id,
                                Account* account,
                                CbStreamMessageType action)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 618 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 619 "../src/util/TweetUtils.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, user_id);
#line 619 "../src/util/TweetUtils.vala"
	_tmp1_ = _tmp0_;
#line 619 "../src/util/TweetUtils.vala"
	_tmp2_ = g_strconcat ("{ \"id\":", _tmp1_, " }", NULL);
#line 619 "../src/util/TweetUtils.vala"
	_tmp3_ = _tmp2_;
#line 619 "../src/util/TweetUtils.vala"
	tweet_utils_inject_user_action_json (_tmp3_, account, action);
#line 619 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp3_);
#line 619 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp1_);
#line 6114 "TweetUtils.c"
}

void
tweet_utils_inject_user_mute (const gchar* user_json,
                              Account* account)
{
#line 622 "../src/util/TweetUtils.vala"
	g_return_if_fail (user_json != NULL);
#line 622 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 623 "../src/util/TweetUtils.vala"
	tweet_utils_inject_user_action_json (user_json, account, CB_STREAM_MESSAGE_EVENT_MUTE);
#line 6127 "TweetUtils.c"
}

void
tweet_utils_inject_user_unmute (const gchar* user_json,
                                Account* account)
{
#line 626 "../src/util/TweetUtils.vala"
	g_return_if_fail (user_json != NULL);
#line 626 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 627 "../src/util/TweetUtils.vala"
	tweet_utils_inject_user_action_json (user_json, account, CB_STREAM_MESSAGE_EVENT_UNMUTE);
#line 6140 "TweetUtils.c"
}

void
tweet_utils_inject_user_block (const gchar* user_json,
                               Account* account)
{
#line 630 "../src/util/TweetUtils.vala"
	g_return_if_fail (user_json != NULL);
#line 630 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 631 "../src/util/TweetUtils.vala"
	tweet_utils_inject_user_action_json (user_json, account, CB_STREAM_MESSAGE_EVENT_BLOCK);
#line 6153 "TweetUtils.c"
}

void
tweet_utils_inject_user_unblock (const gchar* user_json,
                                 Account* account)
{
#line 634 "../src/util/TweetUtils.vala"
	g_return_if_fail (user_json != NULL);
#line 634 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 635 "../src/util/TweetUtils.vala"
	tweet_utils_inject_user_action_json (user_json, account, CB_STREAM_MESSAGE_EVENT_UNBLOCK);
#line 6166 "TweetUtils.c"
}

void
tweet_utils_inject_user_follow (gint64 user_id,
                                Account* account)
{
#line 638 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 639 "../src/util/TweetUtils.vala"
	tweet_utils_inject_user_action (user_id, account, CB_STREAM_MESSAGE_EVENT_FOLLOW);
#line 6177 "TweetUtils.c"
}

void
tweet_utils_inject_user_unfollow (gint64 user_id,
                                  Account* account)
{
#line 642 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 643 "../src/util/TweetUtils.vala"
	tweet_utils_inject_user_action (user_id, account, CB_STREAM_MESSAGE_EVENT_UNFOLLOW);
#line 6188 "TweetUtils.c"
}

void
tweet_utils_inject_user_hide_rts (gint64 user_id,
                                  Account* account)
{
#line 646 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 647 "../src/util/TweetUtils.vala"
	tweet_utils_inject_user_action (user_id, account, CB_STREAM_MESSAGE_EVENT_HIDE_RTS);
#line 6199 "TweetUtils.c"
}

void
tweet_utils_inject_user_show_rts (gint64 user_id,
                                  Account* account)
{
#line 650 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 651 "../src/util/TweetUtils.vala"
	tweet_utils_inject_user_action (user_id, account, CB_STREAM_MESSAGE_EVENT_SHOW_RTS);
#line 6210 "TweetUtils.c"
}

void
tweet_utils_inject_deletion (gint64 id,
                             Account* account)
{
	gchar* message = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	CbUserStream* _tmp10_;
#line 654 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 655 "../src/util/TweetUtils.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
#line 655 "../src/util/TweetUtils.vala"
	_tmp1_ = _tmp0_;
#line 655 "../src/util/TweetUtils.vala"
	_tmp2_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
#line 655 "../src/util/TweetUtils.vala"
	_tmp3_ = _tmp2_;
#line 655 "../src/util/TweetUtils.vala"
	_tmp4_ = g_strdup_printf ("%" G_GINT64_FORMAT, account->id);
#line 655 "../src/util/TweetUtils.vala"
	_tmp5_ = _tmp4_;
#line 655 "../src/util/TweetUtils.vala"
	_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, account->id);
#line 655 "../src/util/TweetUtils.vala"
	_tmp7_ = _tmp6_;
#line 655 "../src/util/TweetUtils.vala"
	_tmp8_ = g_strconcat ("{ \"delete\":{ \"status\":{ \"id\":", _tmp1_, ", \"id_str\":\"", _tmp3_, "\", \"user_id\":", _tmp5_, ", \"user_id_str\":\"", _tmp7_, "\" } } }", NULL);
#line 655 "../src/util/TweetUtils.vala"
	_tmp9_ = _tmp8_;
#line 655 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp7_);
#line 655 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp5_);
#line 655 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp3_);
#line 655 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp1_);
#line 655 "../src/util/TweetUtils.vala"
	message = _tmp9_;
#line 656 "../src/util/TweetUtils.vala"
	_tmp10_ = account->user_stream;
#line 656 "../src/util/TweetUtils.vala"
	cb_user_stream_inject_tweet (_tmp10_, CB_STREAM_MESSAGE_DELETE, message);
#line 654 "../src/util/TweetUtils.vala"
	_g_free0 (message);
#line 6267 "TweetUtils.c"
}

static inline gpointer
tweet_utils_upload_progress_get_instance_private (TweetUtilsUploadProgress* self)
{
	return G_STRUCT_MEMBER_P (self, TweetUtilsUploadProgress_private_offset);
}

TweetUtilsUploadProgress*
tweet_utils_upload_progress_construct (GType object_type,
                                       MediaUpload* media_upload,
                                       gint64 filesize,
                                       gsize total_uploaded,
                                       TweetUtilsUploadMediaCallback callback,
                                       gpointer callback_target)
{
	TweetUtilsUploadProgress* self = NULL;
	MediaUpload* _tmp0_;
#line 667 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (media_upload != NULL, NULL);
#line 667 "../src/util/TweetUtils.vala"
	self = (TweetUtilsUploadProgress*) g_type_create_instance (object_type);
#line 668 "../src/util/TweetUtils.vala"
	_tmp0_ = _g_object_ref0 (media_upload);
#line 668 "../src/util/TweetUtils.vala"
	_g_object_unref0 (self->priv->_upload);
#line 668 "../src/util/TweetUtils.vala"
	self->priv->_upload = _tmp0_;
#line 669 "../src/util/TweetUtils.vala"
	self->priv->_filesize = (gdouble) filesize;
#line 670 "../src/util/TweetUtils.vala"
	self->priv->_total_uploaded = (gdouble) total_uploaded;
#line 671 "../src/util/TweetUtils.vala"
	(self->priv->_cb_target_destroy_notify == NULL) ? NULL : (self->priv->_cb_target_destroy_notify (self->priv->_cb_target), NULL);
#line 671 "../src/util/TweetUtils.vala"
	self->priv->_cb = NULL;
#line 671 "../src/util/TweetUtils.vala"
	self->priv->_cb_target = NULL;
#line 671 "../src/util/TweetUtils.vala"
	self->priv->_cb_target_destroy_notify = NULL;
#line 671 "../src/util/TweetUtils.vala"
	self->priv->_cb = callback;
#line 671 "../src/util/TweetUtils.vala"
	self->priv->_cb_target = callback_target;
#line 671 "../src/util/TweetUtils.vala"
	self->priv->_cb_target_destroy_notify = NULL;
#line 667 "../src/util/TweetUtils.vala"
	return self;
#line 6316 "TweetUtils.c"
}

TweetUtilsUploadProgress*
tweet_utils_upload_progress_new (MediaUpload* media_upload,
                                 gint64 filesize,
                                 gsize total_uploaded,
                                 TweetUtilsUploadMediaCallback callback,
                                 gpointer callback_target)
{
#line 667 "../src/util/TweetUtils.vala"
	return tweet_utils_upload_progress_construct (TWEET_UTILS_TYPE_UPLOAD_PROGRESS, media_upload, filesize, total_uploaded, callback, callback_target);
#line 6328 "TweetUtils.c"
}

void
tweet_utils_upload_progress_callback (TweetUtilsUploadProgress* self,
                                      RestProxyCall* call,
                                      gsize total,
                                      gsize uploaded,
                                      GError* _error_,
                                      GObject* weak_object)
{
	MediaUpload* _tmp3_;
#line 674 "../src/util/TweetUtils.vala"
	g_return_if_fail (self != NULL);
#line 674 "../src/util/TweetUtils.vala"
	g_return_if_fail (call != NULL);
#line 675 "../src/util/TweetUtils.vala"
	if (_error_ != NULL) {
#line 6346 "TweetUtils.c"
		const gchar* _tmp0_;
		MediaUpload* _tmp1_;
		TweetUtilsUploadMediaCallback _tmp2_;
		gpointer _tmp2__target;
#line 676 "../src/util/TweetUtils.vala"
		_tmp0_ = _error_->message;
#line 676 "../src/util/TweetUtils.vala"
		g_warning ("TweetUtils.vala:676: Upload error: %s", _tmp0_);
#line 677 "../src/util/TweetUtils.vala"
		_tmp1_ = self->priv->_upload;
#line 677 "../src/util/TweetUtils.vala"
		g_signal_emit_by_name (_tmp1_, "progress-complete", _error_);
#line 678 "../src/util/TweetUtils.vala"
		_tmp2_ = self->priv->_cb;
#line 678 "../src/util/TweetUtils.vala"
		_tmp2__target = self->priv->_cb_target;
#line 678 "../src/util/TweetUtils.vala"
		_tmp2_ (_tmp2__target);
#line 679 "../src/util/TweetUtils.vala"
		return;
#line 6367 "TweetUtils.c"
	}
#line 682 "../src/util/TweetUtils.vala"
	_tmp3_ = self->priv->_upload;
#line 682 "../src/util/TweetUtils.vala"
	media_upload_set_progress (_tmp3_, (self->priv->_total_uploaded + uploaded) / self->priv->_filesize);
#line 684 "../src/util/TweetUtils.vala"
	if (total == uploaded) {
#line 6375 "TweetUtils.c"
		TweetUtilsUploadMediaCallback _tmp4_;
		gpointer _tmp4__target;
#line 685 "../src/util/TweetUtils.vala"
		_tmp4_ = self->priv->_cb;
#line 685 "../src/util/TweetUtils.vala"
		_tmp4__target = self->priv->_cb_target;
#line 685 "../src/util/TweetUtils.vala"
		_tmp4_ (_tmp4__target);
#line 686 "../src/util/TweetUtils.vala"
		return;
#line 6386 "TweetUtils.c"
	}
}

static void
tweet_utils_value_upload_progress_init (GValue* value)
{
#line 661 "../src/util/TweetUtils.vala"
	value->data[0].v_pointer = NULL;
#line 6395 "TweetUtils.c"
}

static void
tweet_utils_value_upload_progress_free_value (GValue* value)
{
#line 661 "../src/util/TweetUtils.vala"
	if (value->data[0].v_pointer) {
#line 661 "../src/util/TweetUtils.vala"
		tweet_utils_upload_progress_unref (value->data[0].v_pointer);
#line 6405 "TweetUtils.c"
	}
}

static void
tweet_utils_value_upload_progress_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
#line 661 "../src/util/TweetUtils.vala"
	if (src_value->data[0].v_pointer) {
#line 661 "../src/util/TweetUtils.vala"
		dest_value->data[0].v_pointer = tweet_utils_upload_progress_ref (src_value->data[0].v_pointer);
#line 6417 "TweetUtils.c"
	} else {
#line 661 "../src/util/TweetUtils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6421 "TweetUtils.c"
	}
}

static gpointer
tweet_utils_value_upload_progress_peek_pointer (const GValue* value)
{
#line 661 "../src/util/TweetUtils.vala"
	return value->data[0].v_pointer;
#line 6430 "TweetUtils.c"
}

static gchar*
tweet_utils_value_upload_progress_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
#line 661 "../src/util/TweetUtils.vala"
	if (collect_values[0].v_pointer) {
#line 6441 "TweetUtils.c"
		TweetUtilsUploadProgress * object;
		object = collect_values[0].v_pointer;
#line 661 "../src/util/TweetUtils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 661 "../src/util/TweetUtils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6448 "TweetUtils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 661 "../src/util/TweetUtils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6452 "TweetUtils.c"
		}
#line 661 "../src/util/TweetUtils.vala"
		value->data[0].v_pointer = tweet_utils_upload_progress_ref (object);
#line 6456 "TweetUtils.c"
	} else {
#line 661 "../src/util/TweetUtils.vala"
		value->data[0].v_pointer = NULL;
#line 6460 "TweetUtils.c"
	}
#line 661 "../src/util/TweetUtils.vala"
	return NULL;
#line 6464 "TweetUtils.c"
}

static gchar*
tweet_utils_value_upload_progress_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	TweetUtilsUploadProgress ** object_p;
	object_p = collect_values[0].v_pointer;
#line 661 "../src/util/TweetUtils.vala"
	if (!object_p) {
#line 661 "../src/util/TweetUtils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 6479 "TweetUtils.c"
	}
#line 661 "../src/util/TweetUtils.vala"
	if (!value->data[0].v_pointer) {
#line 661 "../src/util/TweetUtils.vala"
		*object_p = NULL;
#line 6485 "TweetUtils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 661 "../src/util/TweetUtils.vala"
		*object_p = value->data[0].v_pointer;
#line 6489 "TweetUtils.c"
	} else {
#line 661 "../src/util/TweetUtils.vala"
		*object_p = tweet_utils_upload_progress_ref (value->data[0].v_pointer);
#line 6493 "TweetUtils.c"
	}
#line 661 "../src/util/TweetUtils.vala"
	return NULL;
#line 6497 "TweetUtils.c"
}

GParamSpec*
tweet_utils_param_spec_upload_progress (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	TweetUtilsParamSpecUploadProgress* spec;
#line 661 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TWEET_UTILS_TYPE_UPLOAD_PROGRESS), NULL);
#line 661 "../src/util/TweetUtils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 661 "../src/util/TweetUtils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 661 "../src/util/TweetUtils.vala"
	return G_PARAM_SPEC (spec);
#line 6516 "TweetUtils.c"
}

gpointer
tweet_utils_value_get_upload_progress (const GValue* value)
{
#line 661 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TWEET_UTILS_TYPE_UPLOAD_PROGRESS), NULL);
#line 661 "../src/util/TweetUtils.vala"
	return value->data[0].v_pointer;
#line 6526 "TweetUtils.c"
}

void
tweet_utils_value_set_upload_progress (GValue* value,
                                       gpointer v_object)
{
	TweetUtilsUploadProgress * old;
#line 661 "../src/util/TweetUtils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TWEET_UTILS_TYPE_UPLOAD_PROGRESS));
#line 661 "../src/util/TweetUtils.vala"
	old = value->data[0].v_pointer;
#line 661 "../src/util/TweetUtils.vala"
	if (v_object) {
#line 661 "../src/util/TweetUtils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TWEET_UTILS_TYPE_UPLOAD_PROGRESS));
#line 661 "../src/util/TweetUtils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 661 "../src/util/TweetUtils.vala"
		value->data[0].v_pointer = v_object;
#line 661 "../src/util/TweetUtils.vala"
		tweet_utils_upload_progress_ref (value->data[0].v_pointer);
#line 6548 "TweetUtils.c"
	} else {
#line 661 "../src/util/TweetUtils.vala"
		value->data[0].v_pointer = NULL;
#line 6552 "TweetUtils.c"
	}
#line 661 "../src/util/TweetUtils.vala"
	if (old) {
#line 661 "../src/util/TweetUtils.vala"
		tweet_utils_upload_progress_unref (old);
#line 6558 "TweetUtils.c"
	}
}

void
tweet_utils_value_take_upload_progress (GValue* value,
                                        gpointer v_object)
{
	TweetUtilsUploadProgress * old;
#line 661 "../src/util/TweetUtils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TWEET_UTILS_TYPE_UPLOAD_PROGRESS));
#line 661 "../src/util/TweetUtils.vala"
	old = value->data[0].v_pointer;
#line 661 "../src/util/TweetUtils.vala"
	if (v_object) {
#line 661 "../src/util/TweetUtils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TWEET_UTILS_TYPE_UPLOAD_PROGRESS));
#line 661 "../src/util/TweetUtils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 661 "../src/util/TweetUtils.vala"
		value->data[0].v_pointer = v_object;
#line 6579 "TweetUtils.c"
	} else {
#line 661 "../src/util/TweetUtils.vala"
		value->data[0].v_pointer = NULL;
#line 6583 "TweetUtils.c"
	}
#line 661 "../src/util/TweetUtils.vala"
	if (old) {
#line 661 "../src/util/TweetUtils.vala"
		tweet_utils_upload_progress_unref (old);
#line 6589 "TweetUtils.c"
	}
}

static void
tweet_utils_upload_progress_class_init (TweetUtilsUploadProgressClass * klass,
                                        gpointer klass_data)
{
#line 661 "../src/util/TweetUtils.vala"
	tweet_utils_upload_progress_parent_class = g_type_class_peek_parent (klass);
#line 661 "../src/util/TweetUtils.vala"
	((TweetUtilsUploadProgressClass *) klass)->finalize = tweet_utils_upload_progress_finalize;
#line 661 "../src/util/TweetUtils.vala"
	g_type_class_adjust_private_offset (klass, &TweetUtilsUploadProgress_private_offset);
#line 6603 "TweetUtils.c"
}

static void
tweet_utils_upload_progress_instance_init (TweetUtilsUploadProgress * self,
                                           gpointer klass)
{
#line 661 "../src/util/TweetUtils.vala"
	self->priv = tweet_utils_upload_progress_get_instance_private (self);
#line 661 "../src/util/TweetUtils.vala"
	self->ref_count = 1;
#line 6614 "TweetUtils.c"
}

static void
tweet_utils_upload_progress_finalize (TweetUtilsUploadProgress * obj)
{
	TweetUtilsUploadProgress * self;
#line 661 "../src/util/TweetUtils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TWEET_UTILS_TYPE_UPLOAD_PROGRESS, TweetUtilsUploadProgress);
#line 661 "../src/util/TweetUtils.vala"
	g_signal_handlers_destroy (self);
#line 662 "../src/util/TweetUtils.vala"
	_g_object_unref0 (self->priv->_upload);
#line 665 "../src/util/TweetUtils.vala"
	(self->priv->_cb_target_destroy_notify == NULL) ? NULL : (self->priv->_cb_target_destroy_notify (self->priv->_cb_target), NULL);
#line 665 "../src/util/TweetUtils.vala"
	self->priv->_cb = NULL;
#line 665 "../src/util/TweetUtils.vala"
	self->priv->_cb_target = NULL;
#line 665 "../src/util/TweetUtils.vala"
	self->priv->_cb_target_destroy_notify = NULL;
#line 6635 "TweetUtils.c"
}

static GType
tweet_utils_upload_progress_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { tweet_utils_value_upload_progress_init, tweet_utils_value_upload_progress_free_value, tweet_utils_value_upload_progress_copy_value, tweet_utils_value_upload_progress_peek_pointer, "p", tweet_utils_value_upload_progress_collect_value, "p", tweet_utils_value_upload_progress_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TweetUtilsUploadProgressClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tweet_utils_upload_progress_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TweetUtilsUploadProgress), 0, (GInstanceInitFunc) tweet_utils_upload_progress_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType tweet_utils_upload_progress_type_id;
	tweet_utils_upload_progress_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TweetUtilsUploadProgress", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TweetUtilsUploadProgress_private_offset = g_type_add_instance_private (tweet_utils_upload_progress_type_id, sizeof (TweetUtilsUploadProgressPrivate));
	return tweet_utils_upload_progress_type_id;
}

GType
tweet_utils_upload_progress_get_type (void)
{
	static volatile gsize tweet_utils_upload_progress_type_id__once = 0;
	if (g_once_init_enter (&tweet_utils_upload_progress_type_id__once)) {
		GType tweet_utils_upload_progress_type_id;
		tweet_utils_upload_progress_type_id = tweet_utils_upload_progress_get_type_once ();
		g_once_init_leave (&tweet_utils_upload_progress_type_id__once, tweet_utils_upload_progress_type_id);
	}
	return tweet_utils_upload_progress_type_id__once;
}

gpointer
tweet_utils_upload_progress_ref (gpointer instance)
{
	TweetUtilsUploadProgress * self;
	self = instance;
#line 661 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 661 "../src/util/TweetUtils.vala"
	return instance;
#line 6671 "TweetUtils.c"
}

void
tweet_utils_upload_progress_unref (gpointer instance)
{
	TweetUtilsUploadProgress * self;
	self = instance;
#line 661 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 661 "../src/util/TweetUtils.vala"
		TWEET_UTILS_UPLOAD_PROGRESS_GET_CLASS (self)->finalize (self);
#line 661 "../src/util/TweetUtils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 6685 "TweetUtils.c"
	}
}

static void
tweet_utils_upload_media_data_free (gpointer _data)
{
	TweetUtilsUploadMediaData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->media_upload);
	_g_object_unref0 (_data_->account);
	_g_object_unref0 (_data_->cancellable);
	g_slice_free (TweetUtilsUploadMediaData, _data_);
}

void
tweet_utils_upload_media (MediaUpload* media_upload,
                          Account* account,
                          GCancellable* cancellable,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	TweetUtilsUploadMediaData* _data_;
	MediaUpload* _tmp0_;
	Account* _tmp1_;
	GCancellable* _tmp2_;
	g_return_if_fail (media_upload != NULL);
	g_return_if_fail (account != NULL);
	_data_ = g_slice_new0 (TweetUtilsUploadMediaData);
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tweet_utils_upload_media_data_free);
	_tmp0_ = _g_object_ref0 (media_upload);
	_g_object_unref0 (_data_->media_upload);
	_data_->media_upload = _tmp0_;
	_tmp1_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp1_;
	_tmp2_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp2_;
	tweet_utils_upload_media_co (_data_);
}

gboolean
tweet_utils_upload_media_finish (GAsyncResult* _res_)
{
	gboolean result;
	TweetUtilsUploadMediaData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	if (NULL == _data_) {
		gboolean _tmp0_ = FALSE;
		return _tmp0_;
	}
	result = _data_->result;
	return result;
}

static Block70Data*
block70_data_ref (Block70Data* _data70_)
{
#line 691 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data70_->_ref_count_);
#line 691 "../src/util/TweetUtils.vala"
	return _data70_;
#line 6749 "TweetUtils.c"
}

static void
block70_data_unref (void * _userdata_)
{
	Block70Data* _data70_;
	_data70_ = (Block70Data*) _userdata_;
#line 691 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data70_->_ref_count_)) {
#line 691 "../src/util/TweetUtils.vala"
		g_slice_free (Block70Data, _data70_);
#line 6761 "TweetUtils.c"
	}
}

static void
tweet_utils_upload_media_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	TweetUtilsUploadMediaData* _data_;
#line 707 "../src/util/TweetUtils.vala"
	_data_ = _user_data_;
#line 707 "../src/util/TweetUtils.vala"
	_data_->_source_object_ = source_object;
#line 707 "../src/util/TweetUtils.vala"
	_data_->_res_ = _res_;
#line 707 "../src/util/TweetUtils.vala"
	tweet_utils_upload_media_co (_data_);
#line 6779 "TweetUtils.c"
}

static gpointer
_rest_param_ref0 (gpointer self)
{
#line 749 "../src/util/TweetUtils.vala"
	return self ? rest_param_ref (self) : NULL;
#line 6787 "TweetUtils.c"
}

static gboolean
_tweet_utils_upload_media_co_tweet_utils_upload_media_callback (gpointer self)
{
	gboolean result;
	result = tweet_utils_upload_media_co (self);
#line 754 "../src/util/TweetUtils.vala"
	return result;
#line 6797 "TweetUtils.c"
}

static void
_tweet_utils_upload_progress_callback_rest_proxy_call_upload_callback (RestProxyCall* call,
                                                                       gsize total,
                                                                       gsize uploaded,
                                                                       GError* _error_,
                                                                       GObject* weak_object,
                                                                       gpointer self)
{
#line 755 "../src/util/TweetUtils.vala"
	tweet_utils_upload_progress_callback ((TweetUtilsUploadProgress*) self, call, total, uploaded, _error_, weak_object);
#line 6810 "TweetUtils.c"
}

static gboolean
_____lambda71_ (Block70Data* _data70_)
{
	gboolean result;
#line 821 "../src/util/TweetUtils.vala"
	tweet_utils_upload_media_co (_data70_->_async_data_);
#line 822 "../src/util/TweetUtils.vala"
	result = FALSE;
#line 822 "../src/util/TweetUtils.vala"
	return result;
#line 6823 "TweetUtils.c"
}

static gboolean
______lambda71__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda71_ (self);
#line 820 "../src/util/TweetUtils.vala"
	return result;
#line 6833 "TweetUtils.c"
}

static gboolean
tweet_utils_upload_media_co (TweetUtilsUploadMediaData* _data_)
{
#line 691 "../src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 691 "../src/util/TweetUtils.vala"
		case 0:
#line 6843 "TweetUtils.c"
		goto _state_0;
#line 691 "../src/util/TweetUtils.vala"
		case 1:
#line 6847 "TweetUtils.c"
		goto _state_1;
#line 691 "../src/util/TweetUtils.vala"
		case 2:
#line 6851 "TweetUtils.c"
		goto _state_2;
#line 691 "../src/util/TweetUtils.vala"
		case 3:
#line 6855 "TweetUtils.c"
		goto _state_3;
#line 691 "../src/util/TweetUtils.vala"
		case 4:
#line 6859 "TweetUtils.c"
		goto _state_4;
#line 691 "../src/util/TweetUtils.vala"
		case 5:
#line 6863 "TweetUtils.c"
		goto _state_5;
		default:
#line 691 "../src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 6868 "TweetUtils.c"
	}
	_state_0:
#line 691 "../src/util/TweetUtils.vala"
	_data_->_data70_ = g_slice_new0 (Block70Data);
#line 691 "../src/util/TweetUtils.vala"
	_data_->_data70_->_ref_count_ = 1;
#line 691 "../src/util/TweetUtils.vala"
	_data_->_data70_->_async_data_ = _data_;
#line 692 "../src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->account->proxy;
#line 692 "../src/util/TweetUtils.vala"
	g_object_get (_data_->_tmp0_, "consumer-key", &_data_->_tmp1_, NULL);
#line 692 "../src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 692 "../src/util/TweetUtils.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 692 "../src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->account->proxy;
#line 692 "../src/util/TweetUtils.vala"
	g_object_get (_data_->_tmp4_, "consumer-secret", &_data_->_tmp5_, NULL);
#line 692 "../src/util/TweetUtils.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 692 "../src/util/TweetUtils.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 692 "../src/util/TweetUtils.vala"
	_data_->_tmp8_ = (OAuthProxy*) oauth_proxy_new (_data_->_tmp3_, _data_->_tmp7_, "https://upload.twitter.com/", FALSE);
#line 692 "../src/util/TweetUtils.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 692 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp7_);
#line 692 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp3_);
#line 692 "../src/util/TweetUtils.vala"
	_data_->upload_proxy = _data_->_tmp9_;
#line 696 "../src/util/TweetUtils.vala"
	_data_->_tmp10_ = _data_->upload_proxy;
#line 696 "../src/util/TweetUtils.vala"
	_data_->_tmp11_ = _data_->account->proxy;
#line 696 "../src/util/TweetUtils.vala"
	_data_->_tmp12_ = oauth_proxy_get_token (_data_->_tmp11_);
#line 696 "../src/util/TweetUtils.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 696 "../src/util/TweetUtils.vala"
	oauth_proxy_set_token (_data_->_tmp10_, _data_->_tmp13_);
#line 697 "../src/util/TweetUtils.vala"
	_data_->_tmp14_ = _data_->upload_proxy;
#line 697 "../src/util/TweetUtils.vala"
	_data_->_tmp15_ = _data_->account->proxy;
#line 697 "../src/util/TweetUtils.vala"
	_data_->_tmp16_ = oauth_proxy_get_token_secret (_data_->_tmp15_);
#line 697 "../src/util/TweetUtils.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 697 "../src/util/TweetUtils.vala"
	oauth_proxy_set_token_secret (_data_->_tmp14_, _data_->_tmp17_);
#line 698 "../src/util/TweetUtils.vala"
	_data_->_tmp18_ = _data_->upload_proxy;
#line 698 "../src/util/TweetUtils.vala"
	_data_->_tmp19_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp18_);
#line 698 "../src/util/TweetUtils.vala"
	_data_->init_call = _data_->_tmp19_;
#line 699 "../src/util/TweetUtils.vala"
	_data_->_tmp20_ = _data_->init_call;
#line 699 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_function (_data_->_tmp20_, "1.1/media/upload.json");
#line 700 "../src/util/TweetUtils.vala"
	_data_->_tmp21_ = _data_->init_call;
#line 700 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_tmp21_, "POST");
#line 701 "../src/util/TweetUtils.vala"
	_data_->_tmp22_ = _data_->init_call;
#line 701 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp22_, "command", "INIT");
#line 702 "../src/util/TweetUtils.vala"
	_data_->_tmp23_ = _data_->init_call;
#line 702 "../src/util/TweetUtils.vala"
	_data_->_tmp24_ = media_upload_get_filesize (_data_->media_upload);
#line 702 "../src/util/TweetUtils.vala"
	_data_->_tmp25_ = _data_->_tmp24_;
#line 702 "../src/util/TweetUtils.vala"
	_data_->_tmp26_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp25_);
#line 702 "../src/util/TweetUtils.vala"
	_data_->_tmp27_ = _data_->_tmp26_;
#line 702 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp23_, "total_bytes", _data_->_tmp27_);
#line 702 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp27_);
#line 703 "../src/util/TweetUtils.vala"
	_data_->_tmp28_ = _data_->init_call;
#line 703 "../src/util/TweetUtils.vala"
	_data_->_tmp29_ = media_upload_get_filetype (_data_->media_upload);
#line 703 "../src/util/TweetUtils.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 703 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp28_, "media_type", _data_->_tmp30_);
#line 704 "../src/util/TweetUtils.vala"
	_data_->_tmp31_ = _data_->init_call;
#line 704 "../src/util/TweetUtils.vala"
	_data_->_tmp32_ = media_upload_get_media_category (_data_->media_upload);
#line 704 "../src/util/TweetUtils.vala"
	_data_->_tmp33_ = _data_->_tmp32_;
#line 704 "../src/util/TweetUtils.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 704 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp31_, "media_category", _data_->_tmp34_);
#line 704 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp34_);
#line 6975 "TweetUtils.c"
	{
#line 707 "../src/util/TweetUtils.vala"
		_data_->_tmp36_ = _data_->init_call;
#line 707 "../src/util/TweetUtils.vala"
		_data_->_state_ = 1;
#line 707 "../src/util/TweetUtils.vala"
		cb_utils_load_threaded_async (_data_->_tmp36_, _data_->cancellable, tweet_utils_upload_media_ready, _data_);
#line 707 "../src/util/TweetUtils.vala"
		return FALSE;
#line 6985 "TweetUtils.c"
		_state_1:
#line 707 "../src/util/TweetUtils.vala"
		_data_->_tmp37_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
#line 707 "../src/util/TweetUtils.vala"
		_data_->_tmp35_ = _data_->_tmp37_;
#line 707 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6993 "TweetUtils.c"
			goto __catch0_g_error;
		}
#line 707 "../src/util/TweetUtils.vala"
		_data_->_tmp38_ = _data_->_tmp35_;
#line 707 "../src/util/TweetUtils.vala"
		_data_->_tmp35_ = NULL;
#line 707 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 707 "../src/util/TweetUtils.vala"
		_data_->root = _data_->_tmp38_;
#line 706 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->_tmp35_);
#line 7006 "TweetUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 706 "../src/util/TweetUtils.vala"
		_data_->e = _data_->_inner_error0_;
#line 706 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = NULL;
#line 710 "../src/util/TweetUtils.vala"
		_data_->_tmp39_ = _data_->init_call;
#line 710 "../src/util/TweetUtils.vala"
		_data_->_tmp40_ = _data_->e;
#line 710 "../src/util/TweetUtils.vala"
		_data_->_tmp41_ = tweet_utils_failed_request_to_error (_data_->_tmp39_, _data_->_tmp40_);
#line 710 "../src/util/TweetUtils.vala"
		_data_->_tmp42_ = _data_->_tmp41_;
#line 710 "../src/util/TweetUtils.vala"
		g_signal_emit_by_name (_data_->media_upload, "progress-complete", _data_->_tmp42_);
#line 710 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data_->_tmp42_);
#line 711 "../src/util/TweetUtils.vala"
		_data_->result = FALSE;
#line 711 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data_->e);
#line 711 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 711 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->init_call);
#line 711 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->upload_proxy);
#line 711 "../src/util/TweetUtils.vala"
		block70_data_unref (_data_->_data70_);
#line 711 "../src/util/TweetUtils.vala"
		_data_->_data70_ = NULL;
#line 711 "../src/util/TweetUtils.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 711 "../src/util/TweetUtils.vala"
		if (_data_->_state_ != 0) {
#line 711 "../src/util/TweetUtils.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 711 "../src/util/TweetUtils.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7049 "TweetUtils.c"
			}
		}
#line 711 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 711 "../src/util/TweetUtils.vala"
		return FALSE;
#line 7056 "TweetUtils.c"
	}
	__finally0:
#line 706 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 706 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 706 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->init_call);
#line 706 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->upload_proxy);
#line 706 "../src/util/TweetUtils.vala"
		block70_data_unref (_data_->_data70_);
#line 706 "../src/util/TweetUtils.vala"
		_data_->_data70_ = NULL;
#line 706 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 706 "../src/util/TweetUtils.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 706 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 706 "../src/util/TweetUtils.vala"
		return FALSE;
#line 7079 "TweetUtils.c"
	}
#line 714 "../src/util/TweetUtils.vala"
	_data_->_tmp43_ = _data_->root;
#line 714 "../src/util/TweetUtils.vala"
	if (_data_->_tmp43_ == NULL) {
#line 715 "../src/util/TweetUtils.vala"
		_data_->_tmp44_ = media_upload_get_filepath (_data_->media_upload);
#line 715 "../src/util/TweetUtils.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 715 "../src/util/TweetUtils.vala"
		_data_->_tmp46_ = _data_->_tmp45_;
#line 715 "../src/util/TweetUtils.vala"
		g_warning ("TweetUtils.vala:715: Null response uploading %s", _data_->_tmp46_);
#line 715 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp46_);
#line 716 "../src/util/TweetUtils.vala"
		_data_->result = FALSE;
#line 716 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 716 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->init_call);
#line 716 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->upload_proxy);
#line 716 "../src/util/TweetUtils.vala"
		block70_data_unref (_data_->_data70_);
#line 716 "../src/util/TweetUtils.vala"
		_data_->_data70_ = NULL;
#line 716 "../src/util/TweetUtils.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 716 "../src/util/TweetUtils.vala"
		if (_data_->_state_ != 0) {
#line 716 "../src/util/TweetUtils.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 716 "../src/util/TweetUtils.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7115 "TweetUtils.c"
			}
		}
#line 716 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 716 "../src/util/TweetUtils.vala"
		return FALSE;
#line 7122 "TweetUtils.c"
	}
#line 719 "../src/util/TweetUtils.vala"
	_data_->_tmp47_ = _data_->root;
#line 719 "../src/util/TweetUtils.vala"
	_data_->_tmp48_ = json_node_get_object (_data_->_tmp47_);
#line 719 "../src/util/TweetUtils.vala"
	media_upload_set_media_id (_data_->media_upload, json_object_get_int_member (_data_->_tmp48_, "media_id"));
#line 720 "../src/util/TweetUtils.vala"
	_data_->file_reader = NULL;
#line 7132 "TweetUtils.c"
	{
#line 722 "../src/util/TweetUtils.vala"
		_data_->_tmp50_ = media_upload_read (_data_->media_upload, &_data_->_inner_error0_);
#line 722 "../src/util/TweetUtils.vala"
		_data_->_tmp49_ = _data_->_tmp50_;
#line 722 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 7140 "TweetUtils.c"
			goto __catch1_g_error;
		}
#line 722 "../src/util/TweetUtils.vala"
		_data_->_tmp51_ = _data_->_tmp49_;
#line 722 "../src/util/TweetUtils.vala"
		_data_->_tmp49_ = NULL;
#line 722 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->file_reader);
#line 722 "../src/util/TweetUtils.vala"
		_data_->file_reader = _data_->_tmp51_;
#line 721 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->_tmp49_);
#line 7153 "TweetUtils.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 721 "../src/util/TweetUtils.vala"
		_data_->_vala1_e = _data_->_inner_error0_;
#line 721 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = NULL;
#line 725 "../src/util/TweetUtils.vala"
		_data_->_tmp52_ = _data_->_vala1_e;
#line 725 "../src/util/TweetUtils.vala"
		g_signal_emit_by_name (_data_->media_upload, "progress-complete", _data_->_tmp52_);
#line 726 "../src/util/TweetUtils.vala"
		_data_->result = FALSE;
#line 726 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data_->_vala1_e);
#line 726 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->file_reader);
#line 726 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 726 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->init_call);
#line 726 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->upload_proxy);
#line 726 "../src/util/TweetUtils.vala"
		block70_data_unref (_data_->_data70_);
#line 726 "../src/util/TweetUtils.vala"
		_data_->_data70_ = NULL;
#line 726 "../src/util/TweetUtils.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 726 "../src/util/TweetUtils.vala"
		if (_data_->_state_ != 0) {
#line 726 "../src/util/TweetUtils.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 726 "../src/util/TweetUtils.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7190 "TweetUtils.c"
			}
		}
#line 726 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 726 "../src/util/TweetUtils.vala"
		return FALSE;
#line 7197 "TweetUtils.c"
	}
	__finally1:
#line 721 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 721 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->file_reader);
#line 721 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 721 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->init_call);
#line 721 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->upload_proxy);
#line 721 "../src/util/TweetUtils.vala"
		block70_data_unref (_data_->_data70_);
#line 721 "../src/util/TweetUtils.vala"
		_data_->_data70_ = NULL;
#line 721 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 721 "../src/util/TweetUtils.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 721 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 721 "../src/util/TweetUtils.vala"
		return FALSE;
#line 7222 "TweetUtils.c"
	}
#line 728 "../src/util/TweetUtils.vala"
	_data_->chunk_idx = 0;
#line 729 "../src/util/TweetUtils.vala"
	_data_->total_uploaded = (gsize) 0;
#line 730 "../src/util/TweetUtils.vala"
	_data_->_tmp53_ = media_upload_get_filesize (_data_->media_upload);
#line 730 "../src/util/TweetUtils.vala"
	_data_->_tmp54_ = _data_->_tmp53_;
#line 730 "../src/util/TweetUtils.vala"
	_data_->filesize = _data_->_tmp54_;
#line 731 "../src/util/TweetUtils.vala"
	media_upload_set_progress (_data_->media_upload, (gdouble) 0);
#line 733 "../src/util/TweetUtils.vala"
	while (TRUE) {
#line 733 "../src/util/TweetUtils.vala"
		if (!(((gint64) _data_->total_uploaded) < _data_->filesize)) {
#line 733 "../src/util/TweetUtils.vala"
			break;
#line 7242 "TweetUtils.c"
		}
#line 734 "../src/util/TweetUtils.vala"
		_data_->_tmp55_ = _data_->upload_proxy;
#line 734 "../src/util/TweetUtils.vala"
		_data_->_tmp56_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp55_);
#line 734 "../src/util/TweetUtils.vala"
		_data_->append_call = _data_->_tmp56_;
#line 7250 "TweetUtils.c"
		{
#line 737 "../src/util/TweetUtils.vala"
			_data_->_tmp58_ = _data_->file_reader;
#line 737 "../src/util/TweetUtils.vala"
			_data_->_tmp59_ = g_input_stream_read_bytes ((GInputStream*) _data_->_tmp58_, (gsize) MAX_CHUNK_SIZE, NULL, &_data_->_inner_error0_);
#line 737 "../src/util/TweetUtils.vala"
			_data_->_tmp57_ = _data_->_tmp59_;
#line 737 "../src/util/TweetUtils.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 7260 "TweetUtils.c"
				goto __catch2_g_error;
			}
#line 737 "../src/util/TweetUtils.vala"
			_data_->_tmp60_ = _data_->_tmp57_;
#line 737 "../src/util/TweetUtils.vala"
			_data_->_tmp57_ = NULL;
#line 737 "../src/util/TweetUtils.vala"
			_g_bytes_unref0 (_data_->chunk);
#line 737 "../src/util/TweetUtils.vala"
			_data_->chunk = _data_->_tmp60_;
#line 736 "../src/util/TweetUtils.vala"
			_g_bytes_unref0 (_data_->_tmp57_);
#line 7273 "TweetUtils.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
#line 736 "../src/util/TweetUtils.vala"
			_data_->_vala2_e = _data_->_inner_error0_;
#line 736 "../src/util/TweetUtils.vala"
			_data_->_inner_error0_ = NULL;
#line 740 "../src/util/TweetUtils.vala"
			_data_->_tmp61_ = _data_->_vala2_e;
#line 740 "../src/util/TweetUtils.vala"
			g_signal_emit_by_name (_data_->media_upload, "progress-complete", _data_->_tmp61_);
#line 741 "../src/util/TweetUtils.vala"
			_data_->result = FALSE;
#line 741 "../src/util/TweetUtils.vala"
			_g_error_free0 (_data_->_vala2_e);
#line 741 "../src/util/TweetUtils.vala"
			_g_bytes_unref0 (_data_->chunk);
#line 741 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->append_call);
#line 741 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->file_reader);
#line 741 "../src/util/TweetUtils.vala"
			__vala_JsonNode_free0 (_data_->root);
#line 741 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->init_call);
#line 741 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->upload_proxy);
#line 741 "../src/util/TweetUtils.vala"
			block70_data_unref (_data_->_data70_);
#line 741 "../src/util/TweetUtils.vala"
			_data_->_data70_ = NULL;
#line 741 "../src/util/TweetUtils.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 741 "../src/util/TweetUtils.vala"
			if (_data_->_state_ != 0) {
#line 741 "../src/util/TweetUtils.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 741 "../src/util/TweetUtils.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7314 "TweetUtils.c"
				}
			}
#line 741 "../src/util/TweetUtils.vala"
			g_object_unref (_data_->_async_result);
#line 741 "../src/util/TweetUtils.vala"
			return FALSE;
#line 7321 "TweetUtils.c"
		}
		__finally2:
#line 736 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 736 "../src/util/TweetUtils.vala"
			_g_bytes_unref0 (_data_->chunk);
#line 736 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->append_call);
#line 736 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->file_reader);
#line 736 "../src/util/TweetUtils.vala"
			__vala_JsonNode_free0 (_data_->root);
#line 736 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->init_call);
#line 736 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->upload_proxy);
#line 736 "../src/util/TweetUtils.vala"
			block70_data_unref (_data_->_data70_);
#line 736 "../src/util/TweetUtils.vala"
			_data_->_data70_ = NULL;
#line 736 "../src/util/TweetUtils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 736 "../src/util/TweetUtils.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 736 "../src/util/TweetUtils.vala"
			g_object_unref (_data_->_async_result);
#line 736 "../src/util/TweetUtils.vala"
			return FALSE;
#line 7350 "TweetUtils.c"
		}
#line 743 "../src/util/TweetUtils.vala"
		_data_->_tmp62_ = _data_->append_call;
#line 743 "../src/util/TweetUtils.vala"
		rest_proxy_call_set_function (_data_->_tmp62_, "1.1/media/upload.json");
#line 744 "../src/util/TweetUtils.vala"
		_data_->_tmp63_ = _data_->append_call;
#line 744 "../src/util/TweetUtils.vala"
		rest_proxy_call_set_method (_data_->_tmp63_, "POST");
#line 745 "../src/util/TweetUtils.vala"
		_data_->_tmp64_ = _data_->append_call;
#line 745 "../src/util/TweetUtils.vala"
		rest_proxy_call_add_param (_data_->_tmp64_, "command", "APPEND");
#line 746 "../src/util/TweetUtils.vala"
		_data_->_tmp65_ = _data_->append_call;
#line 746 "../src/util/TweetUtils.vala"
		_data_->_tmp66_ = media_upload_get_media_id (_data_->media_upload);
#line 746 "../src/util/TweetUtils.vala"
		_data_->_tmp67_ = _data_->_tmp66_;
#line 746 "../src/util/TweetUtils.vala"
		_data_->_tmp68_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp67_);
#line 746 "../src/util/TweetUtils.vala"
		_data_->_tmp69_ = _data_->_tmp68_;
#line 746 "../src/util/TweetUtils.vala"
		rest_proxy_call_add_param (_data_->_tmp65_, "media_id", _data_->_tmp69_);
#line 746 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp69_);
#line 747 "../src/util/TweetUtils.vala"
		_data_->_tmp70_ = _data_->append_call;
#line 747 "../src/util/TweetUtils.vala"
		_data_->_tmp71_ = g_strdup_printf ("%i", _data_->chunk_idx);
#line 747 "../src/util/TweetUtils.vala"
		_data_->_tmp72_ = _data_->_tmp71_;
#line 747 "../src/util/TweetUtils.vala"
		rest_proxy_call_add_param (_data_->_tmp70_, "segment_index", _data_->_tmp72_);
#line 747 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp72_);
#line 748 "../src/util/TweetUtils.vala"
		_data_->_tmp73_ = _data_->chunk;
#line 748 "../src/util/TweetUtils.vala"
		_data_->_tmp74_ = 0;
#line 748 "../src/util/TweetUtils.vala"
		_data_->_tmp75_ = g_bytes_get_data (_data_->_tmp73_, &_data_->_tmp74_);
#line 748 "../src/util/TweetUtils.vala"
		_data_->_tmp76_ = media_upload_get_filepath (_data_->media_upload);
#line 748 "../src/util/TweetUtils.vala"
		_data_->_tmp77_ = _data_->_tmp76_;
#line 748 "../src/util/TweetUtils.vala"
		_data_->_tmp78_ = _data_->_tmp77_;
#line 748 "../src/util/TweetUtils.vala"
		_data_->_tmp79_ = rest_param_new_full ("media", REST_MEMORY_COPY, _data_->_tmp75_, _data_->_tmp74_, "multipart/form-data", _data_->_tmp78_);
#line 748 "../src/util/TweetUtils.vala"
		_data_->_tmp80_ = _data_->_tmp79_;
#line 748 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp78_);
#line 748 "../src/util/TweetUtils.vala"
		_data_->media_param = _data_->_tmp80_;
#line 749 "../src/util/TweetUtils.vala"
		_data_->_tmp81_ = _data_->append_call;
#line 749 "../src/util/TweetUtils.vala"
		_data_->_tmp82_ = _data_->media_param;
#line 749 "../src/util/TweetUtils.vala"
		_data_->_tmp83_ = _rest_param_ref0 (_data_->_tmp82_);
#line 749 "../src/util/TweetUtils.vala"
		rest_proxy_call_add_param_full (_data_->_tmp81_, _data_->_tmp83_);
#line 7416 "TweetUtils.c"
		{
#line 754 "../src/util/TweetUtils.vala"
			_data_->_tmp84_ = tweet_utils_upload_progress_new (_data_->media_upload, _data_->filesize, _data_->total_uploaded, _tweet_utils_upload_media_co_tweet_utils_upload_media_callback, _data_);
#line 754 "../src/util/TweetUtils.vala"
			_data_->upload_progress = _data_->_tmp84_;
#line 755 "../src/util/TweetUtils.vala"
			_data_->_tmp85_ = _data_->append_call;
#line 755 "../src/util/TweetUtils.vala"
			_data_->_tmp86_ = _data_->upload_progress;
#line 755 "../src/util/TweetUtils.vala"
			rest_proxy_call_upload (_data_->_tmp85_, _tweet_utils_upload_progress_callback_rest_proxy_call_upload_callback, (GObject*) _data_->cancellable, tweet_utils_upload_progress_ref (_data_->_tmp86_), &_data_->_inner_error0_);
#line 755 "../src/util/TweetUtils.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 755 "../src/util/TweetUtils.vala"
				_tweet_utils_upload_progress_unref0 (_data_->upload_progress);
#line 7432 "TweetUtils.c"
				goto __catch3_g_error;
			}
#line 756 "../src/util/TweetUtils.vala"
			_data_->_state_ = 2;
#line 756 "../src/util/TweetUtils.vala"
			return FALSE;
#line 7439 "TweetUtils.c"
			_state_2:
			;
#line 751 "../src/util/TweetUtils.vala"
			_tweet_utils_upload_progress_unref0 (_data_->upload_progress);
#line 7444 "TweetUtils.c"
		}
		goto __finally3;
		__catch3_g_error:
		{
#line 751 "../src/util/TweetUtils.vala"
			_data_->_vala3_e = _data_->_inner_error0_;
#line 751 "../src/util/TweetUtils.vala"
			_data_->_inner_error0_ = NULL;
#line 759 "../src/util/TweetUtils.vala"
			_data_->_tmp87_ = _data_->append_call;
#line 759 "../src/util/TweetUtils.vala"
			_data_->_tmp88_ = _data_->_vala3_e;
#line 759 "../src/util/TweetUtils.vala"
			_data_->_tmp89_ = tweet_utils_failed_request_to_error (_data_->_tmp87_, _data_->_tmp88_);
#line 759 "../src/util/TweetUtils.vala"
			_data_->_tmp90_ = _data_->_tmp89_;
#line 759 "../src/util/TweetUtils.vala"
			g_signal_emit_by_name (_data_->media_upload, "progress-complete", _data_->_tmp90_);
#line 759 "../src/util/TweetUtils.vala"
			_g_error_free0 (_data_->_tmp90_);
#line 760 "../src/util/TweetUtils.vala"
			_data_->result = FALSE;
#line 760 "../src/util/TweetUtils.vala"
			_g_error_free0 (_data_->_vala3_e);
#line 760 "../src/util/TweetUtils.vala"
			_rest_param_unref0 (_data_->media_param);
#line 760 "../src/util/TweetUtils.vala"
			_g_bytes_unref0 (_data_->chunk);
#line 760 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->append_call);
#line 760 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->file_reader);
#line 760 "../src/util/TweetUtils.vala"
			__vala_JsonNode_free0 (_data_->root);
#line 760 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->init_call);
#line 760 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->upload_proxy);
#line 760 "../src/util/TweetUtils.vala"
			block70_data_unref (_data_->_data70_);
#line 760 "../src/util/TweetUtils.vala"
			_data_->_data70_ = NULL;
#line 760 "../src/util/TweetUtils.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 760 "../src/util/TweetUtils.vala"
			if (_data_->_state_ != 0) {
#line 760 "../src/util/TweetUtils.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 760 "../src/util/TweetUtils.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7495 "TweetUtils.c"
				}
			}
#line 760 "../src/util/TweetUtils.vala"
			g_object_unref (_data_->_async_result);
#line 760 "../src/util/TweetUtils.vala"
			return FALSE;
#line 7502 "TweetUtils.c"
		}
		__finally3:
#line 751 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 751 "../src/util/TweetUtils.vala"
			_rest_param_unref0 (_data_->media_param);
#line 751 "../src/util/TweetUtils.vala"
			_g_bytes_unref0 (_data_->chunk);
#line 751 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->append_call);
#line 751 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->file_reader);
#line 751 "../src/util/TweetUtils.vala"
			__vala_JsonNode_free0 (_data_->root);
#line 751 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->init_call);
#line 751 "../src/util/TweetUtils.vala"
			_g_object_unref0 (_data_->upload_proxy);
#line 751 "../src/util/TweetUtils.vala"
			block70_data_unref (_data_->_data70_);
#line 751 "../src/util/TweetUtils.vala"
			_data_->_data70_ = NULL;
#line 751 "../src/util/TweetUtils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 751 "../src/util/TweetUtils.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 751 "../src/util/TweetUtils.vala"
			g_object_unref (_data_->_async_result);
#line 751 "../src/util/TweetUtils.vala"
			return FALSE;
#line 7533 "TweetUtils.c"
		}
#line 763 "../src/util/TweetUtils.vala"
		_data_->_tmp91_ = _data_->chunk;
#line 763 "../src/util/TweetUtils.vala"
		_data_->total_uploaded += g_bytes_get_size (_data_->_tmp91_);
#line 764 "../src/util/TweetUtils.vala"
		media_upload_set_progress (_data_->media_upload, ((gdouble) _data_->total_uploaded) / ((gdouble) _data_->filesize));
#line 765 "../src/util/TweetUtils.vala"
		_data_->_tmp92_ = _data_->chunk_idx;
#line 765 "../src/util/TweetUtils.vala"
		_data_->chunk_idx = _data_->_tmp92_ + 1;
#line 733 "../src/util/TweetUtils.vala"
		_rest_param_unref0 (_data_->media_param);
#line 733 "../src/util/TweetUtils.vala"
		_g_bytes_unref0 (_data_->chunk);
#line 733 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->append_call);
#line 7551 "TweetUtils.c"
	}
#line 768 "../src/util/TweetUtils.vala"
	_data_->_tmp93_ = _data_->upload_proxy;
#line 768 "../src/util/TweetUtils.vala"
	_data_->_tmp94_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp93_);
#line 768 "../src/util/TweetUtils.vala"
	_data_->finalise_call = _data_->_tmp94_;
#line 769 "../src/util/TweetUtils.vala"
	_data_->_tmp95_ = _data_->finalise_call;
#line 769 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_function (_data_->_tmp95_, "1.1/media/upload.json");
#line 770 "../src/util/TweetUtils.vala"
	_data_->_tmp96_ = _data_->finalise_call;
#line 770 "../src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_tmp96_, "POST");
#line 771 "../src/util/TweetUtils.vala"
	_data_->_tmp97_ = _data_->finalise_call;
#line 771 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp97_, "command", "FINALIZE");
#line 772 "../src/util/TweetUtils.vala"
	_data_->_tmp98_ = _data_->finalise_call;
#line 772 "../src/util/TweetUtils.vala"
	_data_->_tmp99_ = media_upload_get_media_id (_data_->media_upload);
#line 772 "../src/util/TweetUtils.vala"
	_data_->_tmp100_ = _data_->_tmp99_;
#line 772 "../src/util/TweetUtils.vala"
	_data_->_tmp101_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp100_);
#line 772 "../src/util/TweetUtils.vala"
	_data_->_tmp102_ = _data_->_tmp101_;
#line 772 "../src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp98_, "media_id", _data_->_tmp102_);
#line 772 "../src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp102_);
#line 7585 "TweetUtils.c"
	{
#line 775 "../src/util/TweetUtils.vala"
		_data_->_tmp104_ = _data_->finalise_call;
#line 775 "../src/util/TweetUtils.vala"
		_data_->_state_ = 3;
#line 775 "../src/util/TweetUtils.vala"
		cb_utils_load_threaded_async (_data_->_tmp104_, _data_->cancellable, tweet_utils_upload_media_ready, _data_);
#line 775 "../src/util/TweetUtils.vala"
		return FALSE;
#line 7595 "TweetUtils.c"
		_state_3:
#line 775 "../src/util/TweetUtils.vala"
		_data_->_tmp105_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
#line 775 "../src/util/TweetUtils.vala"
		_data_->_tmp103_ = _data_->_tmp105_;
#line 775 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 7603 "TweetUtils.c"
			goto __catch4_g_error;
		}
#line 775 "../src/util/TweetUtils.vala"
		_data_->_tmp106_ = _data_->_tmp103_;
#line 775 "../src/util/TweetUtils.vala"
		_data_->_tmp103_ = NULL;
#line 775 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 775 "../src/util/TweetUtils.vala"
		_data_->root = _data_->_tmp106_;
#line 774 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->_tmp103_);
#line 7616 "TweetUtils.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
#line 774 "../src/util/TweetUtils.vala"
		_data_->_vala4_e = _data_->_inner_error0_;
#line 774 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = NULL;
#line 778 "../src/util/TweetUtils.vala"
		_data_->_tmp107_ = _data_->finalise_call;
#line 778 "../src/util/TweetUtils.vala"
		_data_->_tmp108_ = _data_->_vala4_e;
#line 778 "../src/util/TweetUtils.vala"
		_data_->_tmp109_ = tweet_utils_failed_request_to_error (_data_->_tmp107_, _data_->_tmp108_);
#line 778 "../src/util/TweetUtils.vala"
		_data_->_tmp110_ = _data_->_tmp109_;
#line 778 "../src/util/TweetUtils.vala"
		g_signal_emit_by_name (_data_->media_upload, "progress-complete", _data_->_tmp110_);
#line 778 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data_->_tmp110_);
#line 779 "../src/util/TweetUtils.vala"
		_data_->result = FALSE;
#line 779 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data_->_vala4_e);
#line 779 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->finalise_call);
#line 779 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->file_reader);
#line 779 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 779 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->init_call);
#line 779 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->upload_proxy);
#line 779 "../src/util/TweetUtils.vala"
		block70_data_unref (_data_->_data70_);
#line 779 "../src/util/TweetUtils.vala"
		_data_->_data70_ = NULL;
#line 779 "../src/util/TweetUtils.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 779 "../src/util/TweetUtils.vala"
		if (_data_->_state_ != 0) {
#line 779 "../src/util/TweetUtils.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 779 "../src/util/TweetUtils.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7663 "TweetUtils.c"
			}
		}
#line 779 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 779 "../src/util/TweetUtils.vala"
		return FALSE;
#line 7670 "TweetUtils.c"
	}
	__finally4:
#line 774 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 774 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->finalise_call);
#line 774 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->file_reader);
#line 774 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 774 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->init_call);
#line 774 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->upload_proxy);
#line 774 "../src/util/TweetUtils.vala"
		block70_data_unref (_data_->_data70_);
#line 774 "../src/util/TweetUtils.vala"
		_data_->_data70_ = NULL;
#line 774 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 774 "../src/util/TweetUtils.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 774 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 774 "../src/util/TweetUtils.vala"
		return FALSE;
#line 7697 "TweetUtils.c"
	}
#line 782 "../src/util/TweetUtils.vala"
	_data_->_tmp111_ = _data_->root;
#line 782 "../src/util/TweetUtils.vala"
	if (_data_->_tmp111_ == NULL) {
#line 783 "../src/util/TweetUtils.vala"
		_data_->_tmp112_ = media_upload_get_filepath (_data_->media_upload);
#line 783 "../src/util/TweetUtils.vala"
		_data_->_tmp113_ = _data_->_tmp112_;
#line 783 "../src/util/TweetUtils.vala"
		_data_->_tmp114_ = _data_->_tmp113_;
#line 783 "../src/util/TweetUtils.vala"
		g_warning ("TweetUtils.vala:783: Null response finalising %s", _data_->_tmp114_);
#line 783 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp114_);
#line 784 "../src/util/TweetUtils.vala"
		_data_->result = FALSE;
#line 784 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->finalise_call);
#line 784 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->file_reader);
#line 784 "../src/util/TweetUtils.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 784 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->init_call);
#line 784 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data_->upload_proxy);
#line 784 "../src/util/TweetUtils.vala"
		block70_data_unref (_data_->_data70_);
#line 784 "../src/util/TweetUtils.vala"
		_data_->_data70_ = NULL;
#line 784 "../src/util/TweetUtils.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 784 "../src/util/TweetUtils.vala"
		if (_data_->_state_ != 0) {
#line 784 "../src/util/TweetUtils.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 784 "../src/util/TweetUtils.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7737 "TweetUtils.c"
			}
		}
#line 784 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 784 "../src/util/TweetUtils.vala"
		return FALSE;
#line 7744 "TweetUtils.c"
	}
#line 787 "../src/util/TweetUtils.vala"
	_data_->_tmp115_ = _data_->root;
#line 787 "../src/util/TweetUtils.vala"
	_data_->_tmp116_ = json_node_get_object (_data_->_tmp115_);
#line 787 "../src/util/TweetUtils.vala"
	_data_->_tmp117_ = _json_object_ref0 (_data_->_tmp116_);
#line 787 "../src/util/TweetUtils.vala"
	_data_->object = _data_->_tmp117_;
#line 788 "../src/util/TweetUtils.vala"
	while (TRUE) {
#line 788 "../src/util/TweetUtils.vala"
		_data_->_tmp118_ = _data_->object;
#line 788 "../src/util/TweetUtils.vala"
		if (!json_object_has_member (_data_->_tmp118_, "processing_info")) {
#line 788 "../src/util/TweetUtils.vala"
			break;
#line 7762 "TweetUtils.c"
		}
#line 789 "../src/util/TweetUtils.vala"
		_data_->_tmp119_ = _data_->object;
#line 789 "../src/util/TweetUtils.vala"
		_data_->_tmp120_ = json_object_get_object_member (_data_->_tmp119_, "processing_info");
#line 789 "../src/util/TweetUtils.vala"
		_data_->_tmp121_ = _json_object_ref0 (_data_->_tmp120_);
#line 789 "../src/util/TweetUtils.vala"
		_data_->processing_info = _data_->_tmp121_;
#line 790 "../src/util/TweetUtils.vala"
		_data_->_tmp122_ = _data_->processing_info;
#line 790 "../src/util/TweetUtils.vala"
		_data_->_tmp123_ = json_object_get_string_member (_data_->_tmp122_, "state");
#line 790 "../src/util/TweetUtils.vala"
		_data_->_tmp124_ = g_strdup (_data_->_tmp123_);
#line 790 "../src/util/TweetUtils.vala"
		_data_->state = _data_->_tmp124_;
#line 791 "../src/util/TweetUtils.vala"
		_data_->_tmp125_ = _data_->state;
#line 791 "../src/util/TweetUtils.vala"
		if (g_strcmp0 (_data_->_tmp125_, "succeeded") == 0) {
#line 792 "../src/util/TweetUtils.vala"
			_g_free0 (_data_->state);
#line 792 "../src/util/TweetUtils.vala"
			_json_object_unref0 (_data_->processing_info);
#line 792 "../src/util/TweetUtils.vala"
			break;
#line 7790 "TweetUtils.c"
		} else {
#line 794 "../src/util/TweetUtils.vala"
			_data_->_tmp126_ = _data_->state;
#line 794 "../src/util/TweetUtils.vala"
			if (g_strcmp0 (_data_->_tmp126_, "failed") == 0) {
#line 795 "../src/util/TweetUtils.vala"
				_data_->_tmp127_ = _data_->processing_info;
#line 795 "../src/util/TweetUtils.vala"
				_data_->_tmp128_ = json_object_get_object_member (_data_->_tmp127_, "error");
#line 795 "../src/util/TweetUtils.vala"
				_data_->_tmp129_ = _json_object_ref0 (_data_->_tmp128_);
#line 795 "../src/util/TweetUtils.vala"
				_data_->_error_ = _data_->_tmp129_;
#line 796 "../src/util/TweetUtils.vala"
				_data_->_tmp130_ = _data_->_error_;
#line 796 "../src/util/TweetUtils.vala"
				_data_->error_code = json_object_get_int_member (_data_->_tmp130_, "code");
#line 798 "../src/util/TweetUtils.vala"
				if (_data_->error_code == ((gint64) 1)) {
#line 799 "../src/util/TweetUtils.vala"
					_data_->_tmp131_ = g_strdup (_ ("Invalid media file"));
#line 799 "../src/util/TweetUtils.vala"
					_g_free0 (_data_->message);
#line 799 "../src/util/TweetUtils.vala"
					_data_->message = _data_->_tmp131_;
#line 7816 "TweetUtils.c"
				} else {
#line 803 "../src/util/TweetUtils.vala"
					_data_->_tmp132_ = _data_->_error_;
#line 803 "../src/util/TweetUtils.vala"
					if (json_object_has_member (_data_->_tmp132_, "message")) {
#line 804 "../src/util/TweetUtils.vala"
						_data_->_tmp133_ = _data_->_error_;
#line 804 "../src/util/TweetUtils.vala"
						_data_->_tmp134_ = json_object_get_string_member (_data_->_tmp133_, "message");
#line 804 "../src/util/TweetUtils.vala"
						_data_->_tmp135_ = g_strdup (_data_->_tmp134_);
#line 804 "../src/util/TweetUtils.vala"
						_g_free0 (_data_->message);
#line 804 "../src/util/TweetUtils.vala"
						_data_->message = _data_->_tmp135_;
#line 7832 "TweetUtils.c"
					} else {
#line 806 "../src/util/TweetUtils.vala"
						_data_->_tmp136_ = _data_->_error_;
#line 806 "../src/util/TweetUtils.vala"
						if (json_object_has_member (_data_->_tmp136_, "name")) {
#line 807 "../src/util/TweetUtils.vala"
							_data_->_tmp137_ = _data_->_error_;
#line 807 "../src/util/TweetUtils.vala"
							_data_->_tmp138_ = json_object_get_string_member (_data_->_tmp137_, "name");
#line 807 "../src/util/TweetUtils.vala"
							_data_->_tmp139_ = g_strdup (_data_->_tmp138_);
#line 807 "../src/util/TweetUtils.vala"
							_data_->error_name = _data_->_tmp139_;
#line 808 "../src/util/TweetUtils.vala"
							_data_->_tmp140_ = _data_->error_name;
#line 808 "../src/util/TweetUtils.vala"
							_data_->_tmp141_ = g_strdup_printf (_ ("Unknown error code %lld during upload: %s"), _data_->error_code, _data_->_tmp140_);
#line 808 "../src/util/TweetUtils.vala"
							_g_free0 (_data_->message);
#line 808 "../src/util/TweetUtils.vala"
							_data_->message = _data_->_tmp141_;
#line 806 "../src/util/TweetUtils.vala"
							_g_free0 (_data_->error_name);
#line 7856 "TweetUtils.c"
						} else {
#line 811 "../src/util/TweetUtils.vala"
							_data_->_tmp142_ = g_strdup_printf (_ ("Unknown error code %lld during upload"), _data_->error_code);
#line 811 "../src/util/TweetUtils.vala"
							_g_free0 (_data_->message);
#line 811 "../src/util/TweetUtils.vala"
							_data_->message = _data_->_tmp142_;
#line 7864 "TweetUtils.c"
						}
					}
				}
#line 814 "../src/util/TweetUtils.vala"
				_data_->_tmp143_ = _data_->message;
#line 814 "../src/util/TweetUtils.vala"
				_data_->_tmp144_ = g_error_new_literal (tweet_utils_get_error_domain (), 0, _data_->_tmp143_);
#line 814 "../src/util/TweetUtils.vala"
				_data_->_tmp145_ = _data_->_tmp144_;
#line 814 "../src/util/TweetUtils.vala"
				g_signal_emit_by_name (_data_->media_upload, "progress-complete", _data_->_tmp145_);
#line 814 "../src/util/TweetUtils.vala"
				_g_error_free0 (_data_->_tmp145_);
#line 815 "../src/util/TweetUtils.vala"
				_data_->result = FALSE;
#line 815 "../src/util/TweetUtils.vala"
				_g_free0 (_data_->message);
#line 815 "../src/util/TweetUtils.vala"
				_json_object_unref0 (_data_->_error_);
#line 815 "../src/util/TweetUtils.vala"
				_g_free0 (_data_->state);
#line 815 "../src/util/TweetUtils.vala"
				_json_object_unref0 (_data_->processing_info);
#line 815 "../src/util/TweetUtils.vala"
				_json_object_unref0 (_data_->object);
#line 815 "../src/util/TweetUtils.vala"
				_g_object_unref0 (_data_->finalise_call);
#line 815 "../src/util/TweetUtils.vala"
				_g_object_unref0 (_data_->file_reader);
#line 815 "../src/util/TweetUtils.vala"
				__vala_JsonNode_free0 (_data_->root);
#line 815 "../src/util/TweetUtils.vala"
				_g_object_unref0 (_data_->init_call);
#line 815 "../src/util/TweetUtils.vala"
				_g_object_unref0 (_data_->upload_proxy);
#line 815 "../src/util/TweetUtils.vala"
				block70_data_unref (_data_->_data70_);
#line 815 "../src/util/TweetUtils.vala"
				_data_->_data70_ = NULL;
#line 815 "../src/util/TweetUtils.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 815 "../src/util/TweetUtils.vala"
				if (_data_->_state_ != 0) {
#line 815 "../src/util/TweetUtils.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 815 "../src/util/TweetUtils.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7912 "TweetUtils.c"
					}
				}
#line 815 "../src/util/TweetUtils.vala"
				g_object_unref (_data_->_async_result);
#line 815 "../src/util/TweetUtils.vala"
				return FALSE;
#line 7919 "TweetUtils.c"
			} else {
#line 818 "../src/util/TweetUtils.vala"
				_data_->_tmp146_ = _data_->object;
#line 818 "../src/util/TweetUtils.vala"
				_data_->_tmp147_ = json_object_get_object_member (_data_->_tmp146_, "processing_info");
#line 818 "../src/util/TweetUtils.vala"
				_data_->delay = (guint) json_object_get_int_member (_data_->_tmp147_, "check_after_secs");
#line 819 "../src/util/TweetUtils.vala"
				g_debug ("TweetUtils.vala:819: Media upload processing - check after %u seconds", _data_->delay);
#line 820 "../src/util/TweetUtils.vala"
				g_timeout_add_full (G_PRIORITY_DEFAULT, _data_->delay * 1000, ______lambda71__gsource_func, block70_data_ref (_data_->_data70_), block70_data_unref);
#line 824 "../src/util/TweetUtils.vala"
				_data_->_state_ = 4;
#line 824 "../src/util/TweetUtils.vala"
				return FALSE;
#line 7935 "TweetUtils.c"
				_state_4:
				;
#line 825 "../src/util/TweetUtils.vala"
				_data_->_tmp148_ = _data_->upload_proxy;
#line 825 "../src/util/TweetUtils.vala"
				_data_->_tmp149_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp148_);
#line 825 "../src/util/TweetUtils.vala"
				_data_->status_call = _data_->_tmp149_;
#line 826 "../src/util/TweetUtils.vala"
				_data_->_tmp150_ = _data_->status_call;
#line 826 "../src/util/TweetUtils.vala"
				rest_proxy_call_set_function (_data_->_tmp150_, "1.1/media/upload.json");
#line 827 "../src/util/TweetUtils.vala"
				_data_->_tmp151_ = _data_->status_call;
#line 827 "../src/util/TweetUtils.vala"
				rest_proxy_call_set_method (_data_->_tmp151_, "GET");
#line 828 "../src/util/TweetUtils.vala"
				_data_->_tmp152_ = _data_->status_call;
#line 828 "../src/util/TweetUtils.vala"
				rest_proxy_call_add_param (_data_->_tmp152_, "command", "STATUS");
#line 829 "../src/util/TweetUtils.vala"
				_data_->_tmp153_ = _data_->status_call;
#line 829 "../src/util/TweetUtils.vala"
				_data_->_tmp154_ = media_upload_get_media_id (_data_->media_upload);
#line 829 "../src/util/TweetUtils.vala"
				_data_->_tmp155_ = _data_->_tmp154_;
#line 829 "../src/util/TweetUtils.vala"
				_data_->_tmp156_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp155_);
#line 829 "../src/util/TweetUtils.vala"
				_data_->_tmp157_ = _data_->_tmp156_;
#line 829 "../src/util/TweetUtils.vala"
				rest_proxy_call_add_param (_data_->_tmp153_, "media_id", _data_->_tmp157_);
#line 829 "../src/util/TweetUtils.vala"
				_g_free0 (_data_->_tmp157_);
#line 7970 "TweetUtils.c"
				{
#line 832 "../src/util/TweetUtils.vala"
					_data_->_tmp159_ = _data_->status_call;
#line 832 "../src/util/TweetUtils.vala"
					_data_->_state_ = 5;
#line 832 "../src/util/TweetUtils.vala"
					cb_utils_load_threaded_async (_data_->_tmp159_, _data_->cancellable, tweet_utils_upload_media_ready, _data_);
#line 832 "../src/util/TweetUtils.vala"
					return FALSE;
#line 7980 "TweetUtils.c"
					_state_5:
#line 832 "../src/util/TweetUtils.vala"
					_data_->_tmp160_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
#line 832 "../src/util/TweetUtils.vala"
					_data_->_tmp158_ = _data_->_tmp160_;
#line 832 "../src/util/TweetUtils.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 7988 "TweetUtils.c"
						goto __catch5_g_error;
					}
#line 832 "../src/util/TweetUtils.vala"
					_data_->_tmp161_ = _data_->_tmp158_;
#line 832 "../src/util/TweetUtils.vala"
					_data_->_tmp158_ = NULL;
#line 832 "../src/util/TweetUtils.vala"
					__vala_JsonNode_free0 (_data_->root);
#line 832 "../src/util/TweetUtils.vala"
					_data_->root = _data_->_tmp161_;
#line 831 "../src/util/TweetUtils.vala"
					__vala_JsonNode_free0 (_data_->_tmp158_);
#line 8001 "TweetUtils.c"
				}
				goto __finally5;
				__catch5_g_error:
				{
#line 831 "../src/util/TweetUtils.vala"
					_data_->_vala5_e = _data_->_inner_error0_;
#line 831 "../src/util/TweetUtils.vala"
					_data_->_inner_error0_ = NULL;
#line 835 "../src/util/TweetUtils.vala"
					_data_->_tmp162_ = _data_->finalise_call;
#line 835 "../src/util/TweetUtils.vala"
					_data_->_tmp163_ = _data_->_vala5_e;
#line 835 "../src/util/TweetUtils.vala"
					_data_->_tmp164_ = tweet_utils_failed_request_to_error (_data_->_tmp162_, _data_->_tmp163_);
#line 835 "../src/util/TweetUtils.vala"
					_data_->_tmp165_ = _data_->_tmp164_;
#line 835 "../src/util/TweetUtils.vala"
					g_signal_emit_by_name (_data_->media_upload, "progress-complete", _data_->_tmp165_);
#line 835 "../src/util/TweetUtils.vala"
					_g_error_free0 (_data_->_tmp165_);
#line 836 "../src/util/TweetUtils.vala"
					_data_->result = FALSE;
#line 836 "../src/util/TweetUtils.vala"
					_g_error_free0 (_data_->_vala5_e);
#line 836 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->status_call);
#line 836 "../src/util/TweetUtils.vala"
					_g_free0 (_data_->state);
#line 836 "../src/util/TweetUtils.vala"
					_json_object_unref0 (_data_->processing_info);
#line 836 "../src/util/TweetUtils.vala"
					_json_object_unref0 (_data_->object);
#line 836 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->finalise_call);
#line 836 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->file_reader);
#line 836 "../src/util/TweetUtils.vala"
					__vala_JsonNode_free0 (_data_->root);
#line 836 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->init_call);
#line 836 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->upload_proxy);
#line 836 "../src/util/TweetUtils.vala"
					block70_data_unref (_data_->_data70_);
#line 836 "../src/util/TweetUtils.vala"
					_data_->_data70_ = NULL;
#line 836 "../src/util/TweetUtils.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 836 "../src/util/TweetUtils.vala"
					if (_data_->_state_ != 0) {
#line 836 "../src/util/TweetUtils.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 836 "../src/util/TweetUtils.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8056 "TweetUtils.c"
						}
					}
#line 836 "../src/util/TweetUtils.vala"
					g_object_unref (_data_->_async_result);
#line 836 "../src/util/TweetUtils.vala"
					return FALSE;
#line 8063 "TweetUtils.c"
				}
				__finally5:
#line 831 "../src/util/TweetUtils.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 831 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->status_call);
#line 831 "../src/util/TweetUtils.vala"
					_g_free0 (_data_->state);
#line 831 "../src/util/TweetUtils.vala"
					_json_object_unref0 (_data_->processing_info);
#line 831 "../src/util/TweetUtils.vala"
					_json_object_unref0 (_data_->object);
#line 831 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->finalise_call);
#line 831 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->file_reader);
#line 831 "../src/util/TweetUtils.vala"
					__vala_JsonNode_free0 (_data_->root);
#line 831 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->init_call);
#line 831 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->upload_proxy);
#line 831 "../src/util/TweetUtils.vala"
					block70_data_unref (_data_->_data70_);
#line 831 "../src/util/TweetUtils.vala"
					_data_->_data70_ = NULL;
#line 831 "../src/util/TweetUtils.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 831 "../src/util/TweetUtils.vala"
					g_clear_error (&_data_->_inner_error0_);
#line 831 "../src/util/TweetUtils.vala"
					g_object_unref (_data_->_async_result);
#line 831 "../src/util/TweetUtils.vala"
					return FALSE;
#line 8098 "TweetUtils.c"
				}
#line 839 "../src/util/TweetUtils.vala"
				_data_->_tmp166_ = _data_->root;
#line 839 "../src/util/TweetUtils.vala"
				if (_data_->_tmp166_ == NULL) {
#line 840 "../src/util/TweetUtils.vala"
					_data_->_tmp167_ = media_upload_get_filepath (_data_->media_upload);
#line 840 "../src/util/TweetUtils.vala"
					_data_->_tmp168_ = _data_->_tmp167_;
#line 840 "../src/util/TweetUtils.vala"
					_data_->_tmp169_ = _data_->_tmp168_;
#line 840 "../src/util/TweetUtils.vala"
					g_warning ("TweetUtils.vala:840: Null response checking status of %s", _data_->_tmp169_);
#line 840 "../src/util/TweetUtils.vala"
					_g_free0 (_data_->_tmp169_);
#line 841 "../src/util/TweetUtils.vala"
					_data_->result = FALSE;
#line 841 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->status_call);
#line 841 "../src/util/TweetUtils.vala"
					_g_free0 (_data_->state);
#line 841 "../src/util/TweetUtils.vala"
					_json_object_unref0 (_data_->processing_info);
#line 841 "../src/util/TweetUtils.vala"
					_json_object_unref0 (_data_->object);
#line 841 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->finalise_call);
#line 841 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->file_reader);
#line 841 "../src/util/TweetUtils.vala"
					__vala_JsonNode_free0 (_data_->root);
#line 841 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->init_call);
#line 841 "../src/util/TweetUtils.vala"
					_g_object_unref0 (_data_->upload_proxy);
#line 841 "../src/util/TweetUtils.vala"
					block70_data_unref (_data_->_data70_);
#line 841 "../src/util/TweetUtils.vala"
					_data_->_data70_ = NULL;
#line 841 "../src/util/TweetUtils.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 841 "../src/util/TweetUtils.vala"
					if (_data_->_state_ != 0) {
#line 841 "../src/util/TweetUtils.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 841 "../src/util/TweetUtils.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8146 "TweetUtils.c"
						}
					}
#line 841 "../src/util/TweetUtils.vala"
					g_object_unref (_data_->_async_result);
#line 841 "../src/util/TweetUtils.vala"
					return FALSE;
#line 8153 "TweetUtils.c"
				}
#line 843 "../src/util/TweetUtils.vala"
				_data_->_tmp170_ = _data_->root;
#line 843 "../src/util/TweetUtils.vala"
				_data_->_tmp171_ = json_node_get_object (_data_->_tmp170_);
#line 843 "../src/util/TweetUtils.vala"
				_data_->_tmp172_ = _json_object_ref0 (_data_->_tmp171_);
#line 843 "../src/util/TweetUtils.vala"
				_json_object_unref0 (_data_->object);
#line 843 "../src/util/TweetUtils.vala"
				_data_->object = _data_->_tmp172_;
#line 794 "../src/util/TweetUtils.vala"
				_g_object_unref0 (_data_->status_call);
#line 8167 "TweetUtils.c"
			}
		}
#line 788 "../src/util/TweetUtils.vala"
		_g_free0 (_data_->state);
#line 788 "../src/util/TweetUtils.vala"
		_json_object_unref0 (_data_->processing_info);
#line 8174 "TweetUtils.c"
	}
#line 846 "../src/util/TweetUtils.vala"
	media_upload_finalize_upload (_data_->media_upload);
#line 847 "../src/util/TweetUtils.vala"
	_data_->result = TRUE;
#line 847 "../src/util/TweetUtils.vala"
	_json_object_unref0 (_data_->object);
#line 847 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->finalise_call);
#line 847 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->file_reader);
#line 847 "../src/util/TweetUtils.vala"
	__vala_JsonNode_free0 (_data_->root);
#line 847 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->init_call);
#line 847 "../src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->upload_proxy);
#line 847 "../src/util/TweetUtils.vala"
	block70_data_unref (_data_->_data70_);
#line 847 "../src/util/TweetUtils.vala"
	_data_->_data70_ = NULL;
#line 847 "../src/util/TweetUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 847 "../src/util/TweetUtils.vala"
	if (_data_->_state_ != 0) {
#line 847 "../src/util/TweetUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 847 "../src/util/TweetUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8204 "TweetUtils.c"
		}
	}
#line 847 "../src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 847 "../src/util/TweetUtils.vala"
	return FALSE;
#line 8211 "TweetUtils.c"
}

static void
tweet_utils_download_avatar_data_free (gpointer _data)
{
	TweetUtilsDownloadAvatarData* _data_;
	_data_ = _data;
	_g_free0 (_data_->avatar_url);
	_g_object_unref0 (_data_->cancellable);
	_g_object_unref0 (_data_->result);
	g_slice_free (TweetUtilsDownloadAvatarData, _data_);
}

void
tweet_utils_download_avatar (const gchar* avatar_url,
                             gint size,
                             GCancellable* cancellable,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	TweetUtilsDownloadAvatarData* _data_;
	gchar* _tmp0_;
	GCancellable* _tmp1_;
	g_return_if_fail (avatar_url != NULL);
	_data_ = g_slice_new0 (TweetUtilsDownloadAvatarData);
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tweet_utils_download_avatar_data_free);
	_tmp0_ = g_strdup (avatar_url);
	_g_free0 (_data_->avatar_url);
	_data_->avatar_url = _tmp0_;
	_data_->size = size;
	_tmp1_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp1_;
	tweet_utils_download_avatar_co (_data_);
}

GdkPixbuf*
tweet_utils_download_avatar_finish (GAsyncResult* _res_,
                                    GError** error)
{
	GdkPixbuf* result;
	TweetUtilsDownloadAvatarData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

/**
   * Downloads the avatar from the given url.
   *
   * @param avatar_url The avatar url to download
   *
   * @return The loaded avatar.
   */
static Block71Data*
block71_data_ref (Block71Data* _data71_)
{
#line 857 "../src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data71_->_ref_count_);
#line 857 "../src/util/TweetUtils.vala"
	return _data71_;
#line 8278 "TweetUtils.c"
}

static void
block71_data_unref (void * _userdata_)
{
	Block71Data* _data71_;
	_data71_ = (Block71Data*) _userdata_;
#line 857 "../src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data71_->_ref_count_)) {
#line 857 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data71_->err);
#line 857 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data71_->msg);
#line 857 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data71_->avatar);
#line 857 "../src/util/TweetUtils.vala"
		g_slice_free (Block71Data, _data71_);
#line 8296 "TweetUtils.c"
	}
}

static void
___lambda9_ (Block71Data* _data71_)
{
	SoupSession* _tmp0_;
	SoupMessage* _tmp1_;
#line 862 "../src/util/TweetUtils.vala"
	_tmp0_ = SOUP_SESSION;
#line 862 "../src/util/TweetUtils.vala"
	_tmp1_ = _data71_->msg;
#line 862 "../src/util/TweetUtils.vala"
	soup_session_cancel_message (_tmp0_, _tmp1_, (guint) SOUP_STATUS_CANCELLED);
#line 8311 "TweetUtils.c"
}

static void
____lambda9__g_cancellable_cancelled (GCancellable* _sender,
                                      gpointer self)
{
#line 862 "../src/util/TweetUtils.vala"
	___lambda9_ (self);
#line 8320 "TweetUtils.c"
}

static guint8*
_vala_array_dup14 (guint8* self,
                   gssize length)
{
#line 871 "../src/util/TweetUtils.vala"
	if (length > 0) {
#line 871 "../src/util/TweetUtils.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 8331 "TweetUtils.c"
	}
#line 871 "../src/util/TweetUtils.vala"
	return NULL;
#line 8335 "TweetUtils.c"
}

static void
__lambda10_ (Block71Data* _data71_,
             SoupSession* s,
             SoupMessage* _msg)
{
	guint _tmp0_;
	guint _tmp1_;
	GMemoryInputStream* memory_stream = NULL;
	SoupMessageBody* _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
	GDestroyNotify _tmp5_;
	GMemoryInputStream* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 865 "../src/util/TweetUtils.vala"
	g_return_if_fail (s != NULL);
#line 865 "../src/util/TweetUtils.vala"
	g_return_if_fail (_msg != NULL);
#line 866 "../src/util/TweetUtils.vala"
	g_object_get (_msg, "status-code", &_tmp0_, NULL);
#line 866 "../src/util/TweetUtils.vala"
	_tmp1_ = _tmp0_;
#line 866 "../src/util/TweetUtils.vala"
	if (_tmp1_ != ((guint) SOUP_STATUS_OK)) {
#line 867 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data71_->avatar);
#line 867 "../src/util/TweetUtils.vala"
		_data71_->avatar = NULL;
#line 868 "../src/util/TweetUtils.vala"
		tweet_utils_download_avatar_co (_data71_->_async_data_);
#line 869 "../src/util/TweetUtils.vala"
		return;
#line 8372 "TweetUtils.c"
	}
#line 871 "../src/util/TweetUtils.vala"
	_tmp2_ = _msg->response_body;
#line 871 "../src/util/TweetUtils.vala"
	_tmp3_ = _tmp2_->data;
#line 871 "../src/util/TweetUtils.vala"
	_tmp3__length1 = _tmp2_->length;
#line 871 "../src/util/TweetUtils.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup14 (_tmp3_, _tmp3__length1) : _tmp3_;
#line 871 "../src/util/TweetUtils.vala"
	_tmp4__length1 = _tmp3__length1;
#line 871 "../src/util/TweetUtils.vala"
	_tmp5_ = g_free;
#line 871 "../src/util/TweetUtils.vala"
	_tmp6_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp4_, _tmp4__length1, _tmp5_);
#line 871 "../src/util/TweetUtils.vala"
	memory_stream = _tmp6_;
#line 8390 "TweetUtils.c"
	{
		GdkPixbuf* _tmp7_ = NULL;
		GMemoryInputStream* _tmp8_;
		GdkPixbuf* _tmp9_;
		GdkPixbuf* _tmp10_;
#line 874 "../src/util/TweetUtils.vala"
		_tmp8_ = memory_stream;
#line 874 "../src/util/TweetUtils.vala"
		_tmp9_ = gdk_pixbuf_new_from_stream_at_scale ((GInputStream*) _tmp8_, _data71_->size, _data71_->size, FALSE, NULL, &_inner_error0_);
#line 874 "../src/util/TweetUtils.vala"
		_tmp7_ = _tmp9_;
#line 874 "../src/util/TweetUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8404 "TweetUtils.c"
			goto __catch0_g_error;
		}
#line 874 "../src/util/TweetUtils.vala"
		_tmp10_ = _tmp7_;
#line 874 "../src/util/TweetUtils.vala"
		_tmp7_ = NULL;
#line 874 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_data71_->avatar);
#line 874 "../src/util/TweetUtils.vala"
		_data71_->avatar = _tmp10_;
#line 873 "../src/util/TweetUtils.vala"
		_g_object_unref0 (_tmp7_);
#line 8417 "TweetUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		GError* _tmp12_;
#line 873 "../src/util/TweetUtils.vala"
		e = _inner_error0_;
#line 873 "../src/util/TweetUtils.vala"
		_inner_error0_ = NULL;
#line 878 "../src/util/TweetUtils.vala"
		_tmp11_ = e;
#line 878 "../src/util/TweetUtils.vala"
		_tmp12_ = _g_error_copy0 (_tmp11_);
#line 878 "../src/util/TweetUtils.vala"
		_g_error_free0 (_data71_->err);
#line 878 "../src/util/TweetUtils.vala"
		_data71_->err = _tmp12_;
#line 873 "../src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 8439 "TweetUtils.c"
	}
	__finally0:
#line 873 "../src/util/TweetUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 873 "../src/util/TweetUtils.vala"
		_g_object_unref0 (memory_stream);
#line 873 "../src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 873 "../src/util/TweetUtils.vala"
		g_clear_error (&_inner_error0_);
#line 873 "../src/util/TweetUtils.vala"
		return;
#line 8452 "TweetUtils.c"
	}
#line 880 "../src/util/TweetUtils.vala"
	tweet_utils_download_avatar_co (_data71_->_async_data_);
#line 865 "../src/util/TweetUtils.vala"
	_g_object_unref0 (memory_stream);
#line 8458 "TweetUtils.c"
}

static void
___lambda10__soup_session_callback (SoupSession* session,
                                    SoupMessage* msg,
                                    gpointer self)
{
#line 865 "../src/util/TweetUtils.vala"
	__lambda10_ (self, session, msg);
#line 865 "../src/util/TweetUtils.vala"
	block71_data_unref (self);
#line 8470 "TweetUtils.c"
}

static gboolean
tweet_utils_download_avatar_co (TweetUtilsDownloadAvatarData* _data_)
{
#line 857 "../src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 857 "../src/util/TweetUtils.vala"
		case 0:
#line 8480 "TweetUtils.c"
		goto _state_0;
#line 857 "../src/util/TweetUtils.vala"
		case 1:
#line 8484 "TweetUtils.c"
		goto _state_1;
		default:
#line 857 "../src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 8489 "TweetUtils.c"
	}
	_state_0:
#line 857 "../src/util/TweetUtils.vala"
	_data_->_data71_ = g_slice_new0 (Block71Data);
#line 857 "../src/util/TweetUtils.vala"
	_data_->_data71_->_ref_count_ = 1;
#line 857 "../src/util/TweetUtils.vala"
	_data_->_data71_->size = _data_->size;
#line 857 "../src/util/TweetUtils.vala"
	_data_->_data71_->_async_data_ = _data_;
#line 859 "../src/util/TweetUtils.vala"
	_data_->_data71_->avatar = NULL;
#line 860 "../src/util/TweetUtils.vala"
	_data_->_tmp0_ = soup_message_new ("GET", _data_->avatar_url);
#line 860 "../src/util/TweetUtils.vala"
	_data_->_data71_->msg = _data_->_tmp0_;
#line 861 "../src/util/TweetUtils.vala"
	if (_data_->cancellable != NULL) {
#line 862 "../src/util/TweetUtils.vala"
		g_signal_connect_data (_data_->cancellable, "cancelled", (GCallback) ____lambda9__g_cancellable_cancelled, block71_data_ref (_data_->_data71_), (GClosureNotify) block71_data_unref, 0);
#line 8510 "TweetUtils.c"
	}
#line 864 "../src/util/TweetUtils.vala"
	_data_->_data71_->err = NULL;
#line 865 "../src/util/TweetUtils.vala"
	_data_->_tmp1_ = SOUP_SESSION;
#line 865 "../src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->_data71_->msg;
#line 865 "../src/util/TweetUtils.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->_tmp2_);
#line 865 "../src/util/TweetUtils.vala"
	soup_session_queue_message (_data_->_tmp1_, _data_->_tmp3_, ___lambda10__soup_session_callback, block71_data_ref (_data_->_data71_));
#line 882 "../src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 882 "../src/util/TweetUtils.vala"
	return FALSE;
#line 8526 "TweetUtils.c"
	_state_1:
	;
#line 883 "../src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->_data71_->err;
#line 883 "../src/util/TweetUtils.vala"
	if (_data_->_tmp4_ != NULL) {
#line 884 "../src/util/TweetUtils.vala"
		_data_->_tmp5_ = _data_->_data71_->err;
#line 884 "../src/util/TweetUtils.vala"
		_data_->_tmp6_ = _g_error_copy0 (_data_->_tmp5_);
#line 884 "../src/util/TweetUtils.vala"
		_data_->_inner_error0_ = _data_->_tmp6_;
#line 884 "../src/util/TweetUtils.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 884 "../src/util/TweetUtils.vala"
		block71_data_unref (_data_->_data71_);
#line 884 "../src/util/TweetUtils.vala"
		_data_->_data71_ = NULL;
#line 884 "../src/util/TweetUtils.vala"
		g_object_unref (_data_->_async_result);
#line 884 "../src/util/TweetUtils.vala"
		return FALSE;
#line 8549 "TweetUtils.c"
	}
#line 886 "../src/util/TweetUtils.vala"
	_data_->_tmp7_ = _data_->_data71_->avatar;
#line 886 "../src/util/TweetUtils.vala"
	_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
#line 886 "../src/util/TweetUtils.vala"
	_data_->result = _data_->_tmp8_;
#line 886 "../src/util/TweetUtils.vala"
	block71_data_unref (_data_->_data71_);
#line 886 "../src/util/TweetUtils.vala"
	_data_->_data71_ = NULL;
#line 886 "../src/util/TweetUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 886 "../src/util/TweetUtils.vala"
	if (_data_->_state_ != 0) {
#line 886 "../src/util/TweetUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 886 "../src/util/TweetUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8569 "TweetUtils.c"
		}
	}
#line 886 "../src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 886 "../src/util/TweetUtils.vala"
	return FALSE;
#line 8576 "TweetUtils.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 8599 "TweetUtils.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 8608 "TweetUtils.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 8627 "TweetUtils.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 8631 "TweetUtils.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 8637 "TweetUtils.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 8647 "TweetUtils.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 8655 "TweetUtils.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 8659 "TweetUtils.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 8665 "TweetUtils.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 8675 "TweetUtils.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1142 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1142 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1144 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1144 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 8699 "TweetUtils.c"
		gchar* _tmp2_;
#line 1145 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1145 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1145 "glib-2.0.vapi"
		return result;
#line 8707 "TweetUtils.c"
	} else {
#line 1147 "glib-2.0.vapi"
		result = -1;
#line 1147 "glib-2.0.vapi"
		return result;
#line 8713 "TweetUtils.c"
	}
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 778 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 779 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 779 "glib-2.0.vapi"
	return result;
#line 8728 "TweetUtils.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 8750 "TweetUtils.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 8754 "TweetUtils.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 8760 "TweetUtils.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 8764 "TweetUtils.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 8768 "TweetUtils.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 8776 "TweetUtils.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 8804 "TweetUtils.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 8813 "TweetUtils.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 8827 "TweetUtils.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 8836 "TweetUtils.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 8850 "TweetUtils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 8859 "TweetUtils.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 8868 "TweetUtils.c"
}

gboolean
tweet_utils_activate_link (const gchar* uri,
                           MainWindow* window)
{
	const gchar* _tmp0_;
	gchar* term = NULL;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 889 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 889 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (window != NULL, FALSE);
#line 890 "../src/util/TweetUtils.vala"
	g_debug ("TweetUtils.vala:890: Activating '%s'", uri);
#line 891 "../src/util/TweetUtils.vala"
	_tmp0_ = g_strstrip (uri);
#line 891 "../src/util/TweetUtils.vala"
	uri = _tmp0_;
#line 892 "../src/util/TweetUtils.vala"
	_tmp1_ = string_substring (uri, (glong) 1, (glong) -1);
#line 892 "../src/util/TweetUtils.vala"
	term = _tmp1_;
#line 894 "../src/util/TweetUtils.vala"
	if (g_str_has_prefix (uri, "@")) {
#line 8896 "TweetUtils.c"
		gint slash_index = 0;
		CbBundle* bundle = NULL;
		CbBundle* _tmp2_;
#line 895 "../src/util/TweetUtils.vala"
		slash_index = string_index_of (uri, "/", 0);
#line 896 "../src/util/TweetUtils.vala"
		_tmp2_ = cb_bundle_new ();
#line 896 "../src/util/TweetUtils.vala"
		bundle = _tmp2_;
#line 897 "../src/util/TweetUtils.vala"
		if (slash_index == -1) {
#line 8908 "TweetUtils.c"
			CbBundle* _tmp3_;
			const gchar* _tmp4_;
			MainWidget* _tmp5_;
			CbBundle* _tmp6_;
#line 898 "../src/util/TweetUtils.vala"
			_tmp3_ = bundle;
#line 898 "../src/util/TweetUtils.vala"
			_tmp4_ = term;
#line 898 "../src/util/TweetUtils.vala"
			cb_bundle_put_int64 (_tmp3_, PROFILE_PAGE_KEY_USER_ID, int64_parse (_tmp4_, (guint) 0));
#line 899 "../src/util/TweetUtils.vala"
			_tmp5_ = window->main_widget;
#line 899 "../src/util/TweetUtils.vala"
			_tmp6_ = bundle;
#line 899 "../src/util/TweetUtils.vala"
			main_widget_switch_page (_tmp5_, (gint) PAGE_PROFILE, _tmp6_);
#line 8925 "TweetUtils.c"
		} else {
			CbBundle* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			CbBundle* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			MainWidget* _tmp18_;
			CbBundle* _tmp19_;
#line 901 "../src/util/TweetUtils.vala"
			_tmp7_ = bundle;
#line 901 "../src/util/TweetUtils.vala"
			_tmp8_ = term;
#line 901 "../src/util/TweetUtils.vala"
			_tmp9_ = string_substring (_tmp8_, (glong) 0, (glong) (slash_index - 1));
#line 901 "../src/util/TweetUtils.vala"
			_tmp10_ = _tmp9_;
#line 901 "../src/util/TweetUtils.vala"
			cb_bundle_put_int64 (_tmp7_, PROFILE_PAGE_KEY_USER_ID, int64_parse (_tmp10_, (guint) 0));
#line 901 "../src/util/TweetUtils.vala"
			_g_free0 (_tmp10_);
#line 902 "../src/util/TweetUtils.vala"
			_tmp11_ = bundle;
#line 902 "../src/util/TweetUtils.vala"
			_tmp12_ = term;
#line 902 "../src/util/TweetUtils.vala"
			_tmp13_ = term;
#line 902 "../src/util/TweetUtils.vala"
			_tmp14_ = strlen (_tmp13_);
#line 902 "../src/util/TweetUtils.vala"
			_tmp15_ = _tmp14_;
#line 902 "../src/util/TweetUtils.vala"
			_tmp16_ = string_substring (_tmp12_, (glong) (slash_index + 1), (glong) ((_tmp15_ - slash_index) - 1));
#line 902 "../src/util/TweetUtils.vala"
			_tmp17_ = _tmp16_;
#line 902 "../src/util/TweetUtils.vala"
			cb_bundle_put_string (_tmp11_, PROFILE_PAGE_KEY_SCREEN_NAME, _tmp17_);
#line 902 "../src/util/TweetUtils.vala"
			_g_free0 (_tmp17_);
#line 904 "../src/util/TweetUtils.vala"
			_tmp18_ = window->main_widget;
#line 904 "../src/util/TweetUtils.vala"
			_tmp19_ = bundle;
#line 904 "../src/util/TweetUtils.vala"
			main_widget_switch_page (_tmp18_, (gint) PAGE_PROFILE, _tmp19_);
#line 8976 "TweetUtils.c"
		}
#line 906 "../src/util/TweetUtils.vala"
		result = TRUE;
#line 906 "../src/util/TweetUtils.vala"
		_g_object_unref0 (bundle);
#line 906 "../src/util/TweetUtils.vala"
		_g_free0 (term);
#line 906 "../src/util/TweetUtils.vala"
		return result;
#line 8986 "TweetUtils.c"
	} else {
#line 907 "../src/util/TweetUtils.vala"
		if (g_str_has_prefix (uri, "#")) {
#line 8990 "TweetUtils.c"
			CbBundle* bundle = NULL;
			CbBundle* _tmp20_;
			CbBundle* _tmp21_;
			MainWidget* _tmp22_;
			CbBundle* _tmp23_;
#line 908 "../src/util/TweetUtils.vala"
			_tmp20_ = cb_bundle_new ();
#line 908 "../src/util/TweetUtils.vala"
			bundle = _tmp20_;
#line 909 "../src/util/TweetUtils.vala"
			_tmp21_ = bundle;
#line 909 "../src/util/TweetUtils.vala"
			cb_bundle_put_string (_tmp21_, SEARCH_PAGE_KEY_QUERY, uri);
#line 910 "../src/util/TweetUtils.vala"
			_tmp22_ = window->main_widget;
#line 910 "../src/util/TweetUtils.vala"
			_tmp23_ = bundle;
#line 910 "../src/util/TweetUtils.vala"
			main_widget_switch_page (_tmp22_, (gint) PAGE_SEARCH, _tmp23_);
#line 911 "../src/util/TweetUtils.vala"
			result = TRUE;
#line 911 "../src/util/TweetUtils.vala"
			_g_object_unref0 (bundle);
#line 911 "../src/util/TweetUtils.vala"
			_g_free0 (term);
#line 911 "../src/util/TweetUtils.vala"
			return result;
#line 9018 "TweetUtils.c"
		} else {
#line 912 "../src/util/TweetUtils.vala"
			if (g_str_has_prefix (uri, "https://twitter.com/")) {
#line 9022 "TweetUtils.c"
				gchar** parts = NULL;
				gchar** _tmp24_;
				gchar** _tmp25_;
				gint parts_length1;
				gint _parts_size_;
				gchar** _tmp26_;
				gint _tmp26__length1;
				const gchar* _tmp27_;
#line 914 "../src/util/TweetUtils.vala"
				_tmp25_ = _tmp24_ = g_strsplit (uri, "/", 0);
#line 914 "../src/util/TweetUtils.vala"
				parts = _tmp25_;
#line 914 "../src/util/TweetUtils.vala"
				parts_length1 = _vala_array_length (_tmp24_);
#line 914 "../src/util/TweetUtils.vala"
				_parts_size_ = parts_length1;
#line 915 "../src/util/TweetUtils.vala"
				_tmp26_ = parts;
#line 915 "../src/util/TweetUtils.vala"
				_tmp26__length1 = parts_length1;
#line 915 "../src/util/TweetUtils.vala"
				_tmp27_ = _tmp26_[4];
#line 915 "../src/util/TweetUtils.vala"
				if (g_strcmp0 (_tmp27_, "status") == 0) {
#line 9047 "TweetUtils.c"
					gint64 tweet_id = 0LL;
					gchar** _tmp28_;
					gint _tmp28__length1;
					const gchar* _tmp29_;
					CbBundle* bundle = NULL;
					CbBundle* _tmp30_;
					CbBundle* _tmp31_;
					CbBundle* _tmp32_;
					CbBundle* _tmp33_;
					gchar** _tmp34_;
					gint _tmp34__length1;
					const gchar* _tmp35_;
					MainWidget* _tmp36_;
					CbBundle* _tmp37_;
#line 917 "../src/util/TweetUtils.vala"
					_tmp28_ = parts;
#line 917 "../src/util/TweetUtils.vala"
					_tmp28__length1 = parts_length1;
#line 917 "../src/util/TweetUtils.vala"
					_tmp29_ = _tmp28_[5];
#line 917 "../src/util/TweetUtils.vala"
					tweet_id = int64_parse (_tmp29_, (guint) 0);
#line 918 "../src/util/TweetUtils.vala"
					_tmp30_ = cb_bundle_new ();
#line 918 "../src/util/TweetUtils.vala"
					bundle = _tmp30_;
#line 919 "../src/util/TweetUtils.vala"
					_tmp31_ = bundle;
#line 919 "../src/util/TweetUtils.vala"
					cb_bundle_put_int (_tmp31_, TWEET_INFO_PAGE_KEY_MODE, TWEET_INFO_PAGE_BY_ID);
#line 920 "../src/util/TweetUtils.vala"
					_tmp32_ = bundle;
#line 920 "../src/util/TweetUtils.vala"
					cb_bundle_put_int64 (_tmp32_, TWEET_INFO_PAGE_KEY_TWEET_ID, tweet_id);
#line 921 "../src/util/TweetUtils.vala"
					_tmp33_ = bundle;
#line 921 "../src/util/TweetUtils.vala"
					_tmp34_ = parts;
#line 921 "../src/util/TweetUtils.vala"
					_tmp34__length1 = parts_length1;
#line 921 "../src/util/TweetUtils.vala"
					_tmp35_ = _tmp34_[3];
#line 921 "../src/util/TweetUtils.vala"
					cb_bundle_put_string (_tmp33_, TWEET_INFO_PAGE_KEY_SCREEN_NAME, _tmp35_);
#line 922 "../src/util/TweetUtils.vala"
					_tmp36_ = window->main_widget;
#line 922 "../src/util/TweetUtils.vala"
					_tmp37_ = bundle;
#line 922 "../src/util/TweetUtils.vala"
					main_widget_switch_page (_tmp36_, (gint) PAGE_TWEET_INFO, _tmp37_);
#line 924 "../src/util/TweetUtils.vala"
					result = TRUE;
#line 924 "../src/util/TweetUtils.vala"
					_g_object_unref0 (bundle);
#line 924 "../src/util/TweetUtils.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 924 "../src/util/TweetUtils.vala"
					_g_free0 (term);
#line 924 "../src/util/TweetUtils.vala"
					return result;
#line 9108 "TweetUtils.c"
				}
#line 912 "../src/util/TweetUtils.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 9112 "TweetUtils.c"
			} else {
#line 927 "../src/util/TweetUtils.vala"
				if (g_str_has_prefix (uri, "translate-")) {
#line 9116 "TweetUtils.c"
					gchar** parts = NULL;
					gchar* _tmp38_;
					gchar* _tmp39_;
					gchar** _tmp40_;
					gchar** _tmp41_;
					gchar** _tmp42_;
					gint _tmp42__length1;
					gint parts_length1;
					gint _parts_size_;
					gchar* src_lang = NULL;
					gchar** _tmp43_;
					gint _tmp43__length1;
					const gchar* _tmp44_;
					gchar* _tmp45_;
					const gchar* _tmp46_;
					gchar* content = NULL;
					gchar** _tmp48_;
					gint _tmp48__length1;
					const gchar* _tmp49_;
					gchar* _tmp50_;
					gchar* target_lang = NULL;
					gchar* _tmp51_;
					gchar* url = NULL;
					gchar* _tmp52_;
					const gchar* _tmp53_;
					const gchar* _tmp54_;
					gchar* _tmp55_;
					gchar* _tmp56_;
					const gchar* _tmp57_;
					gchar* _tmp58_;
					gchar* _tmp59_;
					const gchar* _tmp60_;
					gchar* _tmp61_;
#line 928 "../src/util/TweetUtils.vala"
					_tmp38_ = string_substring (uri, (glong) 10, (glong) -1);
#line 928 "../src/util/TweetUtils.vala"
					_tmp39_ = _tmp38_;
#line 928 "../src/util/TweetUtils.vala"
					_tmp41_ = _tmp40_ = g_strsplit (_tmp39_, ":", 2);
#line 928 "../src/util/TweetUtils.vala"
					_tmp42_ = _tmp41_;
#line 928 "../src/util/TweetUtils.vala"
					_tmp42__length1 = _vala_array_length (_tmp40_);
#line 928 "../src/util/TweetUtils.vala"
					_g_free0 (_tmp39_);
#line 928 "../src/util/TweetUtils.vala"
					parts = _tmp42_;
#line 928 "../src/util/TweetUtils.vala"
					parts_length1 = _tmp42__length1;
#line 928 "../src/util/TweetUtils.vala"
					_parts_size_ = parts_length1;
#line 929 "../src/util/TweetUtils.vala"
					_tmp43_ = parts;
#line 929 "../src/util/TweetUtils.vala"
					_tmp43__length1 = parts_length1;
#line 929 "../src/util/TweetUtils.vala"
					_tmp44_ = _tmp43_[0];
#line 929 "../src/util/TweetUtils.vala"
					_tmp45_ = g_strdup (_tmp44_);
#line 929 "../src/util/TweetUtils.vala"
					src_lang = _tmp45_;
#line 930 "../src/util/TweetUtils.vala"
					_tmp46_ = src_lang;
#line 930 "../src/util/TweetUtils.vala"
					if (g_strcmp0 (_tmp46_, "und") == 0) {
#line 9182 "TweetUtils.c"
						gchar* _tmp47_;
#line 931 "../src/util/TweetUtils.vala"
						_tmp47_ = g_strdup ("auto");
#line 931 "../src/util/TweetUtils.vala"
						_g_free0 (src_lang);
#line 931 "../src/util/TweetUtils.vala"
						src_lang = _tmp47_;
#line 9190 "TweetUtils.c"
					}
#line 933 "../src/util/TweetUtils.vala"
					_tmp48_ = parts;
#line 933 "../src/util/TweetUtils.vala"
					_tmp48__length1 = parts_length1;
#line 933 "../src/util/TweetUtils.vala"
					_tmp49_ = _tmp48_[1];
#line 933 "../src/util/TweetUtils.vala"
					_tmp50_ = g_strdup (_tmp49_);
#line 933 "../src/util/TweetUtils.vala"
					content = _tmp50_;
#line 934 "../src/util/TweetUtils.vala"
					_tmp51_ = utils_get_user_language ();
#line 934 "../src/util/TweetUtils.vala"
					target_lang = _tmp51_;
#line 935 "../src/util/TweetUtils.vala"
					_tmp52_ = settings_get_translation_service_url ();
#line 935 "../src/util/TweetUtils.vala"
					url = _tmp52_;
#line 936 "../src/util/TweetUtils.vala"
					_tmp53_ = url;
#line 936 "../src/util/TweetUtils.vala"
					_tmp54_ = src_lang;
#line 936 "../src/util/TweetUtils.vala"
					_tmp55_ = string_replace (_tmp53_, "{SOURCE_LANG}", _tmp54_);
#line 936 "../src/util/TweetUtils.vala"
					_tmp56_ = _tmp55_;
#line 936 "../src/util/TweetUtils.vala"
					_tmp57_ = target_lang;
#line 936 "../src/util/TweetUtils.vala"
					_tmp58_ = string_replace (_tmp56_, "{TARGET_LANG}", _tmp57_);
#line 936 "../src/util/TweetUtils.vala"
					_tmp59_ = _tmp58_;
#line 936 "../src/util/TweetUtils.vala"
					_tmp60_ = content;
#line 936 "../src/util/TweetUtils.vala"
					_tmp61_ = string_replace (_tmp59_, "{CONTENT}", _tmp60_);
#line 936 "../src/util/TweetUtils.vala"
					_g_free0 (url);
#line 936 "../src/util/TweetUtils.vala"
					url = _tmp61_;
#line 936 "../src/util/TweetUtils.vala"
					_g_free0 (_tmp59_);
#line 936 "../src/util/TweetUtils.vala"
					_g_free0 (_tmp56_);
#line 9236 "TweetUtils.c"
					{
						const gchar* _tmp62_;
#line 938 "../src/util/TweetUtils.vala"
						_tmp62_ = url;
#line 938 "../src/util/TweetUtils.vala"
						gtk_show_uri_on_window ((GtkWindow*) window, _tmp62_, (guint32) GDK_CURRENT_TIME, &_inner_error0_);
#line 938 "../src/util/TweetUtils.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9245 "TweetUtils.c"
							goto __catch0_g_error;
						}
#line 939 "../src/util/TweetUtils.vala"
						result = TRUE;
#line 939 "../src/util/TweetUtils.vala"
						_g_free0 (url);
#line 939 "../src/util/TweetUtils.vala"
						_g_free0 (target_lang);
#line 939 "../src/util/TweetUtils.vala"
						_g_free0 (content);
#line 939 "../src/util/TweetUtils.vala"
						_g_free0 (src_lang);
#line 939 "../src/util/TweetUtils.vala"
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 939 "../src/util/TweetUtils.vala"
						_g_free0 (term);
#line 939 "../src/util/TweetUtils.vala"
						return result;
#line 9264 "TweetUtils.c"
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* e = NULL;
						GError* _tmp63_;
#line 937 "../src/util/TweetUtils.vala"
						e = _inner_error0_;
#line 937 "../src/util/TweetUtils.vala"
						_inner_error0_ = NULL;
#line 942 "../src/util/TweetUtils.vala"
						_tmp63_ = e;
#line 942 "../src/util/TweetUtils.vala"
						utils_show_error_dialog (_tmp63_, (GtkWindow*) window, NULL, 0);
#line 937 "../src/util/TweetUtils.vala"
						_g_error_free0 (e);
#line 9281 "TweetUtils.c"
					}
					__finally0:
#line 937 "../src/util/TweetUtils.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9286 "TweetUtils.c"
						gboolean _tmp64_ = FALSE;
#line 937 "../src/util/TweetUtils.vala"
						_g_free0 (url);
#line 937 "../src/util/TweetUtils.vala"
						_g_free0 (target_lang);
#line 937 "../src/util/TweetUtils.vala"
						_g_free0 (content);
#line 937 "../src/util/TweetUtils.vala"
						_g_free0 (src_lang);
#line 937 "../src/util/TweetUtils.vala"
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 937 "../src/util/TweetUtils.vala"
						_g_free0 (term);
#line 937 "../src/util/TweetUtils.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 937 "../src/util/TweetUtils.vala"
						g_clear_error (&_inner_error0_);
#line 937 "../src/util/TweetUtils.vala"
						return _tmp64_;
#line 9306 "TweetUtils.c"
					}
#line 927 "../src/util/TweetUtils.vala"
					_g_free0 (url);
#line 927 "../src/util/TweetUtils.vala"
					_g_free0 (target_lang);
#line 927 "../src/util/TweetUtils.vala"
					_g_free0 (content);
#line 927 "../src/util/TweetUtils.vala"
					_g_free0 (src_lang);
#line 927 "../src/util/TweetUtils.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 9318 "TweetUtils.c"
				}
			}
		}
	}
#line 945 "../src/util/TweetUtils.vala"
	result = FALSE;
#line 945 "../src/util/TweetUtils.vala"
	_g_free0 (term);
#line 945 "../src/util/TweetUtils.vala"
	return result;
#line 9329 "TweetUtils.c"
}

void
tweet_utils_work_array (JsonArray* json_array,
                        TweetListBox* tweet_list,
                        Account* account)
{
	guint n_tweets = 0U;
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
#line 949 "../src/util/TweetUtils.vala"
	g_return_if_fail (json_array != NULL);
#line 949 "../src/util/TweetUtils.vala"
	g_return_if_fail (tweet_list != NULL);
#line 949 "../src/util/TweetUtils.vala"
	g_return_if_fail (account != NULL);
#line 952 "../src/util/TweetUtils.vala"
	n_tweets = json_array_get_length (json_array);
#line 955 "../src/util/TweetUtils.vala"
	if (n_tweets == ((guint) 0)) {
#line 956 "../src/util/TweetUtils.vala"
		return;
#line 9352 "TweetUtils.c"
	}
#line 959 "../src/util/TweetUtils.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 959 "../src/util/TweetUtils.vala"
	now = _tmp0_;
#line 9358 "TweetUtils.c"
	{
		guint i = 0U;
#line 960 "../src/util/TweetUtils.vala"
		i = (guint) 0;
#line 9363 "TweetUtils.c"
		{
			gboolean _tmp1_ = FALSE;
#line 960 "../src/util/TweetUtils.vala"
			_tmp1_ = TRUE;
#line 960 "../src/util/TweetUtils.vala"
			while (TRUE) {
#line 9370 "TweetUtils.c"
				CbTweet* tweet = NULL;
				CbTweet* _tmp3_;
				CbTweet* _tmp4_;
				JsonNode* _tmp5_;
				GDateTime* _tmp6_;
				gboolean _tmp7_ = FALSE;
				gboolean _tmp8_ = FALSE;
				CbUserCounter* _tmp9_;
				CbUserCounter* _tmp11_;
				CbTweet* _tmp12_;
				CbTweet* _tmp13_;
				CbMiniTweet* _tmp14_;
				CbTweet* _tmp18_;
				CbTweetModel* _tmp19_;
				CbTweet* _tmp20_;
#line 960 "../src/util/TweetUtils.vala"
				if (!_tmp1_) {
#line 9388 "TweetUtils.c"
					guint _tmp2_;
#line 960 "../src/util/TweetUtils.vala"
					_tmp2_ = i;
#line 960 "../src/util/TweetUtils.vala"
					i = _tmp2_ + 1;
#line 9394 "TweetUtils.c"
				}
#line 960 "../src/util/TweetUtils.vala"
				_tmp1_ = FALSE;
#line 960 "../src/util/TweetUtils.vala"
				if (!(i < n_tweets)) {
#line 960 "../src/util/TweetUtils.vala"
					break;
#line 9402 "TweetUtils.c"
				}
#line 961 "../src/util/TweetUtils.vala"
				_tmp3_ = cb_tweet_new ();
#line 961 "../src/util/TweetUtils.vala"
				tweet = _tmp3_;
#line 962 "../src/util/TweetUtils.vala"
				_tmp4_ = tweet;
#line 962 "../src/util/TweetUtils.vala"
				_tmp5_ = json_array_get_element (json_array, i);
#line 962 "../src/util/TweetUtils.vala"
				_tmp6_ = now;
#line 962 "../src/util/TweetUtils.vala"
				cb_tweet_load_from_json (_tmp4_, _tmp5_, account->id, _tmp6_);
#line 963 "../src/util/TweetUtils.vala"
				_tmp9_ = account->user_counter;
#line 963 "../src/util/TweetUtils.vala"
				if (_tmp9_ == NULL) {
#line 963 "../src/util/TweetUtils.vala"
					_tmp8_ = TRUE;
#line 9422 "TweetUtils.c"
				} else {
#line 964 "../src/util/TweetUtils.vala"
					_tmp8_ = tweet_list == NULL;
#line 9426 "TweetUtils.c"
				}
#line 963 "../src/util/TweetUtils.vala"
				if (_tmp8_) {
#line 963 "../src/util/TweetUtils.vala"
					_tmp7_ = TRUE;
#line 9432 "TweetUtils.c"
				} else {
					GtkWidget* _tmp10_;
#line 965 "../src/util/TweetUtils.vala"
					_tmp10_ = gtk_widget_get_toplevel ((GtkWidget*) tweet_list);
#line 965 "../src/util/TweetUtils.vala"
					_tmp7_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gtk_window_get_type ());
#line 9439 "TweetUtils.c"
				}
#line 963 "../src/util/TweetUtils.vala"
				if (_tmp7_) {
#line 966 "../src/util/TweetUtils.vala"
					_g_object_unref0 (tweet);
#line 966 "../src/util/TweetUtils.vala"
					break;
#line 9447 "TweetUtils.c"
				}
#line 968 "../src/util/TweetUtils.vala"
				_tmp11_ = account->user_counter;
#line 968 "../src/util/TweetUtils.vala"
				_tmp12_ = tweet;
#line 968 "../src/util/TweetUtils.vala"
				cb_user_counter_id_seen (_tmp11_, &_tmp12_->source_tweet.author);
#line 969 "../src/util/TweetUtils.vala"
				_tmp13_ = tweet;
#line 969 "../src/util/TweetUtils.vala"
				_tmp14_ = _tmp13_->retweeted_tweet;
#line 969 "../src/util/TweetUtils.vala"
				if (_tmp14_ != NULL) {
#line 9461 "TweetUtils.c"
					CbUserCounter* _tmp15_;
					CbTweet* _tmp16_;
					CbMiniTweet* _tmp17_;
#line 970 "../src/util/TweetUtils.vala"
					_tmp15_ = account->user_counter;
#line 970 "../src/util/TweetUtils.vala"
					_tmp16_ = tweet;
#line 970 "../src/util/TweetUtils.vala"
					_tmp17_ = _tmp16_->retweeted_tweet;
#line 970 "../src/util/TweetUtils.vala"
					cb_user_counter_id_seen (_tmp15_, &(*_tmp17_).author);
#line 9473 "TweetUtils.c"
				}
#line 972 "../src/util/TweetUtils.vala"
				_tmp18_ = tweet;
#line 972 "../src/util/TweetUtils.vala"
				tweet_utils_set_tweet_hidden_flags (_tmp18_, account);
#line 974 "../src/util/TweetUtils.vala"
				_tmp19_ = tweet_list->model;
#line 974 "../src/util/TweetUtils.vala"
				_tmp20_ = tweet;
#line 974 "../src/util/TweetUtils.vala"
				cb_tweet_model_add (_tmp19_, _tmp20_);
#line 960 "../src/util/TweetUtils.vala"
				_g_object_unref0 (tweet);
#line 9487 "TweetUtils.c"
			}
		}
	}
#line 949 "../src/util/TweetUtils.vala"
	_g_date_time_unref0 (now);
#line 9493 "TweetUtils.c"
}

void
tweet_utils_handle_media_click (CbMedia** media,
                                gint media_length1,
                                MainWindow* window,
                                gint index)
{
	GdkDisplay* default_display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkMonitor* current_monitor = NULL;
	GdkWindow* _tmp2_;
	GdkMonitor* _tmp3_;
	GdkMonitor* _tmp4_;
	GdkRectangle workarea = {0};
	GdkRectangle _tmp5_ = {0};
	GdkRectangle max_dimensions = {0};
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_ = {0};
	MediaDialog* media_dialog = NULL;
	GdkRectangle _tmp9_;
	MediaDialog* _tmp10_;
#line 979 "../src/util/TweetUtils.vala"
	g_return_if_fail (window != NULL);
#line 994 "../src/util/TweetUtils.vala"
	_tmp0_ = gdk_display_get_default ();
#line 994 "../src/util/TweetUtils.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 994 "../src/util/TweetUtils.vala"
	default_display = _tmp1_;
#line 995 "../src/util/TweetUtils.vala"
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) window);
#line 995 "../src/util/TweetUtils.vala"
	_tmp3_ = gdk_display_get_monitor_at_window (default_display, _tmp2_);
#line 995 "../src/util/TweetUtils.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 995 "../src/util/TweetUtils.vala"
	current_monitor = _tmp4_;
#line 996 "../src/util/TweetUtils.vala"
	gdk_monitor_get_workarea (current_monitor, &_tmp5_);
#line 996 "../src/util/TweetUtils.vala"
	workarea = _tmp5_;
#line 997 "../src/util/TweetUtils.vala"
	_tmp6_ = workarea;
#line 997 "../src/util/TweetUtils.vala"
	_tmp7_ = workarea;
#line 997 "../src/util/TweetUtils.vala"
	_tmp8_.x = 0;
#line 997 "../src/util/TweetUtils.vala"
	_tmp8_.y = 0;
#line 997 "../src/util/TweetUtils.vala"
	_tmp8_.width = (gint) round (_tmp6_.width * 0.95);
#line 997 "../src/util/TweetUtils.vala"
	_tmp8_.height = (gint) round (_tmp7_.height * 0.95);
#line 997 "../src/util/TweetUtils.vala"
	max_dimensions = _tmp8_;
#line 998 "../src/util/TweetUtils.vala"
	_tmp9_ = max_dimensions;
#line 998 "../src/util/TweetUtils.vala"
	_tmp10_ = media_dialog_new (media, media_length1, index, &_tmp9_);
#line 998 "../src/util/TweetUtils.vala"
	g_object_ref_sink (_tmp10_);
#line 998 "../src/util/TweetUtils.vala"
	media_dialog = _tmp10_;
#line 999 "../src/util/TweetUtils.vala"
	gtk_window_set_transient_for ((GtkWindow*) media_dialog, (GtkWindow*) window);
#line 1000 "../src/util/TweetUtils.vala"
	gtk_window_set_modal ((GtkWindow*) media_dialog, TRUE);
#line 1001 "../src/util/TweetUtils.vala"
	gtk_widget_show ((GtkWidget*) media_dialog);
#line 979 "../src/util/TweetUtils.vala"
	_g_object_unref0 (media_dialog);
#line 979 "../src/util/TweetUtils.vala"
	_g_object_unref0 (current_monitor);
#line 979 "../src/util/TweetUtils.vala"
	_g_object_unref0 (default_display);
#line 9572 "TweetUtils.c"
}

void
tweet_utils_sort_entities (CbTextEntity** entities,
                           gint* entities_length1)
{
	{
		gint i = 0;
#line 1007 "../src/util/TweetUtils.vala"
		i = 0;
#line 9583 "TweetUtils.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1007 "../src/util/TweetUtils.vala"
			_tmp0_ = TRUE;
#line 1007 "../src/util/TweetUtils.vala"
			while (TRUE) {
#line 1007 "../src/util/TweetUtils.vala"
				if (!_tmp0_) {
#line 9592 "TweetUtils.c"
					gint _tmp1_;
#line 1007 "../src/util/TweetUtils.vala"
					_tmp1_ = i;
#line 1007 "../src/util/TweetUtils.vala"
					i = _tmp1_ + 1;
#line 9598 "TweetUtils.c"
				}
#line 1007 "../src/util/TweetUtils.vala"
				_tmp0_ = FALSE;
#line 1007 "../src/util/TweetUtils.vala"
				if (!(i < (*entities_length1))) {
#line 1007 "../src/util/TweetUtils.vala"
					break;
#line 9606 "TweetUtils.c"
				}
				{
					gint k = 0;
#line 1008 "../src/util/TweetUtils.vala"
					k = 0;
#line 9612 "TweetUtils.c"
					{
						gboolean _tmp2_ = FALSE;
#line 1008 "../src/util/TweetUtils.vala"
						_tmp2_ = TRUE;
#line 1008 "../src/util/TweetUtils.vala"
						while (TRUE) {
#line 9619 "TweetUtils.c"
							CbTextEntity _tmp4_;
							CbTextEntity _tmp5_;
#line 1008 "../src/util/TweetUtils.vala"
							if (!_tmp2_) {
#line 9624 "TweetUtils.c"
								gint _tmp3_;
#line 1008 "../src/util/TweetUtils.vala"
								_tmp3_ = k;
#line 1008 "../src/util/TweetUtils.vala"
								k = _tmp3_ + 1;
#line 9630 "TweetUtils.c"
							}
#line 1008 "../src/util/TweetUtils.vala"
							_tmp2_ = FALSE;
#line 1008 "../src/util/TweetUtils.vala"
							if (!(k < (*entities_length1))) {
#line 1008 "../src/util/TweetUtils.vala"
								break;
#line 9638 "TweetUtils.c"
							}
#line 1009 "../src/util/TweetUtils.vala"
							_tmp4_ = (*entities)[i];
#line 1009 "../src/util/TweetUtils.vala"
							_tmp5_ = (*entities)[k];
#line 1009 "../src/util/TweetUtils.vala"
							if (_tmp4_.from < _tmp5_.from) {
#line 9646 "TweetUtils.c"
								CbTextEntity c = {0};
								CbTextEntity _tmp6_;
								CbTextEntity _tmp7_;
								CbTextEntity _tmp8_ = {0};
								CbTextEntity _tmp9_;
								CbTextEntity _tmp10_;
								CbTextEntity _tmp11_ = {0};
								CbTextEntity _tmp12_;
								CbTextEntity _tmp13_;
								CbTextEntity _tmp14_ = {0};
#line 1010 "../src/util/TweetUtils.vala"
								_tmp6_ = (*entities)[i];
#line 1010 "../src/util/TweetUtils.vala"
								_tmp7_ = _tmp6_;
#line 1010 "../src/util/TweetUtils.vala"
								cb_text_entity_copy (&_tmp7_, &_tmp8_);
#line 1010 "../src/util/TweetUtils.vala"
								c = _tmp8_;
#line 1011 "../src/util/TweetUtils.vala"
								_tmp9_ = (*entities)[k];
#line 1011 "../src/util/TweetUtils.vala"
								_tmp10_ = _tmp9_;
#line 1011 "../src/util/TweetUtils.vala"
								cb_text_entity_copy (&_tmp10_, &_tmp11_);
#line 1011 "../src/util/TweetUtils.vala"
								cb_text_entity_free (&(*entities)[i]);
#line 1011 "../src/util/TweetUtils.vala"
								(*entities)[i] = _tmp11_;
#line 1012 "../src/util/TweetUtils.vala"
								_tmp12_ = c;
#line 1012 "../src/util/TweetUtils.vala"
								_tmp13_ = _tmp12_;
#line 1012 "../src/util/TweetUtils.vala"
								cb_text_entity_copy (&_tmp13_, &_tmp14_);
#line 1012 "../src/util/TweetUtils.vala"
								cb_text_entity_free (&(*entities)[k]);
#line 1012 "../src/util/TweetUtils.vala"
								(*entities)[k] = _tmp14_;
#line 1009 "../src/util/TweetUtils.vala"
								cb_text_entity_free (&c);
#line 9687 "TweetUtils.c"
							}
						}
					}
				}
			}
		}
	}
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 9703 "TweetUtils.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 9711 "TweetUtils.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 9720 "TweetUtils.c"
	}
}

void
tweet_utils_log_tweet (CbTweet* tweet)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	CbMiniTweet _tmp12_;
	CbUserIdentity _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	CbMiniTweet _tmp16_;
	CbUserIdentity _tmp17_;
	const gchar* _tmp18_;
	CbMiniTweet* _tmp19_;
#line 1018 "../src/util/TweetUtils.vala"
	g_return_if_fail (tweet != NULL);
#line 1022 "../src/util/TweetUtils.vala"
	_tmp0_ = bool_to_string (cb_tweet_get_seen (tweet));
#line 1022 "../src/util/TweetUtils.vala"
	_tmp1_ = _tmp0_;
#line 1022 "../src/util/TweetUtils.vala"
	g_message ("TweetUtils.vala:1022: Seen      : %s", _tmp1_);
#line 1022 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp1_);
#line 1023 "../src/util/TweetUtils.vala"
	_tmp2_ = g_strdup_printf ("%" G_GINT64_FORMAT, tweet->my_retweet);
#line 1023 "../src/util/TweetUtils.vala"
	_tmp3_ = _tmp2_;
#line 1023 "../src/util/TweetUtils.vala"
	g_message ("TweetUtils.vala:1023: My retweet: %s", _tmp3_);
#line 1023 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp3_);
#line 1024 "../src/util/TweetUtils.vala"
	_tmp4_ = bool_to_string (cb_tweet_is_flag_set (tweet, (guint) CB_TWEET_STATE_RETWEETED));
#line 1024 "../src/util/TweetUtils.vala"
	_tmp5_ = _tmp4_;
#line 1024 "../src/util/TweetUtils.vala"
	g_message ("TweetUtils.vala:1024: Retweeted: %s", _tmp5_);
#line 1024 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp5_);
#line 1025 "../src/util/TweetUtils.vala"
	_tmp6_ = bool_to_string (cb_tweet_is_flag_set (tweet, (guint) CB_TWEET_STATE_FAVORITED));
#line 1025 "../src/util/TweetUtils.vala"
	_tmp7_ = _tmp6_;
#line 1025 "../src/util/TweetUtils.vala"
	g_message ("TweetUtils.vala:1025: Favorited: %s", _tmp7_);
#line 1025 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp7_);
#line 1026 "../src/util/TweetUtils.vala"
	_tmp8_ = bool_to_string (cb_tweet_is_flag_set (tweet, (guint) CB_TWEET_STATE_PROTECTED));
#line 1026 "../src/util/TweetUtils.vala"
	_tmp9_ = _tmp8_;
#line 1026 "../src/util/TweetUtils.vala"
	g_message ("TweetUtils.vala:1026: Protected: %s", _tmp9_);
#line 1026 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp9_);
#line 1027 "../src/util/TweetUtils.vala"
	_tmp10_ = g_strdup_printf ("%u", tweet->state);
#line 1027 "../src/util/TweetUtils.vala"
	_tmp11_ = _tmp10_;
#line 1027 "../src/util/TweetUtils.vala"
	g_message ("TweetUtils.vala:1027: State    : %s", _tmp11_);
#line 1027 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp11_);
#line 1028 "../src/util/TweetUtils.vala"
	_tmp12_ = tweet->source_tweet;
#line 1028 "../src/util/TweetUtils.vala"
	_tmp13_ = _tmp12_.author;
#line 1028 "../src/util/TweetUtils.vala"
	_tmp14_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp13_.id);
#line 1028 "../src/util/TweetUtils.vala"
	_tmp15_ = _tmp14_;
#line 1028 "../src/util/TweetUtils.vala"
	g_message ("TweetUtils.vala:1028: Source tweet author id: %s", _tmp15_);
#line 1028 "../src/util/TweetUtils.vala"
	_g_free0 (_tmp15_);
#line 1029 "../src/util/TweetUtils.vala"
	_tmp16_ = tweet->source_tweet;
#line 1029 "../src/util/TweetUtils.vala"
	_tmp17_ = _tmp16_.author;
#line 1029 "../src/util/TweetUtils.vala"
	_tmp18_ = _tmp17_.screen_name;
#line 1029 "../src/util/TweetUtils.vala"
	g_message ("TweetUtils.vala:1029: Source tweet author screen_name: %s", _tmp18_);
#line 1030 "../src/util/TweetUtils.vala"
	_tmp19_ = tweet->retweeted_tweet;
#line 1030 "../src/util/TweetUtils.vala"
	if (_tmp19_ != NULL) {
#line 9821 "TweetUtils.c"
		CbMiniTweet* _tmp20_;
		CbUserIdentity _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		CbMiniTweet* _tmp24_;
		CbUserIdentity _tmp25_;
		const gchar* _tmp26_;
#line 1031 "../src/util/TweetUtils.vala"
		g_message ("TweetUtils.vala:1031: Retweet!");
#line 1032 "../src/util/TweetUtils.vala"
		_tmp20_ = tweet->retweeted_tweet;
#line 1032 "../src/util/TweetUtils.vala"
		_tmp21_ = (*_tmp20_).author;
#line 1032 "../src/util/TweetUtils.vala"
		_tmp22_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp21_.id);
#line 1032 "../src/util/TweetUtils.vala"
		_tmp23_ = _tmp22_;
#line 1032 "../src/util/TweetUtils.vala"
		g_message ("TweetUtils.vala:1032: Retweet author id: %s", _tmp23_);
#line 1032 "../src/util/TweetUtils.vala"
		_g_free0 (_tmp23_);
#line 1033 "../src/util/TweetUtils.vala"
		_tmp24_ = tweet->retweeted_tweet;
#line 1033 "../src/util/TweetUtils.vala"
		_tmp25_ = (*_tmp24_).author;
#line 1033 "../src/util/TweetUtils.vala"
		_tmp26_ = _tmp25_.screen_name;
#line 1033 "../src/util/TweetUtils.vala"
		g_message ("TweetUtils.vala:1033: Retweet author screen_name: %s", _tmp26_);
#line 9851 "TweetUtils.c"
	}
#line 1035 "../src/util/TweetUtils.vala"
	if (cb_tweet_has_inline_media (tweet)) {
#line 9855 "TweetUtils.c"
		gint _tmp27_ = 0;
		CbMedia** _tmp28_;
#line 1036 "../src/util/TweetUtils.vala"
		_tmp28_ = cb_tweet_get_medias (tweet, &_tmp27_);
#line 9860 "TweetUtils.c"
		{
			CbMedia** m_collection = NULL;
			gint m_collection_length1 = 0;
			gint _m_collection_size_ = 0;
			gint m_it = 0;
#line 1036 "../src/util/TweetUtils.vala"
			m_collection = _tmp28_;
#line 1036 "../src/util/TweetUtils.vala"
			m_collection_length1 = _tmp27_;
#line 1036 "../src/util/TweetUtils.vala"
			for (m_it = 0; m_it < m_collection_length1; m_it = m_it + 1) {
#line 9872 "TweetUtils.c"
				CbMedia* _tmp29_;
				CbMedia* m = NULL;
#line 1036 "../src/util/TweetUtils.vala"
				_tmp29_ = _g_object_ref0 (m_collection[m_it]);
#line 1036 "../src/util/TweetUtils.vala"
				m = _tmp29_;
#line 9879 "TweetUtils.c"
				{
					CbMedia* _tmp30_;
#line 1037 "../src/util/TweetUtils.vala"
					_tmp30_ = m;
#line 1037 "../src/util/TweetUtils.vala"
					g_message ("TweetUtils.vala:1037: Media: %p", _tmp30_);
#line 1036 "../src/util/TweetUtils.vala"
					_g_object_unref0 (m);
#line 9888 "TweetUtils.c"
				}
			}
		}
	}
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5907 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5908 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5908 "glib-2.0.vapi"
	return result;
#line 9905 "TweetUtils.c"
}

gint
tweet_utils_rerun_filters (TweetListBox* tweet_list,
                           Account* account)
{
	CbTweetModel* tm = NULL;
	CbTweetModel* _tmp0_;
	CbTweetModel* _tmp1_;
	gint hidden_unseen = 0;
	gint result;
#line 1042 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (tweet_list != NULL, 0);
#line 1042 "../src/util/TweetUtils.vala"
	g_return_val_if_fail (account != NULL, 0);
#line 1043 "../src/util/TweetUtils.vala"
	_tmp0_ = tweet_list->model;
#line 1043 "../src/util/TweetUtils.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1043 "../src/util/TweetUtils.vala"
	tm = _tmp1_;
#line 1045 "../src/util/TweetUtils.vala"
	hidden_unseen = 0;
#line 9929 "TweetUtils.c"
	{
		guint i = 0U;
#line 1047 "../src/util/TweetUtils.vala"
		i = (guint) 0;
#line 9934 "TweetUtils.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1047 "../src/util/TweetUtils.vala"
			_tmp2_ = TRUE;
#line 1047 "../src/util/TweetUtils.vala"
			while (TRUE) {
#line 9941 "TweetUtils.c"
				CbTweetModel* _tmp4_;
				CbTweet* tweet = NULL;
				CbTweetModel* _tmp5_;
				GObject* _tmp6_;
				CbTweet* _tmp7_;
#line 1047 "../src/util/TweetUtils.vala"
				if (!_tmp2_) {
#line 9949 "TweetUtils.c"
					guint _tmp3_;
#line 1047 "../src/util/TweetUtils.vala"
					_tmp3_ = i;
#line 1047 "../src/util/TweetUtils.vala"
					i = _tmp3_ + 1;
#line 9955 "TweetUtils.c"
				}
#line 1047 "../src/util/TweetUtils.vala"
				_tmp2_ = FALSE;
#line 1047 "../src/util/TweetUtils.vala"
				_tmp4_ = tm;
#line 1047 "../src/util/TweetUtils.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) _tmp4_))) {
#line 1047 "../src/util/TweetUtils.vala"
					break;
#line 9965 "TweetUtils.c"
				}
#line 1048 "../src/util/TweetUtils.vala"
				_tmp5_ = tm;
#line 1048 "../src/util/TweetUtils.vala"
				_tmp6_ = g_list_model_get_object ((GListModel*) _tmp5_, i);
#line 1048 "../src/util/TweetUtils.vala"
				tweet = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, CB_TYPE_TWEET, CbTweet);
#line 1049 "../src/util/TweetUtils.vala"
				_tmp7_ = tweet;
#line 1049 "../src/util/TweetUtils.vala"
				if (account_filter_matches (account, _tmp7_)) {
#line 9977 "TweetUtils.c"
					CbTweetModel* _tmp8_;
					CbTweet* _tmp9_;
					CbTweet* _tmp11_;
#line 1050 "../src/util/TweetUtils.vala"
					_tmp8_ = tm;
#line 1050 "../src/util/TweetUtils.vala"
					_tmp9_ = tweet;
#line 1050 "../src/util/TweetUtils.vala"
					if (cb_tweet_model_set_tweet_flag (_tmp8_, _tmp9_, CB_TWEET_STATE_HIDDEN_FILTERED)) {
#line 9987 "TweetUtils.c"
						guint _tmp10_;
#line 1051 "../src/util/TweetUtils.vala"
						_tmp10_ = i;
#line 1051 "../src/util/TweetUtils.vala"
						i = _tmp10_ - 1;
#line 9993 "TweetUtils.c"
					}
#line 1054 "../src/util/TweetUtils.vala"
					_tmp11_ = tweet;
#line 1054 "../src/util/TweetUtils.vala"
					if (!cb_tweet_get_seen (_tmp11_)) {
#line 9999 "TweetUtils.c"
						gint _tmp12_;
						CbTweet* _tmp13_;
#line 1055 "../src/util/TweetUtils.vala"
						_tmp12_ = hidden_unseen;
#line 1055 "../src/util/TweetUtils.vala"
						hidden_unseen = _tmp12_ + 1;
#line 1056 "../src/util/TweetUtils.vala"
						_tmp13_ = tweet;
#line 1056 "../src/util/TweetUtils.vala"
						cb_tweet_set_seen (_tmp13_, TRUE);
#line 10010 "TweetUtils.c"
					}
				} else {
					CbTweetModel* _tmp14_;
					CbTweet* _tmp15_;
#line 1059 "../src/util/TweetUtils.vala"
					_tmp14_ = tm;
#line 1059 "../src/util/TweetUtils.vala"
					_tmp15_ = tweet;
#line 1059 "../src/util/TweetUtils.vala"
					if (cb_tweet_model_unset_tweet_flag (_tmp14_, _tmp15_, CB_TWEET_STATE_HIDDEN_FILTERED)) {
#line 10021 "TweetUtils.c"
						guint _tmp16_;
#line 1060 "../src/util/TweetUtils.vala"
						_tmp16_ = i;
#line 1060 "../src/util/TweetUtils.vala"
						i = _tmp16_ - 1;
#line 10027 "TweetUtils.c"
					}
				}
#line 1047 "../src/util/TweetUtils.vala"
				_g_object_unref0 (tweet);
#line 10032 "TweetUtils.c"
			}
		}
	}
	{
		guint i = 0U;
#line 1067 "../src/util/TweetUtils.vala"
		i = (guint) 0;
#line 10040 "TweetUtils.c"
		{
			gboolean _tmp17_ = FALSE;
#line 1067 "../src/util/TweetUtils.vala"
			_tmp17_ = TRUE;
#line 1067 "../src/util/TweetUtils.vala"
			while (TRUE) {
#line 10047 "TweetUtils.c"
				CbTweetModel* _tmp19_;
				GPtrArray* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				CbTweet* tweet = NULL;
				CbTweetModel* _tmp23_;
				GPtrArray* _tmp24_;
				gconstpointer _tmp25_;
				CbTweet* _tmp26_;
				CbTweet* _tmp27_;
#line 1067 "../src/util/TweetUtils.vala"
				if (!_tmp17_) {
#line 10060 "TweetUtils.c"
					guint _tmp18_;
#line 1067 "../src/util/TweetUtils.vala"
					_tmp18_ = i;
#line 1067 "../src/util/TweetUtils.vala"
					i = _tmp18_ + 1;
#line 10066 "TweetUtils.c"
				}
#line 1067 "../src/util/TweetUtils.vala"
				_tmp17_ = FALSE;
#line 1067 "../src/util/TweetUtils.vala"
				_tmp19_ = tm;
#line 1067 "../src/util/TweetUtils.vala"
				_tmp20_ = _tmp19_->hidden_tweets;
#line 1067 "../src/util/TweetUtils.vala"
				_tmp21_ = vala_g_ptr_array_get_length (_tmp20_);
#line 1067 "../src/util/TweetUtils.vala"
				_tmp22_ = _tmp21_;
#line 1067 "../src/util/TweetUtils.vala"
				if (!(i < ((guint) _tmp22_))) {
#line 1067 "../src/util/TweetUtils.vala"
					break;
#line 10082 "TweetUtils.c"
				}
#line 1068 "../src/util/TweetUtils.vala"
				_tmp23_ = tm;
#line 1068 "../src/util/TweetUtils.vala"
				_tmp24_ = _tmp23_->hidden_tweets;
#line 1068 "../src/util/TweetUtils.vala"
				_tmp25_ = g_ptr_array_index (_tmp24_, i);
#line 1068 "../src/util/TweetUtils.vala"
				_tmp26_ = _g_object_ref0 ((CbTweet*) _tmp25_);
#line 1068 "../src/util/TweetUtils.vala"
				tweet = _tmp26_;
#line 1069 "../src/util/TweetUtils.vala"
				_tmp27_ = tweet;
#line 1069 "../src/util/TweetUtils.vala"
				if (cb_tweet_is_flag_set (_tmp27_, (guint) CB_TWEET_STATE_HIDDEN_FILTERED)) {
#line 10098 "TweetUtils.c"
					CbTweet* _tmp28_;
#line 1070 "../src/util/TweetUtils.vala"
					_tmp28_ = tweet;
#line 1070 "../src/util/TweetUtils.vala"
					if (!account_filter_matches (account, _tmp28_)) {
#line 10104 "TweetUtils.c"
						CbTweetModel* _tmp29_;
						CbTweet* _tmp30_;
						guint _tmp31_;
#line 1071 "../src/util/TweetUtils.vala"
						_tmp29_ = tm;
#line 1071 "../src/util/TweetUtils.vala"
						_tmp30_ = tweet;
#line 1071 "../src/util/TweetUtils.vala"
						cb_tweet_model_unset_tweet_flag (_tmp29_, _tmp30_, CB_TWEET_STATE_HIDDEN_FILTERED);
#line 1072 "../src/util/TweetUtils.vala"
						_tmp31_ = i;
#line 1072 "../src/util/TweetUtils.vala"
						i = _tmp31_ - 1;
#line 10118 "TweetUtils.c"
					}
				}
#line 1067 "../src/util/TweetUtils.vala"
				_g_object_unref0 (tweet);
#line 10123 "TweetUtils.c"
			}
		}
	}
#line 1077 "../src/util/TweetUtils.vala"
	result = hidden_unseen;
#line 1077 "../src/util/TweetUtils.vala"
	_g_object_unref0 (tm);
#line 1077 "../src/util/TweetUtils.vala"
	return result;
#line 10133 "TweetUtils.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

